/**
 * @license
 * Copyright 2023 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import*as e from"@tensorflow/tfjs-core";import{env as t,util as n,clone as r,scalar as s,keep as a,tensor as o,stack as i,concat as u,unstack as p,tidy as l,reshape as c,slice as h,io as d,Tensor as m,dispose as f}from"@tensorflow/tfjs-core";function y(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var r=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,r.get?r:{enumerable:!0,get:function(){return t[n]}})}}))})),e}var g,b;t().registerFlag("KEEP_INTERMEDIATE_TENSORS",(()=>!1),(e=>{e&&console.warn("Keep intermediate tensors is ON. This will print the values of all intermediate tensors during model inference. Not all models support this mode. For details, check e2e/benchmarks/ model_config.js. This significantly impacts performance.")})),function(e){e[e.DT_INVALID=0]="DT_INVALID",e[e.DT_FLOAT=1]="DT_FLOAT",e[e.DT_DOUBLE=2]="DT_DOUBLE",e[e.DT_INT32=3]="DT_INT32",e[e.DT_UINT8=4]="DT_UINT8",e[e.DT_INT16=5]="DT_INT16",e[e.DT_INT8=6]="DT_INT8",e[e.DT_STRING=7]="DT_STRING",e[e.DT_COMPLEX64=8]="DT_COMPLEX64",e[e.DT_INT64=9]="DT_INT64",e[e.DT_BOOL=10]="DT_BOOL",e[e.DT_QINT8=11]="DT_QINT8",e[e.DT_QUINT8=12]="DT_QUINT8",e[e.DT_QINT32=13]="DT_QINT32",e[e.DT_BFLOAT16=14]="DT_BFLOAT16",e[e.DT_QINT16=15]="DT_QINT16",e[e.DT_QUINT16=16]="DT_QUINT16",e[e.DT_UINT16=17]="DT_UINT16",e[e.DT_COMPLEX128=18]="DT_COMPLEX128",e[e.DT_HALF=19]="DT_HALF",e[e.DT_RESOURCE=20]="DT_RESOURCE",e[e.DT_VARIANT=21]="DT_VARIANT",e[e.DT_UINT32=22]="DT_UINT32",e[e.DT_UINT64=23]="DT_UINT64",e[e.DT_FLOAT_REF=101]="DT_FLOAT_REF",e[e.DT_DOUBLE_REF=102]="DT_DOUBLE_REF",e[e.DT_INT32_REF=103]="DT_INT32_REF",e[e.DT_UINT8_REF=104]="DT_UINT8_REF",e[e.DT_INT16_REF=105]="DT_INT16_REF",e[e.DT_INT8_REF=106]="DT_INT8_REF",e[e.DT_STRING_REF=107]="DT_STRING_REF",e[e.DT_COMPLEX64_REF=108]="DT_COMPLEX64_REF",e[e.DT_INT64_REF=109]="DT_INT64_REF",e[e.DT_BOOL_REF=110]="DT_BOOL_REF",e[e.DT_QINT8_REF=111]="DT_QINT8_REF",e[e.DT_QUINT8_REF=112]="DT_QUINT8_REF",e[e.DT_QINT32_REF=113]="DT_QINT32_REF",e[e.DT_BFLOAT16_REF=114]="DT_BFLOAT16_REF",e[e.DT_QINT16_REF=115]="DT_QINT16_REF",e[e.DT_QUINT16_REF=116]="DT_QUINT16_REF",e[e.DT_UINT16_REF=117]="DT_UINT16_REF",e[e.DT_COMPLEX128_REF=118]="DT_COMPLEX128_REF",e[e.DT_HALF_REF=119]="DT_HALF_REF",e[e.DT_RESOURCE_REF=120]="DT_RESOURCE_REF",e[e.DT_VARIANT_REF=121]="DT_VARIANT_REF",e[e.DT_UINT32_REF=122]="DT_UINT32_REF",e[e.DT_UINT64_REF=123]="DT_UINT64_REF"}(g||(g={})),function(e){var t;(t=e.CheckpointFormatVersion||(e.CheckpointFormatVersion={}))[t.LEGACY=0]="LEGACY",t[t.V1=1]="V1",t[t.V2=2]="V2"}(b||(b={}));const x={};function N(e,t){const n={tfOpName:e,category:"custom",inputs:[],attrs:[],customExecutor:t};x[e]=n}function w(e){return x[e]}function k(e){delete x[e]}function T(e,t,r,s,a){const o=t.inputParams[e];if(o&&void 0!==o.inputIndexStart){const e=o.inputIndexStart,i=0===o.inputIndexEnd?void 0:void 0===o.inputIndexEnd?e+1:o.inputIndexEnd;if("tensor"===o.type)return v(t.inputNames[o.inputIndexStart],r,s,a);if("tensors"===o.type){return t.inputNames.slice(e,i).map((e=>v(e,r,s,a)))}const u=v(t.inputNames.slice(e)[0],r,s,a),p=u.dataSync();return"number"===o.type?p[0]:n.toNestedArray(u.shape,p)}const i=t.attrParams[e];return i&&i.value}function v(e,t,n,r){const[s,a]=E(e);if(null!=r){const e=r.getHashTableHandleByName(s);if(null!=e)return e}const o=n.currentContextIds.find((e=>!!t[S(s,e)]));return void 0!==o?t[S(s,o)][a]:void 0}function _(e,t){const[n,r,s]=E(e);return[S(n,t&&t.currentContextId),r,s]}function S(e,t){return t?`${e}-${t}`:e}function E(e){const t=e.split(":");if(1===t.length)return[e,0,void 0];const n=t[0],r=3===t.length?t[1]:void 0;return[n,Number(t[t.length-1]),r]}function I(e,t,n){let r=T("pad",e,t,n);if("explicit"===r){r=T("explicitPaddings",e,t,n);const s=[[0,0],[0,0],[0,0],[0,0]];for(let e=0;e<4;e++)s[e][0]=r[2*e],s[e][1]=r[2*e+1];return s}return r}function $(e){return e.kept?e:r(e)}var D={__proto__:null,json:[{tfOpName:"Add",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddV2",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddN",category:"arithmetic",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"BiasAdd",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"Sub",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"RealDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Div",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"DivNoNan",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mul",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Maximum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Minimum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Pow",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SquaredDifference",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorMod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var A={__proto__:null,json:[{tfOpName:"Abs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan2",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Ceil",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ClipByValue",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"clipValueMin",type:"number"},{start:2,name:"clipValueMax",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Complex",category:"basic_math",inputs:[{start:0,name:"real",type:"tensor"},{start:1,name:"imag",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ComplexAbs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Elu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Exp",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Floor",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Imag",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Neg",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Real",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Prelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"alpha",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu6",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Selu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sigmoid",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Rsqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Square",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sign",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Round",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Expm1",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log1p",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Reciprocal",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Softplus",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Erf",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Prod",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axes",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LeakyRelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"alpha",name:"alpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"IsNan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var O={__proto__:null,json:[{tfOpName:"EmptyTensorList",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"maxNumElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"LoopCond",category:"control",inputs:[{start:0,name:"pred",type:"tensor"}]},{tfOpName:"Switch",category:"control",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"pred",type:"tensor"}]},{tfOpName:"Merge",category:"control",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"Enter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"frame_name",name:"frameName",type:"string"},{tfName:"is_constant",name:"isConstant",type:"bool"}]},{tfOpName:"Exit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NextIteration",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayV3",category:"control",inputs:[{start:0,name:"size",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"dynamic_size",name:"dynamicSize",type:"bool"},{tfName:"clear_after_read",name:"clearAfterRead",type:"bool"},{tfName:"identical_element_shapes",name:"identicalElementShapes",type:"bool"},{tfName:"tensor_array_name",name:"name",type:"string"}]},{tfOpName:"TensorArrayWriteV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayReadV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayGatherV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"}]},{tfOpName:"TensorArrayScatterV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArrayConcatV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape_except0",name:"elementShapeExcept0",type:"shape",notSupported:!0}]},{tfOpName:"TensorArraySplitV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"tensor",type:"tensor"},{start:2,name:"lengths",type:"number[]"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArraySizeV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}]},{tfOpName:"TensorArrayCloseV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"}]},{tfOpName:"StatelessIf",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"If",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"StatelessWhile",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"While",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"TensorListScatter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListScatterV2",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"},{start:3,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGather",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListSetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListReserve",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListFromTensor",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListStack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"},{tfName:"num_elements",name:"numElements",type:"dtype"}]},{tfOpName:"TensorListSplit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"},{start:2,name:"lengths",type:"number[]"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcat",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcatV2",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPopBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPushBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListLength",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}]},{tfOpName:"TensorListResize",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"size",type:"number"}]}]};var M={__proto__:null,json:[{tfOpName:"AvgPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[],notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPoolWithArgmax",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"include_batch_in_index",name:"includeBatchInIndex",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AvgPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Conv1D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"stride",name:"stride",type:"number"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NWC"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"dilation",name:"dilation",type:"number",defaultValue:1}]},{tfOpName:"Conv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"useCudnnOnGpu",name:"useCudnnOnGpu",type:"bool"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"_FusedConv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"use_cudnn_on_gpu",name:"useCudnnOnGpu",type:"bool",defaultValue:!0},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2}]},{tfOpName:"Conv2DBackpropInput",category:"convolution",inputs:[{start:2,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:0,name:"outputShape",type:"number[]"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]",notSupported:!0}]},{tfOpName:"DepthwiseConv2d",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"DepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"FusedDepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]}]},{tfOpName:"Conv3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"Dilation2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"rates",name:"dilations",type:"number[]"},{tfName:"padding",name:"pad",type:"string"}]}]};var C={__proto__:null,json:[{tfOpName:"Fill",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"},{start:1,name:"value",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"LinSpace",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"num",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"OneHot",category:"creation",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"depth",type:"number"},{start:2,name:"onValue",type:"number",defaultValue:1},{start:3,name:"offValue",type:"number",defaultValue:0}],attrs:[{tfName:"axis",name:"axis",type:"number",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Ones",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"OnesLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"RandomStandardNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"RandomUniform",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"minval",name:"minval",type:"number",defaultValue:0},{tfName:"maxval",name:"maxval",type:"number",defaultValue:1},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Range",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"step",type:"number",defaultValue:0}],attrs:[{tfName:"Tidx",name:"dtype",type:"dtype"}]},{tfOpName:"TruncatedNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"means",name:"mean",type:"number",defaultValue:0},{tfName:"stddev",name:"stdDev",type:"number",defaultValue:1},{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Zeros",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"ZerosLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Multinomial",category:"creation",inputs:[{start:0,name:"logits",type:"tensor"},{start:1,name:"numSamples",type:"number"}],attrs:[{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number"},{tfName:"T",name:"dtype",type:"dtype"},{tfName:"output_dtype",name:"output_dtype",type:"dtype"}]}]};var F={__proto__:null,json:[{tfOpName:"NonMaxSuppressionV2",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV3",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV4",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"T_threshold",name:"threshold",type:"dtype",notSupported:!0},{tfName:"pad_to_max_output_size",name:"padToMaxOutputSize",type:"bool"}]},{tfOpName:"NonMaxSuppressionV5",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"},{start:5,name:"softNmsSigma",type:"number"}]},{tfOpName:"Where",category:"dynamic",inputs:[{start:0,name:"condition",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ListDiff",category:"dynamic",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var R={__proto__:null,json:[{tfOpName:"LowerBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"TopKV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"k",type:"number"}],attrs:[{tfName:"sorted",name:"sorted",type:"bool"}]},{tfOpName:"UpperBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"Unique",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"UniqueV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]}]};var z={__proto__:null,json:[{tfOpName:"PlaceholderWithDefault",category:"graph",inputs:[{start:0,name:"default",type:"tensor"}],attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Placeholder",category:"graph",attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Const",category:"graph"},{tfOpName:"Identity",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IdentityN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Snapshot",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Rank",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Size",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Shape",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"ShapeN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Print",category:"graph",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"data",type:"tensors"}],attrs:[{tfName:"message",name:"message",type:"string"},{tfName:"first_n",name:"firstN",type:"number",notSupported:!0},{tfName:"summarize",name:"summarize",type:"number",defaultValue:3}]},{tfOpName:"NoOp",category:"graph",inputs:[]},{tfOpName:"StopGradient",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"FakeQuantWithMinMaxVars",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"min",name:"min",type:"number"},{tfName:"max",name:"max",type:"number"}]}]};var V={__proto__:null,json:[{tfOpName:"HashTable",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"HashTableV2",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"LookupTableImport",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableImportV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFind",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFindV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableSize",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"LookupTableSizeV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"InitializeTable",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}]},{tfOpName:"InitializeTableV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}]}]};var L={__proto__:null,json:[{tfOpName:"ResizeBilinear",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ResizeNearestNeighbor",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"CropAndResize",category:"image",inputs:[{start:0,name:"image",type:"tensor"},{start:1,name:"boxes",type:"tensor"},{start:2,name:"boxInd",type:"tensor"},{start:3,name:"cropSize",type:"number[]"}],attrs:[{tfName:"method",name:"method",type:"string"},{tfName:"extrapolation_value",name:"extrapolationValue",type:"number"}]},{tfOpName:"ImageProjectiveTransformV3",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"transforms",type:"tensor"},{start:2,name:"outputShape",type:"number[]"},{start:3,name:"fillValue",type:"number"}],attrs:[{tfName:"interpolation",name:"interpolation",type:"string"},{tfName:"fill_mode",name:"fillMode",type:"string"}]}]};var B={__proto__:null,json:[{tfOpName:"Equal",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NotEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Greater",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"GreaterEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Less",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LessEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalAnd",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalNot",category:"logical",inputs:[{start:0,name:"a",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalOr",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Select",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SelectV2",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]};var P={__proto__:null,json:[{tfOpName:"_FusedMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMulV2",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Transpose",category:"matrices",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"perm",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Einsum",category:"matrices",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"equation",name:"equation",type:"string"},{tfName:"N",name:"n",type:"number",defaultValue:2},{tfName:"T",name:"dtype",type:"dtype"}]}]};var K={__proto__:null,json:[{tfOpName:"EuclideanNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",defaultValue:!1}]},{tfOpName:"FusedBatchNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV2",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV3",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"LRN",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"depth_radius",name:"radius",type:"number",defaultValue:5},{tfName:"bias",name:"bias",type:"number",defaultValue:1},{tfName:"alpha",name:"alpha",type:"number",defaultValue:1},{tfName:"beta",name:"beta",type:"number",defaultValue:.5}]},{tfOpName:"Softmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"LogSoftmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"SparseToDense",category:"normalization",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!0,notSupported:!0}]}]};var q={__proto__:null,json:[{tfOpName:"Bincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}]},{tfOpName:"DenseBincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}],attrs:[{tfName:"binary_output",name:"binaryOutput",type:"bool"}]},{tfOpName:"Max",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Mean",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Min",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Sum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"All",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Any",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"ArgMax",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"ArgMin",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"Prod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Cumprod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]},{tfOpName:"Cumsum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]}]};var U={__proto__:null,json:[{tfOpName:"ConcatV2",category:"slice_join",inputs:[{start:0,end:-1,name:"tensors",type:"tensors"},{start:-1,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"Concat",category:"slice_join",inputs:[{start:1,end:0,name:"tensors",type:"tensors"},{start:0,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"GatherV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"axis",type:"number",defaultValue:0}],attrs:[{tfName:"batch_dims",name:"batchDims",type:"number",defaultValue:0}]},{tfOpName:"Gather",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",notSupported:!0}]},{tfOpName:"Reverse",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"dims",type:"bool[]"}]},{tfOpName:"ReverseV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}]},{tfOpName:"Slice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"size",type:"number[]"}]},{tfOpName:"StridedSlice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"end",type:"number[]"},{start:3,name:"strides",type:"number[]"}],attrs:[{tfName:"begin_mask",name:"beginMask",type:"number",defaultValue:0},{tfName:"end_mask",name:"endMask",type:"number",defaultValue:0},{tfName:"new_axis_mask",name:"newAxisMask",type:"number",defaultValue:0},{tfName:"ellipsis_mask",name:"ellipsisMask",type:"number",defaultValue:0},{tfName:"shrink_axis_mask",name:"shrinkAxisMask",type:"number",defaultValue:0}]},{tfOpName:"Pack",category:"slice_join",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0}]},{tfOpName:"Unpack",category:"slice_join",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0},{tfName:"num",name:"num",type:"number",defaultValue:0,notSupported:!0}]},{tfOpName:"Tile",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"reps",type:"number[]"}]},{tfOpName:"Split",category:"slice_join",inputs:[{start:0,name:"axis",type:"number",defaultValue:0},{start:1,name:"x",type:"tensor"}],attrs:[{tfName:"num_split",name:"numOrSizeSplits",type:"number",defaultValue:1}]},{tfOpName:"SplitV",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"numOrSizeSplits",type:"number[]"},{start:2,name:"axis",type:"number",defaultValue:0}]},{tfOpName:"ScatterNd",category:"slice_join",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"shape",type:"number[]"}]},{tfOpName:"GatherNd",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}]},{tfOpName:"SparseToDense",category:"slice_join",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!1,notSupported:!0}]}]};var W={__proto__:null,json:[{tfOpName:"SparseFillEmptyRows",category:"sparse",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"denseShape",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}]},{tfOpName:"SparseReshape",category:"sparse",inputs:[{start:0,name:"inputIndices",type:"tensor"},{start:1,name:"inputShape",type:"tensor"},{start:2,name:"newShape",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SparseSegmentMean",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]},{tfOpName:"SparseSegmentSum",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]}]};var j={__proto__:null,json:[{tfOpName:"FFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"RFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]},{tfOpName:"IRFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]}]};var H={__proto__:null,json:[{tfOpName:"StringNGrams",category:"string",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"dataSplits",type:"tensor"}],attrs:[{tfName:"separator",name:"separator",type:"string"},{tfName:"ngram_widths",name:"nGramWidths",type:"number[]"},{tfName:"left_pad",name:"leftPad",type:"string"},{tfName:"right_pad",name:"rightPad",type:"string"},{tfName:"pad_width",name:"padWidth",type:"number"},{tfName:"preserve_short_sequences",name:"preserveShortSequences",type:"bool"}],outputs:["ngrams","ngrams_splits"]},{tfOpName:"StringSplit",category:"string",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"delimiter",type:"tensor"}],attrs:[{tfName:"skip_empty",name:"skipEmpty",type:"bool"}],outputs:["indices","values","shape"]},{tfOpName:"StringToHashBucketFast",category:"string",inputs:[{start:0,name:"input",type:"tensor"}],attrs:[{tfName:"num_buckets",name:"numBuckets",type:"number"}]}]};var G={__proto__:null,json:[{tfOpName:"Cast",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"SrcT",name:"sdtype",type:"dtype",notSupported:!0},{tfName:"DstT",name:"dtype",type:"dtype"}]},{tfOpName:"ExpandDims",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"MirrorPad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"mode",name:"mode",type:"string"}]},{tfOpName:"Pad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"constant_value",name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"PadV2",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"},{start:2,name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"Reshape",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}]},{tfOpName:"Squeeze",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"axis",tfDeprecatedName:"squeeze_dims",name:"axis",type:"number[]"}]},{tfOpName:"SpaceToBatchND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"paddings",type:"number[]"}]},{tfOpName:"BatchToSpaceND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"crops",type:"number[]"}]},{tfOpName:"DepthToSpace",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"block_size",name:"blockSize",type:"number"},{tfName:"data_format",name:"dataFormat",type:"string"}]},{tfOpName:"BroadcastTo",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}],attrs:[]},{tfOpName:"BroadcastArgs",category:"transformation",inputs:[{start:0,name:"s0",type:"tensor"},{start:1,name:"s1",type:"tensor"}],attrs:[]}]};class Z{constructor(){const e=[].concat(...[D,A,O,M,C,F,R,z,V,L,B,P,K,q,U,W,j,H,G].map((e=>e.json)));this.opMappers=e.reduce(((e,t)=>(e[t.tfOpName]=t,e)),{})}static get Instance(){return this._instance||(this._instance=new this)}transformGraph(e,t={}){const n=e.node,r=[],s=[],a=[],o=n.reduce(((e,t)=>(e[t.name]=this.mapNode(t),t.op.startsWith("Placeholder")?r.push(e[t.name]):"Const"===t.op?s.push(e[t.name]):null!=t.input&&0!==t.input.length||a.push(e[t.name]),e)),{});let i=[];const u=[];let p={},l={};null!=t&&(p=this.mapSignatureEntries(t.inputs),l=this.mapSignatureEntries(t.outputs));const c=Object.keys(o);c.forEach((e=>{const t=o[e];t.inputNames.forEach(((e,n)=>{const[r,,s]=_(e),a=o[r];if(null!=a.outputs){const e=a.outputs.indexOf(s);if(-1!==e){const s=`${r}:${e}`;t.inputNames[n]=s}}t.inputs.push(a),a.children.push(t)}))})),0===Object.keys(l).length?c.forEach((e=>{const t=o[e];0===t.children.length&&u.push(t)})):Object.keys(l).forEach((e=>{const[t]=_(e),n=o[t];null!=n&&(n.signatureKey=l[e],u.push(n))})),Object.keys(p).length>0?Object.keys(p).forEach((e=>{const[t]=_(e),n=o[t];n&&(n.signatureKey=p[e],i.push(n))})):i=r;let h={};null!=e.library&&null!=e.library.function&&(h=e.library.function.reduce(((e,t)=>(e[t.signature.name]=this.mapFunction(t),e)),{}));const d={nodes:o,inputs:i,outputs:u,weights:s,placeholders:r,signature:t,functions:h};return a.length>0&&(d.initNodes=a),d}mapSignatureEntries(e){return Object.keys(e||{}).reduce(((t,n)=>(t[e[n].name]=n,t)),{})}mapNode(e){const t=w(e.op)||this.opMappers[e.op]||{};null==e.attr&&(e.attr={});const n={name:e.name,op:e.op,category:t.category,inputNames:(e.input||[]).map((e=>e.startsWith("^")?e.slice(1):e)),inputs:[],children:[],inputParams:{},attrParams:{},rawAttrs:e.attr,outputs:t.outputs};return null!=t.inputs&&(n.inputParams=t.inputs.reduce(((e,t)=>(e[t.name]={type:t.type,inputIndexStart:t.start,inputIndexEnd:t.end},e)),{})),null!=t.attrs&&(n.attrParams=t.attrs.reduce(((t,n)=>{const r=n.type;let s;switch(n.type){case"string":s=Y(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=Y(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"string[]":s=ie(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ie(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"number":s=J(e.attr,n.tfName,n.defaultValue||0),void 0===s&&n.tfDeprecatedName&&(s=J(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"number[]":s=oe(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=oe(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool":s=X(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=X(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool[]":s=pe(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=pe(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape":s=ae(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ae(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape[]":s=ue(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ue(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype":s=ne(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=ne(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype[]":s=re(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=re(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"func":s=te(e.attr,n.tfName,n.defaultValue),void 0===s&&n.tfDeprecatedName&&(s=te(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"tensor":case"tensors":break;default:throw new Error(`Unsupported param type: ${n.type} for op: ${e.op}`)}return t[n.name]={value:s,type:r},t}),{})),n}mapFunction(e){const t=e.nodeDef,n=[];let r={};null!=t&&(r=t.reduce(((e,t)=>(e[t.name]=this.mapNode(t),"Const"===t.op&&n.push(e[t.name]),e)),{}));const s=[],a=[];e.signature.inputArg.forEach((e=>{const[t]=_(e.name),n={name:t,op:"Placeholder",inputs:[],inputNames:[],category:"graph",inputParams:{},attrParams:{dtype:{value:ee(e.type),type:"dtype"}},children:[]};n.signatureKey=e.name,s.push(n),r[t]=n}));Object.keys(r).forEach((e=>{const t=r[e];t.inputNames.forEach(((e,n)=>{const[s,,a]=_(e),o=r[s];if(null!=o.outputs){const e=o.outputs.indexOf(a);if(-1!==e){const r=`${s}:${e}`;t.inputNames[n]=r}}t.inputs.push(o),o.children.push(t)}))}));const o=e.ret;e.signature.outputArg.forEach((e=>{const[t,n]=_(o[e.name]),s=r[t];null!=s&&(s.defaultOutput=n,a.push(s))}));const i=this.mapArgsToSignature(e);return{nodes:r,inputs:s,outputs:a,weights:n,placeholders:[],signature:i}}mapArgsToSignature(e){return{methodName:e.signature.name,inputs:e.signature.inputArg.reduce(((e,t)=>(e[t.name]=this.mapArgToTensorInfo(t),e)),{}),outputs:e.signature.outputArg.reduce(((t,n)=>(t[n.name]=this.mapArgToTensorInfo(n,e.ret),t)),{})}}mapArgToTensorInfo(e,t){let n=e.name;return null!=t&&(n=t[n]),{name:n,dtype:e.type}}}function Q(e,n){const r=Array.isArray(e)?String.fromCharCode.apply(null,e):function(e){const n=t().global;if("undefined"!=typeof n.atob)return n.atob(e);if("undefined"!=typeof Buffer)return new Buffer(e,"base64").toString();throw new Error("Unable to decode base64 in this environment. Missing built-in atob() or Buffer()")}(e);return n?r:r.toLowerCase()}function Y(e,t,n,r=!1){const s=e[t];return null!=s?Q(s.s,r):n}function X(e,t,n){const r=e[t];return r?r.b:n}function J(e,t,n){const r=e[t]||{},s=null!=r.i?r.i:null!=r.f?r.f:n;return"number"==typeof s?s:parseInt(s,10)}function ee(e){switch("string"==typeof e&&(e=g[e]),e){case g.DT_FLOAT:case g.DT_HALF:return"float32";case g.DT_INT32:case g.DT_INT64:case g.DT_INT8:case g.DT_UINT8:return"int32";case g.DT_BOOL:return"bool";case g.DT_DOUBLE:return"float32";case g.DT_STRING:return"string";default:return null}}function te(e,t,n){const r=e[t];return r&&r.func?r.func.name:n}function ne(e,t,n){const r=e[t];return r&&r.type?ee(r.type):n}function re(e,t,n){const r=e[t];return r&&r.list&&r.list.type?r.list.type.map((e=>ee(e))):n}function se(e){if(!e.unknownRank)return null!=e.dim?e.dim.map((e=>"number"==typeof e.size?e.size:parseInt(e.size,10))):[]}function ae(e,t,n){const r=e[t];return r&&r.shape?se(r.shape):n}function oe(e,t,n){const r=e[t];return r?((r.list.f&&r.list.f.length?r.list.f:r.list.i)||[]).map((e=>"number"==typeof e?e:parseInt(e,10))):n}function ie(e,t,n,r=!1){const s=e[t];return s&&s.list&&s.list.s?s.list.s.map((e=>Q(e,r))):n}function ue(e,t,n){const r=e[t];return r&&r.list&&r.list.shape?r.list.shape.map((e=>se(e))):n}function pe(e,t,n){const r=e[t];return r&&r.list&&r.list.b?r.list.b:n}class le{constructor(e,t,n){this.node=e,this.tensorMap=t,this.context=n,this.inputs=[],this.attrs={},this.inputs=e.inputNames.map((e=>this.getInput(e))),null!=e.rawAttrs&&(this.attrs=Object.keys(e.rawAttrs).reduce(((e,t)=>(e[t]=this.getAttr(t),e)),{}))}getInput(e){return v(e,this.tensorMap,this.context)}getAttr(e,t){const n=this.node.rawAttrs[e];if(null!=n.tensor)return v(e,this.tensorMap,this.context);if(null!=n.i||null!=n.f)return J(this.node.rawAttrs,e,t);if(null!=n.s)return Y(this.node.rawAttrs,e,t);if(null!=n.b)return X(this.node.rawAttrs,e,t);if(null!=n.shape)return ae(this.node.rawAttrs,e,t);if(null!=n.type)return ne(this.node.rawAttrs,e,t);if(null!=n.list){if(null!=n.list.i||null!=n.list.f)return oe(this.node.rawAttrs,e,t);if(null!=n.list.s)return ie(this.node.rawAttrs,e,t);if(null!=n.list.shape)return ue(this.node.rawAttrs,e,t);if(null!=n.list.b)return pe(this.node.rawAttrs,e,t);if(null!=n.list.type)return re(this.node.rawAttrs,e,t)}return t}}function ce(e){throw new Error(`'${e}' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen`)}function he(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function de(e,t,n=""){he(ye(e,t),(()=>n+` Shapes ${e} and ${t} must match`))}function me(e){he(null!=e,(()=>"The input to the tensor constructor must be a non-null value."))}function fe(e){if(0===e.length)return 1;let t=e[0];for(let n=1;n<e.length;n++)t*=e[n];return t}function ye(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function ge(e){return e%1==0}function be(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function xe(e,t){const n=t.length;return he((e=null==e?t.map(((e,t)=>t)):[].concat(e)).every((e=>e>=-n&&e<n)),(()=>`All values in axis param must be in range [-${n}, ${n}) but got axis ${e}`)),he(e.every((e=>ge(e))),(()=>`All values in axis param must be integers but got axis ${e}`)),e.map((e=>e<0?n+e:e))}function Ne(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error(`Unknown dtype ${e}`)}function we(e){return"string"==typeof e||e instanceof String}function ke(e){return Array.isArray(e)?ke(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray?"int32":"number"==typeof e?"float32":we(e)?"string":function(e){return"boolean"==typeof e}(e)?"bool":"float32"}function Te(e){return!!(e&&e.constructor&&e.call&&e.apply)}function ve(e){const t=e.length;if(t<2)return[];const n=new Array(t-1);n[t-2]=e[t-1];for(let r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function _e(e,t,n,r=!1){const s=new Array;if(1===t.length){const a=t[0]*(r?2:1);for(let t=0;t<a;t++)s[t]=n[e+t]}else{const a=t[0],o=t.slice(1),i=o.reduce(((e,t)=>e*t))*(r?2:1);for(let t=0;t<a;t++)s[t]=_e(e+t*i,o,n,r)}return s}function Se(e,t,n=!1){if(0===e.length)return t[0];const r=e.reduce(((e,t)=>e*t))*(n?2:1);if(0===r)return[];if(r!==t.length)throw new Error(`[${e}] does not match the input size ${t.length}${n?" for a complex tensor":""}.`);return _e(0,e,t,n)}function Ee(e,t){const n=Ie(e,t);for(let e=0;e<n.length;e++)n[e]=1;return n}function Ie(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error(`Unknown data type ${t}`)}function $e(e){e.forEach((t=>{he(Number.isInteger(t)&&t>=0,(()=>`Tensor must have a shape comprised of positive integers but got shape [${e}].`))}))}function De(e){return e&&e.then&&"function"==typeof e.then}class Ae{constructor(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=Oe,this.populateURLFlags()}setPlatform(e,t){null!=this.platform&&(Me().getBool("IS_TEST")||Me().getBool("PROD")||console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${e}.`)),this.platformName=e,this.platform=t}registerFlag(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){const t=this.urlFlags[e];Me().getBool("IS_TEST")||Me().getBool("PROD")||console.warn(`Setting feature override from URL ${e}: ${t}.`),this.set(e,t)}}async getAsync(e){return e in this.flags||(this.flags[e]=await this.evaluateFlag(e)),this.flags[e]}get(e){if(e in this.flags)return this.flags[e];const t=this.evaluateFlag(e);if(De(t))throw new Error(`Flag ${e} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[e]=t,this.flags[e]}getNumber(e){return this.get(e)}getBool(e){return this.get(e)}getFlags(){return this.flags}get features(){return this.flags}set(e,t){if(null==this.flagRegistry[e])throw new Error(`Cannot set flag ${e} as it has not been registered.`);this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)}evaluateFlag(e){if(null==this.flagRegistry[e])throw new Error(`Cannot evaluate flag '${e}': no evaluation function found.`);return this.flagRegistry[e].evaluationFn()}setFlags(e){this.flags=Object.assign({},e)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if("undefined"==typeof this.global||"undefined"==typeof this.global.location||"undefined"==typeof this.global.location.search)return;const e=this.getQueryParams(this.global.location.search);if("tfjsflags"in e){e.tfjsflags.split(",").forEach((e=>{const[t,n]=e.split(":");this.urlFlags[t]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if(""+ +t===t)return+t;throw new Error(`Could not parse value flag value ${t} for flag ${e}.`)}(t,n)}))}}}function Oe(e){const t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,((e,...n)=>(function(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}(t,n[0],n[1]),n.join("=")))),t}function Me(){return Fe}let Ce,Fe=null;function Re(){if(null==Ce){let e;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}Ce=e}return Ce}function ze(e,t){const n=function(){const e=Re();return null==e._tfGlobals&&(e._tfGlobals=new Map),e._tfGlobals}();if(n.has(e))return n.get(e);{const r=t();return n.set(e,r),n.get(e)}}function Ve(...e){Me().getBool("IS_TEST")||Me().getBool("PROD")||console.warn(...e)}const Le=ze("kernelRegistry",(()=>new Map)),Be=ze("gradRegistry",(()=>new Map));function Pe(e,t){const n=function(e,t){return`${t}_${e}`}(e,t);return Le.get(n)}function Ke(e){return Be.get(e)}function qe(e){const t=Le.entries(),n=[];for(;;){const{done:r,value:s}=t.next();if(r)break;const[a,o]=s,[i]=a.split("_");i===e&&n.push(o)}return n}var Ue=je,We=null;try{We=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(e){}function je(e,t,n){this.low=0|e,this.high=0|t,this.unsigned=!!n}function He(e){return!0===(e&&e.__isLong__)}je.prototype.__isLong__,Object.defineProperty(je.prototype,"__isLong__",{value:!0}),je.isLong=He;var Ge={},Ze={};function Qe(e,t){var n,r,s;return t?(s=0<=(e>>>=0)&&e<256)&&(r=Ze[e])?r:(n=Xe(e,(0|e)<0?-1:0,!0),s&&(Ze[e]=n),n):(s=-128<=(e|=0)&&e<128)&&(r=Ge[e])?r:(n=Xe(e,e<0?-1:0,!1),s&&(Ge[e]=n),n)}function Ye(e,t){if(isNaN(e))return t?it:ot;if(t){if(e<0)return it;if(e>=rt)return ht}else{if(e<=-st)return dt;if(e+1>=st)return ct}return e<0?Ye(-e,t).neg():Xe(e%nt|0,e/nt|0,t)}function Xe(e,t,n){return new je(e,t,n)}je.fromInt=Qe,je.fromNumber=Ye,je.fromBits=Xe;var Je=Math.pow;function et(e,t,n){if(0===e.length)throw Error("empty string");if("NaN"===e||"Infinity"===e||"+Infinity"===e||"-Infinity"===e)return ot;if("number"==typeof t?(n=t,t=!1):t=!!t,(n=n||10)<2||36<n)throw RangeError("radix");var r;if((r=e.indexOf("-"))>0)throw Error("interior hyphen");if(0===r)return et(e.substring(1),t,n).neg();for(var s=Ye(Je(n,8)),a=ot,o=0;o<e.length;o+=8){var i=Math.min(8,e.length-o),u=parseInt(e.substring(o,o+i),n);if(i<8){var p=Ye(Je(n,i));a=a.mul(p).add(Ye(u))}else a=(a=a.mul(s)).add(Ye(u))}return a.unsigned=t,a}function tt(e,t){return"number"==typeof e?Ye(e,t):"string"==typeof e?et(e,t):Xe(e.low,e.high,"boolean"==typeof t?t:e.unsigned)}je.fromString=et,je.fromValue=tt;var nt=4294967296,rt=nt*nt,st=rt/2,at=Qe(1<<24),ot=Qe(0);je.ZERO=ot;var it=Qe(0,!0);je.UZERO=it;var ut=Qe(1);je.ONE=ut;var pt=Qe(1,!0);je.UONE=pt;var lt=Qe(-1);je.NEG_ONE=lt;var ct=Xe(-1,2147483647,!1);je.MAX_VALUE=ct;var ht=Xe(-1,-1,!0);je.MAX_UNSIGNED_VALUE=ht;var dt=Xe(0,-2147483648,!1);je.MIN_VALUE=dt;var mt=je.prototype;mt.toInt=function(){return this.unsigned?this.low>>>0:this.low},mt.toNumber=function(){return this.unsigned?(this.high>>>0)*nt+(this.low>>>0):this.high*nt+(this.low>>>0)},mt.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(dt)){var t=Ye(e),n=this.div(t),r=n.mul(t).sub(this);return n.toString(e)+r.toInt().toString(e)}return"-"+this.neg().toString(e)}for(var s=Ye(Je(e,6),this.unsigned),a=this,o="";;){var i=a.div(s),u=(a.sub(i.mul(s)).toInt()>>>0).toString(e);if((a=i).isZero())return u+o;for(;u.length<6;)u="0"+u;o=""+u+o}},mt.getHighBits=function(){return this.high},mt.getHighBitsUnsigned=function(){return this.high>>>0},mt.getLowBits=function(){return this.low},mt.getLowBitsUnsigned=function(){return this.low>>>0},mt.getNumBitsAbs=function(){if(this.isNegative())return this.eq(dt)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;t>0&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},mt.isZero=function(){return 0===this.high&&0===this.low},mt.eqz=mt.isZero,mt.isNegative=function(){return!this.unsigned&&this.high<0},mt.isPositive=function(){return this.unsigned||this.high>=0},mt.isOdd=function(){return 1==(1&this.low)},mt.isEven=function(){return 0==(1&this.low)},mt.equals=function(e){return He(e)||(e=tt(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&(this.high===e.high&&this.low===e.low)},mt.eq=mt.equals,mt.notEquals=function(e){return!this.eq(e)},mt.neq=mt.notEquals,mt.ne=mt.notEquals,mt.lessThan=function(e){return this.comp(e)<0},mt.lt=mt.lessThan,mt.lessThanOrEqual=function(e){return this.comp(e)<=0},mt.lte=mt.lessThanOrEqual,mt.le=mt.lessThanOrEqual,mt.greaterThan=function(e){return this.comp(e)>0},mt.gt=mt.greaterThan,mt.greaterThanOrEqual=function(e){return this.comp(e)>=0},mt.gte=mt.greaterThanOrEqual,mt.ge=mt.greaterThanOrEqual,mt.compare=function(e){if(He(e)||(e=tt(e)),this.eq(e))return 0;var t=this.isNegative(),n=e.isNegative();return t&&!n?-1:!t&&n?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},mt.comp=mt.compare,mt.negate=function(){return!this.unsigned&&this.eq(dt)?dt:this.not().add(ut)},mt.neg=mt.negate,mt.add=function(e){He(e)||(e=tt(e));var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,s=65535&this.low,a=e.high>>>16,o=65535&e.high,i=e.low>>>16,u=0,p=0,l=0,c=0;return l+=(c+=s+(65535&e.low))>>>16,p+=(l+=r+i)>>>16,u+=(p+=n+o)>>>16,u+=t+a,Xe((l&=65535)<<16|(c&=65535),(u&=65535)<<16|(p&=65535),this.unsigned)},mt.subtract=function(e){return He(e)||(e=tt(e)),this.add(e.neg())},mt.sub=mt.subtract,mt.multiply=function(e){if(this.isZero())return ot;if(He(e)||(e=tt(e)),We)return Xe(We.mul(this.low,this.high,e.low,e.high),We.get_high(),this.unsigned);if(e.isZero())return ot;if(this.eq(dt))return e.isOdd()?dt:ot;if(e.eq(dt))return this.isOdd()?dt:ot;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(at)&&e.lt(at))return Ye(this.toNumber()*e.toNumber(),this.unsigned);var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,s=65535&this.low,a=e.high>>>16,o=65535&e.high,i=e.low>>>16,u=65535&e.low,p=0,l=0,c=0,h=0;return c+=(h+=s*u)>>>16,l+=(c+=r*u)>>>16,c&=65535,l+=(c+=s*i)>>>16,p+=(l+=n*u)>>>16,l&=65535,p+=(l+=r*i)>>>16,l&=65535,p+=(l+=s*o)>>>16,p+=t*u+n*i+r*o+s*a,Xe((c&=65535)<<16|(h&=65535),(p&=65535)<<16|(l&=65535),this.unsigned)},mt.mul=mt.multiply,mt.divide=function(e){if(He(e)||(e=tt(e)),e.isZero())throw Error("division by zero");var t,n,r;if(We)return this.unsigned||-2147483648!==this.high||-1!==e.low||-1!==e.high?Xe((this.unsigned?We.div_u:We.div_s)(this.low,this.high,e.low,e.high),We.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?it:ot;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return it;if(e.gt(this.shru(1)))return pt;r=it}else{if(this.eq(dt))return e.eq(ut)||e.eq(lt)?dt:e.eq(dt)?ut:(t=this.shr(1).div(e).shl(1)).eq(ot)?e.isNegative()?ut:lt:(n=this.sub(e.mul(t)),r=t.add(n.div(e)));if(e.eq(dt))return this.unsigned?it:ot;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();r=ot}for(n=this;n.gte(e);){t=Math.max(1,Math.floor(n.toNumber()/e.toNumber()));for(var s=Math.ceil(Math.log(t)/Math.LN2),a=s<=48?1:Je(2,s-48),o=Ye(t),i=o.mul(e);i.isNegative()||i.gt(n);)i=(o=Ye(t-=a,this.unsigned)).mul(e);o.isZero()&&(o=ut),r=r.add(o),n=n.sub(i)}return r},mt.div=mt.divide,mt.modulo=function(e){return He(e)||(e=tt(e)),We?Xe((this.unsigned?We.rem_u:We.rem_s)(this.low,this.high,e.low,e.high),We.get_high(),this.unsigned):this.sub(this.div(e).mul(e))},mt.mod=mt.modulo,mt.rem=mt.modulo,mt.not=function(){return Xe(~this.low,~this.high,this.unsigned)},mt.and=function(e){return He(e)||(e=tt(e)),Xe(this.low&e.low,this.high&e.high,this.unsigned)},mt.or=function(e){return He(e)||(e=tt(e)),Xe(this.low|e.low,this.high|e.high,this.unsigned)},mt.xor=function(e){return He(e)||(e=tt(e)),Xe(this.low^e.low,this.high^e.high,this.unsigned)},mt.shiftLeft=function(e){return He(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?Xe(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):Xe(0,this.low<<e-32,this.unsigned)},mt.shl=mt.shiftLeft,mt.shiftRight=function(e){return He(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?Xe(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):Xe(this.high>>e-32,this.high>=0?0:-1,this.unsigned)},mt.shr=mt.shiftRight,mt.shiftRightUnsigned=function(e){if(He(e)&&(e=e.toInt()),0===(e&=63))return this;var t=this.high;return e<32?Xe(this.low>>>e|t<<32-e,t>>>e,this.unsigned):Xe(32===e?t:t>>>e-32,0,this.unsigned)},mt.shru=mt.shiftRightUnsigned,mt.shr_u=mt.shiftRightUnsigned,mt.toSigned=function(){return this.unsigned?Xe(this.low,this.high,!1):this},mt.toUnsigned=function(){return this.unsigned?this:Xe(this.low,this.high,!0)},mt.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},mt.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},mt.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},je.fromBytes=function(e,t,n){return n?je.fromBytesLE(e,t):je.fromBytesBE(e,t)},je.fromBytesLE=function(e,t){return new je(e[0]|e[1]<<8|e[2]<<16|e[3]<<24,e[4]|e[5]<<8|e[6]<<16|e[7]<<24,t)},je.fromBytesBE=function(e,t){return new je(e[4]<<24|e[5]<<16|e[6]<<8|e[7],e[0]<<24|e[1]<<16|e[2]<<8|e[3],t)};const ft=Ue||y({__proto__:null,default:Ue},[Ue]);function yt(e){return ft.fromString(e,!0,16)}function gt(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=wt(e)),Me().getBool("DEBUG")&&function(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(isNaN(r)||!isFinite(r))throw Error(`A tensor of type ${t} being uploaded contains ${r}.`)}}(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){const t=new Uint8Array(e.length);for(let n=0;n<t.length;++n)0!==Math.round(e[n])&&(t[n]=1);return t}throw new Error(`Unknown data type ${t}`)}function bt(){return Me().platform.now()}function xt(e,t="utf-8"){return t=t||"utf-8",Me().platform.decode(e,t)}function Nt(e){return Me().platform.isTypedArray(e)}function wt(e,t=[],n=!1){if(null==t&&(t=[]),"boolean"==typeof e||"number"==typeof e||"string"==typeof e||De(e)||null==e||Nt(e)&&n)t.push(e);else if(Array.isArray(e)||Nt(e))for(let r=0;r<e.length;++r)wt(e[r],t,n);else{let r=-1;for(const t of Object.keys(e))/^([1-9]+[0-9]*|0)$/.test(t)&&(r=Math.max(r,Number(t)));for(let s=0;s<=r;s++)wt(e[s],t,n)}return t}yt("c3a5c85c97cb3127"),yt("b492b66fbe98f273"),yt("9ae16a3b2f90404f");class kt{constructor(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new vt)}profileKernel(e,t,n){let r;const s=()=>{r=n()};let a;const o=bt();if(this.backendTimer.timerAvailable())a=this.backendTimer.time(s);else{s();for(const e of r)e.dataSync();a=Promise.resolve({kernelMs:bt()-o})}if(Me().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(let t=0;t<r.length;t++){const n=r[t];n.data().then((t=>{Tt(t,n.dtype,e)}))}return{kernelName:e,outputs:r,inputs:t,timeMs:a.then((e=>e.kernelMs)),extraInfo:a.then((e=>null!=e.getExtraProfileInfo?e.getExtraProfileInfo():""))}}logKernelProfile(e){const{kernelName:t,outputs:n,timeMs:r,inputs:s,extraInfo:a}=e;n.forEach((e=>{Promise.all([e.data(),r,a]).then((n=>{this.logger.logKernelProfile(t,e,n[0],n[1],s,n[2])}))}))}}function Tt(e,t,n){if("float32"!==t)return!1;for(let t=0;t<e.length;t++){const r=e[t];if(isNaN(r)||!isFinite(r))return console.warn(`Found ${r} in the result of '${n}'`),!0}return!1}class vt{logKernelProfile(e,t,n,r,s,a){const o="number"==typeof r?be(`${r}ms`,9):r.error,i=be(e,25),u=t.rank,p=t.size,l=be(t.shape.toString(),14);let c="";for(const e in s){const n=s[e];if(null!=n){const r=n.shape||t.shape,s=r.length;c+=`${e}: ${s}D ${s>0?r:""} `}}console.log(`%c${i}\t%c${o}\t%c${u}D ${l}\t%c${p}\t%c${c}\t%c${a}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function _t(e,t,n,r){const s=ve(t),a=function(e,t,n,r){const s=fe(t),a=r[r.length-1],o=new Array(a).fill(0),i=t.length,u="complex64"===n?$t(e):e;if(i>1)for(let e=0;e<s/a;e++){const t=e*a;for(let e=0;e<a;e++)o[e]=Math.max(o[e],St(u[t+e],0,n).length)}return o}(e,t,n,s),o=t.length,i=It(e,t,n,s,a),u=["Tensor"];return r&&(u.push(`  dtype: ${n}`),u.push(`  rank: ${o}`),u.push(`  shape: [${t}]`),u.push("  values:")),u.push(i.map((e=>"    "+e)).join("\n")),u.join("\n")}function St(e,t,n){let r;return r=Array.isArray(e)?`${parseFloat(e[0].toFixed(7))} + ${parseFloat(e[1].toFixed(7))}j`:we(e)?`'${e}'`:"bool"===n?Et(e):parseFloat(e.toFixed(7)).toString(),be(r,t)}function Et(e){return 0===e?"false":"true"}function It(e,t,n,r,s,a=!0){const o="complex64"===n?2:1,i=t[0],u=t.length;if(0===u){if("complex64"===n){return[St($t(e)[0],0,n)]}return"bool"===n?[Et(e[0])]:[e[0].toString()]}if(1===u){if(i>20){const t=3*o;let r=Array.from(e.slice(0,t)),a=Array.from(e.slice((i-3)*o,i*o));return"complex64"===n&&(r=$t(r),a=$t(a)),["["+r.map(((e,t)=>St(e,s[t],n))).join(", ")+", ..., "+a.map(((e,t)=>St(e,s[i-3+t],n))).join(", ")+"]"]}return["["+("complex64"===n?$t(e):Array.from(e)).map(((e,t)=>St(e,s[t],n))).join(", ")+"]"]}const p=t.slice(1),l=r.slice(1),c=r[0]*o,h=[];if(i>20){for(let t=0;t<3;t++){const r=t*c,a=r+c;h.push(...It(e.slice(r,a),p,n,l,s,!1))}h.push("...");for(let t=i-3;t<i;t++){const r=t*c,a=r+c;h.push(...It(e.slice(r,a),p,n,l,s,t===i-1))}}else for(let t=0;t<i;t++){const r=t*c,a=r+c;h.push(...It(e.slice(r,a),p,n,l,s,t===i-1))}const d=2===u?",":"";h[0]="["+(i>0?h[0]+d:"");for(let e=1;e<h.length-1;e++)h[e]=" "+h[e]+d;let m=",\n";for(let e=2;e<u;e++)m+="\n";return h[h.length-1]=" "+h[h.length-1]+"]"+(a?"":m),h}function $t(e){const t=[];for(let n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}class Dt{constructor(e,t,n){if(this.dtype=t,this.shape=e.slice(),this.size=fe(e),null!=n){const e=n.length;he(e===this.size,(()=>`Length of values '${e}' does not match the size inferred by the shape '${this.size}'.`))}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||function(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error(`Unknown data type ${e}`);n=new Array(t)}return n}(t,this.size),this.strides=ve(e)}set(e,...t){0===t.length&&(t=[0]),he(t.length===this.rank,(()=>`The number of provided coordinates (${t.length}) must match the rank (${this.rank})`));const n=this.locToIndex(t);this.values[n]=e}get(...e){0===e.length&&(e=[0]);let t=0;for(const n of e){if(n<0||n>=this.shape[t]){const t=`Requested out of range element at ${e}.   Buffer shape=${this.shape}`;throw new Error(t)}t++}let n=e[e.length-1];for(let t=0;t<e.length-1;++t)n+=this.strides[t]*e[t];return this.values[n]}locToIndex(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];let t=e[e.length-1];for(let n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t}indexToLoc(e){if(0===this.rank)return[];if(1===this.rank)return[e];const t=new Array(this.shape.length);for(let n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t}get rank(){return this.shape.length}toTensor(){return At().makeTensor(this.values,this.shape,this.dtype)}}let At=null;class Ot{constructor(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=fe(e),this.strides=ve(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const e=await this.data();return null.buffer(this.shape,this.dtype,e)}bufferSync(){return null.buffer(this.shape,this.dtype,this.dataSync())}async array(){const e=await this.data();return Se(this.shape,e,"complex64"===this.dtype)}arraySync(){return Se(this.shape,this.dataSync(),"complex64"===this.dtype)}async data(){this.throwIfDisposed();const e=At().read(this.dataId);if("string"===this.dtype){const t=await e;try{return t.map((e=>xt(e)))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return e}dataToGPU(e){return this.throwIfDisposed(),At().readToGPU(this.dataId,e)}dataSync(){this.throwIfDisposed();const e=At().readSync(this.dataId);if("string"===this.dtype)try{return e.map((e=>xt(e)))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e}async bytes(){this.throwIfDisposed();const e=await At().read(this.dataId);return"string"===this.dtype?e:new Uint8Array(e.buffer)}dispose(){this.isDisposed||(At().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(e=!1){return null.print(this,e)}clone(){return this.throwIfDisposed(),null.clone(this)}toString(e=!1){return _t(this.dataSync(),this.shape,this.dtype,e)}cast(e){return this.throwIfDisposed(),null.cast(this,e)}variable(e=!0,t,n){return this.throwIfDisposed(),At().makeVariable(this,e,t,n)}}Object.defineProperty(Ot,Symbol.hasInstance,{value:e=>!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed}),ze("Tensor",(()=>Ot));class Mt extends Ot{constructor(e,t,n,r){super(e.shape,e.dtype,e.dataId,r),this.trainable=t,this.name=n}assign(e){if(e.dtype!==this.dtype)throw new Error(`dtype of the new value (${e.dtype}) and previous value (${this.dtype}) must match`);if(!ye(e.shape,this.shape))throw new Error(`shape of the new value (${e.shape}) and previous value (${this.shape}) must match`);At().disposeTensor(this),this.dataId=e.dataId,At().incRef(this,null)}dispose(){At().disposeVariable(this),this.isDisposedInternal=!0}}var Ct,Ft,Rt,zt,Vt;Object.defineProperty(Mt,Symbol.hasInstance,{value:e=>e instanceof Ot&&null!=e.assign&&e.assign instanceof Function}),function(e){e.R0="R0",e.R1="R1",e.R2="R2",e.R3="R3",e.R4="R4",e.R5="R5",e.R6="R6"}(Ct||(Ct={})),function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(Ft||(Ft={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(Rt||(Rt={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(zt||(zt={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(Vt||(Vt={}));const Lt={float32:zt,int32:Ft,bool:Rt,complex64:Vt};function Bt(e,t){if(e.dtype===t.dtype)return[e,t];const n=function(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error(`Can not upcast ${e} with ${t}`)}return Lt[e][t]}(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function Pt(e){const t=[];return Kt(e,t,new Set),t}function Kt(e,t,n){if(null==e)return;if(e instanceof Ot)return void t.push(e);if(r=e,!Array.isArray(r)&&"object"!=typeof r)return;var r;const s=e;for(const e in s){const r=s[e];n.has(r)||(n.add(r),Kt(r,t,n))}}function qt(e){return null!=e.kernelName}class Ut{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map((e=>e.name))))}}}dispose(){for(const e in this.registeredVariables)this.registeredVariables[e].dispose()}}class Wt{constructor(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Ut}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then((()=>{}));if(null!=this.backendInstance)return;const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:e,asyncInit:t}=this.initializeBackendsAndReturnBest();if(t)throw new Error(`The highest priority backend '${e}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(e)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;{const{asyncInit:t}=this.initializeBackend(e);if(t)return null}}return this.registry[e]}findBackendFactory(e){return e in this.registryFactory?this.registryFactory[e].factory:null}registerBackend(e,t,n=1){return e in this.registryFactory?(Ve(`${e} backend was already registered. Reusing existing backend factory.`),!1):(this.registryFactory[e]={factory:t,priority:n},!0)}async setBackend(e){if(null==this.registryFactory[e])throw new Error(`Backend name '${e}' not found in registry`);if(this.backendName=e,null==this.registry[e]){this.backendInstance=null;const{success:t,asyncInit:n}=this.initializeBackend(e);if(!(n?await t:t))return!1}return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new kt(this.backendInstance),!0}setupRegisteredKernels(){qe(this.backendName).forEach((e=>{null!=e.setupFunc&&e.setupFunc(this.backendInstance)}))}disposeRegisteredKernels(e){qe(e).forEach((t=>{null!=t.disposeFunc&&t.disposeFunc(this.registry[e])}))}initializeBackend(e){const t=this.registryFactory[e];if(null==t)throw new Error(`Cannot initialize backend ${e}, no registration found.`);try{const n=t.factory();if(!n||n instanceof class{refCount(e){return ce("refCount")}incRef(e){return ce("incRef")}timerAvailable(){return!0}time(e){return ce("time")}read(e){return ce("read")}readSync(e){return ce("readSync")}readToGPU(e,t){return ce("readToGPU")}numDataIds(){return ce("numDataIds")}disposeData(e,t){return ce("disposeData")}write(e,t,n){return ce("write")}move(e,t,n,r,s){return ce("move")}createTensorFromGPUData(e,t,n){return ce("createTensorFromGPUData")}memory(){return ce("memory")}floatPrecision(){return ce("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}dispose(){return ce("dispose")}}||"function"!=typeof n.then)return this.registry[e]=n,{success:!0,asyncInit:!1};{const t=++this.pendingBackendInitId,r=n.then((n=>!(t<this.pendingBackendInitId)&&(this.registry[e]=n,this.pendingBackendInit=null,!0))).catch((n=>(t<this.pendingBackendInitId||(this.pendingBackendInit=null,Ve(`Initialization of backend ${e} failed`),Ve(n.stack||n.message)),!1)));return this.pendingBackendInit=r,{success:r,asyncInit:!0}}}catch(t){return Ve(`Initialization of backend ${e} failed`),Ve(t.stack||t.message),{success:!1,asyncInit:!1}}}removeBackend(e){if(!(e in this.registryFactory))throw new Error(`${e} backend not found in registry`);this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort(((e,t)=>this.registryFactory[t].priority-this.registryFactory[e].priority))}initializeBackendsAndReturnBest(){const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t],{success:r,asyncInit:s}=this.initializeBackend(n);if(s||r)return{name:n,asyncInit:s}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(e,t){const n=this.state.tensorInfo.get(t),r=n.backend,s=this.readSync(t),a=r.refCount(t);r.disposeData(t,!0),n.backend=e,e.move(t,s,n.shape,n.dtype,a),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(e,t){let n,r=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");r=e}return this.scopedRun((()=>this.startScope(r)),(()=>this.endScope(n)),(()=>(n=t(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n)))}scopedRun(e,t,n){e();try{const e=n();return t(),e}catch(e){throw t(),e}}nextTensorId(){return Wt.nextTensorId++}nextVariableId(){return Wt.nextVariableId++}clone(e){const t=jt.runKernel("Identity",{x:e}),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],(e=>({x:()=>{const t={x:e},n={dtype:"float32"};return jt.runKernel("Cast",t,n)}})),[],{}),t}runKernel(e,t,n){null==this.backendName&&this.backend;if(!(null!=Pe(e,this.backendName)))throw new Error(`Kernel '${e}' not registered for backend '${this.backendName}'`);return this.runKernelFunc({kernelName:e,inputs:t,attrs:n})}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(e,t,n){const r=this.backend.numDataIds();let s=0;n.forEach((e=>{s+="complex64"===e.dtype?3:1}));const a=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],o=r-t-s-a;if(o>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${o} data ids) after running '${e}'`)}runKernelFunc(e){let t,n=[];const r=this.isTapeOn(),s=this.state.numBytes,a=this.state.numTensors;let o,i;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;const u=qt(e)?e.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(qt(e)){const{kernelName:t,inputs:s,attrs:a}=e;null==this.backendName&&this.backend;const u=Pe(t,this.backendName);he(null!=u,(()=>`Cannot find registered kernel '${t}' for backend '${this.backendName}'`)),o=()=>{const e=this.backend.numDataIds();i=u.kernelFunc({inputs:s,attrs:a,backend:this.backend});const o=Array.isArray(i)?i:[i];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(t,e,o);const p=o.map((e=>null!=e.rank?e:this.makeTensorFromTensorInfo(e)));if(r){const e=this.getTensorsForGradient(t,s,p);n=this.saveTensorsForBackwardMode(e)}return p}}else{const{forwardFunc:t}=e,s=e=>{r&&(n=e.map((e=>this.keep(this.clone(e)))))};o=()=>{const e=this.backend.numDataIds();i=this.tidy((()=>t(this.backend,s)));const n=Array.isArray(i)?i:[i];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(u,e,n),n}}const{inputs:p,attrs:l}=e,c=qt(e)?null:e.backwardsFunc;let h;return this.scopedRun((()=>this.state.kernelDepth++),(()=>this.state.kernelDepth--),(()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(h=this.profiler.profileKernel(u,p,(()=>o())),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(h),t=h.outputs):t=o()})),r&&this.addTapeNode(u,p,t,c,n,l),this.state.profiling&&this.state.activeProfile.kernels.push({name:u,bytesAdded:this.state.numBytes-s,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-a,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(p).map((e=>null!=p[e]?p[e].shape:null)),outputShapes:t.map((e=>e.shape)),kernelTimeMs:h.timeMs,extraInfo:h.extraInfo}),Array.isArray(i)?t:t[0]}saveTensorsForBackwardMode(e){const t=e.map((e=>this.keep(this.clone(e))));return t}getTensorsForGradient(e,t,n){const r=Ke(e);if(null!=r){const e=r.inputsToSave||[],s=r.outputsToSave||[];let a;r.saveAllInputs?(he(Array.isArray(t),(()=>"saveAllInputs is true, expected inputs to be an array.")),a=Object.keys(t).map((e=>t[e]))):a=e.map((e=>t[e]));const o=n.filter(((e,t)=>s[t]));return a.concat(o)}return[]}makeTensor(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;let s=e;"string"===n&&we(e[0])&&(s=e.map((e=>function(e,t="utf-8"){return t=t||"utf-8",Me().platform.encode(e,t)}(e))));const a=r.write(s,t,n),o=new Ot(t,n,a,this.nextTensorId());if(this.trackTensor(o,r),"string"===n){const e=this.state.tensorInfo.get(a),t=function(e){if(null==e)return 0;let t=0;return e.forEach((e=>t+=e.length)),t}(s);this.state.numBytes+=t-e.bytes,e.bytes=t}return o}makeTensorFromDataId(e,t,n,r){const s={dataId:e,shape:t,dtype:n=n||"float32"};return this.makeTensorFromTensorInfo(s,r)}makeTensorFromTensorInfo(e,t){const{dataId:n,shape:r,dtype:s}=e,a=new Ot(r,s,n,this.nextTensorId());return this.trackTensor(a,t),a}makeVariable(e,t=!0,n,r){n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));const s=new Mt(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[s.name])throw new Error(`Variable with name ${s.name} was already registered`);return this.state.registeredVariables[s.name]=s,this.incRef(s,this.backend),s}trackTensor(e,t){this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++;let n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*Ne(e.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(e.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n})),e instanceof Mt||this.track(e)}incRef(e,t){this.trackTensor(e,t),this.backend.incRef(e.dataId)}removeDataId(e,t){this.state.tensorInfo.has(e)&&this.state.tensorInfo.get(e).backend===t&&(this.state.tensorInfo.delete(e),this.state.numDataBuffers--)}disposeTensor(e){if(!this.state.tensorInfo.has(e.dataId))return;const t=this.state.tensorInfo.get(e.dataId);if(this.state.numTensors--,"string"===e.dtype&&(this.state.numStringTensors--,this.state.numBytes-=t.bytes),"complex64"!==e.dtype&&"string"!==e.dtype){const t=e.size*Ne(e.dtype);this.state.numBytes-=t}t.backend.disposeData(e.dataId)&&this.removeDataId(e.dataId,t.backend)}disposeVariables(){for(const e in this.state.registeredVariables){const t=this.state.registeredVariables[e];this.disposeVariable(t)}}disposeVariable(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]}memory(){const e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e}async profile(e){this.state.profiling=!0;const t=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await e(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map((e=>e.totalBytesSnapshot))),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const e of this.state.activeProfile.kernels)e.kernelTimeMs=await e.kernelTimeMs,e.extraInfo=await e.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(e,t,n,r,s,a){const o={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:s},i=Ke(e);null!=i&&(r=i.gradFunc),null!=r&&(o.gradient=e=>(e=e.map(((e,t)=>{if(null==e){const e=n[t],r=Ie(e.size,e.dtype);return this.makeTensor(r,e.shape,e.dtype)}return e})),r(e.length>1?e:e[0],s,a))),this.state.activeTape.push(o)}keep(e){return e.kept=!0,e}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(e){const t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t}endScope(e){const t=Pt(e),n=new Set(t.map((e=>e.id)));for(let e=0;e<this.state.activeScope.track.length;e++){const t=this.state.activeScope.track[e];t.kept||n.has(t.id)||t.dispose()}const r=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],t.forEach((e=>{e.kept||e.scopeId!==r.id||this.track(e)}))}gradients(e,t,n,r=!1){if(he(t.length>0,(()=>"gradients() received an empty list of xs.")),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const s=this.scopedRun((()=>this.startTape()),(()=>this.endTape()),(()=>this.tidy("forward",e)));he(s instanceof Ot,(()=>"The result y returned by f() must be a tensor."));const a=function(e,t,n){const r={},s={};for(let e=0;e<t.length;e++)r[t[e].id]=!0;for(let n=0;n<e.length;n++){const a=e[n],o=a.inputs;for(const e in o){const n=o[e];let i=!1;for(let e=0;e<t.length;e++)if(r[n.id]){a.outputs.forEach((e=>r[e.id]=!0)),i=!0,s[a.id]=!0;break}if(i)break}}const a={};a[n.id]=!0;const o={};for(let t=e.length-1;t>=0;t--){const n=e[t],r=n.inputs;for(let e=0;e<n.outputs.length;e++)if(a[n.outputs[e].id]){for(const e in r)a[r[e].id]=!0,o[n.id]=!0;break}}const i=[];for(let t=0;t<e.length;t++){const n=e[t];if(s[n.id]&&o[n.id]){const e={};for(const t in n.inputs){const s=n.inputs[t];r[s.id]&&(e[t]=s)}const t=Object.assign({},n);t.inputs=e,t.outputs=n.outputs,i.push(t)}}return i}(this.state.activeTape,t,s);if(!r&&0===a.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(()=>{const e={};e[s.id]=null==n?function(e){const t=Ee(fe(e),"float32");return jt.makeTensor(t,e,"float32")}(s.shape):n,function(e,t,n,r){for(let s=t.length-1;s>=0;s--){const a=t[s],o=[];if(a.outputs.forEach((t=>{const n=e[t.id];null!=n?o.push(n):o.push(null)})),null==a.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${a.kernelName}.`);const i=a.gradient(o);for(const t in a.inputs){if(!(t in i))throw new Error(`Cannot backprop through input ${t}. Available gradients found: ${Object.keys(i)}.`);const s=n((()=>i[t]()));if("float32"!==s.dtype)throw new Error(`Error in gradient for op ${a.kernelName}. The gradient of input ${t} must have 'float32' dtype, but has '${s.dtype}'`);const o=a.inputs[t];if(!ye(s.shape,o.shape))throw new Error(`Error in gradient for op ${a.kernelName}. The gradient of input '${t}' has shape '${s.shape}', which does not match the shape of the input '${o.shape}'`);if(null==e[o.id])e[o.id]=s;else{const t=e[o.id];e[o.id]=r(t,s),t.dispose()}}}}(e,a,(e=>this.tidy(e)),Ht);const r=t.map((t=>e[t.id]));return 0===this.state.gradientDepth&&(this.state.activeTape.forEach((e=>{for(const t of e.saved)t.dispose()})),this.state.activeTape=null),{value:s,grads:r}}))}customGrad(e){return he(Te(e),(()=>"The f passed in customGrad(f) must be a function.")),(...t)=>{let n;he(t.every((e=>e instanceof Ot)),(()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors"));const r={};t.forEach(((e,t)=>{r[t]=e}));return this.runKernelFunc({forwardFunc:(r,s)=>(n=e(...t,s),he(n.value instanceof Ot,(()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor")),he(Te(n.gradFunc),(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function.")),n.value),backwardsFunc:(e,r)=>{const s=n.gradFunc(e,r),a=Array.isArray(s)?s:[s];he(a.length===t.length,(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...).")),he(a.every((e=>e instanceof Ot)),(()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."));const o={};return a.forEach(((e,t)=>{o[t]=()=>e})),o},inputs:r})}}readSync(e){return this.state.tensorInfo.get(e).backend.readSync(e)}read(e){return this.state.tensorInfo.get(e).backend.read(e)}readToGPU(e,t){return this.state.tensorInfo.get(e).backend.readToGPU(e,t)}async time(e){const t=bt(),n=await this.backend.time(e);return n.wallMs=bt()-t,n}track(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Ut;for(const e in this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}Wt.nextTensorId=0,Wt.nextVariableId=0;const jt=function(){const e=Re();if(null==e._tfengine){const t=new Ae(e);e._tfengine=new Wt(t)}var t;return t=e._tfengine.ENV,Fe=t,At=()=>e._tfengine,e._tfengine}();function Ht(e,t){const n={a:e,b:t};return jt.runKernel("Add",n)}function Gt(e,t){let n=e;if(Nt(e))return"string"===t?[]:[e.length];if("object"==typeof e){if("texture"in e){const t=e.channels||"RGBA";return[e.height,e.width*t.length]}if("buffer"in e&&!(e.buffer instanceof ArrayBuffer))return[e.buffer.size/(null==t?4:Ne(t))]}if(!Array.isArray(e))return[];const r=[];for(;Array.isArray(n)||Nt(n)&&"string"!==t;)r.push(n.length),n=n[0];return Array.isArray(e)&&Me().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&Zt(e,r,[]),r}function Zt(e,t,n){if(n=n||[],!Array.isArray(e)&&!Nt(e))return void he(0===t.length,(()=>`Element arr[${n.join("][")}] is a primitive, but should be an array/TypedArray of ${t[0]} elements`));he(t.length>0,(()=>`Element arr[${n.join("][")}] should be a primitive, but is an array of ${e.length} elements`)),he(e.length===t[0],(()=>`Element arr[${n.join("][")}] should have ${t[0]} elements, but has ${e.length} elements`));const r=t.slice(1);for(let t=0;t<e.length;++t)Zt(e[t],r,n.concat(t))}function Qt(e,t,n,r){if("string_or_numeric"!==e){if(null==e)throw new Error("Expected dtype cannot be null.");if("numeric"!==e&&e!==t||"numeric"===e&&"string"===t)throw new Error(`Argument '${n}' passed to '${r}' must be ${e} tensor, but got ${t} tensor`)}}function Yt(e,t,n,r="numeric"){if(e instanceof Ot)return Qt(r,e.dtype,t,n),e;let s=ke(e);if("string"!==s&&["bool","int32","float32"].indexOf(r)>=0&&(s=r),Qt(r,s,t,n),null==e||!Nt(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){const r=null==e?"null":e.constructor.name;throw new Error(`Argument '${t}' passed to '${n}' must be a Tensor or TensorLike, but got '${r}'`)}const a=Gt(e,s);Nt(e)||Array.isArray(e)||(e=[e]);const o="string"!==s?gt(e,s):wt(e,[],!0);return jt.makeTensor(o,a,s)}function Xt(e,t,n,r="numeric"){if(!Array.isArray(e))throw new Error(`Argument ${t} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return e.map(((e,s)=>Yt(e,`${t}[${s}]`,n,r)))}function Jt(e){const t=Object.keys(e);if(1!==t.length)throw new Error(`Please provide an object with a single key (operation name) mapping to a function. Got an object with ${t.length} keys.`);let n=t[0];const r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+="__op";const s=(...e)=>{jt.startScope(n);try{const t=r(...e);return De(t)&&console.error("Cannot return a Promise inside of tidy."),jt.endScope(t),t}catch(e){throw jt.endScope(null),e}};return Object.defineProperty(s,"name",{value:n,configurable:!0}),s}const en=Jt({abs_:function(e){const t=Yt(e,"x","abs");if("complex64"===t.dtype){const e={x:t};return jt.runKernel("ComplexAbs",e)}{const e={x:t};return jt.runKernel("Abs",e)}}});const tn=Jt({acos_:function(e){const t={x:Yt(e,"x","acos")};return jt.runKernel("Acos",t)}});const nn=Jt({acosh_:function(e){const t={x:Yt(e,"x","acosh")};return jt.runKernel("Acosh",t)}});const rn=Jt({add_:function(e,t){let n=Yt(e,"a","add"),r=Yt(t,"b","add");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("Add",s)}});const sn=Jt({addN_:function(e){he(Array.isArray(e),(()=>"The argument passed to tf.addN() must be a list of tensors")),he(e.length>=1,(()=>`Must pass at least one tensor to tf.addN(), but got ${e.length}`));const t=e.map(((e,t)=>Yt(e,`tensors${t}`,"addN"))),n=t[0];t.forEach((e=>{if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),t.forEach((e=>{if(!ye(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));const r=t;return jt.runKernel("AddN",r)}});const an=Jt({all_:function(e,t=null,n=!1){const r={x:Yt(e,"x","all","bool")},s={axis:t,keepDims:n};return jt.runKernel("All",r,s)}});const on=Jt({any_:function(e,t=null,n=!1){const r={x:Yt(e,"x","any","bool")},s={axis:t,keepDims:n};return jt.runKernel("Any",r,s)}});const un=Jt({argMax_:function(e,t=0){const n={x:Yt(e,"x","argMax")},r={axis:t};return jt.runKernel("ArgMax",n,r)}});const pn=Jt({argMin_:function(e,t=0){const n={x:Yt(e,"x","argMin")},r={axis:t};return jt.runKernel("ArgMin",n,r)}});const ln=Jt({asin_:function(e){const t={x:Yt(e,"x","asin")};return jt.runKernel("Asin",t)}});const cn=Jt({asinh_:function(e){const t={x:Yt(e,"x","asinh")};return jt.runKernel("Asinh",t)}});const hn=Jt({atan_:function(e){const t={x:Yt(e,"x","atan")};return jt.runKernel("Atan",t)}});const dn=Jt({atan2_:function(e,t){let n=Yt(e,"a","atan2"),r=Yt(t,"b","atan2");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("Atan2",s)}});const mn=Jt({atanh_:function(e){const t={x:Yt(e,"x","atanh")};return jt.runKernel("Atanh",t)}});const fn=Jt({cast_:function(e,t){const n=Yt(e,"x","cast");if(!function(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}(t))throw new Error(`Failed to cast to unknown dtype ${t}`);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const r={x:n},s={dtype:t};return jt.runKernel("Cast",r,s)}});function yn(e,t,n,r,s,a,o=!1,i="channelsLast"){let[u,p,l,c]=[-1,-1,-1,-1];if("channelsLast"===i)[u,p,l,c]=e;else{if("channelsFirst"!==i)throw new Error(`Unknown dataFormat ${i}`);[u,c,p,l]=e}const[h,d,,m]=t,[f,y]=gn(n),[g,b]=gn(r),x=bn(h,g),N=bn(d,b),{padInfo:w,outHeight:k,outWidth:T}=function(e,t,n,r,s,a,o,i,u){let p,l,c;if("number"==typeof e){p={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};const s=function(e,t,n,r,s){null==r&&(r=function(e,t,n,r=1){const s=bn(t,r);return Math.floor((e[0]*(n-1)-n+s)/2)}(e,t,n));const a=e[0],o=e[1],i=xn((a-t+2*r)/n+1,s),u=xn((o-t+2*r)/n+1,s);return[i,u]}([t,n],a,r,e,i);l=s[0],c=s[1]}else if("same"===e){l=Math.ceil(t/r),c=Math.ceil(n/s);const e=Math.max(0,(l-1)*r+a-t),i=Math.max(0,(c-1)*s+o-n),u=Math.floor(e/2),h=e-u,d=Math.floor(i/2);p={top:u,bottom:h,left:d,right:i-d,type:"SAME"}}else if("valid"===e)p={top:0,bottom:0,left:0,right:0,type:"VALID"},l=Math.ceil((t-a+1)/r),c=Math.ceil((n-o+1)/s);else{if("object"!=typeof e)throw Error(`Unknown padding parameter: ${e}`);{const h="channelsLast"===u?e[1][0]:e[2][0],d="channelsLast"===u?e[1][1]:e[2][1],m="channelsLast"===u?e[2][0]:e[3][0],f="channelsLast"===u?e[2][1]:e[3][1];p={top:h,bottom:d,left:m,right:f,type:0===h&&0===d&&0===m&&0===f?"VALID":"EXPLICIT"},l=xn((t-a+h+d)/r+1,i),c=xn((n-o+m+f)/s+1,i)}}return{padInfo:p,outHeight:l,outWidth:c}}(s,p,l,f,y,x,N,a,i),v=o?m*c:m;let _;return"channelsFirst"===i?_=[u,v,k,T]:"channelsLast"===i&&(_=[u,k,T,v]),{batchSize:u,dataFormat:i,inHeight:p,inWidth:l,inChannels:c,outHeight:k,outWidth:T,outChannels:v,padInfo:w,strideHeight:f,strideWidth:y,filterHeight:h,filterWidth:d,effectiveFilterHeight:x,effectiveFilterWidth:N,dilationHeight:g,dilationWidth:b,inShape:e,outShape:_,filterShape:t}}function gn(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function bn(e,t){return t<=1?e:e+(e-1)*(t-1)}function xn(e,t){if(!t)return Math.trunc(e);switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error(`Unknown roundingMode ${t}`)}}function Nn(e){const[t,n,r]=gn(e);return 1===t&&1===n&&1===r}function wn(e,t){return Nn(e)||Nn(t)}function kn(e){return gn(e).every((e=>e>0))}function Tn(e,t,n){if(null!=n){if("string"==typeof t)throw Error(`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`);if("number"==typeof t)he(ge(t),(()=>`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`));else{if("object"!=typeof t)throw Error(`Error in ${e}: Unknown padding parameter: ${t}`);t.forEach((t=>{t.forEach((t=>{he(ge(t),(()=>`Error in ${e}: pad must be an integer when using dimRoundingMode ${n} but got pad ${t}.`))}))}))}}}const vn=Jt({reshape_:function(e,t){const n={x:Yt(e,"x","reshape","string_or_numeric")},r={shape:t};return jt.runKernel("Reshape",n,r)}});const _n=Jt({avgPool_:function(e,t,n,r,s){const a=Yt(e,"x","avgPool","float32");he(wn(n,1),(()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`));let o=a,i=!1;3===a.rank&&(i=!0,o=vn(a,[1,a.shape[0],a.shape[1],a.shape[2]])),he(4===o.rank,(()=>`Error in avgPool: x must be rank 4 but got rank ${o.rank}.`)),Tn("avgPool",r,s);const u={x:o},p={filterSize:t,strides:n,pad:r,dimRoundingMode:s};let l=jt.runKernel("AvgPool",u,p);return l=fn(l,a.dtype),i?vn(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});const Sn=Jt({avgPool3d_:function(e,t,n,r,s,a="NDHWC"){const o=Yt(e,"x","avgPool3d","float32");let i=o,u=!1;4===o.rank&&(u=!0,i=vn(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),he(5===i.rank,(()=>`Error in avgPool3d: x must be rank 5 but got rank ${i.rank}.`)),he("NDHWC"===a,(()=>`Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of ${a}`)),he("number"==typeof n&&n>0||Array.isArray(n)&&n[0]>0&&n[1]>0&&n[2]>0,(()=>`Error in avgPool3d: Stride must be > 0, but got '${n}'`)),Tn("avgPool3d",r,s);const p={x:i},l={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:a};let c=jt.runKernel("AvgPool3D",p,l);return c=fn(c,i.dtype),u?vn(c,[c.shape[1],c.shape[2],c.shape[3],c.shape[4]]):c}});const En=Jt({clone_:function(e){const t={x:Yt(e,"x","clone","string_or_numeric")};return jt.runKernel("Identity",t)}});const In=Jt({concat_:function(e,t=0){he(e.length>=1,(()=>"Pass at least one tensor to concat"));const n=Xt(e,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach((e=>{if("complex64"!==e.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${e.dtype}. `)})),1===n.length)return En(n[0]);const r=n,s={axis:t};return jt.runKernel("Concat",r,s)}});const $n=Jt({matMul_:function(e,t,n=!1,r=!1){let s=Yt(e,"a","matMul"),a=Yt(t,"b","matMul");[s,a]=Bt(s,a);const o={a:s,b:a},i={transposeA:n,transposeB:r};return jt.runKernel("BatchMatMul",o,i)}});const Dn=Jt({mul_:function(e,t){let n=Yt(e,"a","mul"),r=Yt(t,"b","mul");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("Multiply",s)}});const An=Jt({sigmoid_:function(e){const t={x:Yt(e,"x","sigmoid","float32")};return jt.runKernel("Sigmoid",t)}});const On=Jt({slice_:function(e,t,n){const r=Yt(e,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");const s={x:r},a={begin:t,size:n};return jt.runKernel("Slice",s,a)}});const Mn=Jt({tanh_:function(e){const t={x:Yt(e,"x","tanh","float32")};return jt.runKernel("Tanh",t)}});const Cn=Jt({basicLSTMCell_:function(e,t,n,r,s,a){const o=Yt(e,"forgetBias","basicLSTMCell"),i=Yt(t,"lstmKernel","basicLSTMCell"),u=Yt(n,"lstmBias","basicLSTMCell"),p=Yt(r,"data","basicLSTMCell"),l=Yt(s,"c","basicLSTMCell"),c=Yt(a,"h","basicLSTMCell"),h=In([p,c],1),d=$n(h,i),m=rn(d,u),f=m.shape[0],y=m.shape[1]/4,g=[f,y],b=On(m,[0,0],g),x=On(m,[0,y],g),N=On(m,[0,2*y],g),w=On(m,[0,3*y],g),k=rn(Dn(An(b),Mn(x)),Dn(l,An(rn(o,N))));return[k,Dn(Mn(k),An(w))]}});const Fn=Jt({batchToSpaceND_:function(e,t,n){const r=Yt(e,"x","batchToSpaceND"),s=t.reduce(((e,t)=>e*t));he(r.rank>=1+t.length,(()=>`input rank is ${r.rank} but should be > than blockShape.length ${t.length}`)),he(n.length===t.length,(()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${t.length}`)),he(r.shape[0]%s==0,(()=>`input tensor batch is ${r.shape[0]} but is not divisible by the product of the elements of blockShape ${t.join(" * ")} === ${s}`));const a={x:r},o={blockShape:t,crops:n};return jt.runKernel("BatchToSpaceND",a,o)}});const Rn=Jt({batchNorm_:function(e,t,n,r,s,a){null==a&&(a=.001);const o=Yt(e,"x","batchNorm"),i=Yt(t,"mean","batchNorm"),u=Yt(n,"variance","batchNorm");let p,l;null!=s&&(p=Yt(s,"scale","batchNorm")),null!=r&&(l=Yt(r,"offset","batchNorm")),he(i.rank===u.rank,(()=>"Batch normalization gradient requires mean and variance to have equal ranks.")),he(null==l||i.rank===l.rank,(()=>"Batch normalization gradient requires mean and offset to have equal ranks.")),he(null==p||i.rank===p.rank,(()=>"Batch normalization gradient requires mean and scale to have equal ranks."));const c=function(e){let t;return t=0===e.rank||1===e.rank?vn(e,[1,1,1,e.size]):2===e.rank?vn(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?vn(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e,t}(o),h={x:c,scale:p,offset:l,mean:i,variance:u},d={varianceEpsilon:a},m=jt.runKernel("FusedBatchNorm",h,d);return vn(m,o.shape)}});const zn=Jt({batchNorm2d_:function(e,t,n,r,s,a){const o=Yt(e,"x","batchNorm"),i=Yt(t,"mean","batchNorm"),u=Yt(n,"variance","batchNorm");let p,l;return null!=s&&(p=Yt(s,"scale","batchNorm")),null!=r&&(l=Yt(r,"offset","batchNorm")),he(2===o.rank,(()=>`Error in batchNorm2D: x must be rank 2 but got rank ${o.rank}.`)),he(2===i.rank||1===i.rank,(()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${i.rank}.`)),he(2===u.rank||1===u.rank,(()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`)),null!=p&&he(2===p.rank||1===p.rank,(()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${p.rank}.`)),null!=l&&he(2===l.rank||1===l.rank,(()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${l.rank}.`)),Rn(o,i,u,l,p,a)}});const Vn=Jt({batchNorm3d_:function(e,t,n,r,s,a){const o=Yt(e,"x","batchNorm"),i=Yt(t,"mean","batchNorm"),u=Yt(n,"variance","batchNorm");let p,l;return null!=s&&(p=Yt(s,"scale","batchNorm")),null!=r&&(l=Yt(r,"offset","batchNorm")),he(3===o.rank,(()=>`Error in batchNorm3D: x must be rank 3 but got rank ${o.rank}.`)),he(3===i.rank||1===i.rank,(()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${i.rank}.`)),he(3===u.rank||1===u.rank,(()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`)),null!=p&&he(3===p.rank||1===p.rank,(()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${p.rank}.`)),null!=l&&he(3===l.rank||1===l.rank,(()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${l.rank}.`)),Rn(o,i,u,l,p,a)}});const Ln=Jt({batchNorm4d_:function(e,t,n,r,s,a){const o=Yt(e,"x","batchNorm"),i=Yt(t,"mean","batchNorm"),u=Yt(n,"variance","batchNorm");let p,l;return null!=s&&(p=Yt(s,"scale","batchNorm")),null!=r&&(l=Yt(r,"offset","batchNorm")),he(4===o.rank,(()=>`Error in batchNorm4D: x must be rank 4 but got rank ${o.rank}.`)),he(4===i.rank||1===i.rank,(()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${i.rank}.`)),he(4===u.rank||1===u.rank,(()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`)),null!=p&&he(4===p.rank||1===p.rank,(()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${p.rank}.`)),null!=l&&he(4===l.rank||1===l.rank,(()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${l.rank}.`)),Rn(o,i,u,l,p,a)}});const Bn=Jt({bincount_:function(e,t,n){const r=Yt(e,"x","bincount"),s=Yt(t,"weights","bincount");he("int32"===r.dtype,(()=>`Error in bincount: input dtype must be int32, but got ${r.dtype}`)),he(n>=0,(()=>`size must be non-negative, but got ${n}.`)),he(s.size===r.size||0===s.size,(()=>`Error in bincount: weights must have the same size as input or0-length, but got input shape: ${r.shape}, weights shape: ${s.shape}.`));const a={x:r,weights:s},o={size:n};return jt.runKernel("Bincount",a,o)}});const Pn=Jt({broadcastArgs_:function(e,t){const n=Yt(e,"s0","broadcastArgs","int32"),r=Yt(t,"s1","broadcastArgs","int32");if(1!==n.rank)throw new Error(`broadcastArgs(): first input must be a vector (rank=1). Has rank ${n.rank}`);if(1!==r.rank)throw new Error(`broadcastArgs(): second input must be a vector (rank=1). Has rank ${r.rank}`);const s={s0:n,s1:r};return jt.runKernel("BroadcastArgs",s)}});const Kn=Jt({broadcastTo_:function(e,t){let n=Yt(e,"broadcastTo","x");const r=n.shape;if($e(t),t.length<n.rank)throw new Error(`broadcastTo(): shape.length=${t.length} < input.rank=${n.rank}.`);if(t.length>n.rank){const e=n.shape.slice();for(;e.length<t.length;)e.unshift(1);n=vn(n,e)}const s=n.shape,a=Array.from(t);for(let e=t.length-1;e>=0;e--)if(s[e]===t[e])a[e]=1;else if(1!==n.shape[e])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${t}].`);if(0===a.map(((e,t)=>e>1?t:-1)).filter((e=>e>=0)).length)return En(n);const o={x:n},i={reps:a};return jt.runKernel("Tile",o,i)}});function qn(e,t="float32",n){return t=t||"float32",$e(e),new Dt(e,t,n)}const Un=Jt({ceil_:function(e){const t={x:Yt(e,"x","ceil","float32")};return jt.runKernel("Ceil",t)}});function Wn(e,t,n){$e(e);const r={shape:e,value:t,dtype:n};return jt.runKernel("Fill",{},r)}const jn=Jt({clipByValue_:function(e,t,n){const r=Yt(e,"x","clipByValue");if(he(t<=n,(()=>`Error in clip: min (${t}) must be less than or equal to max (${n}).`)),t===n)return Wn(r.shape,t,r.dtype);const s={x:r},a={clipValueMin:t,clipValueMax:n};return jt.runKernel("ClipByValue",s,a)}});const Hn=Jt({complex_:function(e,t){const n=Yt(e,"real","complex"),r=Yt(t,"imag","complex");de(n.shape,r.shape,`real and imag shapes, ${n.shape} and ${r.shape}, must match in call to tf.complex().`);const s={real:n,imag:r};return jt.runKernel("Complex",s)}});const Gn=Jt({concat1d_:function(e){return In(e,0)}});const Zn=Jt({concat2d_:function(e,t){return In(e,t)}});const Qn=Jt({concat3d_:function(e,t){return In(e,t)}});const Yn=Jt({concat4d_:function(e,t){return In(e,t)}});const Xn=Jt({conv2d_:function(e,t,n,r,s="NHWC",a=[1,1],o){const i=Yt(e,"x","conv2d","float32"),u=Yt(t,"filter","conv2d","float32");let p=i,l=!1;3===i.rank&&(l=!0,p=vn(i,[1,i.shape[0],i.shape[1],i.shape[2]])),he(4===p.rank,(()=>`Error in conv2d: input must be rank 4, but got rank ${p.rank}.`)),he(4===u.rank,(()=>`Error in conv2d: filter must be rank 4, but got rank ${u.rank}.`)),Tn("conv2d",r,o);const c="NHWC"===s?p.shape[3]:p.shape[1];he(c===u.shape[2],(()=>`Error in conv2d: depth of input (${c}) must match input depth for filter ${u.shape[2]}.`)),he(wn(n,a),(()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`)),he(kn(a),(()=>"Error in conv2D: Dilated rates should be larger than 0.")),he(kn(n),(()=>"Error in conv2D: Strides should be larger than 0."));const h={x:p,filter:u},d={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o},m=jt.runKernel("Conv2D",h,d);return l?vn(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const Jn=Jt({conv1d_:function(e,t,n,r,s="NWC",a=1,o){const i=Yt(e,"x","conv1d"),u=Yt(t,"filter","conv1d");let p=i,l=!1;2===i.rank&&(l=!0,p=vn(i,[1,i.shape[0],i.shape[1]])),he(3===p.rank,(()=>`Error in conv1d: input must be rank 3, but got rank ${p.rank}.`)),he(3===u.rank,(()=>`Error in conv1d: filter must be rank 3, but got rank ${u.rank}.`)),Tn("conv1d",r,o),he(p.shape[2]===u.shape[1],(()=>`Error in conv1d: depth of input (${p.shape[2]}) must match input depth for filter ${u.shape[1]}.`)),he(wn(n,a),(()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${a}'`)),he(kn(a),(()=>"Error in conv1D: Dilated rates should be larger than 0.")),he(kn(n),(()=>"Error in conv1D: Stride should be larger than 0.")),he("NWC"===s,(()=>`Error in conv1d: got dataFormat of ${s} but only NWC is currently supported.`));const c=vn(u,[1,u.shape[0],u.shape[1],u.shape[2]]),h=vn(p,[p.shape[0],1,p.shape[1],p.shape[2]]),d=Xn(h,c,[1,n],r,"NHWC",[1,a],o);return vn(d,l?[d.shape[2],d.shape[3]]:[d.shape[0],d.shape[2],d.shape[3]])}});const er=Jt({conv2DBackpropInput_:function(e,t,n,r,s,a="NHWC",o){he(e.length===t.rank,(()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`));let i=e,u=t,p=!1;3===t.rank&&(p=!0,u=vn(t,[1,t.shape[0],t.shape[1],t.shape[2]]),i=[1,e[0],e[1],e[2]]),he(4===i.length,(()=>`Error in conv2dDerInput: inShape must be length 4, but got length ${i.length}.`)),he(4===u.rank,(()=>`Error in conv2dDerInput: dy must be rank 4, but got rank ${u.rank}`)),he(4===n.rank,(()=>`Error in conv2dDerInput: filter must be rank 4, but got rank ${n.rank}`));const l="NHWC"===a?i[3]:i[1],c="NHWC"===a?u.shape[3]:u.shape[1];he(l===n.shape[2],(()=>`Error in conv2dDerInput: depth of input (${l}) must match input depth for filter ${n.shape[2]}.`)),he(c===n.shape[3],(()=>`Error in conv2dDerInput: depth of output (${c}) must match output depth for filter ${n.shape[3]}.`)),Tn("conv2dDerInput",s,o);const h={dy:u,filter:n},d={strides:r,pad:s,dataFormat:a,dimRoundingMode:o,inputShape:i},m=jt.runKernel("Conv2DBackpropInput",h,d);return p?vn(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const tr=Jt({conv2dTranspose_:function(e,t,n,r,s,a){const o=Yt(e,"x","conv2dTranspose"),i=Yt(t,"filter","conv2dTranspose");return er(n,o,i,r,s,"NHWC",a)}});const nr=Jt({conv3d_:function(e,t,n,r,s="NDHWC",a=[1,1,1]){const o=Yt(e,"x","conv3d"),i=Yt(t,"filter","conv3d");let u=o,p=!1;4===o.rank&&(p=!0,u=vn(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),he(5===u.rank,(()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`)),he(5===i.rank,(()=>`Error in conv3d: filter must be rank 5, but got rank ${i.rank}.`)),he(u.shape[4]===i.shape[3],(()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${i.shape[3]}.`)),he(wn(n,a),(()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`)),he("NDHWC"===s,(()=>`Error in conv3d: got dataFormat of ${s} but only NDHWC is currently supported.`)),he(kn(a),(()=>"Error in conv3D: Dilated rates should be larger than 0.")),he(kn(n),(()=>"Error in conv3D: Strides should be larger than 0."));const l={x:u,filter:i},c={strides:n,pad:r,dataFormat:s,dilations:a},h=jt.runKernel("Conv3D",l,c);return p?vn(h,[h.shape[1],h.shape[2],h.shape[3],h.shape[4]]):h}});const rr=Jt({conv3DBackpropInput_:function(e,t,n,r,s){he(e.length===t.rank,(()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`));let a=e,o=t,i=!1;4===t.rank&&(i=!0,o=vn(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),a=[1,e[0],e[1],e[2],e[3]]);const u=a[4],p=o.shape[4];he(5===a.length,(()=>`Error in conv3dDerInput: inShape must be length 5, but got length ${a.length}.`)),he(5===o.rank,(()=>`Error in conv3dDerInput: dy must be rank 5, but got rank ${o.rank}`)),he(5===n.rank,(()=>`Error in conv3dDerInput: filter must be rank 5, but got rank ${n.rank}`)),he(u===n.shape[3],(()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`)),he(p===n.shape[4],(()=>`Error in conv3dDerInput: depth of output (${p}) must match output depth for filter ${n.shape[4]}.`));const l={dy:o,filter:n},c={pad:s,strides:r,inputShape:a},h=jt.runKernel("Conv3DBackpropInputV2",l,c);return i?vn(h,[h.shape[1],h.shape[2],h.shape[3],h.shape[4]]):h}});const sr=Jt({conv3dTranspose_:function(e,t,n,r,s){const a=Yt(e,"x","conv3dTranspose"),o=Yt(t,"filter","conv3dTranspose");return rr(n,a,o,r,s)}});const ar=Jt({cos_:function(e){const t={x:Yt(e,"x","cos","float32")};return jt.runKernel("Cos",t)}});const or=Jt({cosh_:function(e){const t={x:Yt(e,"x","cosh","float32")};return jt.runKernel("Cosh",t)}});const ir=Jt({cumprod_:function(e,t=0,n=!1,r=!1){const s={x:Yt(e,"x","cumprod")},a={axis:t,exclusive:n,reverse:r};return jt.runKernel("Cumprod",s,a)}});const ur=Jt({cumsum_:function(e,t=0,n=!1,r=!1){const s={x:Yt(e,"x","cumsum")},a={axis:t,exclusive:n,reverse:r};return jt.runKernel("Cumsum",s,a)}});const pr=Jt({denseBincount_:function(e,t,n,r=!1){const s=Yt(e,"x","denseBincount"),a=Yt(t,"weights","denseBincount");he("int32"===s.dtype,(()=>`Error in denseBincount: input dtype must be int32, but got ${s.dtype}`)),he(s.rank<=2,(()=>`Error in denseBincount: input must be at most rank 2, but got rank ${s.rank}.`)),he(n>=0,(()=>`size must be non-negative, but got ${n}.`)),he(a.size===s.size||0===a.size,(()=>`Error in denseBincount: weights must have the same shape as x or 0-length, but got x shape: ${s.shape}, weights shape: ${a.shape}.`));const o={x:s,weights:a},i={size:n,binaryOutput:r};return jt.runKernel("DenseBincount",o,i)}});const lr=Jt({depthToSpace_:function(e,t,n="NHWC"){const r=Yt(e,"x","depthToSpace","float32"),s="NHWC"===n?r.shape[1]:r.shape[2],a="NHWC"===n?r.shape[2]:r.shape[3],o="NHWC"===n?r.shape[3]:r.shape[1];he(t>1,(()=>`blockSize should be > 1 for depthToSpace, but was: ${t}`)),he(s*t>=0,(()=>`Negative dimension size caused by overflow when multiplying\n    ${s} and ${t}  for depthToSpace with input shape\n    ${r.shape}`)),he(a*t>=0,(()=>`Negative dimension size caused by overflow when multiplying\n    ${a} and ${t} for depthToSpace with input shape\n        ${r.shape}`)),he(o%(t*t)==0,(()=>`Dimension size must be evenly divisible by ${t*t} but is ${o} for depthToSpace with input shape ${r.shape}`));const i={x:r},u={blockSize:t,dataFormat:n};return jt.runKernel("DepthToSpace",i,u)}});const cr=Jt({depthwiseConv2d_:function(e,t,n,r,s="NHWC",a=[1,1],o){const i=Yt(e,"x","depthwiseConv2d","float32"),u=Yt(t,"filter","depthwiseConv2d","float32");let p=i,l=!1;3===i.rank&&(l=!0,p=vn(i,[1,i.shape[0],i.shape[1],i.shape[2]])),he(4===p.rank,(()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${p.rank}.`)),he(4===u.rank,(()=>`Error in depthwiseConv2d: filter must be rank 4, but got rank ${u.rank}.`));const c="NHWC"===s?p.shape[3]:p.shape[1];he(c===u.shape[2],(()=>`Error in depthwiseConv2d: number of input channels (${c}) must match the inChannels dimension in filter ${u.shape[2]}.`)),Tn("depthwiseConv2d",r,o);const h={x:p,filter:u},d={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o},m=jt.runKernel("DepthwiseConv2dNative",h,d);return l?vn(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const hr=Jt({diag_:function(e){const t={x:Yt(e,"x","diag")};return jt.runKernel("Diag",t)}});const dr=Jt({dilation2d_:function(e,t,n,r,s=[1,1],a="NHWC"){const o=Yt(e,"x","dilation2d"),i=Yt(t,"filter","dilation2d");he(3===o.rank||4===o.rank,(()=>`Error in dilation2d: input must be rank 3 or 4, but got rank ${o.rank}.`)),he(3===i.rank,(()=>`Error in dilation2d: filter must be rank 3, but got rank ${i.rank}.`)),he("NHWC"===a,(()=>`Error in dilation2d: Only NHWC is currently supported, but got dataFormat of ${a}`));let u=o,p=!1;3===o.rank&&(u=vn(o,[1,o.shape[0],o.shape[1],o.shape[2]]),p=!0),he(u.shape[3]===i.shape[2],(()=>`Error in dilation2d:  input and filter must have the same depth: ${u.shape[3]} vs ${i.shape[2]}`));const l={x:u,filter:i},c={strides:n,pad:r,dilations:s},h=jt.runKernel("Dilation2D",l,c);return p?vn(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const mr=Jt({floorDiv_:function(e,t){let n=Yt(e,"a","floorDiv"),r=Yt(t,"b","floorDiv");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("FloorDiv",s)}});const fr=Jt({div_:function(e,t){let n=Yt(e,"a","div"),r=Yt(t,"b","div");if([n,r]=Bt(n,r),"int32"===n.dtype&&"int32"===r.dtype)return mr(n,r);const s={a:n,b:r};return jt.runKernel("RealDiv",s,{})}});function yr(e,t){const n=[],r=Math.max(e.length,t.length);for(let s=0;s<r;s++){let r=e[e.length-s-1];null==r&&(r=1);let a=t[t.length-s-1];if(null==a&&(a=1),1===r)n.unshift(a);else if(1===a)n.unshift(r);else{if(r!==a){throw Error(`Operands could not be broadcast together with shapes ${e} and ${t}.`)}n.unshift(r)}}return n}const gr=Jt({equal_:function(e,t){let n=Yt(e,"a","equal","string_or_numeric"),r=Yt(t,"b","equal","string_or_numeric");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("Equal",s)}});const br=Jt({where_:function(e,t,n){const r=Yt(t,"a","where"),s=Yt(n,"b","where"),a=Yt(e,"condition","where","bool"),o=yr(yr(a.shape,r.shape),s.shape),i={condition:Kn(a,o),t:Kn(r,o),e:Kn(s,o)};return jt.runKernel("Select",i)}});const xr=Jt({zerosLike_:function(e){const t={x:Yt(e,"x","zerosLike")};return jt.runKernel("ZerosLike",t)}});const Nr=Jt({divNoNan_:function(e,t){let n=Yt(e,"a","div"),r=Yt(t,"b","div");[n,r]=Bt(n,r);const s=fr(n,r),a=xr(s),o=gr(r,a);return br(o,a,s)}});const wr=Jt({dot_:function(e,t){const n=Yt(e,"t1","dot"),r=Yt(t,"t2","dot");he(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${r.rank}.`));const s=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];if(he(s===a,(()=>`Error in dot: inner dimensions of inputs must match, but got ${s} and ${a}.`)),1===n.rank&&1===r.rank){const e=vn(n,[1,-1]),t=vn(r,[-1,1]),s=$n(e,t);return vn(s,[])}if(1===n.rank&&2===r.rank){const e=vn(n,[1,-1]),t=vn(r,[r.shape[0],r.shape[1]]),s=$n(e,t);return vn(s,[s.size])}if(2===n.rank&&1===r.rank){const e=vn(r,[-1,1]),t=$n(n,e);return vn(t,[t.size])}{const e=vn(r,[r.shape[0],r.shape[1]]);return $n(n,e)}}});const kr=Jt({einsum_:function(e,...t){const n=t.map(((e,t)=>Yt(e,`tensors${t}`,"einsum"))),r={equation:e};return jt.runKernel("Einsum",n,r)}});const Tr=Jt({elu_:function(e){const t={x:Yt(e,"x","elu","float32")};return jt.runKernel("Elu",t)}});const vr=Jt({erf_:function(e){let t=Yt(e,"x","erf");he("int32"===t.dtype||"float32"===t.dtype,(()=>"Input dtype must be `int32` or `float32`.")),"int32"===t.dtype&&(t=fn(t,"float32"));const n={x:t};return jt.runKernel("Erf",n)}});function _r(e,t){return function(e,t,n){const r=e.length+t.length,s=[];let a=0,o=0;for(let i=0;i<r;i++)-1===n.indexOf(i)?s.push(e[a++]):s.push(t[o++]);return s}(e,t.map((e=>1)),t)}const Sr=Jt({max_:function(e,t=null,n=!1){const r={x:Yt(e,"x","max")},s={reductionIndices:t,keepDims:n};return jt.runKernel("Max",r,s)}});const Er=Jt({min_:function(e,t=null,n=!1){const r={x:Yt(e,"x","min")},s={axis:t,keepDims:n};return jt.runKernel("Min",r,s)}});const Ir=Jt({pow_:function(e,t){let n=Yt(e,"base","pow"),r=Yt(t,"exp","pow");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("Pow",s)}});function $r(e,t,n,r){if(null==r)r=ke(e);else if("complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if("object"==typeof e&&("texture"in e||"buffer"in e&&!(e.buffer instanceof ArrayBuffer))){if("float32"!==r&&"int32"!==r)throw new Error(`Creating tensor from GPU data only supports 'float32'|'int32' dtype, while the dtype is ${r}.`);return jt.backend.createTensorFromGPUData(e,t||n,r)}if(!Nt(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){$e(t);const e=fe(t),r=fe(n);he(e===r,(()=>`Based on the provided shape, [${t}], the tensor should have ${e} values but has ${r}`));for(let e=0;e<n.length;++e){const r=n[e],s=e!==n.length-1||r!==fe(t.slice(e));he(n[e]===t[e]||!s,(()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${t}). `))}}return Nt(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?gt(e,r):wt(e,[],!0),jt.makeTensor(e,t,r)}function Dr(e,t){if((Nt(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&Nt(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return $r(e,[],[],t)}const Ar=Jt({sqrt_:function(e){const t={x:Yt(e,"x","sqrt","float32")};return jt.runKernel("Sqrt",t)}});const Or=Jt({square_:function(e){const t=Yt(e,"x","square");return jt.runKernel("Square",{x:t},{})}});const Mr=Jt({sum_:function(e,t=null,n=!1){let r=Yt(e,"x","sum");"bool"===r.dtype&&(r=fn(r,"int32"));const s={x:r},a={axis:t,keepDims:n};return jt.runKernel("Sum",s,a)}});function Cr(e,t,n=null){if(0===e.rank)return en(e);if(1!==e.rank&&null===n)return Cr(vn(e,[-1]),t,n);if(1===e.rank||"number"==typeof n||Array.isArray(n)&&1===n.length){if(1===t)return Mr(en(e),n);if(t===1/0)return Sr(en(e),n);if(t===-1/0)return Er(en(e),n);if("euclidean"===t||2===t)return Ar(Mr(Ir(en(e),Dr(2,"int32")),n));throw new Error(`Error in norm: invalid ord value: ${t}`)}if(Array.isArray(n)&&2===n.length){if(1===t)return Sr(Mr(en(e),n[0]),n[1]-1);if(t===1/0)return Sr(Mr(en(e),n[1]),n[0]);if(t===-1/0)return Er(Mr(en(e),n[1]),n[0]);if("fro"===t||"euclidean"===t)return Ar(Mr(Or(e),n));throw new Error(`Error in norm: invalid ord value: ${t}`)}throw new Error(`Error in norm: invalid axis: ${n}`)}const Fr=Jt({norm_:function(e,t="euclidean",n=null,r=!1){const s=Cr(e=Yt(e,"x","norm"),t,n);let a=s.shape;if(r){const t=xe(n,e.shape);a=_r(s.shape,t)}return vn(s,a)}});const Rr=Jt({euclideanNorm_:function(e,t=null,n=!1){return Fr(e,"euclidean",t,n)}});const zr=Jt({exp_:function(e){const t={x:Yt(e,"x","exp")};return jt.runKernel("Exp",t)}});const Vr=Jt({expandDims_:function(e,t=0){const n=Yt(e,"x","expandDims","string_or_numeric");he(t<=n.rank,(()=>"Axis must be <= rank of the tensor"));const r={input:n},s={dim:t};return jt.runKernel("ExpandDims",r,s)}});const Lr=Jt({expm1_:function(e){const t={x:Yt(e,"x","expm1")};return jt.runKernel("Expm1",t)}});const Br=Jt({tile_:function(e,t){const n=Yt(e,"x","tile","string_or_numeric");he(n.rank===t.length,(()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${t}.`));const r={x:n},s={reps:t};return jt.runKernel("Tile",r,s)}});const Pr=Jt({eye_:function(e,t,n,r="float32"){null==t&&(t=e);const s=qn([e,t],r),a=e<=t?e:t;for(let e=0;e<a;++e)s.set(1,e,e);const o=vn(s.toTensor(),[e,t]);if(null==n)return o;if(1===n.length)return Br(Vr(o,0),[n[0],1,1]);if(2===n.length)return Br(Vr(Vr(o,0),0),[n[0],n[1],1,1]);if(3===n.length)return Br(Vr(Vr(Vr(o,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});const Kr=Jt({floor_:function(e){const t={x:Yt(e,"x","floor","float32")};return jt.runKernel("Floor",t)}});const qr=Jt({gather_:function(e,t,n=0,r=0){const s={x:Yt(e,"x","gather"),indices:Yt(t,"indices","gather","int32")},a={axis:n,batchDims:r};return jt.runKernel("GatherV2",s,a)}});const Ur=Jt({greater_:function(e,t){let n=Yt(e,"a","greater","string_or_numeric"),r=Yt(t,"b","greater","string_or_numeric");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("Greater",s)}});const Wr=Jt({greaterEqual_:function(e,t){let n=Yt(e,"a","greaterEqual","string_or_numeric"),r=Yt(t,"b","greaterEqual","string_or_numeric");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("GreaterEqual",s)}});const jr=Jt({imag_:function(e){const t={input:Yt(e,"input","imag")};return jt.runKernel("Imag",t)}});const Hr=Jt({isFinite_:function(e){const t={x:Yt(e,"x","isFinite")};return jt.runKernel("IsFinite",t)}});const Gr=Jt({isInf_:function(e){const t={x:Yt(e,"x","isInf")};return jt.runKernel("IsInf",t)}});const Zr=Jt({isNaN_:function(e){const t={x:Yt(e,"x","isNaN")};return jt.runKernel("IsNan",t)}});const Qr=Jt({leakyRelu_:function(e,t=.2){const n={x:Yt(e,"x","leakyRelu")},r={alpha:t};return jt.runKernel("LeakyRelu",n,r)}});const Yr=Jt({less_:function(e,t){let n=Yt(e,"a","less","string_or_numeric"),r=Yt(t,"b","less","string_or_numeric");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("Less",s)}});const Xr=Jt({lessEqual_:function(e,t){let n=Yt(e,"a","lessEqual","string_or_numeric"),r=Yt(t,"b","lessEqual","string_or_numeric");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("LessEqual",s)}});const Jr=Jt({localResponseNormalization_:function(e,t=5,n=1,r=1,s=.5){const a=Yt(e,"x","localResponseNormalization");he(4===a.rank||3===a.rank,(()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${a.rank}.`)),he(ge(t),(()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${t}.`));let o=a,i=!1;3===a.rank&&(i=!0,o=vn(a,[1,a.shape[0],a.shape[1],a.shape[2]]));const u={x:o},p={depthRadius:t,bias:n,alpha:r,beta:s},l=jt.runKernel("LRN",u,p);return i?vn(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});const es=Jt({log_:function(e){const t={x:Yt(e,"x","log","float32")};return jt.runKernel("Log",t)}});const ts=Jt({log1p_:function(e){const t={x:Yt(e,"x","log1p")};return jt.runKernel("Log1p",t)}});function ns(e){return jt.customGrad(e)}const rs=Jt({neg_:function(e){const t={x:Yt(e,"x","neg")};return jt.runKernel("Neg",t)}});const ss=Jt({softplus_:function(e){const t={x:Yt(e,"x","softplus")};return jt.runKernel("Softplus",t)}});const as=Jt({logSigmoid_:function(e){const t=Yt(e,"x","logSigmoid"),n=ns((e=>({value:rs(ss(rs(e))),gradFunc:t=>Dn(t,An(rs(e)))})));return n(t)}});const os=Jt({sub_:function(e,t){let n=Yt(e,"a","sub"),r=Yt(t,"b","sub");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("Sub",s)}});const is=Jt({logSoftmax_:function(e,t=-1){const n=Yt(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${t}`);const r=ns(((e,n)=>{const r=Sr(e,t,!0),s=os(e,r),a=os(fn(s,"float32"),es(Mr(zr(s),t,!0)));n([a]);return{value:a,gradFunc:(e,n)=>{const[r]=n,s=zr(r);return os(e,Dn(Mr(e,t,!0),s))}}}));return r(n)}});const us=Jt({logSumExp_:function(e,t=null,n=!1){const r=Yt(e,"x","logSumExp"),s=xe(t,r.shape),a=Sr(r,s,!0),o=os(r,a),i=zr(o),u=Mr(i,s),p=es(u),l=rn(vn(a,p.shape),p);if(n){const e=_r(l.shape,s);return vn(l,e)}return l}});const ps=Jt({logicalAnd_:function(e,t){const n=Yt(e,"a","logicalAnd","bool"),r=Yt(t,"b","logicalAnd","bool");yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("LogicalAnd",s)}});const ls=Jt({logicalNot_:function(e){const t={x:Yt(e,"x","logicalNot","bool")};return jt.runKernel("LogicalNot",t)}});const cs=Jt({logicalOr_:function(e,t){const n=Yt(e,"a","logicalOr","bool"),r=Yt(t,"b","logicalOr","bool");yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("LogicalOr",s)}});const hs=Jt({logicalXor_:function(e,t){const n=Yt(e,"a","logicalXor","bool"),r=Yt(t,"b","logicalXor","bool");return yr(n.shape,r.shape),ps(cs(e,t),ls(ps(e,t)))}});const ds=Jt({searchSorted_:function(e,t,n="left"){const r=Yt(e,"sortedSequence","searchSorted"),s=Yt(t,"values","searchSorted"),a=r.shape[r.shape.length-1],o=s.shape[s.shape.length-1],i=vn(r,[-1,a]),u=vn(s,[-1,o]);if(i.rank<2)throw new Error("Sorted input argument must be at least 2-dimensional");if(i.shape[0]!==u.shape[0])throw new Error("Leading dimension of 'sortedSequence' and 'values' must match.");if(fe(u.shape)>=2147483648)throw new Error("values tensor size must less than 2147483648");if(i.shape[1]>=2147483648)throw new Error(`trailing dim_size must less than 2147483648 for int32 output type, was ${i.shape[1]}`);const p={sortedSequence:i,values:u},l={side:n};return jt.runKernel("SearchSorted",p,l)}});const ms=Jt({maxPool_:function(e,t,n,r,s){const a=Yt(e,"x","maxPool");let o=a,i=!1;3===a.rank&&(i=!0,o=vn(a,[1,a.shape[0],a.shape[1],a.shape[2]])),he(4===o.rank,(()=>`Error in maxPool: input must be rank 4 but got rank ${o.rank}.`)),he(wn(n,1),(()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`)),Tn("maxPool",r,s);const u={x:o},p={filterSize:t,strides:n,pad:r,dimRoundingMode:s},l=jt.runKernel("MaxPool",u,p);return i?vn(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});const fs=Jt({maxPool3d_:function(e,t=[1,1,1],n,r,s,a="NDHWC"){const o=Yt(e,"x","maxPool3d");let i=o,u=!1;4===o.rank&&(u=!0,i=vn(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),he(5===i.rank,(()=>`Error in maxPool3d: x must be rank 5 but got rank ${i.rank}.`)),he("NDHWC"===a,(()=>`Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of ${a}`)),Tn("maxPool3d",r,s);const p={x:i},l={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:a},c=jt.runKernel("MaxPool3D",p,l);return u?vn(c,[c.shape[1],c.shape[2],c.shape[3],c.shape[4]]):c}});const ys=Jt({maxPoolWithArgmax_:function(e,t,n,r,s=!1){const a={x:Yt(e,"x","maxPoolWithArgmax")},o={filterSize:t,strides:n,pad:r,includeBatchInIndex:s},i=jt.runKernel("MaxPoolWithArgmax",a,o);return{result:i[0],indexes:i[1]}}});const gs=Jt({maximum_:function(e,t){let n=Yt(e,"a","maximum"),r=Yt(t,"b","maximum");[n,r]=Bt(n,r),"bool"===n.dtype&&(n=fn(n,"int32"),r=fn(r,"int32")),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("Maximum",s)}});const bs=Jt({mean_:function(e,t=null,n=!1){const r={x:Yt(e,"x","mean")},s={axis:t,keepDims:n};return jt.runKernel("Mean",r,s)}});function xs(e,t="float32"){if($e(e),"complex64"===t){const t=xs(e,"float32"),n=xs(e,"float32");return Hn(t,n)}const n=Ie(fe(e),t);return jt.makeTensor(n,e,t)}function Ns(e,t="float32"){if($e(e),"complex64"===t){const t=Ns(e,"float32"),n=xs(e,"float32");return Hn(t,n)}const n=Ee(fe(e),t);return jt.makeTensor(n,e,t)}const ws=Jt({minimum_:function(e,t){let n=Yt(e,"a","minimum"),r=Yt(t,"b","minimum");[n,r]=Bt(n,r),"bool"===n.dtype&&(n=fn(n,"int32"),r=fn(r,"int32")),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("Minimum",s)}});const ks=Jt({mirrorPad_:function(e,t,n){he("reflect"===n||"symmetric"===n,(()=>`Invalid mode. Mode must be either reflect or symmetric. Got ${n}.`));const r=Yt(e,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");he(t.length===r.rank,(()=>`Padding doesn't match input. Must be ${r.rank}. Got ${t.length}.`));const s="reflect"===n?1:0;for(let e=0;e<r.rank;e++)he(2===t[e].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),he(t[e][0]>=0&&t[e][0]<=r.shape[e]-s&&t[e][1]>=0&&t[e][1]<=r.shape[e]-s,(()=>`Padding in dimension ${e} cannot be greater than or equal to ${r.shape[e]-s} or less than 0 for input of shape ${r.shape}`));const a={paddings:t,mode:n},o={x:r};return jt.runKernel("MirrorPad",o,a)}});const Ts=Jt({mod_:function(e,t){let n=Yt(e,"a","mod"),r=Yt(t,"b","mod");[n,r]=Bt(n,r);const s={a:n,b:r};return jt.runKernel("Mod",s)}});const vs=Jt({moments_:function(e,t=null,n=!1){const r=xe(t,(e=Yt(e,"x","moments")).shape),s=bs(e,r,n);let a=s.shape;n||(a=_r(s.shape,r));const o=Or(os(fn(e,"float32"),vn(s,a)));return{mean:s,variance:bs(o,r,n)}}});const _s=Jt({multiRNNCell_:function(e,t,n,r){const s=Yt(t,"data","multiRNNCell"),a=Xt(n,"c","multiRNNCell"),o=Xt(r,"h","multiRNNCell");let i=s;const u=[];for(let t=0;t<e.length;t++){const n=e[t](i,a[t],o[t]);u.push(n[0]),u.push(n[1]),i=n[1]}const p=[],l=[];for(let e=0;e<u.length;e+=2)p.push(u[e]),l.push(u[e+1]);return[p,l]}});const Ss=Jt({multinomial_:function(e,t,n,r=!1){const s=Yt(e,"logits","multinomial"),a=s.size,o=s.rank;if(a<2)throw new Error(`Error in multinomial: you need at least 2 outcomes, but got ${a}.`);if(o>2)throw new Error(`Rank of probabilities must be 1 or 2, but is ${o}`);n=n||Math.random();const i={logits:1===o?vn(s,[1,-1]):s},u={numSamples:t,seed:n,normalized:r},p=jt.runKernel("Multinomial",i,u);return 1===o?vn(p,[p.size]):p}});const Es=Jt({notEqual_:function(e,t){let n=Yt(e,"a","notEqual","string_or_numeric"),r=Yt(t,"b","notEqual","string_or_numeric");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("NotEqual",s)}});const Is=Jt({oneHot_:function(e,t,n=1,r=0,s="int32"){if(t<2)throw new Error(`Error in oneHot: depth must be >=2, but it is ${t}`);const a={indices:Yt(e,"indices","oneHot","int32")},o={dtype:s,depth:t,onValue:n,offValue:r};return jt.runKernel("OneHot",a,o)}});const $s=Jt({onesLike_:function(e){const t={x:Yt(e,"x","onesLike")};return jt.runKernel("OnesLike",t)}});const Ds=Jt({outerProduct_:function(e,t){const n=Yt(e,"v1","outerProduct"),r=Yt(t,"v2","outerProduct");he(1===n.rank&&1===r.rank,(()=>`Error in outerProduct: inputs must be rank 1, but got ranks ${n.rank} and ${r.rank}.`));const s=vn(n,[-1,1]),a=vn(r,[1,-1]);return $n(s,a)}});const As=Jt({pad_:function(e,t,n=0){const r=Yt(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const s={paddings:t,constantValue:n},a={x:r};return jt.runKernel("PadV2",a,s)}});const Os=Jt({pad1d_:function(e,t,n=0){return he(2===t.length,(()=>"Invalid number of paddings. Must be length of 2.")),As(e,[t],n)}});const Ms=Jt({pad2d_:function(e,t,n=0){return he(2===t.length&&2===t[0].length&&2===t[1].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),As(e,t,n)}});const Cs=Jt({pad3d_:function(e,t,n=0){return he(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),As(e,t,n)}});const Fs=Jt({pad4d_:function(e,t,n=0){return he(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,(()=>"Invalid number of paddings. Must be length of 2 each.")),As(e,t,n)}});const Rs=Jt({spaceToBatchND_:function(e,t,n){const r=Yt(e,"x","spaceToBatchND");he(r.rank>=1+t.length,(()=>`input rank ${r.rank} should be > than [blockShape] ${t.length}`)),he(n.length===t.length,(()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${t.length}`)),he(r.shape.reduce(((e,r,s)=>s>0&&s<=t.length?e&&(r+n[s-1][0]+n[s-1][1])%t[s-1]==0:e),!0),(()=>`input spatial dimensions ${r.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${t.toString()}`));const s={x:r},a={blockShape:t,paddings:n};return jt.runKernel("SpaceToBatchND",s,a)}});const zs=Jt({pool_:function(e,t,n,r,s,a,o){null==s&&(s=[1,1]),null==a&&(a=1),0===r&&(r="valid");const i=Yt(e,"x","maxPool");let u=i,p=!1;3===i.rank&&(p=!0,u=vn(i,[1,i.shape[0],i.shape[1],i.shape[2]])),he(wn(a,s),(()=>`Error in pool: Either strides or dilations must be 1. Got strides ${a} and dilations '${s}'`));const l=function(e,t,n,r,s,a,o="channelsLast"){const[i,u]=gn(t);let p;if("channelsLast"===o)p=[i,u,e[3],e[3]];else{if("channelsFirst"!==o)throw new Error(`Unknown dataFormat ${o}`);p=[i,u,e[1],e[1]]}return yn(e,p,n,r,s,a,!1,o)}(u.shape,t,a,s,r),c=[l.dilationHeight,l.dilationWidth];let h;h="same"===r?function(e,t){const n=e.map(((e,n)=>e+(e-1)*(t[n]-1))).map((e=>e-1)),r=n.map((e=>Math.floor(e/2))),s=n.map(((e,t)=>e-r[t]));return n.map(((e,t)=>[r[t],s[t]]))}([l.filterHeight,l.filterWidth],c):[[0,0],[0,0]];const d=1===c[0]&&1===c[1],[m,f]=function(e,t,n){const r=n.map((e=>e[0])),s=n.map((e=>e[1])),a=e.concat(r,s),o=t.map(((e,t)=>(e-a[t]%e)%e)),i=s.map(((e,t)=>e+o[t])),u=t.map(((e,t)=>[r[t],i[t]])),p=t.map(((e,t)=>[0,o[t]]));return[u,p]}([l.inHeight,l.inWidth],c,h),y=d?r:"valid",g=d?u:Rs(u,c,m),b=("avg"===n?()=>_n(g,t,a,y,o):()=>ms(g,t,a,y,o))(),x=d?b:Fn(b,c,f);return p?vn(x,[x.shape[1],x.shape[2],x.shape[3]]):x}});const Vs=Jt({prelu_:function(e,t){const n={x:Yt(e,"x","prelu"),alpha:Yt(t,"alpha","prelu")};return jt.runKernel("Prelu",n)}});const Ls=Jt({prod_:function(e,t=null,n=!1){let r=Yt(e,"x","prod");"bool"===r.dtype&&(r=fn(r,"int32"));const s={x:r},a={axis:t,keepDims:n};return jt.runKernel("Prod",s,a)}});const Bs=Jt({raggedGather_:function(e,t,n,r){const s={paramsNestedSplits:e.map(((e,t)=>Yt(e,`tensors${t}`,"raggedGather","int32"))),paramsDenseValues:Yt(t,"paramsDenseValues","raggedGather"),indices:Yt(n,"indices","raggedGather","int32")},a={outputRaggedRank:r},o=jt.runKernel("RaggedGather",s,a);return{outputNestedSplits:o.slice(0,o.length-1),outputDenseValues:o[o.length-1]}}});const Ps=Jt({raggedRange_:function(e,t,n){const r=Yt(e,"starts","raggedRange"),s={starts:r,limits:Yt(t,"limits","raggedRange",r.dtype),deltas:Yt(n,"deltas","raggedRange",r.dtype)},a=jt.runKernel("RaggedRange",s);return{rtNestedSplits:a[0],rtDenseValues:a[1]}}});const Ks=Jt({raggedTensorToTensor_:function(e,t,n,r,s){const a=Yt(e,"shape","raggedTensorToTensor","int32"),o=Yt(t,"values","raggedTensorToTensor"),i={shape:a,values:o,defaultValue:Yt(n,"defaultValue","raggedTensorToTensor",o.dtype),rowPartitionTensors:r.map(((e,t)=>Yt(e,`tensors${t}`,"raggedTensorToTensor","int32")))},u={rowPartitionTypes:s};return jt.runKernel("RaggedTensorToTensor",i,u)}});const qs=Jt({rand_:function(e,t,n){$e(e);const r=fe(e);let s=null;if(null==n||"float32"===n)s=new Float32Array(r);else if("int32"===n)s=new Int32Array(r);else{if("bool"!==n)throw new Error(`Unknown data type ${n}`);s=new Uint8Array(r)}for(let e=0;e<r;e++)s[e]=t();return jt.makeTensor(s,e,n)}});var Us="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Ws(e){if(e.__esModule)return e;var t=Object.defineProperty({},"__esModule",{value:!0});return Object.keys(e).forEach((function(n){var r=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,r.get?r:{enumerable:!0,get:function(){return e[n]}})})),t}function js(e){var t={exports:{}};return e(t,t.exports),t.exports}var Hs=js((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=String(e);for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function s(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function a(e,t){var n=new r(e),a=t&&t.state,o=n.next;return o.int32=function(){return 4294967296*n.next()|0},o.double=function(){return o()+11102230246251565e-32*(2097152*o()|0)},o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.alea=a}(0,e,!1)})),Gs=js((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function a(e,t){var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xor128=a}(0,e,!1)})),Zs=js((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function a(e,t){var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xorwow=a}(0,e,!1)})),Qs=js((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,s=t.i;return e=r[s],n=(e^=e>>>7)^e<<24,n^=(e=r[s+1&7])^e>>>10,n^=(e=r[s+3&7])^e>>>3,n^=(e=r[s+4&7])^e<<7,e=r[s+7&7],n^=(e^=e<<13)^e<<9,r[s]=n,t.i=s+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n&&(r[7]=-1),e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function s(e,t){return t.x=e.x.slice(),t.i=e.i,t}function a(e,t){null==e&&(e=+new Date);var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&(a.x&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xorshift7=a}(0,e,!1)})),Ys=js((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,s=t.X,a=t.i;return t.w=r=r+1640531527|0,n=s[a+34&127],e=s[a=a+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=s[a]=n^e,t.i=a,n+(r^r>>>16)|0},function(e,t){var n,r,s,a,o,i=[],u=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,u=Math.max(u,t.length)),s=0,a=-32;a<u;++a)t&&(r^=t.charCodeAt((a+32)%t.length)),0===a&&(o=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(o=o+1640531527|0,s=0==(n=i[127&a]^=r+o)?s+1:0);for(s>=128&&(i[127&(t&&t.length||0)]=-1),s=127,a=512;a>0;--a)r=i[s+34&127],n=i[s=s+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[s]=r^n;e.w=o,e.X=i,e.i=s}(t,e)}function s(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function a(e,t){null==e&&(e=+new Date);var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&(a.X&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.xor4096=a}(0,e,!1)})),Xs=js((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,s=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^s,s=s-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^s,t.a=s-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function a(e,t){var n=new r(e),a=t&&t.state,o=function(){return(n.next()>>>0)/4294967296};return o.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},o.int32=n.next,o.quick=o,a&&("object"==typeof a&&s(a,n),o.state=function(){return s(n,{})}),o}t&&t.exports?t.exports=a:n&&n.amd?n((function(){return a})):this.tychei=a}(0,e,!1)})),Js=Ws({__proto__:null,default:{}}),ea=js((function(e){!function(t,n,r){var s,a=256,o=r.pow(a,6),i=r.pow(2,52),u=2*i,p=255;function l(e,p,l){var y=[],g=m(d((p=1==p?{entropy:!0}:p||{}).entropy?[e,f(n)]:null==e?function(){try{var e;return s&&(e=s.randomBytes)?e=e(a):(e=new Uint8Array(a),(t.crypto||t.msCrypto).getRandomValues(e)),f(e)}catch(e){var r=t.navigator,o=r&&r.plugins;return[+new Date,t,o,t.screen,f(n)]}}():e,3),y),b=new c(y),x=function(){for(var e=b.g(6),t=o,n=0;e<i;)e=(e+n)*a,t*=a,n=b.g(1);for(;e>=u;)e/=2,t/=2,n>>>=1;return(e+n)/t};return x.int32=function(){return 0|b.g(4)},x.quick=function(){return b.g(4)/4294967296},x.double=x,m(f(b.S),n),(p.pass||l||function(e,t,n,s){return s&&(s.S&&h(s,b),e.state=function(){return h(b,{})}),n?(r.random=e,t):e})(x,g,"global"in p?p.global:this==r,p.state)}function c(e){var t,n=e.length,r=this,s=0,o=r.i=r.j=0,i=r.S=[];for(n||(e=[n++]);s<a;)i[s]=s++;for(s=0;s<a;s++)i[s]=i[o=p&o+e[s%n]+(t=i[s])],i[o]=t;(r.g=function(e){for(var t,n=0,s=r.i,o=r.j,i=r.S;e--;)t=i[s=p&s+1],n=n*a+i[p&(i[s]=i[o=p&o+t])+(i[o]=t)];return r.i=s,r.j=o,n})(a)}function h(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function d(e,t){var n,r=[],s=typeof e;if(t&&"object"==s)for(n in e)try{r.push(d(e[n],t-1))}catch(e){}return r.length?r:"string"==s?e:e+"\0"}function m(e,t){for(var n,r=e+"",s=0;s<r.length;)t[p&s]=p&(n^=19*t[p&s])+r.charCodeAt(s++);return f(t)}function f(e){return String.fromCharCode.apply(0,e)}if(m(r.random(),n),e.exports){e.exports=l;try{s=Js}catch(e){}}else r.seedrandom=l}("undefined"!=typeof self?self:Us,[],Math)}));ea.alea=Hs,ea.xor128=Gs,ea.xorwow=Zs,ea.xorshift7=Qs,ea.xor4096=Ys,ea.tychei=Xs;var ta=ea;class na{constructor(e,t,n,r,s){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const a=s||Math.random();this.random=ta.alea(a.toString())}nextValue(){if(!isNaN(this.nextVal)){const e=this.nextVal;return this.nextVal=NaN,e}let e,t,n=!1;for(;!n;){let r,s,a;do{r=2*this.random()-1,s=2*this.random()-1,a=r*r+s*s}while(a>=1||0===a);const o=Math.sqrt(-2*Math.log(a)/a);e=this.mean+this.stdDev*r*o,t=this.mean+this.stdDev*s*o,this.truncated&&!this.isValidTruncated(e)||(n=!0)}return this.truncated&&!this.isValidTruncated(t)||(this.nextVal=this.convertValue(t)),this.convertValue(e)}convertValue(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)}isValidTruncated(e){return e<=this.upper&&e>=this.lower}}class ra{constructor(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;const s=r||Math.random();this.randu=ta.alea(s.toString()),this.randn=new na(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}nextValue(){let e,t,n,r,s,a;for(;;){do{r=this.randn.nextValue(),a=1+this.c*r}while(a<=0);if(a*=a*a,e=r*r,t=1-.331*e*e,n=.5*e+this.d*(1-a+Math.log(a)),s=this.randu(),s<t||Math.log(s)<n)break}return a=1/this.beta*this.d*a,this.alpha<1&&(a*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(a)}convertValue(e){return"float32"===this.dtype?e:Math.round(e)}}class sa{constructor(e=0,t=1,n,r){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${e} - ${t} <= 1 and dtype is not float`);this.random=ta.alea(r)}convertValue(e){return this.canReturnFloat()?e:Math.round(e)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const aa=Jt({randomGamma_:function(e,t,n=1,r="float32",s){if($e(e),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error(`Unsupported data type ${r}`);const a=new ra(t,n,r,s),o=qn(e,r);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});const oa=Jt({randomNormal_:function(e,t=0,n=1,r,s){if($e(e),null!=r&&"bool"===r)throw new Error(`Unsupported data type ${r}`);const a=new na(t,n,r,!1,s),o=qn(e,r);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});const ia=Jt({randomStandardNormal_:function(e,t,n){if(null!=t&&"bool"===t)throw new Error(`Unsupported data type ${t}`);return oa(e,0,1,t,n)}});const ua=Jt({randomUniform_:function(e,t=0,n=1,r="float32",s){$e(e);const a=qn(e,r),o=new sa(t,n,null,s);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});function pa(e,t,n=1,r="float32"){if(0===n)throw new Error("Cannot have a step of zero");const s={start:e,stop:t,step:n,dtype:r};return jt.runKernel("Range",{},s)}const la=Jt({real_:function(e){const t={input:Yt(e,"input","real")};return jt.runKernel("Real",t)}});const ca=Jt({reciprocal_:function(e){const t={x:Yt(e,"x","reciprocal")};return jt.runKernel("Reciprocal",t)}});const ha=Jt({relu_:function(e){const t={x:Yt(e,"x","relu")};return jt.runKernel("Relu",t)}});const da=Jt({relu6_:function(e){const t={x:Yt(e,"x","relu6")};return jt.runKernel("Relu6",t)}});const ma=Jt({reverse_:function(e,t){const n={x:Yt(e,"x","reverse")},r={dims:t};return jt.runKernel("Reverse",n,r)}});const fa=Jt({reverse1d_:function(e){const t=Yt(e,"x","reverse");return he(1===t.rank,(()=>`Error in reverse1D: x must be rank 1 but got rank ${t.rank}.`)),ma(t,0)}});const ya=Jt({reverse2d_:function(e,t){const n=Yt(e,"x","reverse");return he(2===n.rank,(()=>`Error in reverse2D: x must be rank 2 but got rank ${n.rank}.`)),ma(n,t)}});const ga=Jt({reverse3d_:function(e,t){const n=Yt(e,"x","reverse");return he(3===n.rank,(()=>`Error in reverse3D: x must be rank 3 but got rank ${n.rank}.`)),ma(n,t)}});const ba=Jt({reverse4d_:function(e,t){const n=Yt(e,"x","reverse");return he(4===n.rank,(()=>`Error in reverse4D: x must be rank 4 but got rank ${n.rank}.`)),ma(n,t)}});const xa=Jt({round_:function(e){const t={x:Yt(e,"x","round")};return jt.runKernel("Round",t)}});const Na=Jt({rsqrt_:function(e){const t={x:Yt(e,"x","rsqrt","float32")};return jt.runKernel("Rsqrt",t)}});const wa=Jt({selu_:function(e){const t={x:Yt(e,"x","selu")};return jt.runKernel("Selu",t)}});const ka=Jt({separableConv2d_:function(e,t,n,r,s,a=[1,1],o="NHWC"){const i=Yt(e,"x","separableConv2d"),u=Yt(t,"depthwiseFilter","separableConv2d"),p=Yt(n,"pointwiseFilter","separableConv2d");let l=i,c=!1;if(3===i.rank&&(c=!0,l=vn(i,[1,i.shape[0],i.shape[1],i.shape[2]])),"NCHW"===o)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");he(4===l.rank,(()=>`Error in separableConv2d: input must be rank 4, but got rank ${l.rank}.`)),he(4===u.rank,(()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`)),he(4===p.rank,(()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`)),he(1===p.shape[0],(()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${p.shape[0]}.`)),he(1===p.shape[1],(()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${p.shape[1]}.`));const h=u.shape[2],d=u.shape[3];he(p.shape[2]===h*d,(()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${h*d}, but got ${p.shape[2]}.`));const m=cr(l,u,r,s,o,a),f=Xn(m,p,1,"valid",o);return c?vn(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});const Ta=async function(e,t){const n=Yt(e,"x","setdiff1d"),r=Yt(t,"y","setdiff1d");he(n.dtype===r.dtype,(()=>`x and y should have the same dtype, but got x (${n.dtype}) and y (${r.dtype}).`)),he(1===n.rank,(()=>`x should be 1D tensor, but got x (${n.shape}).`)),he(1===r.rank,(()=>`y should be 1D tensor, but got y (${r.shape}).`));const s=await n.data(),a=await r.data(),o=new Set(a);let i=0;for(let e=0;e<s.length;e++)o.has(s[e])||i++;const u=new Dt([i],n.dtype),p=new Dt([i],"int32");for(let e=0,t=0;e<s.length;e++)o.has(s[e])||(u.values[t]=s[e],p.values[t]=e,t++);return[u.toTensor(),p.toTensor()]};const va=Jt({sign_:function(e){const t={x:Yt(e,"x","sign")};return jt.runKernel("Sign",t)}});const _a=Jt({sin_:function(e){const t={x:Yt(e,"x","sin","float32")};return jt.runKernel("Sin",t)}});const Sa=Jt({sinh_:function(e){const t={x:Yt(e,"x","sinh")};return jt.runKernel("Sinh",t)}});const Ea=Jt({slice1d_:function(e,t,n){const r=Yt(e,"x","slice1d");return he(1===r.rank,(()=>`slice1d expects a rank-1 tensor, but got a rank-${r.rank} tensor`)),On(r,[t],[n])}});const Ia=Jt({slice2d_:function(e,t,n){const r=Yt(e,"x","slice2d");return he(2===r.rank,(()=>`slice2d expects a rank-2 tensor, but got a rank-${r.rank} tensor`)),On(r,t,n)}});const $a=Jt({slice3d_:function(e,t,n){const r=Yt(e,"x","slice3d");return he(3===r.rank,(()=>`slice3d expects a rank-3 tensor, but got a rank-${r.rank} tensor`)),On(r,t,n)}});const Da=Jt({slice4d_:function(e,t,n){const r=Yt(e,"x","slice4d");return he(4===r.rank,(()=>`slice4d expects a rank-4 tensor, but got a rank-${r.rank} tensor`)),On(r,t,n)}});const Aa=Jt({softmax_:function(e,t=-1){const n=Yt(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${t}`);const r={logits:n},s={dim:t};return jt.runKernel("Softmax",r,s)}});const Oa=Jt({fft_:function(e){he("complex64"===e.dtype,(()=>`The dtype for tf.spectral.fft() must be complex64 but got ${e.dtype}.`));const t={input:e};return jt.runKernel("FFT",t)}});const Ma=Jt({ifft_:function(e){he("complex64"===e.dtype,(()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${e.dtype}.`));const t={input:e};return jt.runKernel("IFFT",t)}});const Ca=Jt({irfft_:function(e){const t=e.shape[e.shape.length-1],n=e.size/t;let r;if(t<=2){const s=vn(e,[n,t]);r=Ma(s)}else{const s=[n,2*(t-1)],a=vn(la(e),[n,t]),o=vn(jr(e),[n,t]),i=ma(On(a,[0,1],[n,t-2]),1),u=Dn(ma(On(o,[0,1],[n,t-2]),1),Dr(-1)),p=In([a,i],1),l=In([o,u],1),c=vn(Hn(p,l),[s[0],s[1]]);r=Ma(c)}if(r=la(r),3===e.rank&&0!==e.shape[0]){const t=r,n=e.shape[0];r=vn(r,[n,r.shape[0]/n,r.shape[1]]),t.dispose()}return r}});const Fa=Jt({split_:function(e,t,n=0){const r={x:Yt(e,"x","split")},s={numOrSizeSplits:t,axis:n};return jt.runKernel("SplitV",r,s)}});const Ra=Jt({rfft_:function(e,t){he("float32"===e.dtype,(()=>`The dtype for rfft() must be real value but got ${e.dtype}`));let n=e.shape[e.shape.length-1];const r=e.size/n;let s;if(null!=t&&t<n){const r=e.shape.map((e=>0)),a=e.shape.map((e=>e));a[e.shape.length-1]=t,s=On(e,r,a),n=t}else if(null!=t&&t>n){const r=e.shape.map((e=>e));r[e.shape.length-1]=t-n,s=In([e,xs(r)],e.shape.length-1),n=t}else s=e;const a=xr(s),o=vn(Hn(s,a),[r,n]),i=Oa(o),u=Math.floor(n/2)+1,p=la(i),l=jr(i),c=Fa(p,[u,n-u],p.shape.length-1),h=Fa(l,[u,n-u],l.shape.length-1),d=s.shape.slice();return d[s.shape.length-1]=u,vn(Hn(c[0],h[0]),d)}});const za=Jt({squaredDifference_:function(e,t){let n=Yt(e,"a","squaredDifference"),r=Yt(t,"b","squaredDifference");[n,r]=Bt(n,r),yr(n.shape,r.shape);const s={a:n,b:r};return jt.runKernel("SquaredDifference",s,{})}});const Va=Jt({squeeze_:function(e,t){const n=Yt(e,"x","squeeze","string_or_numeric");return vn(n,function(e,t){const n=[],r=[],s=null!=t&&Array.isArray(t)&&0===t.length,a=null==t||s?null:xe(t,e).sort();let o=0;for(let t=0;t<e.length;++t){if(null!=a){if(a[o]===t&&1!==e[t])throw new Error(`Can't squeeze axis ${t} since its dim '${e[t]}' is not 1`);(null==a[o]||a[o]>t)&&1===e[t]&&(n.push(e[t]),r.push(t)),a[o]<=t&&o++}1!==e[t]&&(n.push(e[t]),r.push(t))}return{newShape:n,keptDims:r}}(n.shape,t).newShape)}});const La=Jt({stack_:function(e,t=0){const n=Xt(e,"tensors","stack","string_or_numeric");he(n.length>=1,(()=>"Pass at least one tensor to tf.stack")),n.length>0&&he(t<=n[0].rank,(()=>"Axis must be <= rank of the tensor"));const r=n,s={axis:t};return jt.runKernel("Pack",r,s)}});const Ba=Jt({step_:function(e,t=0){const n={x:Yt(e,"x","step")},r={alpha:t};return jt.runKernel("Step",n,r)}});const Pa=Jt({stridedSlice_:function(e,t,n,r,s=0,a=0,o=0,i=0,u=0){const p={x:Yt(e,"x","stridedSlice","string_or_numeric")},l={begin:t,end:n,strides:r,beginMask:s,endMask:a,ellipsisMask:o,newAxisMask:i,shrinkAxisMask:u};return jt.runKernel("StridedSlice",p,l)}});const Ka=Jt({tan_:function(e){const t={x:Yt(e,"x","tan","float32")};return jt.runKernel("Tan",t)}});function qa(e,t,n){return $r(e,t,Gt(e,n),n)}function Ua(e,t){me(e);const n=Gt(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return $r(e,null,n,t)}function Wa(e,t,n){if(me(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");const r=Gt(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return $r(e,t,r,n)}const ja=Jt({topk_:function(e,t=1,n=!0){const r=Yt(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const s=r.shape[r.shape.length-1];if(t<0)throw new Error(`'k' passed to topk() must be >= 0 but got ${t}`);if(t>s)throw new Error(`'k' passed to topk() must be <= the last dimension (${s}) but got ${t}`);const a={x:r},o={k:t,sorted:n},[i,u]=jt.runKernel("TopK",a,o);return{values:i,indices:u}}});const Ha=Jt({truncatedNormal_:function(e,t=0,n=1,r,s){if($e(e),null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");const a=new na(t,n,r,!0,s),o=qn(e,r);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});const Ga=Jt({unique_:function(e,t=0){const n=Yt(e,"x","unique","string_or_numeric");he(n.rank>0,(()=>"The input tensor must be at least 1D"));const r={x:n},s={axis:t},[a,o]=jt.runKernel("Unique",r,s);return{values:a,indices:o}}});const Za=Jt({unsortedSegmentSum_:function(e,t,n){const r=Yt(e,"x","unsortedSegmentSum"),s=Yt(t,"segmentIds","unsortedSegmentSum","int32");he(ge(n),(()=>"numSegments must be of dtype int"));const a={x:r,segmentIds:s},o={numSegments:n};return jt.runKernel("UnsortedSegmentSum",a,o)}});const Qa=Jt({unstack_:function(e,t=0){const n=Yt(e,"x","unstack","string_or_numeric");he(t>=-n.shape.length&&t<n.shape.length,(()=>`Axis = ${t} is not in [-${n.shape.length}, ${n.shape.length})`));const r={value:n},s={axis:t};return jt.runKernel("Unpack",r,s)}});const Ya=async function(e){const t=Yt(e,"condition","whereAsync","bool"),n=await t.data(),r=function(e,t){const n=[];for(let e=0;e<t.length;e++)t[e]&&n.push(e);const r=qn(e,"int32"),s=qn([n.length,e.length],"int32");for(let t=0;t<n.length;t++){const a=r.indexToLoc(n[t]),o=t*e.length;s.values.set(a,o)}return s.toTensor()}(t.shape,n);return e!==t&&t.dispose(),r};const Xa=async function(e,t,n){const r=Yt(e,"tensor","boolMask"),s=Yt(t,"mask","boolMask","bool"),a=null==n?0:n,o=s.rank,i=r.shape;he(o>0,(()=>"mask cannot be scalar")),de(i.slice(a,a+o),s.shape,"mask's shape must match the first K dimensions of tensor's shape,");let u=1;for(let e=a;e<a+o;e++)u*=i[e];const p=i.slice(0,a).concat([u],i.slice(a+o)),l=vn(r,p),c=vn(s,[-1]),h=await Ya(c),d=Va(h,[1]),m=qr(l,d,a);return e!==r&&r.dispose(),t!==s&&s.dispose(),d.dispose(),l.dispose(),c.dispose(),h.dispose(),m};const Ja=Jt({transpose_:function(e,t,n){const r=Yt(e,"x","transpose");if(null==t&&(t=r.shape.map(((e,t)=>t)).reverse()),he(r.rank===t.length,(()=>`Error in transpose: rank of input ${r.rank} must match length of perm ${t}.`)),t.forEach((e=>{he(e>=0&&e<r.rank,(()=>"All entries in 'perm' must be between 0 and "+(r.rank-1)+` but got ${t}`))})),r.rank<=1)return r.clone();const s={x:r},a={perm:t};return"complex64"===r.dtype?(o=()=>{let e=la(r),t=jr(r);return e=jt.runKernel("Transpose",{x:e},a),t=jt.runKernel("Transpose",{x:t},a),n&&(t=rs(t)),Hn(e,t)},jt.tidy(o,i)):jt.runKernel("Transpose",s,a);var o,i}});const eo=Jt({movingAverage_:function(e,t,n,r,s=!0){const a=Yt(e,"v","movingAverage"),o=Yt(t,"x","movingAverage"),i=Yt(n,"decay","movingAverage");var u,p;p=o,he((u=a).dtype===p.dtype,(()=>`The dtypes of the first(${u.dtype}) and second(${p.dtype}) input must match`)),he(ye(a.shape,o.shape),(()=>"Shape mismatch in v and x"));const l=Dr(1),c=os(l,i);let h=Dn(os(o,a),c);if(s){he(null!=r,(()=>"When using zeroDebias: true, step is required."));const e=Yt(r,"step","movingAverage");h=fr(h,os(l,Ir(i,e)))}return rn(a,h)}});function to(e,t,n){if(t.rank<1)throw new Error(`tf.scatterND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if(e.rank<1)throw new Error(`tf.scatterND() expects the updates to be rank 1 or higher, but the rank was ${e.rank}.`);if("int32"!==t.dtype)throw new Error(`The dtype of 'indices' should be int32, but got dtype: ${t.dtype}`);if(n.length<1)throw new Error(`Output rank must be greater or equal to 1, but got shape: ${n}`);if(0===n.length){if(0===t.size)throw new Error(`Indices specified for empty output. indices shape: ${t.shape}`);if(0===e.size)throw new Error(`Updates specified for empty output. updates shape: ${e.shape}`)}!function(e,t,n){const r=t.rank>1?t.shape[t.rank-1]:1,s=t.rank>1?t.rank-1:1,a=`Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: ${n.shape}, indices.shape: ${t.shape}, shape: ${e}, sliceDim: ${r}, and batchDim: ${s}.`;if(n.rank<s)throw new Error(a+` update.rank < ${s}. `);if(e.length<r+(n.rank-s))throw new Error(a+` Output shape length < ${r+(n.rank-s)}`);if(n.rank!==s+e.length-r)throw new Error(a+" update.rank != "+(s+e.length-r));for(let e=0;e<s;++e)if(n.shape[e]!==t.shape[e])throw new Error(a+` updates.shape[${e}] (${n.shape[e]}) != indices.shape[${e}] (${t.shape[e]}).`);for(let t=0;t<n.rank-s;++t)if(n.shape[t+s]!==e[t+r])throw new Error(a+` updates.shape[${t+s}] (${n.shape[t+s]}) != shape[${t+s}] (${e[t+s]})`)}(n,t,e)}const no=Jt({scatterND_:function(e,t,n){$e(n);const r=Yt(e,"indices","scatterND","int32"),s=Yt(t,"updates","scatterND");to(s,r,n);const a={indices:r,updates:s},o={shape:n};return jt.runKernel("ScatterNd",a,o)}});const ro=Jt({sparseToDense_:function(e,t,n,r=0){$e(n);const s=Yt(e,"sparseIndices","sparseToDense","int32"),a=Yt(t,"sparseValues","sparseToDense","string_or_numeric"),o=Yt(r,"defaultValue","sparseToDense",a.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error(`tf.sparseToDense() expects the indices to be int32 type, but the dtype was ${e.dtype}.`);if(e.rank>2)throw new Error(`sparseIndices should be a scalar, vector, or matrix, but got shape ${e.shape}.`);const s=e.rank>0?e.shape[0]:1,a=e.rank>1?e.shape[1]:1;if(n.length!==a)throw new Error(`outputShape has incorrect number of elements:, ${n.length}, should be: ${a}.`);const o=t.size;if(0!==t.rank&&(1!==t.rank||o!==s))throw new Error(`sparseValues has incorrect shape ${t.shape}, should be [] or [${s}]`);if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(s,a,n,o);const i={sparseIndices:s,sparseValues:a,defaultValue:o},u={outputShape:n};return jt.runKernel("SparseToDense",i,u)}});const so=Jt({gatherND_:function(e,t){const n=Yt(t,"indices","gatherND","int32"),r={params:Yt(e,"x","gatherND","string_or_numeric"),indices:n};return jt.runKernel("GatherNd",r)}});const ao=Jt({dropout_:function(e,t,n,r){const s=Yt(e,"x","dropout");if(he("float32"===s.dtype,(()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${s.dtype} tensor instead.`)),he(t>=0&&t<1,(()=>`rate must be a float in the range [0, 1), but got ${t}.`)),0===t)return e instanceof Ot?s.clone():s;const a=function(e,t){if(null==t)return e.shape.slice();if(ye(e.shape,t))return t;if(e.shape.length===t.length){const n=[];for(let r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(s,n),o=1-t,i=fr(Kr(rn(ua(a,0,1,"float32",r),o)),o);return Dn(s,i)}});function oo(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function io(e,t,n){const r=1-e%2,s=new Float32Array(e);for(let a=0;a<e;++a){const o=2*Math.PI*a/(e+r-1);s[a]=t-n*Math.cos(o)}return Ua(s,"float32")}const uo=async function(e,t,n=1){const r=Yt(e,"predictions","inTopK"),s=Yt(t,"targets","inTopK");he(r.rank>1,(()=>`inTopK() expects the predictions to be of rank 2 or higher, but got ${r.rank}`)),he(r.rank-1===s.rank,(()=>`predictions rank should be 1 larger than targets rank, but got predictions rank ${r.rank} and targets rank ${s.rank}`)),de(r.shape.slice(0,r.shape.length-1),s.shape,"predictions's shape should be align with the targets' shape, except the last dimension.");const a=r.shape[r.shape.length-1];he(n>0&&n<=a,(()=>`'k' passed to inTopK() must be > 0 && <= the predictions last dimension (${a}), but got ${n}`));const o=await r.data(),i=await s.data(),[u,p]=[o.length/a,a],l=function(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else{if("bool"!==e)throw new Error(`Unknown data type ${e}`);n=new Uint8Array(t)}return n}("bool",u);for(let e=0;e<u;e++){const t=e*p,r=o.subarray(t,t+p),s=[];for(let e=0;e<r.length;e++)s.push({value:r[e],index:e});s.sort(((e,t)=>t.value-e.value)),l[e]=0;for(let t=0;t<n;t++)if(s[t].index===i[e]){l[e]=1;break}}return e!==r&&r.dispose(),t!==s&&s.dispose(),qa(l,s.shape,"bool")};const po=Jt({conv2DBackpropFilter_:function(e,t,n,r,s,a="NHWC",o){let i=e;3===e.rank&&(i=vn(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=vn(t,[1,t.shape[0],t.shape[1],t.shape[2]])),he(4===i.rank,(()=>`Error in conv2dDerFilter: input must be rank 4, but got shape ${i.shape}.`)),he(4===u.rank,(()=>`Error in conv2dDerFilter: dy must be rank 4, but got shape ${u.shape}.`)),he(4===n.length,(()=>`Error in conv2dDerFilter: filterShape must be length 4, but got ${n}.`));const p="NHWC"===a?i.shape[3]:i.shape[1],l="NHWC"===a?u.shape[3]:u.shape[1];he(p===n[2],(()=>`Error in conv2dDerFilter: depth of input ${p}) must match input depth in filter (${n[2]}.`)),he(l===n[3],(()=>`Error in conv2dDerFilter: depth of dy (${l}) must match output depth for filter (${n[3]}).`)),Tn("conv2dDerFilter",s,o);const c={x:i,dy:u},h={strides:r,pad:s,dataFormat:a,dimRoundingMode:o,filterShape:n};return jt.runKernel("Conv2DBackpropFilter",c,h)}});function lo(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return Dn(e,Ba(t));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function co(e,t){let n=t;const r=function(e,t){const n=[];for(let r=0;r<t.length;r++){const s=e[e.length-r-1],a=t.length-r-1,o=t[a];(null==s||1===s&&o>1)&&n.unshift(a)}return n}(e.shape,t.shape);return r.length>0&&(n=Mr(n,r)),vn(n,e.shape)}function ho(e,t,n,r){if("linear"===t)return e;if("relu"===t)return ha(e);if("elu"===t)return Tr(e);if("relu6"===t)return da(e);if("prelu"===t)return Vs(e,n);if("leakyrelu"===t)return Qr(e,r);if("sigmoid"===t)return An(e);throw new Error(`Unknown fused activation ${t}.`)}const mo=(e,t)=>!(e>0)||"linear"===t;const fo=Jt({fusedConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:a=[1,1],dimRoundingMode:o,bias:i,activation:u="linear",preluActivationWeights:p,leakyreluAlpha:l}){if(u=u||"linear",!1===mo(jt.state.gradientDepth,u)){he("NHWC"===s,(()=>`Error in fused conv2d: got dataFormat of ${s} but only NHWC is currently supported for the case of gradient depth is 0 and the activation is not linear.`));let c=Xn(e,t,n,r,s,a,o);return null!=i&&(c=rn(c,i)),ho(c,u,p,l)}const c=Yt(e,"x","conv2d","float32"),h=Yt(t,"filter","conv2d","float32");let d=c,m=!1;3===c.rank&&(m=!0,d=vn(c,[1,c.shape[0],c.shape[1],c.shape[2]])),he(4===d.rank,(()=>`Error in fused conv2d: input must be rank 4, but got rank ${d.rank}.`)),he(4===h.rank,(()=>`Error in fused conv2d: filter must be rank 4, but got rank ${h.rank}.`)),Tn("fused conv2d",r,o);const f="NHWC"===s?d.shape[3]:d.shape[1];he(h.shape[2]===f,(()=>`Error in conv2d: depth of input (${f}) must match input depth for filter ${h.shape[2]}.`)),he(wn(n,a),(()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`));const y=yn(d.shape,h.shape,n,a,r,o);let g,b;if(null!=i&&(g=Yt(i,"bias","fused conv2d"),[g]=Bt(g,c),"NHWC"===s?yr(y.outShape,g.shape):(he(g.shape.length<=1,(()=>`Error in fused conv2d: only supports scalar or 1-D Tensor bias for NCHW format but got the bias of rank-${g.shape.length}.`)),he(0===g.shape.length||g.shape[0]===y.outChannels||1===g.shape[0],(()=>`Error in fused conv2d: bias shape (${g.shape}) is not compatible with the number of output channels (${y.outChannels})`)))),null!=p){const e=p.shape;if(he(e.length<=1||3===e.length,(()=>`Error in fused conv2d: only supports scalar, 1-D Tensor or 3-D Tensor PReLU activation weights but got a tensor of rank-${e.length}.`)),1===e.length)he(1===e[0]||e[0]===y.outChannels,(()=>`Error in fused conv2d: PReLU activation weights (${e}) is not compatible with the number of output channels (${y.outChannels}).`));else if(3===e.length)try{yr(e,y.outShape)}catch(t){const n=`Error in fused conv2d: PReLU activation weights (${e}) is not compatible with the output shape of the conv2d (${y.outShape}).`;throw Error(n)}b=Yt(p,"prelu weights","fused conv2d")}const x=(e,t)=>{he("NHWC"===s,(()=>`Error in gradient of fused conv2D: got dataFormat of ${s} but only NHWC is currently supported.`));const[o,i,p,l]=t,c=lo(e,p,u);he(Nn(a),(()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${a}'`));const h=[er(i.shape,c,o,n,r),po(i,c,o.shape,n,r)];if(null!=l){const e=co(l,c);h.push(e)}return h},N={x:d,filter:h,bias:g,preluActivationWeights:b},w={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o,activation:u,leakyreluAlpha:l};if(null==i){const e=ns(((e,t,n)=>{let r=jt.runKernel("FusedConv2D",N,w);return n([t,e,r]),m&&(r=vn(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:x}}));return e(d,h)}{const e=ns(((e,t,n,r)=>{let s=jt.runKernel("FusedConv2D",N,w);return r([t,e,s,n]),m&&(s=vn(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:x}}));return e(d,h,g)}}});const yo=Jt({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r,s,a=[1,1],o){let i=e;3===e.rank&&(i=vn(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=vn(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const p={x:i,dy:u},l={strides:r,pad:s,dimRoundingMode:o,dilations:a,filterShape:n};return jt.runKernel("DepthwiseConv2dNativeBackpropFilter",p,l)}});const go=Jt({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r,s,a=[1,1],o){let i=t,u=!1;3===t.rank&&(u=!0,i=vn(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const p={dy:i,filter:n},l={strides:r,pad:s,dimRoundingMode:o,dilations:a,inputShape:e},c=jt.runKernel("DepthwiseConv2dNativeBackpropInput",p,l);return u?vn(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const bo=Jt({fusedDepthwiseConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:a=[1,1],dimRoundingMode:o,bias:i,activation:u="linear",preluActivationWeights:p,leakyreluAlpha:l}){if(!1===mo(jt.state.gradientDepth,u)){let c=cr(e,t,n,r,s,a,o);return null!=i&&(c=rn(c,i)),ho(c,u,p,l)}const c=Yt(e,"x","depthwiseConv2d","float32"),h=Yt(t,"filter","depthwiseConv2d","float32");let d=c,m=!1;3===c.rank&&(m=!0,d=vn(c,[1,c.shape[0],c.shape[1],c.shape[2]])),he(4===d.rank,(()=>`Error in fused depthwiseConv2d: input must be rank 4, but got rank ${d.rank}.`)),he(4===h.rank,(()=>`Error in fused depthwiseConv2d: filter must be rank 4, but got rank ${h.rank}.`)),he(d.shape[3]===h.shape[2],(()=>`Error in fused depthwiseConv2d: number of input channels (${d.shape[3]}) must match the inChannels dimension in filter ${h.shape[2]}.`)),null==a&&(a=[1,1]),he(wn(n,a),(()=>`Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`)),Tn("fused depthwiseConv2d",r,o);const f=yn(d.shape,h.shape,n,a,r,o,!0);let y,g;null!=i&&(y=Yt(i,"bias","fused conv2d"),[y]=Bt(y,c),yr(f.outShape,y.shape)),null!=p&&(g=Yt(p,"prelu weights","fused depthwiseConv2d"));const b=(e,t)=>{he(Nn(a),(()=>`Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '${a}'`));const[s,i,p,l]=t,c=lo(e,p,u),h=go(i.shape,c,s,n,r,a,o),d=yo(i,c,s.shape,n,r,a,o);if(null!=l){return[h,d,co(y,c)]}return[h,d]},x={x:d,filter:h,bias:y,preluActivationWeights:g},N={strides:n,pad:r,dataFormat:s,dilations:a,dimRoundingMode:o,activation:u,leakyreluAlpha:l};if(null==i){const e=ns(((e,t,n)=>{let r=jt.runKernel("FusedDepthwiseConv2D",x,N);return n([t,e,r]),m&&(r=vn(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:b}}));return e(d,h)}{const e=ns(((e,t,n,r)=>{let s=jt.runKernel("FusedDepthwiseConv2D",x,N);return r([t,e,s,n]),m&&(s=vn(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:b}}));return e(d,h,y)}}});var xo={__proto__:null,conv2d:fo,depthwiseConv2d:bo,matMul:Jt({fusedMatMul_:function({a:e,b:t,transposeA:n=!1,transposeB:r=!1,bias:s,activation:a="linear",preluActivationWeights:o,leakyreluAlpha:i=.2}){if(!1===mo(jt.state.gradientDepth,a)){let u=$n(e,t,n,r);return null!=s&&(u=rn(u,s)),ho(u,a,o,i)}let u=Yt(e,"a","fused matMul"),p=Yt(t,"b","fused matMul");[u,p]=Bt(u,p);const l=n?u.shape[u.rank-2]:u.shape[u.rank-1],c=r?p.shape[p.rank-1]:p.shape[p.rank-2],h=n?u.shape[u.rank-1]:u.shape[u.rank-2],d=r?p.shape[p.rank-2]:p.shape[p.rank-1],m=u.shape.slice(0,-2),f=p.shape.slice(0,-2),y=fe(m),g=fe(f);he(l===c,(()=>`Error in fused matMul: inner shapes (${l}) and (${c}) of Tensors with shapes ${u.shape} and ${p.shape} and transposeA=${n} and transposeB=${r} must match.`));const b=yr(u.shape.slice(0,-2),p.shape.slice(0,-2)).concat([h,d]),x=vn(u,n?[y,l,h]:[y,h,l]),N=vn(p,r?[g,d,c]:[g,c,d]);let w,k;null!=s&&(w=Yt(s,"bias","fused matMul"),[w]=Bt(w,u),yr(b,w.shape)),null!=o&&(k=Yt(o,"prelu weights","fused matMul"));const T=(e,t)=>{const[o,i,u,p]=t,l=lo(vn(e,u.shape),u,a);let c,h;if(n||r?!n&&r?(c=$n(l,i,!1,!1),h=$n(l,o,!0,!1)):n&&!r?(c=$n(i,l,!1,!0),h=$n(o,l,!1,!1)):(c=$n(i,l,!0,!0),h=$n(l,o,!0,!0)):(c=$n(l,i,!1,!0),h=$n(o,l,!0,!1)),null!=s){return[c,h,co(p,l)]}return[c,h]},v={a:x,b:N,bias:w,preluActivationWeights:k},_={transposeA:n,transposeB:r,activation:a,leakyreluAlpha:i};if(null==s){const e=ns(((e,t,n)=>{const r=jt.runKernel("_FusedMatMul",v,_);return n([e,t,r]),{value:vn(r,b),gradFunc:T}}));return e(x,N)}{const e=ns(((e,t,n,r)=>{const s=jt.runKernel("_FusedMatMul",v,_);return r([e,t,s,n]),{value:vn(s,b),gradFunc:T}}));return e(x,N,w)}}})};const No=Jt({hammingWindow_:function(e){return io(e,.54,.46)}});const wo=Jt({hannWindow_:function(e){return io(e,.5,.5)}});const ko=Jt({frame_:function(e,t,n,r=!1,s=0){let a=0;const o=[];for(;a+t<=e.size;)o.push(On(e,a,t)),a+=n;if(r)for(;a<e.size;){const r=a+t-e.size,i=In([On(e,a,t-r),Wn([r],s)]);o.push(i),a+=n}return 0===o.length?Wa([],[0,t]):vn(In(o),[o.length,t])}});const To=Jt({stft_:function(e,t,n,r,s=wo){null==r&&(r=oo(t));const a=ko(e,t,n),o=Dn(a,s(t));return Ra(o,r)}});const vo=Jt({cropAndResize_:function(e,t,n,r,s="bilinear",a=0){const o=Yt(e,"image","cropAndResize"),i=Yt(t,"boxes","cropAndResize","float32"),u=Yt(n,"boxInd","cropAndResize","int32"),p=i.shape[0];he(4===o.rank,(()=>`Error in cropAndResize: image must be rank 4,but got rank ${o.rank}.`)),he(2===i.rank&&4===i.shape[1],(()=>`Error in cropAndResize: boxes must be have size [${p},4] but had shape ${i.shape}.`)),he(1===u.rank&&u.shape[0]===p,(()=>`Error in cropAndResize: boxInd must be have size [${p}] but had shape ${i.shape}.`)),he(2===r.length,(()=>`Error in cropAndResize: cropSize must be of length 2, but got length ${r.length}.`)),he(r[0]>=1&&r[1]>=1,(()=>`cropSize must be atleast [1,1], but was ${r}`)),he("bilinear"===s||"nearest"===s,(()=>`method must be bilinear or nearest, but was ${s}`));const l={image:o,boxes:i,boxInd:u},c={method:s,extrapolationValue:a,cropSize:r};return jt.runKernel("CropAndResize",l,c)}});const _o=Jt({flipLeftRight_:function(e){const t=Yt(e,"image","flipLeftRight","float32");he(4===t.rank,(()=>`Error in flipLeftRight: image must be rank 4,but got rank ${t.rank}.`));const n={image:t};return jt.runKernel("FlipLeftRight",n,{})}});const So=Jt({grayscaleToRGB_:function(e){const t=Yt(e,"image","grayscaleToRGB"),n=t.rank-1,r=t.shape[n];he(t.rank>=2,(()=>`Error in grayscaleToRGB: images must be at least rank 2, but got rank ${t.rank}.`)),he(1===r,(()=>`Error in grayscaleToRGB: last dimension of a grayscale image should be size 1, but got size ${r}.`));const s=new Array(t.rank);return s.fill(1,0,n),s[n]=3,Br(t,s)}});const Eo=Jt({rotateWithOffset_:function(e,t,n=0,r=.5){const s=Yt(e,"image","rotateWithOffset","float32");he(4===s.rank,(()=>`Error in rotateWithOffset: image must be rank 4,but got rank ${s.rank}.`));const a={image:s},o={radians:t,fillValue:n,center:r};return jt.runKernel("RotateWithOffset",a,o)}});function Io(e,t,n,r,s,a){null==r&&(r=.5),null==s&&(s=Number.NEGATIVE_INFINITY),null==a&&(a=0);const o=e.shape[0];return n=Math.min(n,o),he(0<=r&&r<=1,(()=>`iouThreshold must be in [0, 1], but was '${r}'`)),he(2===e.rank,(()=>`boxes must be a 2D tensor, but was of rank '${e.rank}'`)),he(4===e.shape[1],(()=>`boxes must have 4 columns, but 2nd dimension was ${e.shape[1]}`)),he(1===t.rank,(()=>"scores must be a 1D tensor")),he(t.shape[0]===o,(()=>`scores has incompatible shape with boxes. Expected ${o}, but was ${t.shape[0]}`)),he(0<=a&&a<=1,(()=>`softNmsSigma must be in [0, 1], but was '${a}'`)),{maxOutputSize:n,iouThreshold:r,scoreThreshold:s,softNmsSigma:a}}const $o=Jt({nonMaxSuppression_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const a=Yt(e,"boxes","nonMaxSuppression","float32"),o=Yt(t,"scores","nonMaxSuppression","float32"),i=Io(a,o,n,r,s),u={maxOutputSize:n=i.maxOutputSize,iouThreshold:r=i.iouThreshold,scoreThreshold:s=i.scoreThreshold};return jt.runKernel("NonMaxSuppressionV3",{boxes:a,scores:o},u)}});function Do(e,t,n){const r=function(e,t,n){return function(e,t,n){let r=0,s=e.length,a=0,o=!1;for(;r<s;){a=r+(s-r>>>1);const i=n(t,e[a]);i>0?r=a+1:(s=a,o=!i)}return o?r:-r-1}(e,t,n||Ao)}(e,t,n),s=r<0?-(r+1):r;e.splice(s,0,t)}function Ao(e,t){return e>t?1:e<t?-1:0}function Oo(e,t,n,r,s,a,o=!1,i=!1,u=!1){const p=[];for(let e=0;e<t.length;e++)t[e]>s&&p.push({score:t[e],boxIndex:e,suppressBeginIndex:0});p.sort(Fo);const l=a>0?-.5/a:0,c=[],h=[];for(;c.length<n&&p.length>0;){const t=p.pop(),{score:n,boxIndex:a,suppressBeginIndex:o}=t;if(n<s)break;let i=!1;for(let n=c.length-1;n>=o;--n){const o=Mo(e,a,c[n]);if(o>=r){i=!0;break}if(t.score=t.score*Co(r,l,o),t.score<=s)break}t.suppressBeginIndex=c.length,i||(t.score===n?(c.push(a),h.push(t.score)):t.score>s&&Do(p,t,Fo))}const d=c.length,m=n-d;i&&m>0&&(c.push(...new Array(m).fill(0)),h.push(...new Array(m).fill(0)));const f={selectedIndices:c};return o&&(f.selectedScores=h),u&&(f.validOutputs=d),f}function Mo(e,t,n){const r=e.subarray(4*t,4*t+4),s=e.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),o=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),p=Math.min(s[0],s[2]),l=Math.min(s[1],s[3]),c=Math.max(s[0],s[2]),h=Math.max(s[1],s[3]),d=(i-a)*(u-o),m=(c-p)*(h-l);if(d<=0||m<=0)return 0;const f=Math.max(a,p),y=Math.max(o,l),g=Math.min(i,c),b=Math.min(u,h),x=Math.max(g-f,0)*Math.max(b-y,0);return x/(d+m-x)}function Co(e,t,n){const r=Math.exp(t*n*n);return n<=e?r:0}function Fo(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}const Ro=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const a=Yt(e,"boxes","nonMaxSuppressionAsync"),o=Yt(t,"scores","nonMaxSuppressionAsync"),i=Io(a,o,n,r,s);n=i.maxOutputSize,r=i.iouThreshold,s=i.scoreThreshold;const u=await Promise.all([a.data(),o.data()]),p=u[0],l=u[1],{selectedIndices:c}=function(e,t,n,r,s){return Oo(e,t,n,r,s,0)}(p,l,n,r,s);return a!==e&&a.dispose(),o!==t&&o.dispose(),Ua(c,"int32")};const zo=Jt({nonMaxSuppressionWithScore_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=0){const o=Yt(e,"boxes","nonMaxSuppression"),i=Yt(t,"scores","nonMaxSuppression"),u=Io(o,i,n,r,s,a),p={boxes:o,scores:i},l={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:s=u.scoreThreshold,softNmsSigma:a=u.softNmsSigma},c=jt.runKernel("NonMaxSuppressionV5",p,l);return{selectedIndices:c[0],selectedScores:c[1]}}});const Vo=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=0){const o=Yt(e,"boxes","nonMaxSuppressionAsync"),i=Yt(t,"scores","nonMaxSuppressionAsync"),u=Io(o,i,n,r,s,a);n=u.maxOutputSize,r=u.iouThreshold,s=u.scoreThreshold,a=u.softNmsSigma;const p=await Promise.all([o.data(),i.data()]),l=p[0],c=p[1],{selectedIndices:h,selectedScores:d}=function(e,t,n,r,s,a){return Oo(e,t,n,r,s,a,!0)}(l,c,n,r,s,a);return o!==e&&o.dispose(),i!==t&&i.dispose(),{selectedIndices:Ua(h,"int32"),selectedScores:Ua(d)}};const Lo=Jt({nonMaxSuppressionPadded_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=!1){const o=Yt(e,"boxes","nonMaxSuppression"),i=Yt(t,"scores","nonMaxSuppression"),u=Io(o,i,n,r,s,null),p={boxes:o,scores:i},l={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:a},c=jt.runKernel("NonMaxSuppressionV4",p,l);return{selectedIndices:c[0],validOutputs:c[1]}}});const Bo=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,a=!1){const o=Yt(e,"boxes","nonMaxSuppressionAsync"),i=Yt(t,"scores","nonMaxSuppressionAsync"),u=Io(o,i,n,r,s,null),p=u.maxOutputSize,l=u.iouThreshold,c=u.scoreThreshold,[h,d]=await Promise.all([o.data(),i.data()]),{selectedIndices:m,validOutputs:f}=function(e,t,n,r,s,a){return Oo(e,t,n,r,s,0,!1,a,!0)}(h,d,p,l,c,a);return o!==e&&o.dispose(),i!==t&&i.dispose(),{selectedIndices:Ua(m,"int32"),validOutputs:Dr(f,"int32")}};const Po=Jt({resizeBilinear_:function(e,t,n=!1,r=!1){const s=Yt(e,"images","resizeBilinear");he(3===s.rank||4===s.rank,(()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${s.rank}.`)),he(2===t.length,(()=>`Error in resizeBilinear: new shape must 2D, but got shape ${t}.`)),he(!1===r||!1===n,(()=>"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false."));let a=s,o=!1;3===s.rank&&(o=!0,a=vn(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const i={images:a},u={alignCorners:n,halfPixelCenters:r,size:t},p=jt.runKernel("ResizeBilinear",i,u);return o?vn(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const Ko=Jt({resizeNearestNeighbor_:function(e,t,n=!1,r=!1){const s=Yt(e,"images","resizeNearestNeighbor");he(3===s.rank||4===s.rank,(()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${s.rank}.`)),he(2===t.length,(()=>`Error in resizeNearestNeighbor: new shape must 2D, but got shape ${t}.`)),he("float32"===s.dtype||"int32"===s.dtype,(()=>"`images` must have `int32` or `float32` as dtype")),he(!1===r||!1===n,(()=>"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false."));let a=s,o=!1;3===s.rank&&(o=!0,a=vn(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const i={images:a},u={alignCorners:n,halfPixelCenters:r,size:t},p=jt.runKernel("ResizeNearestNeighbor",i,u);return o?vn(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const qo=Jt({threshold_:function(e,t="binary",n=!1,r=.5){const s=Yt(e,"image","threshold"),a=s.shape[0]*s.shape[1];let o,i,u,p,l=Dn(Ua([r]),255);if(he(3===s.rank,(()=>`Error in threshold: image must be rank 3,but got rank ${s.rank}.`)),he(3===s.shape[2]||1===s.shape[2],(()=>`Error in threshold: image color channel must be equal to 3 or 1but got ${s.shape[2]}.`)),he("int32"===s.dtype||"float32"===s.dtype,(()=>`Error in dtype: image dtype must be int32 or float32,but got dtype ${s.dtype}.`)),he("otsu"===t||"binary"===t,(()=>`Method must be binary or otsu, but was ${t}`)),3===s.shape[2]){[o,i,u]=Fa(s,[1,1,1],-1);const e=Dn(o,.2989),t=Dn(i,.587),n=Dn(u,.114);p=rn(rn(e,t),n)}else p=e;if("otsu"===t){l=function(e,t){let n,r,s,a,o,i,u=Ua([-1]),p=Ua([0]),l=Ua([0]);for(let c=0;c<e.size-1;c++){n=On(e,0,c+1),r=On(e,c+1),o=fr(Mr(n),t),i=fr(Mr(r),t);const h=Mr(Dn(n,pa(0,n.size)));s=fr(h,Mr(n));const d=Wn(r.shape,n.size),m=rn(pa(0,r.size),d),f=Dn(r,m);a=fr(Mr(f),Mr(r));const y=os(s,a),g=os(s,a),b=Dn(o,i);l=Dn(Dn(b,y),g);const x=Ur(l,p);p=br(x,l,p),u=br(x,Ua([c]),u)}return u}(Bn(fn(xa(p),"int32"),qa([]),256),a)}const c=n?Xr(p,l):Ur(p,l);return fn(Dn(c,255),"int32")}});const Uo=Jt({transform_:function(e,t,n="nearest",r="constant",s=0,a){const o=Yt(e,"image","transform","float32"),i=Yt(t,"transforms","transform","float32");he(4===o.rank,(()=>`Error in transform: image must be rank 4,but got rank ${o.rank}.`)),he(2===i.rank&&(i.shape[0]===o.shape[0]||1===i.shape[0])&&8===i.shape[1],(()=>"Error in transform: Input transform should be batch x 8 or 1 x 8")),he(null==a||2===a.length,(()=>`Error in transform: outputShape must be [height, width] or null, but got ${a}.`));const u={image:o,transforms:i},p={interpolation:n,fillMode:r,fillValue:s,outputShape:a};return jt.runKernel("Transform",u,p)}});const Wo=Jt({bandPart_:function(e,t,n){he(t%1==0,(()=>`bandPart(): numLower must be an integer, got ${t}.`)),he(n%1==0,(()=>`bandPart(): numUpper must be an integer, got ${n}.`));const r=Yt(e,"a","bandPart");he(r.rank>=2,(()=>`bandPart(): Rank must be at least 2, got ${r.rank}.`));const s=r.shape,[a,o]=r.shape.slice(-2);if(!(t<=a))throw new Error(`bandPart(): numLower (${t}) must not be greater than the number of rows (${a}).`);if(!(n<=o))throw new Error(`bandPart(): numUpper (${n}) must not be greater than the number of columns (${o}).`);t<0&&(t=a),n<0&&(n=o);const i=vn(pa(0,a,1,"int32"),[-1,1]),u=pa(0,o,1,"int32"),p=os(i,u),l=ps(Xr(p,Dr(+t,"int32")),Wr(p,Dr(-n,"int32"))),c=xs([a,o],r.dtype);return vn(La(Qa(vn(r,[-1,a,o])).map((e=>br(l,e,c)))),s)}});const jo=Jt({gramSchmidt_:function(e){let t;if(Array.isArray(e)){t=!1,he(null!=e&&e.length>0,(()=>"Gram-Schmidt process: input must not be null, undefined, or empty"));const n=e[0].shape[0];for(let t=1;t<e.length;++t)he(e[t].shape[0]===n,(()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${e[t].shape[0]} vs. ${n})`))}else t=!0,e=Fa(e,e.shape[0],0).map((e=>Va(e,[0])));he(e.length<=e[0].shape[0],(()=>`Gram-Schmidt: Number of vectors (${e.length}) exceeds number of dimensions (${e[0].shape[0]}).`));const n=[],r=e;for(let t=0;t<e.length;++t)n.push(jt.tidy((()=>{let e=r[t];if(t>0)for(let r=0;r<t;++r){const t=Dn(Mr(Dn(n[r],e)),n[r]);e=os(e,t)}return fr(e,Fr(e,"euclidean"))})));return t?La(n,0):n}});function Ho(e,t=!1){return jt.tidy((()=>{he(2===e.shape.length,(()=>`qr2d() requires a 2D Tensor, but got a ${e.shape.length}D Tensor.`));const n=e.shape[0],r=e.shape[1];let s=Pr(n),a=En(e);const o=Wa([[1]],[1,1]);let i=En(o);const u=n>=r?r:n;for(let e=0;e<u;++e){const t=a,u=i,p=s;[i,a,s]=jt.tidy((()=>{const t=On(a,[e,e],[n-e,1]),u=Fr(t),p=On(a,[e,e],[1,1]),l=br(Ur(p,0),Wa([[-1]]),Wa([[1]])),c=os(p,Dn(l,u)),h=fr(t,c);i=1===h.shape[0]?En(o):In([o,On(h,[1,0],[h.shape[0]-1,h.shape[1]])],0);const d=rs(fr($n(l,c),u)),m=On(a,[e,0],[n-e,r]),f=Dn(d,i),y=Ja(i);if(0===e)a=os(m,$n(f,$n(y,m)));else{const t=os(m,$n(f,$n(y,m)));a=In([On(a,[0,0],[e,r]),t],0)}const g=Ja(f),b=On(s,[0,e],[n,s.shape[1]-e]);if(0===e)s=os(b,$n($n(b,i),g));else{const t=os(b,$n($n(b,i),g));s=In([On(s,[0,0],[n,e]),t],1)}return[i,a,s]})),Pt([t,u,p]).forEach((e=>e.dispose()))}return!t&&n>r&&(s=On(s,[0,0],[n,r]),a=On(a,[0,0],[r,r])),[s,a]}))}const Go=Jt({qr_:function(e,t=!1){if(he(e.rank>=2,(()=>`qr() requires input tensor to have a rank >= 2, but got rank ${e.rank}`)),2===e.rank)return Ho(e,t);{const n=e.shape.slice(0,e.shape.length-2).reduce(((e,t)=>e*t)),r=Qa(vn(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),s=[],a=[];r.forEach((e=>{const[n,r]=Ho(e,t);s.push(n),a.push(r)}));return[vn(La(s,0),e.shape),vn(La(a,0),e.shape)]}}});var Zo;!function(e){e[e.NONE=0]="NONE",e[e.MEAN=1]="MEAN",e[e.SUM=2]="SUM",e[e.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}(Zo||(Zo={}));const Qo=Jt({computeWeightedLoss_:function(e,t,n=Zo.SUM_BY_NONZERO_WEIGHTS){const r=Yt(e,"losses","computeWeightedLoss");let s=null;null!=t&&(s=Yt(t,"weights","computeWeightedLoss"));const a=null==s?r:Dn(r,s);if(n===Zo.NONE)return a;if(n===Zo.SUM)return Mr(a);if(n===Zo.MEAN){if(null==s)return bs(a);{const e=r.size/s.size,t=fr(Mr(a),Mr(s));return e>1?fr(t,Dr(e)):t}}if(n===Zo.SUM_BY_NONZERO_WEIGHTS){if(null==s)return fr(Mr(a),Dr(r.size));{const e=Dn(s,Ns(r.shape)),t=fn(Mr(Es(e,Dr(0))),"float32");return fr(Mr(a),t)}}throw Error(`Unknown reduction: ${n}`)}});const Yo=Jt({absoluteDifference_:function(e,t,n,r=Zo.SUM_BY_NONZERO_WEIGHTS){const s=Yt(e,"labels","absoluteDifference"),a=Yt(t,"predictions","absoluteDifference");let o=null;null!=n&&(o=Yt(n,"weights","absoluteDifference")),de(s.shape,a.shape,"Error in absoluteDifference: ");const i=en(os(s,a));return Qo(i,o,r)}});const Xo=Jt({cosineDistance_:function(e,t,n,r,s=Zo.SUM_BY_NONZERO_WEIGHTS){const a=Yt(e,"labels","cosineDistance"),o=Yt(t,"predictions","cosineDistance");let i=null;null!=r&&(i=Yt(r,"weights","cosineDistance")),de(a.shape,o.shape,"Error in cosineDistance: ");const u=Dr(1),p=os(u,Mr(Dn(a,o),n,!0));return Qo(p,i,s)}});const Jo=Jt({hingeLoss_:function(e,t,n,r=Zo.SUM_BY_NONZERO_WEIGHTS){let s=Yt(e,"labels","hingeLoss");const a=Yt(t,"predictions","hingeLoss");let o=null;null!=n&&(o=Yt(n,"weights","hingeLoss")),de(s.shape,a.shape,"Error in hingeLoss: ");const i=Dr(1);s=os(Dn(Dr(2),s),i);const u=ha(os(i,Dn(s,a)));return Qo(u,o,r)}});const ei=Jt({huberLoss_:function(e,t,n,r=1,s=Zo.SUM_BY_NONZERO_WEIGHTS){const a=Yt(e,"labels","huberLoss"),o=Yt(t,"predictions","huberLoss");let i=null;null!=n&&(i=Yt(n,"weights","huberLoss")),de(a.shape,o.shape,"Error in huberLoss: ");const u=Dr(r),p=en(os(o,a)),l=ws(p,u),c=os(p,l),h=rn(Dn(Dr(.5),Or(l)),Dn(u,c));return Qo(h,i,s)}});const ti=Jt({logLoss_:function(e,t,n,r=1e-7,s=Zo.SUM_BY_NONZERO_WEIGHTS){const a=Yt(e,"labels","logLoss"),o=Yt(t,"predictions","logLoss");let i=null;null!=n&&(i=Yt(n,"weights","logLoss")),de(a.shape,o.shape,"Error in logLoss: ");const u=Dr(1),p=Dr(r),l=rs(Dn(a,es(rn(o,p)))),c=Dn(os(u,a),es(rn(os(u,o),p))),h=os(l,c);return Qo(h,i,s)}});const ni=Jt({meanSquaredError_:function(e,t,n,r=Zo.SUM_BY_NONZERO_WEIGHTS){const s=Yt(e,"labels","meanSquaredError"),a=Yt(t,"predictions","meanSquaredError");let o=null;null!=n&&(o=Yt(n,"weights","meanSquaredError")),de(s.shape,a.shape,"Error in meanSquaredError: ");const i=za(s,a);return Qo(i,o,r)}});const ri=Jt({sigmoidCrossEntropy_:function(e,t,n,r=0,s=Zo.SUM_BY_NONZERO_WEIGHTS){let a=Yt(e,"multiClassLabels","sigmoidCrossEntropy");const o=Yt(t,"logits","sigmoidCrossEntropy");let i=null;if(null!=n&&(i=Yt(n,"weights","sigmoidCrossEntropy")),de(a.shape,o.shape,"Error in sigmoidCrossEntropy: "),r>0){const e=Dr(r),t=Dr(1),n=Dr(.5);a=rn(Dn(a,os(t,e)),Dn(n,e))}const u=function(e,t){const n=Yt(e,"labels","sigmoidCrossEntropyWithLogits"),r=Yt(t,"logits","sigmoidCrossEntropyWithLogits");de(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");const s=ha(r),a=Dn(r,n),o=ts(zr(rs(en(r))));return rn(os(s,a),o)}(a,o);return Qo(u,i,s)}});const si=Jt({softmaxCrossEntropy_:function(e,t,n,r=0,s=Zo.SUM_BY_NONZERO_WEIGHTS){let a=Yt(e,"onehotLabels","softmaxCrossEntropy");const o=Yt(t,"logits","softmaxCrossEntropy");let i=null;if(null!=n&&(i=Yt(n,"weights","softmaxCrossEntropy")),de(a.shape,o.shape,"Error in softmaxCrossEntropy: "),r>0){const e=Dr(r),t=Dr(1),n=Dr(a.shape[1]);a=rn(Dn(a,os(t,e)),fr(e,n))}const u=function(e,t,n=-1){if(-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error(`Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank ${t.rank} and dim was ${n}`);const r=ns(((e,t,r)=>{const s=us(t,[n],!0),a=os(fn(t,"float32"),s);r([e,a]);const o=rs(Dn(a,e));return{value:Mr(o,[n]),gradFunc:(e,t)=>{const[r,s]=t,a=_r(e.shape,[n]);return[Dn(vn(e,a),os(fn(r,"float32"),zr(s))),Dn(vn(e,a),os(zr(s),fn(r,"float32")))]}}}));return r(e,t)}(a,o);return Qo(u,i,s)}});const ai=Jt({sparseFillEmptyRows_:function(e,t,n,r){const s=Yt(e,"indices","sparseFillEmptyRows","int32"),a=Yt(t,"values","sparseFillEmptyRows"),o=Yt(n,"denseShape","sparseFillEmptyRows","int32"),i=Yt(r,"defaultValue","sparseFillEmptyRows",a.dtype);if(2!==s.rank)throw new Error(`Indices should be Tensor2D but received shape\n        ${s.shape}`);if(1!==a.rank)throw new Error(`Values should be Tensor1D but received shape ${a.shape}`);if(1!==o.rank)throw new Error(`Dense shape should be Tensor1D but received shape ${o.shape}`);if(0!==i.rank)throw new Error(`Default value should be a scalar but received shape ${i.shape}`);const u={indices:s,values:a,denseShape:o,defaultValue:i},p=jt.runKernel("SparseFillEmptyRows",u);return{outputIndices:p[0],outputValues:p[1],emptyRowIndicator:p[2],reverseIndexMap:p[3]}}});const oi=Jt({sparseReshape_:function(e,t,n){const r=Yt(e,"inputIndices","sparseReshape","int32"),s=Yt(t,"inputShape","sparseReshape","int32"),a=Yt(n,"newShape","sparseReshape","int32");if(2!==r.rank)throw new Error(`Input indices should be Tensor2D but received shape\n        ${r.shape}`);if(1!==s.rank)throw new Error(`Input shape should be Tensor1D but received shape ${s.shape}`);if(1!==a.rank)throw new Error(`New shape should be Tensor1D but received shape ${a.shape}`);const o={inputIndices:r,inputShape:s,newShape:a},i=jt.runKernel("SparseReshape",o);return{outputIndices:i[0],outputShape:i[1]}}});const ii=Jt({sparseSegmentMean_:function(e,t,n){const r=Yt(e,"data","sparseSegmentMean"),s=Yt(t,"indices","sparseSegmentMean","int32"),a=Yt(n,"segmentIds","sparseSegmentMean","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==s.rank)throw new Error(`Indices should be Tensor1D but received shape\n          ${s.shape}`);if(1!==a.rank)throw new Error(`Segment ids should be Tensor1D but received shape\n          ${a.shape}`);const o={data:r,indices:s,segmentIds:a};return jt.runKernel("SparseSegmentMean",o)}});const ui=Jt({sparseSegmentSum_:function(e,t,n){const r=Yt(e,"data","sparseSegmentSum"),s=Yt(t,"indices","sparseSegmentSum","int32"),a=Yt(n,"segmentIds","sparseSegmentSum","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==s.rank)throw new Error(`Indices should be Tensor1D but received shape\n         ${s.shape}`);if(1!==a.rank)throw new Error(`Segment ids should be Tensor1D but received shape\n         ${a.shape}`);const o={data:r,indices:s,segmentIds:a};return jt.runKernel("SparseSegmentSum",o)}});const pi=Jt({stringNGrams_:function(e,t,n,r,s,a,o,i){const u=Yt(e,"data","stringNGrams","string");if("string"!==u.dtype)throw new Error("Data must be of datatype string");if(1!==u.shape.length)throw new Error(`Data must be a vector, saw: ${u.shape}`);const p=Yt(t,"dataSplits","stringNGrams");if("int32"!==p.dtype)throw new Error("Data splits must be of datatype int32");const l={separator:n,nGramWidths:r,leftPad:s,rightPad:a,padWidth:o,preserveShortSequences:i},c={data:u,dataSplits:p},h=jt.runKernel("StringNGrams",c,l);return{nGrams:h[0],nGramsSplits:h[1]}}});var li={__proto__:null,abs:en,acos:tn,acosh:nn,add:rn,addN:sn,all:an,any:on,argMax:un,argMin:pn,asin:ln,asinh:cn,atan:hn,atan2:dn,atanh:mn,avgPool:_n,avgPool3d:Sn,basicLSTMCell:Cn,batchToSpaceND:Fn,batchNorm:Rn,batchNorm2d:zn,batchNorm3d:Vn,batchNorm4d:Ln,bincount:Bn,broadcastArgs:Pn,broadcastTo:Kn,buffer:qn,cast:fn,ceil:Un,clipByValue:jn,clone:En,complex:Hn,concat:In,concat1d:Gn,concat2d:Zn,concat3d:Qn,concat4d:Yn,conv1d:Jn,conv2d:Xn,conv2dTranspose:tr,conv3d:nr,conv3dTranspose:sr,cos:ar,cosh:or,cumprod:ir,cumsum:ur,denseBincount:pr,depthToSpace:lr,depthwiseConv2d:cr,diag:hr,dilation2d:dr,div:fr,divNoNan:Nr,dot:wr,einsum:kr,elu:Tr,equal:gr,erf:vr,euclideanNorm:Rr,exp:zr,expandDims:Vr,expm1:Lr,eye:Pr,fill:Wn,floor:Kr,floorDiv:mr,gather:qr,greater:Ur,greaterEqual:Wr,imag:jr,isFinite:Hr,isInf:Gr,isNaN:Zr,leakyRelu:Qr,less:Yr,lessEqual:Xr,linspace:function(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");const r={start:e,stop:t,num:n};return jt.runKernel("LinSpace",{},r)},localResponseNormalization:Jr,log:es,log1p:ts,logSigmoid:as,logSoftmax:is,logSumExp:us,logicalAnd:ps,logicalNot:ls,logicalOr:cs,logicalXor:hs,lowerBound:function(e,t){return ds(e,t,"left")},matMul:$n,max:Sr,maxPool:ms,maxPool3d:fs,maxPoolWithArgmax:ys,maximum:gs,mean:bs,meshgrid:function(e,t,{indexing:n="xy"}={}){if("xy"!==n&&"ij"!==n)throw new TypeError(`${n} is not a valid third argument to meshgrid`);if(void 0===e)return[];let r=Yt(e,"x","meshgrid",e instanceof Ot?e.dtype:"float32");if(void 0===t)return[r];let s=Yt(t,"y","meshgrid",t instanceof Ot?t.dtype:"float32");const a=fe(r.shape),o=fe(s.shape);return"xy"===n?(r=vn(r,[1,-1]),s=vn(s,[-1,1]),[$n(Ns([o,1],r.dtype),r),$n(s,Ns([1,a],s.dtype))]):(r=vn(r,[-1,1]),s=vn(s,[1,-1]),[$n(r,Ns([1,o],r.dtype)),$n(Ns([a,1],s.dtype),s)])},min:Er,minimum:ws,mirrorPad:ks,mod:Ts,moments:vs,mul:Dn,multiRNNCell:_s,multinomial:Ss,neg:rs,notEqual:Es,oneHot:Is,ones:Ns,onesLike:$s,outerProduct:Ds,pad:As,pad1d:Os,pad2d:Ms,pad3d:Cs,pad4d:Fs,pool:zs,pow:Ir,prelu:Vs,print:function(e,t=!1){console.log(e.toString(t))},prod:Ls,raggedGather:Bs,raggedRange:Ps,raggedTensorToTensor:Ks,rand:qs,randomGamma:aa,randomNormal:oa,randomStandardNormal:ia,randomUniform:ua,range:pa,real:la,reciprocal:ca,relu:ha,relu6:da,reshape:vn,reverse:ma,reverse1d:fa,reverse2d:ya,reverse3d:ga,reverse4d:ba,round:xa,rsqrt:Na,scalar:Dr,selu:wa,separableConv2d:ka,setdiff1dAsync:Ta,sigmoid:An,sign:va,sin:_a,sinh:Sa,slice:On,slice1d:Ea,slice2d:Ia,slice3d:$a,slice4d:Da,softmax:Aa,softplus:ss,spaceToBatchND:Rs,fft:Oa,ifft:Ma,irfft:Ca,rfft:Ra,split:Fa,sqrt:Ar,square:Or,squaredDifference:za,squeeze:Va,stack:La,step:Ba,stridedSlice:Pa,sub:os,sum:Mr,tan:Ka,tanh:Mn,tensor:qa,tensor1d:Ua,tensor2d:Wa,tensor3d:function(e,t,n){if(me(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");const r=Gt(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return $r(e,t,r,n)},tensor4d:function(e,t,n){if(me(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");const r=Gt(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return $r(e,t,r,n)},tensor5d:function(e,t,n){if(me(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");const r=Gt(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return $r(e,t,r,n)},tensor6d:function(e,t,n){if(me(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");const r=Gt(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return $r(e,t=t||r,r,n)},tile:Br,topk:ja,truncatedNormal:Ha,unique:Ga,unsortedSegmentSum:Za,unstack:Qa,upperBound:function(e,t){return ds(e,t,"right")},variable:function(e,t=!0,n,r){return jt.makeVariable(e,t,n,r)},where:br,whereAsync:Ya,zeros:xs,zerosLike:xr,op:Jt,OP_SCOPE_SUFFIX:"__op",booleanMaskAsync:Xa,transpose:Ja,norm:Fr,movingAverage:eo,scatterND:no,searchSorted:ds,sparseToDense:ro,gatherND:so,dropout:ao,enclosingPowerOfTwo:oo,cosineWindow:io,inTopKAsync:uo,image:{flipLeftRight:_o,grayscaleToRGB:So,resizeNearestNeighbor:Ko,resizeBilinear:Po,rotateWithOffset:Eo,cropAndResize:vo,nonMaxSuppression:$o,nonMaxSuppressionAsync:Ro,nonMaxSuppressionWithScore:zo,nonMaxSuppressionWithScoreAsync:Vo,nonMaxSuppressionPadded:Lo,nonMaxSuppressionPaddedAsync:Bo,threshold:qo,transform:Uo},linalg:{bandPart:Wo,gramSchmidt:jo,qr:Go},losses:{absoluteDifference:Yo,computeWeightedLoss:Qo,cosineDistance:Xo,hingeLoss:Jo,huberLoss:ei,logLoss:ti,meanSquaredError:ni,sigmoidCrossEntropy:ri,softmaxCrossEntropy:si},spectral:{fft:Oa,ifft:Ma,rfft:Ra,irfft:Ca},fused:xo,signal:{hammingWindow:No,hannWindow:wo,frame:ko,stft:To},sparse:{sparseFillEmptyRows:ai,sparseReshape:oi,sparseSegmentMean:ii,sparseSegmentSum:ui},string:{stringNGrams:pi,stringSplit:Jt({stringSplit_:function(e,t,n=!0){const r=Yt(e,"input","stringSplit","string"),s=Yt(t,"delimiter","stringSplit","string");if(1!==r.rank)throw new Error(`Input should be Tensor1D but received shape ${r.shape}`);if(0!==s.rank)throw new Error(`Delimiter should be a scalar but received shape ${s.shape}`);const a={skipEmpty:n},o={input:r,delimiter:s},i=jt.runKernel("StringSplit",o,a);return{indices:i[0],values:i[1],shape:i[2]}}}),stringToHashBucketFast:Jt({stringToHashBucketFast_:function(e,t){const n=Yt(e,"input","stringToHashBucketFast","string"),r={numBuckets:t};if(t<=0)throw new Error("Number of buckets must be at least 1");const s={input:n};return jt.runKernel("StringToHashBucketFast",s,r)}})}};function ci(e,t,r=""){if("number"!=typeof e&&"number"!=typeof t){n.assert(e.length===t.length,(()=>r+` Shapes ${e} and ${t} must match`));for(let s=0;s<e.length;s++){const a=e[s],o=t[s];n.assert(a<0||o<0||a===o,(()=>r+` Shapes ${e} and ${t} must match`))}}}function hi(e){return"number"!=typeof e&&!e.some((e=>e<0))}function di(e,t,n){let r=mi(e,n);const s=!hi(r);if(s&&0===t.length)throw new Error(`Tried to calculate elements of an empty list with non-fully-defined elementShape: ${r}`);if(s&&t.forEach((e=>{r=mi(e.shape,r)})),!hi(r))throw new Error(`Non-fully-defined elementShape: ${r}`);return r}function mi(e,t){if("number"==typeof e)return t;if("number"==typeof t)return e;if(e.length!==t.length)throw new Error(`Incompatible ranks during merge: ${e} vs. ${t}`);const n=[];for(let r=0;r<e.length;++r){const s=e[r],a=t[r];if(s>=0&&a>=0&&s!==a)throw new Error(`Incompatible shape during merge: ${e} vs. ${t}`);n[r]=s>=0?s:a}return n}class fi{constructor(e,t,n,r,o,i,u){this.name=e,this.dtype=t,this.maxSize=n,this.elementShape=r,this.identicalElementShapes=o,this.dynamicSize=i,this.clearAfterRead=u,this.tensors=[],this.closed_=!1,this.idTensor=s(0),a(this.idTensor)}get id(){return this.idTensor.id}get closed(){return this.closed_}clearAndClose(e){this.tensors.forEach((t=>{null!=e&&e.has(t.tensor.id)||t.tensor.dispose()})),this.tensors=[],this.closed_=!0,this.idTensor.dispose()}size(){return this.tensors.length}read(e){if(this.closed_)throw new Error(`TensorArray ${this.name} has already been closed.`);if(e<0||e>=this.size())throw new Error(`Tried to read from index ${e}, but array size is: ${this.size()}`);const t=this.tensors[e];if(t.cleared)throw new Error(`TensorArray ${this.name}: Could not read index ${e} twice because it was cleared after a previous read (perhaps try setting clear_after_read = false?).`);return this.clearAfterRead&&(t.cleared=!0),t.read=!0,t.tensor}readMany(e){return e.map((e=>this.read(e)))}write(e,t){if(this.closed_)throw new Error(`TensorArray ${this.name} has already been closed.`);if(e<0||!this.dynamicSize&&e>=this.maxSize)throw new Error(`Tried to write to index ${e}, but array is not resizeable and size is: ${this.maxSize}`);const n=this.tensors[e]||{};if(t.dtype!==this.dtype)throw new Error(`TensorArray ${this.name}: Could not write to TensorArray index ${e},\n          because the value dtype is ${t.dtype}, but TensorArray dtype is ${this.dtype}.`);if(0!==this.size()||null!=this.elementShape&&0!==this.elementShape.length||(this.elementShape=t.shape),ci(this.elementShape,t.shape,`TensorArray ${this.name}: Could not write to TensorArray index ${e}.`),n.read)throw new Error(`TensorArray ${this.name}: Could not write to TensorArray index ${e}, because it has already been read.`);if(n.written)throw new Error(`TensorArray ${this.name}: Could not write to TensorArray index ${e}, because it has already been written.`);n.tensor=t,a(t),n.written=!0,this.tensors[e]=n}writeMany(e,t){if(e.length!==t.length)throw new Error(`TensorArray ${this.name}: could not write multiple tensors,because the index size: ${e.length} is not the same as tensors size: ${t.length}.`);e.forEach(((e,n)=>this.write(e,t[n])))}gather(e,t){if(t&&t!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but gather requested dtype ${t}`);if(e)e=e.slice(0,this.size());else{e=[];for(let t=0;t<this.size();t++)e.push(t)}if(0===e.length)return o([],[0].concat(this.elementShape));const n=this.readMany(e);return ci(this.elementShape,n[0].shape,"TensorArray shape mismatch: "),i(n,0)}concat(e){if(e&&e!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but concat requested dtype ${e}`);if(0===this.size())return o([],[0].concat(this.elementShape));const t=[];for(let e=0;e<this.size();e++)t.push(e);const n=this.readMany(t);return ci(this.elementShape,n[0].shape,`TensorArray shape mismatch: tensor array shape (${this.elementShape}) vs first tensor shape (${n[0].shape})`),u(n,0)}scatter(e,t){if(t.dtype!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but tensor has dtype ${t.dtype}`);if(e.length!==t.shape[0])throw new Error(`Expected len(indices) == tensor.shape[0], but saw: ${e.length} vs. ${t.shape[0]}`);const n=Math.max(...e);if(!this.dynamicSize&&n>=this.maxSize)throw new Error(`Max index must be < array size (${n}  vs. ${this.maxSize})`);this.writeMany(e,p(t,0))}split(e,t){if(t.dtype!==this.dtype)throw new Error(`TensorArray dtype is ${this.dtype} but tensor has dtype ${t.dtype}`);let n=0;const r=e.map((e=>(n+=e,n)));if(n!==t.shape[0])throw new Error(`Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ${n}, and tensor's shape is: ${t.shape}`);if(!this.dynamicSize&&e.length!==this.maxSize)throw new Error(`TensorArray's size is not equal to the size of lengths (${this.maxSize} vs. ${e.length}), and the TensorArray is not marked as dynamically resizeable`);const s=0===n?0:t.size/n,a=[];l((()=>{t=c(t,[1,n,s]);for(let n=0;n<e.length;++n){const o=[0,0===n?0:r[n-1],0],i=[1,e[n],s];a[n]=c(h(t,o,i),this.elementShape)}return a}));const o=[];for(let t=0;t<e.length;t++)o[t]=t;this.writeMany(o,a)}}class yi{constructor(e,t,n,r=-1){this.tensors=e,this.elementShape=t,this.elementDtype=n,null!=e&&e.forEach((e=>{if(n!==e.dtype)throw new Error(`Invalid data types; op elements ${n}, but list elements ${e.dtype}`);ci(t,e.shape,"TensorList shape mismatch: "),a(e)})),this.idTensor=s(0),this.maxNumElements=r,a(this.idTensor)}get id(){return this.idTensor.id}copy(){return new yi([...this.tensors],this.elementShape,this.elementDtype)}clearAndClose(e){this.tensors.forEach((t=>{null!=e&&e.has(t.id)||t.dispose()})),this.tensors.length=0,this.idTensor.dispose()}size(){return this.tensors.length}stack(e,t,n=-1){if(t!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t}, but list elements ${this.elementDtype}`);if(-1!==n&&this.tensors.length!==n)throw new Error(`Operation expected a list with ${n} elements but got a list with ${this.tensors.length} elements.`);ci(e,this.elementShape,"TensorList shape mismatch: ");const r=di(this.elementShape,this.tensors,e);return l((()=>{const e=this.tensors.map((e=>c(e,r)));return i(e,0)}))}popBack(e,t){if(t!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t}, but list elements ${this.elementDtype}`);if(0===this.size())throw new Error("Trying to pop from an empty list.");const n=di(this.elementShape,this.tensors,e),r=this.tensors.pop();return r.kept=!1,ci(r.shape,e,"TensorList shape mismatch: "),c(r,n)}pushBack(e){if(e.dtype!==this.elementDtype)throw new Error(`Invalid data types; op elements ${e.dtype}, but list elements ${this.elementDtype}`);if(ci(e.shape,this.elementShape,"TensorList shape mismatch: "),this.maxNumElements===this.size())throw new Error("Trying to push element into a full list.");a(e),this.tensors.push(e)}resize(e){if(e<0)throw new Error(`TensorListResize expects size to be non-negative. Got: ${e}`);if(-1!==this.maxNumElements&&e>this.maxNumElements)throw new Error(`TensorListResize input size ${e} is greater maxNumElement ${this.maxNumElements}.`);const t=new yi([],this.elementShape,this.elementDtype,this.maxNumElements);t.tensors.length=e;for(let n=0;n<Math.min(this.tensors.length,e);++n)t.tensors[n]=this.tensors[n];return t}getItem(e,t,n){if(n!==this.elementDtype)throw new Error(`Invalid data types; op elements ${n}, but list elements ${this.elementDtype}`);if(e<0||e>this.tensors.length)throw new Error(`Trying to access element ${e} in a list with ${this.tensors.length} elements.`);if(null==this.tensors[e])throw new Error(`element at index ${e} is null.`);ci(this.tensors[e].shape,t,"TensorList shape mismatch: ");const r=di(this.elementShape,this.tensors,t);return c(this.tensors[e],r)}setItem(e,t){if(t.dtype!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t.dtype}, but list elements ${this.elementDtype}`);if(e<0||-1!==this.maxNumElements&&e>=this.maxNumElements)throw new Error(`Trying to set element ${e} in a list with max ${this.maxNumElements} elements.`);ci(this.elementShape,t.shape,"TensorList shape mismatch: "),a(t),null!=this.tensors[e]&&(this.tensors[e].kept=!1),this.tensors[e]=t}gather(e,t,n){if(t!==this.elementDtype)throw new Error(`Invalid data types; op elements ${t}, but list elements ${this.elementDtype}`);ci(this.elementShape,n,"TensorList shape mismatch: "),e=e.slice(0,this.size());const r=di(this.elementShape,this.tensors,n);return 0===e.length?o([],[0].concat(r)):l((()=>{const t=e.map((e=>c(this.tensors[e],r)));return i(t,0)}))}concat(e,t){if(e&&e!==this.elementDtype)throw new Error(`TensorList dtype is ${this.elementDtype} but concat requested dtype ${e}`);ci(this.elementShape,t,"TensorList shape mismatch: ");const n=di(this.elementShape,this.tensors,t);return 0===this.size()?o([],[0].concat(n)):l((()=>{const e=this.tensors.map((e=>c(e,n)));return u(e,0)}))}}const gi=async(e,t,n)=>{switch(e.op){case"If":case"StatelessIf":{const r=T("thenBranch",e,t,n),s=T("elseBranch",e,t,n),a=T("cond",e,t,n),o=T("args",e,t,n);return(await a.data())[0]?n.functionMap[r].executeFunctionAsync(o,n.tensorArrayMap,n.tensorListMap):n.functionMap[s].executeFunctionAsync(o,n.tensorArrayMap,n.tensorListMap)}case"While":case"StatelessWhile":{const r=T("body",e,t,n),s=T("cond",e,t,n),a=T("args",e,t,n),o=await n.functionMap[s].executeFunctionAsync(a,n.tensorArrayMap,n.tensorListMap),i=a.map((e=>e.id));let u=await o[0].data();o.forEach((e=>{e.kept||-1!==i.indexOf(e.id)||e.dispose()}));let p=a;for(;u[0];){const e=p;p=await n.functionMap[r].executeFunctionAsync(p,n.tensorArrayMap,n.tensorListMap);const t=p.map((e=>e.id));e.forEach((e=>{e.kept||-1!==i.indexOf(e.id)||-1!==t.indexOf(e.id)||e.dispose()}));const a=await n.functionMap[s].executeFunctionAsync(p,n.tensorArrayMap,n.tensorListMap);u=await a[0].data(),a.forEach((e=>{e.kept||-1!==i.indexOf(e.id)||-1!==t.indexOf(e.id)||e.dispose()}))}return p}case"LoopCond":return[$(T("pred",e,t,n))];case"Switch":{const r=T("pred",e,t,n);let s=T("data",e,t,n);return s.kept||(s=$(s)),(await r.data())[0]?[void 0,s]:[s,void 0]}case"Merge":{const r=e.inputNames.find((e=>void 0!==v(e,t,n)));if(r){return[$(v(r,t,n))]}return}case"Enter":{const r=T("frameName",e,t,n),s=T("tensor",e,t,n);return n.enterFrame(r),[$(s)]}case"Exit":{const r=T("tensor",e,t,n);return n.exitFrame(),[$(r)]}case"NextIteration":{const r=T("tensor",e,t,n);return n.nextIteration(),[$(r)]}case"TensorArrayV3":{const r=T("size",e,t,n),a=T("dtype",e,t,n),o=T("elementShape",e,t,n),i=T("dynamicSize",e,t,n),u=T("clearAfterRead",e,t,n),p=T("identicalElementShapes",e,t,n),l=T("name",e,t,n),c=new fi(l,a,r,o,p,i,u);return n.addTensorArray(c),[c.idTensor,s(1)]}case"TensorArrayWriteV3":{const r=T("tensorArrayId",e,t,n),s=T("index",e,t,n),a=T("tensor",e,t,n),o=n.getTensorArray(r.id);return o.write(s,a),[o.idTensor]}case"TensorArrayReadV3":{const r=T("tensorArrayId",e,t,n),s=T("index",e,t,n);return[n.getTensorArray(r.id).read(s)]}case"TensorArrayGatherV3":{const r=T("tensorArrayId",e,t,n),s=T("indices",e,t,n),a=T("dtype",e,t,n);return[n.getTensorArray(r.id).gather(s,a)]}case"TensorArrayScatterV3":{const r=T("tensorArrayId",e,t,n),s=T("indices",e,t,n),a=T("tensor",e,t,n),o=n.getTensorArray(r.id);return o.scatter(s,a),[o.idTensor]}case"TensorArrayConcatV3":{const r=T("tensorArrayId",e,t,n),s=n.getTensorArray(r.id),a=T("dtype",e,t,n);return[s.concat(a)]}case"TensorArraySplitV3":{const r=T("tensorArrayId",e,t,n),s=T("tensor",e,t,n),a=T("lengths",e,t,n),o=n.getTensorArray(r.id);return o.split(a,s),[o.idTensor]}case"TensorArraySizeV3":{const r=T("tensorArrayId",e,t,n),a=n.getTensorArray(r.id);return[s(a.size(),"int32")]}case"TensorArrayCloseV3":{const r=T("tensorArrayId",e,t,n),s=n.getTensorArray(r.id);return s.clearAndClose(),[s.idTensor]}case"TensorListSetItem":{const r=T("tensorListId",e,t,n),s=T("index",e,t,n),a=T("tensor",e,t,n),o=n.getTensorList(r.id);return o.setItem(s,a),[o.idTensor]}case"TensorListGetItem":{const r=T("tensorListId",e,t,n),s=T("index",e,t,n),a=T("elementShape",e,t,n),o=T("elementDType",e,t,n);return[n.getTensorList(r.id).getItem(s,a,o)]}case"TensorListScatterV2":case"TensorListScatter":{const r=T("indices",e,t,n),s=function(e,t,n,r){if(t.length!==e.shape[0])throw new Error(`Expected len(indices) == tensor.shape[0], but saw: ${t.length} vs. ${e.shape[0]}`);const s=Math.max(...t);if(null!=r&&-1!==r&&s>=r)throw new Error(`Max index must be < array size (${s}  vs. ${r})`);const a=new yi([],n,e.dtype,r),o=p(e,0);return t.forEach(((e,t)=>{a.setItem(e,o[t])})),a}(T("tensor",e,t,n),r,T("elementShape",e,t,n),T("numElements",e,t,n));return n.addTensorList(s),[s.idTensor]}case"TensorListReserve":case"EmptyTensorList":{const r=T("elementShape",e,t,n),s=T("elementDType",e,t,n);let a;a="TensorListReserve"===e.op?"numElements":"maxNumElements";const o=T(a,e,t,n),i=function(e,t,n,r){return new yi([],e,t,r)}(r,s,0,"TensorListReserve"===e.op?-1:o);return n.addTensorList(i),[i.idTensor]}case"TensorListGather":{const r=T("tensorListId",e,t,n),s=T("indices",e,t,n),a=T("elementShape",e,t,n),o=T("elementDType",e,t,n);return[n.getTensorList(r.id).gather(s,o,a)]}case"TensorListStack":{const r=T("tensorListId",e,t,n),s=T("elementShape",e,t,n),a=T("elementDType",e,t,n),o=T("numElements",e,t,n);return[n.getTensorList(r.id).stack(s,a,o)]}case"TensorListFromTensor":{const r=function(e,t,n){const r=e.dtype;if(e.shape.length<1)throw new Error(`Tensor must be at least a vector, but saw shape: ${e.shape}`);if(e.dtype!==n)throw new Error(`Invalid data types; op elements ${e.dtype}, but list elements ${n}`);ci(e.shape.slice(1),t,"TensorList shape mismatch: ");const s=p(e);return new yi(s,t,r)}(T("tensor",e,t,n),T("elementShape",e,t,n),T("elementDType",e,t,n));return n.addTensorList(r),[r.idTensor]}case"TensorListConcat":case"TensorListConcatV2":{const r=T("tensorListId",e,t,n),s=n.getTensorList(r.id),a=T("dtype",e,t,n),o=T("elementShape",e,t,n);return[s.concat(a,o)]}case"TensorListPushBack":{const r=T("tensorListId",e,t,n),s=T("tensor",e,t,n),a=n.getTensorList(r.id);return a.pushBack(s),[a.idTensor]}case"TensorListPopBack":{const r=T("tensorListId",e,t,n),s=T("elementShape",e,t,n),a=T("elementDType",e,t,n);return[n.getTensorList(r.id).popBack(s,a)]}case"TensorListSplit":{const r=T("tensor",e,t,n),s=T("elementShape",e,t,n),a=function(e,t,n){let r=0;const s=t.map((e=>(r+=e,r)));if(r!==e.shape[0])throw new Error(`Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ${r}, and tensor's shape is: ${e.shape}`);const a=mi(e.shape.slice(1),n),o=0===r?0:e.size/r,i=l((()=>{const n=[];e=c(e,[1,r,o]);for(let r=0;r<t.length;++r){const i=[0,0===r?0:s[r-1],0],u=[1,t[r],o];n[r]=c(h(e,i,u),a)}return e.dispose(),n})),u=new yi([],n,e.dtype,t.length);for(let e=0;e<i.length;e++)u.setItem(e,i[e]);return u}(r,T("lengths",e,t,n),s);return n.addTensorList(a),[a.idTensor]}case"TensorListLength":{const r=T("tensorListId",e,t,n),a=n.getTensorList(r.id);return[s(a.size(),"int32")]}case"TensorListResize":{const r=T("tensorListId",e,t,n),s=T("size",e,t,n),a=n.getTensorList(r.id).resize(s);return n.addTensorList(a),[a.idTensor]}default:throw TypeError(`Node type ${e.op} is not implemented`)}};function bi(e,t,n){const[r,s]=T("fusedOps",e,t,n),a="biasadd"===r,o=!a,i="prelu"===s,u="fusedbatchnorm"===r,p=T("numArgs",e,t,n);if(a){if(i&&2!==p)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!i&&a&&1!==p)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd must have one extra argument: bias.")}if(u)throw new Error("FusedConv2d and DepthwiseConv2d with FusedBatchNorm is not supported");const l=T("strides",e,t,n),c=I(e,t,n),h=T("dataFormat",e,t,n).toUpperCase(),d=T("dilations",e,t,n);let[m,f]=T("args",e,t,n);o&&(f=m,m=void 0);return{stride:l,pad:c,dataFormat:h,dilations:d,biasArg:m,preluArg:f,activationFunc:s,leakyreluAlpha:T("leakyreluAlpha",e,t,n)}}function xi(e,t,n){return{boxes:T("boxes",e,t,n),scores:T("scores",e,t,n),maxOutputSize:T("maxOutputSize",e,t,n),iouThreshold:T("iouThreshold",e,t,n),scoreThreshold:T("scoreThreshold",e,t,n),softNmsSigma:T("softNmsSigma",e,t,n)}}class Ni{constructor(e,t){this.keyDType=e,this.valueDType=t,this.handle=s(0),this.tensorMap=new Map,a(this.handle)}get id(){return this.handle.id}clearAndClose(){this.tensorMap.forEach((e=>e.dispose())),this.tensorMap.clear(),this.handle.dispose()}size(){return this.tensorMap.size}tensorSize(){return Dr(this.size(),"int32")}async import(e,t){this.checkKeyAndValueTensor(e,t);const r=await e.data();return this.tensorMap.forEach((e=>e.dispose())),this.tensorMap.clear(),l((()=>{const e=p(t),s=r.length,o=e.length;n.assert(s===o,(()=>`The number of elements doesn't match, keys has ${s} elements, the values has ${o} elements.`));for(let t=0;t<s;t++){const n=r[t],s=e[t];a(s),this.tensorMap.set(n,s)}return this.handle}))}async find(e,t){this.checkKeyAndValueTensor(e,t);const n=await e.data();return l((()=>{const e=[];for(let r=0;r<n.length;r++){const s=n[r],a=this.findWithDefault(s,t);e.push(a)}return i(e)}))}findWithDefault(e,t){const n=this.tensorMap.get(e);return null!=n?n:t}checkKeyAndValueTensor(e,t){if(e.dtype!==this.keyDType)throw new Error(`Expect key dtype ${this.keyDType}, but got ${e.dtype}`);if(t.dtype!==this.valueDType)throw new Error(`Expect value dtype ${this.valueDType}, but got ${t.dtype}`)}}function wi(t,r,s,a,o=e.tidy){const i=((e,t,r)=>{switch(e.category){case"arithmetic":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"BiasAdd":case"AddV2":case"Add":return[r.add(T("a",e,t,n),T("b",e,t,n))];case"AddN":return[r.addN(T("tensors",e,t,n))];case"FloorMod":case"Mod":return[r.mod(T("a",e,t,n),T("b",e,t,n))];case"Mul":return[r.mul(T("a",e,t,n),T("b",e,t,n))];case"RealDiv":case"Div":return[r.div(T("a",e,t,n),T("b",e,t,n))];case"DivNoNan":return[r.divNoNan(T("a",e,t,n),T("b",e,t,n))];case"FloorDiv":return[r.floorDiv(T("a",e,t,n),T("b",e,t,n))];case"Sub":return[r.sub(T("a",e,t,n),T("b",e,t,n))];case"Minimum":return[r.minimum(T("a",e,t,n),T("b",e,t,n))];case"Maximum":return[r.maximum(T("a",e,t,n),T("b",e,t,n))];case"Pow":return[r.pow(T("a",e,t,n),T("b",e,t,n))];case"SquaredDifference":return[r.squaredDifference(T("a",e,t,n),T("b",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"basic_math":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Abs":case"ComplexAbs":return[r.abs(T("x",e,t,n))];case"Acos":return[r.acos(T("x",e,t,n))];case"Acosh":return[r.acosh(T("x",e,t,n))];case"Asin":return[r.asin(T("x",e,t,n))];case"Asinh":return[r.asinh(T("x",e,t,n))];case"Atan":return[r.atan(T("x",e,t,n))];case"Atan2":return[r.atan2(T("x",e,t,n),T("y",e,t,n))];case"Atanh":return[r.atanh(T("x",e,t,n))];case"Ceil":return[r.ceil(T("x",e,t,n))];case"Complex":return[r.complex(T("real",e,t,n),T("imag",e,t,n))];case"Cos":return[r.cos(T("x",e,t,n))];case"Cosh":return[r.cosh(T("x",e,t,n))];case"Elu":return[r.elu(T("x",e,t,n))];case"Erf":return[r.erf(T("x",e,t,n))];case"Exp":return[r.exp(T("x",e,t,n))];case"Expm1":return[r.expm1(T("x",e,t,n))];case"Floor":return[r.floor(T("x",e,t,n))];case"Log":return[r.log(T("x",e,t,n))];case"Log1p":return[r.log1p(T("x",e,t,n))];case"Imag":return[r.imag(T("x",e,t,n))];case"Neg":return[r.neg(T("x",e,t,n))];case"Reciprocal":return[r.reciprocal(T("x",e,t,n))];case"Real":return[r.real(T("x",e,t,n))];case"Relu":return[r.relu(T("x",e,t,n))];case"Round":return[r.round(T("x",e,t,n))];case"Selu":return[r.selu(T("x",e,t,n))];case"Sigmoid":return[r.sigmoid(T("x",e,t,n))];case"Sin":return[r.sin(T("x",e,t,n))];case"Sign":return[r.sign(T("x",e,t,n))];case"Sinh":return[r.sinh(T("x",e,t,n))];case"Softplus":return[r.softplus(T("x",e,t,n))];case"Sqrt":return[r.sqrt(T("x",e,t,n))];case"Square":return[r.square(T("x",e,t,n))];case"Tanh":return[r.tanh(T("x",e,t,n))];case"Tan":return[r.tan(T("x",e,t,n))];case"ClipByValue":return[r.clipByValue(T("x",e,t,n),T("clipValueMin",e,t,n),T("clipValueMax",e,t,n))];case"Relu6":return[r.relu6(T("x",e,t,n))];case"Rsqrt":return[r.rsqrt(v(e.inputNames[0],t,n))];case"Prod":return[r.prod(T("x",e,t,n),T("axes",e,t,n))];case"LeakyRelu":return[r.leakyRelu(T("x",e,t,n),T("alpha",e,t,n))];case"Prelu":return[r.prelu(T("x",e,t,n),T("alpha",e,t,n))];case"IsNan":return[r.isNaN(v(e.inputNames[0],t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"control":return gi(e,t,r);case"convolution":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Conv1D":{const s=T("stride",e,t,n),a=T("pad",e,t,n),o=T("dataFormat",e,t,n).toUpperCase(),i=T("dilation",e,t,n);return[r.conv1d(T("x",e,t,n),T("filter",e,t,n),s,a,o,i)]}case"Conv2D":{const s=T("strides",e,t,n),a=I(e,t,n),o=T("dataFormat",e,t,n).toUpperCase(),i=T("dilations",e,t,n);return[r.conv2d(T("x",e,t,n),T("filter",e,t,n),[s[1],s[2]],a,o,[i[1],i[2]])]}case"_FusedConv2D":{const{stride:s,pad:a,dataFormat:o,dilations:i,biasArg:u,preluArg:p,activationFunc:l,leakyreluAlpha:c}=bi(e,t,n);return[r.fused.conv2d({x:T("x",e,t,n),filter:T("filter",e,t,n),strides:[s[1],s[2]],pad:a,dataFormat:o,dilations:[i[1],i[2]],bias:u,activation:l,preluActivationWeights:p,leakyreluAlpha:c})]}case"FusedDepthwiseConv2dNative":{const{stride:s,pad:a,dataFormat:o,dilations:i,biasArg:u,preluArg:p,activationFunc:l,leakyreluAlpha:c}=bi(e,t,n);return[r.fused.depthwiseConv2d({x:T("x",e,t,n),filter:T("filter",e,t,n),strides:[s[1],s[2]],pad:a,dataFormat:o,dilations:[i[1],i[2]],bias:u,activation:l,preluActivationWeights:p,leakyreluAlpha:c})]}case"Conv2DBackpropInput":case"Conv2dTranspose":{const s=T("outputShape",e,t,n),a=T("strides",e,t,n),o=I(e,t,n);return[r.conv2dTranspose(T("x",e,t,n),T("filter",e,t,n),s,[a[1],a[2]],o)]}case"DepthwiseConv2dNative":case"DepthwiseConv2d":{const s=T("strides",e,t,n),a=I(e,t,n),o=T("dilations",e,t,n),i=T("dataFormat",e,t,n).toUpperCase();return[r.depthwiseConv2d(T("input",e,t,n),T("filter",e,t,n),[s[1],s[2]],a,i,[o[1],o[2]])]}case"Conv3D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("dataFormat",e,t,n).toUpperCase(),i=T("dilations",e,t,n);return[r.conv3d(T("x",e,t,n),T("filter",e,t,n),[s[1],s[2],s[3]],a,o,[i[1],i[2],i[3]])]}case"AvgPool":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.avgPool(T("x",e,t,n),[o[1],o[2]],[s[1],s[2]],a)]}case"MaxPool":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.maxPool(T("x",e,t,n),[o[1],o[2]],[s[1],s[2]],a)]}case"MaxPoolWithArgmax":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n),i=T("includeBatchInIndex",e,t,n),{result:u,indexes:p}=r.maxPoolWithArgmax(T("x",e,t,n),[o[1],o[2]],[s[1],s[2]],a,i);return[u,p]}case"AvgPool3D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.avgPool3d(T("x",e,t,n),[o[1],o[2],o[3]],[s[1],s[2],s[3]],a)]}case"MaxPool3D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("kernelSize",e,t,n);return[r.maxPool3d(T("x",e,t,n),[o[1],o[2],o[3]],[s[1],s[2],s[3]],a)]}case"Dilation2D":{const s=T("strides",e,t,n),a=T("pad",e,t,n),o=T("dilations",e,t,n),i=s[1],u=s[2],p=o[1],l=o[2];return[r.dilation2d(T("x",e,t,n),T("filter",e,t,n),[i,u],a,[p,l],"NHWC")]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"creation":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Fill":{const s=T("shape",e,t,n),a=T("dtype",e,t,n),o=T("value",e,t,n);return[r.fill(s,o,a)]}case"LinSpace":{const s=T("start",e,t,n),a=T("stop",e,t,n),o=T("num",e,t,n);return[r.linspace(s,a,o)]}case"Multinomial":{const s=T("logits",e,t,n),a=T("numSamples",e,t,n),o=T("seed",e,t,n);return[r.multinomial(s,a,o)]}case"OneHot":{const s=T("indices",e,t,n),a=T("depth",e,t,n),o=T("onValue",e,t,n),i=T("offValue",e,t,n),u=T("dtype",e,t,n);return[r.oneHot(s,a,o,i,u)]}case"Ones":return[r.ones(T("shape",e,t,n),T("dtype",e,t,n))];case"OnesLike":return[r.onesLike(T("x",e,t,n))];case"RandomStandardNormal":return[r.randomStandardNormal(T("shape",e,t,n),T("dtype",e,t,n),T("seed",e,t,n))];case"RandomUniform":return[r.randomUniform(T("shape",e,t,n),T("minval",e,t,n),T("maxval",e,t,n),T("dtype",e,t,n))];case"Range":{const s=T("start",e,t,n),a=T("stop",e,t,n),o=T("step",e,t,n);return[r.range(s,a,o,T("dtype",e,t,n))]}case"TruncatedNormal":{const s=T("shape",e,t,n),a=T("mean",e,t,n),o=T("stdDev",e,t,n),i=T("seed",e,t,n);return[r.truncatedNormal(s,a,o,T("dtype",e,t,n),i)]}case"Zeros":return[r.zeros(T("shape",e,t,n),T("dtype",e,t,n))];case"ZerosLike":return[r.zerosLike(T("x",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"dynamic":return(async(e,t,n,r,s=li)=>{switch(e.op){case"NonMaxSuppressionV5":{const{boxes:r,scores:a,maxOutputSize:o,iouThreshold:i,scoreThreshold:u,softNmsSigma:p}=xi(e,t,n),l=await s.image.nonMaxSuppressionWithScoreAsync(r,a,o,i,u,p);return[l.selectedIndices,l.selectedScores]}case"NonMaxSuppressionV4":{const{boxes:r,scores:a,maxOutputSize:o,iouThreshold:i,scoreThreshold:u}=xi(e,t,n),p=T("padToMaxOutputSize",e,t,n),l=await s.image.nonMaxSuppressionPaddedAsync(r,a,o,i,u,p);return[l.selectedIndices,l.validOutputs]}case"NonMaxSuppressionV3":case"NonMaxSuppressionV2":{const{boxes:r,scores:a,maxOutputSize:o,iouThreshold:i,scoreThreshold:u}=xi(e,t,n);return[await s.image.nonMaxSuppressionAsync(r,a,o,i,u)]}case"Where":{const r=s.cast(T("condition",e,t,n),"bool"),a=[await s.whereAsync(r)];return r.dispose(),a}case"ListDiff":return s.setdiff1dAsync(T("x",e,t,n),T("y",e,t,n));default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r);case"evaluation":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"LowerBound":{const s=T("sortedSequence",e,t,n),a=T("values",e,t,n);return[r.lowerBound(s,a)]}case"TopKV2":{const s=T("x",e,t,n),a=T("k",e,t,n),o=T("sorted",e,t,n),i=r.topk(s,a,o);return[i.values,i.indices]}case"UpperBound":{const s=T("sortedSequence",e,t,n),a=T("values",e,t,n);return[r.upperBound(s,a)]}case"Unique":{const s=T("x",e,t,n),a=r.unique(s);return[a.values,a.indices]}case"UniqueV2":{const s=T("x",e,t,n),a=T("axis",e,t,n),o=r.unique(s,a);return[o.values,o.indices]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"image":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"ResizeBilinear":{const s=T("images",e,t,n),a=T("size",e,t,n),o=T("alignCorners",e,t,n),i=T("halfPixelCenters",e,t,n);return[r.image.resizeBilinear(s,[a[0],a[1]],o,i)]}case"ResizeNearestNeighbor":{const s=T("images",e,t,n),a=T("size",e,t,n),o=T("alignCorners",e,t,n),i=T("halfPixelCenters",e,t,n);return[r.image.resizeNearestNeighbor(s,[a[0],a[1]],o,i)]}case"CropAndResize":{const s=T("image",e,t,n),a=T("boxes",e,t,n),o=T("boxInd",e,t,n),i=T("cropSize",e,t,n),u=T("method",e,t,n),p=T("extrapolationValue",e,t,n);return[r.image.cropAndResize(s,a,o,i,u,p)]}case"ImageProjectiveTransformV3":{const s=T("images",e,t,n),a=T("transforms",e,t,n),o=T("outputShape",e,t,n),i=T("fillValue",e,t,n),u=T("interpolation",e,t,n),p=T("fillMode",e,t,n);return[r.image.transform(s,a,u.toLowerCase(),p.toLowerCase(),i,o)]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"graph":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Const":return t[e.name];case"PlaceholderWithDefault":const s=T("default",e,t,n);return[v(e.name,t,n)||s];case"Placeholder":return[v(e.name,t,n)];case"Identity":case"StopGradient":case"FakeQuantWithMinMaxVars":case"Snapshot":return[$(T("x",e,t,n))];case"IdentityN":return T("x",e,t,n).map((e=>$(e)));case"Shape":return[r.tensor1d(T("x",e,t,n).shape,"int32")];case"ShapeN":return T("x",e,t,n).map((e=>r.tensor1d(e.shape)));case"Size":return[r.scalar(T("x",e,t,n).size,"int32")];case"Rank":return[r.scalar(T("x",e,t,n).rank,"int32")];case"NoOp":return[r.scalar(1)];case"Print":const a=T("x",e,t,n),o=T("data",e,t,n),i=T("message",e,t,n),u=T("summarize",e,t,n);console.warn("The graph has a tf.print() operation,usually used for debugging, which slows down performance."),console.log(i);for(let e=0;e<o.length;e++)console.log(Array.prototype.slice.call(o[e].dataSync()).slice(0,u));return[a];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"logical":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Equal":return[r.equal(T("a",e,t,n),T("b",e,t,n))];case"NotEqual":return[r.notEqual(T("a",e,t,n),T("b",e,t,n))];case"Greater":return[r.greater(T("a",e,t,n),T("b",e,t,n))];case"GreaterEqual":return[r.greaterEqual(T("a",e,t,n),T("b",e,t,n))];case"Less":return[r.less(T("a",e,t,n),T("b",e,t,n))];case"LessEqual":return[r.lessEqual(T("a",e,t,n),T("b",e,t,n))];case"LogicalAnd":return[r.logicalAnd(T("a",e,t,n),T("b",e,t,n))];case"LogicalNot":return[r.logicalNot(T("a",e,t,n))];case"LogicalOr":return[r.logicalOr(T("a",e,t,n),T("b",e,t,n))];case"Select":case"SelectV2":return[r.where(T("condition",e,t,n),T("a",e,t,n),T("b",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"matrices":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"BatchMatMul":case"BatchMatMulV2":case"MatMul":return[r.matMul(T("a",e,t,n),T("b",e,t,n),T("transposeA",e,t,n),T("transposeB",e,t,n))];case"Einsum":return[r.einsum(T("equation",e,t,n),...T("tensors",e,t,n))];case"Transpose":return[r.transpose(T("x",e,t,n),T("perm",e,t,n))];case"_FusedMatMul":const[s,a]=T("fusedOps",e,t,n),o="biasadd"===s,i="prelu"===a,u=T("numArgs",e,t,n),p=T("leakyreluAlpha",e,t,n);if(o){if(i&&2!==u)throw new Error("Fused MatMul with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!i&&1!==u)throw new Error("Fused MatMul with BiasAdd must have one extra argument: bias.")}const[l,c]=T("args",e,t,n);return[r.fused.matMul({a:T("a",e,t,n),b:T("b",e,t,n),transposeA:T("transposeA",e,t,n),transposeB:T("transposeB",e,t,n),bias:l,activation:a,preluActivationWeights:c,leakyreluAlpha:p})];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"normalization":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"EuclideanNorm":return[r.euclideanNorm(T("x",e,t,n),T("axis",e,t,n),T("keepDims",e,t,n))];case"FusedBatchNorm":case"FusedBatchNormV2":case"FusedBatchNormV3":return[r.batchNorm(T("x",e,t,n),T("mean",e,t,n),T("variance",e,t,n),T("offset",e,t,n),T("scale",e,t,n),T("epsilon",e,t,n))];case"LRN":return[r.localResponseNormalization(T("x",e,t,n),T("radius",e,t,n),T("bias",e,t,n),T("alpha",e,t,n),T("beta",e,t,n))];case"Softmax":return[r.softmax(T("x",e,t,n))];case"LogSoftmax":return[r.logSoftmax(T("x",e,t,n))];case"SparseToDense":return[r.sparseToDense(T("sparseIndices",e,t,n),T("outputShape",e,t,n),T("sparseValues",e,t,n),T("defaultValue",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"ragged":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"RaggedGather":{const{outputNestedSplits:s,outputDenseValues:a}=r.raggedGather(T("paramsNestedSplits",e,t,n),T("paramsDenseValues",e,t,n),T("indices",e,t,n),T("outputRaggedRank",e,t,n));return s.concat(a)}case"RaggedRange":{const{rtNestedSplits:s,rtDenseValues:a}=r.raggedRange(T("starts",e,t,n),T("limits",e,t,n),T("splits",e,t,n));return[s,a]}case"RaggedTensorToTensor":return[r.raggedTensorToTensor(T("shape",e,t,n),T("values",e,t,n),T("defaultValue",e,t,n),T("rowPartitionTensors",e,t,n),T("rowPartitionTypes",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"reduction":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Max":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.max(T("x",e,t,n),s,a)]}case"Mean":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.mean(T("x",e,t,n),s,a)]}case"Min":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.min(T("x",e,t,n),s,a)]}case"Sum":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.sum(T("x",e,t,n),s,a)]}case"All":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.all(T("x",e,t,n),s,a)]}case"Any":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.any(T("x",e,t,n),s,a)]}case"ArgMax":{const s=T("axis",e,t,n);return[r.argMax(T("x",e,t,n),s)]}case"ArgMin":{const s=T("axis",e,t,n);return[r.argMin(T("x",e,t,n),s)]}case"Prod":{const s=T("axis",e,t,n),a=T("keepDims",e,t,n);return[r.prod(T("x",e,t,n),s,a)]}case"Cumprod":{const s=T("axis",e,t,n),a=T("exclusive",e,t,n),o=T("reverse",e,t,n);return[r.cumprod(T("x",e,t,n),s,a,o)]}case"Cumsum":{const s=T("axis",e,t,n),a=T("exclusive",e,t,n),o=T("reverse",e,t,n);return[r.cumsum(T("x",e,t,n),s,a,o)]}case"Bincount":const s=T("x",e,t,n),a=T("weights",e,t,n),o=T("size",e,t,n);return[r.bincount(s,a,o)];case"DenseBincount":{const s=T("x",e,t,n),a=T("weights",e,t,n),o=T("size",e,t,n),i=T("binaryOutput",e,t,n);return[r.denseBincount(s,a,o,i)]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"slice_join":return o((()=>((e,t,r,s=li)=>{switch(e.op){case"ConcatV2":case"Concat":{const n=T("n",e,t,r),a=T("axis",e,t,r);let o=T("tensors",e,t,r);return o=o.slice(0,n),[s.concat(o,a)]}case"Gather":{const n=T("x",e,t,r),a=T("indices",e,t,r);return[s.gather(n,s.cast(a,"int32"),0)]}case"GatherV2":{const n=T("axis",e,t,r),a=T("batchDims",e,t,r),o=T("x",e,t,r),i=T("indices",e,t,r);return[s.gather(o,s.cast(i,"int32"),n,a)]}case"Reverse":{const n=T("dims",e,t,r),a=[];for(let e=0;e<n.length;e++)n[e]&&a.push(e);const o=T("x",e,t,r);return[s.reverse(o,a)]}case"ReverseV2":{const n=T("axis",e,t,r),a=T("x",e,t,r);return[s.reverse(a,n)]}case"Slice":{const n=T("begin",e,t,r),a=T("size",e,t,r);return[s.slice(T("x",e,t,r),n,a)]}case"StridedSlice":{const n=T("begin",e,t,r),a=T("end",e,t,r),o=T("strides",e,t,r),i=T("beginMask",e,t,r),u=T("endMask",e,t,r),p=T("ellipsisMask",e,t,r),l=T("newAxisMask",e,t,r),c=T("shrinkAxisMask",e,t,r),h=T("x",e,t,r);return[s.stridedSlice(h,n,a,o,i,u,p,l,c)]}case"Pack":return l((()=>{const a=T("axis",e,t,r),o=T("tensors",e,t,r),i=o[0].shape,u=s.squeeze(o[0]).shape,p=o.map((e=>{const t=n.arraysEqual(e.shape,i);if(!t&&!n.arraysEqual(s.squeeze(e).shape,u))throw new Error("the input tensors shape does not match");return t?e:s.reshape(e,i)}));return[s.stack(p,a)]}));case"Unpack":{const n=T("axis",e,t,r),a=T("tensor",e,t,r);return s.unstack(a,n)}case"Tile":{const n=T("reps",e,t,r);return[s.tile(T("x",e,t,r),n)]}case"Split":case"SplitV":{const n=T("axis",e,t,r),a=T("numOrSizeSplits",e,t,r),o=T("x",e,t,r);return s.split(o,a,n)}case"ScatterNd":{const n=T("indices",e,t,r),a=T("values",e,t,r),o=T("shape",e,t,r);return[s.scatterND(n,a,o)]}case"GatherNd":{const n=T("x",e,t,r),a=T("indices",e,t,r);return[s.gatherND(n,a)]}case"SparseToDense":{const n=T("sparseIndices",e,t,r),a=T("outputShape",e,t,r),o=T("sparseValues",e,t,r),i=T("defaultValue",e,t,r);return[s.sparseToDense(n,o,a,o.dtype===i.dtype?i:s.cast(i,o.dtype))]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"sparse":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"SparseFillEmptyRows":{const{outputIndices:s,outputValues:a,emptyRowIndicator:o,reverseIndexMap:i}=r.sparse.sparseFillEmptyRows(T("indices",e,t,n),T("values",e,t,n),T("denseShape",e,t,n),T("defaultValue",e,t,n));return[s,a,o,i]}case"SparseReshape":{const{outputIndices:s,outputShape:a}=r.sparse.sparseReshape(T("inputIndices",e,t,n),T("inputShape",e,t,n),T("newShape",e,t,n));return[s,a]}case"SparseSegmentMean":return[r.sparse.sparseSegmentMean(T("data",e,t,n),T("indices",e,t,n),T("segmentIds",e,t,n))];case"SparseSegmentSum":return[r.sparse.sparseSegmentSum(T("data",e,t,n),T("indices",e,t,n),T("segmentIds",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"spectral":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"FFT":return[r.fft(T("x",e,t,n))];case"IFFT":return[r.ifft(T("x",e,t,n))];case"RFFT":return[r.rfft(T("x",e,t,n))];case"IRFFT":return[r.irfft(T("x",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"string":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"StringNGrams":{const{nGrams:s,nGramsSplits:a}=r.string.stringNGrams(T("data",e,t,n),T("dataSplits",e,t,n),T("separator",e,t,n),T("nGramWidths",e,t,n),T("leftPad",e,t,n),T("rightPad",e,t,n),T("padWidth",e,t,n),T("preserveShortSequences",e,t,n));return[s,a]}case"StringSplit":{const{indices:s,values:a,shape:o}=r.string.stringSplit(T("input",e,t,n),T("delimiter",e,t,n),T("skipEmpty",e,t,n));return[s,a,o]}case"StringToHashBucketFast":return[r.string.stringToHashBucketFast(T("input",e,t,n),T("numBuckets",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"transformation":return o((()=>((e,t,n,r=li)=>{switch(e.op){case"Cast":return[r.cast(T("x",e,t,n),T("dtype",e,t,n))];case"ExpandDims":{const s=T("axis",e,t,n);return[r.expandDims(T("x",e,t,n),s)]}case"Squeeze":{const s=T("axis",e,t,n);return[r.squeeze(T("x",e,t,n),s)]}case"Reshape":return[r.reshape(T("x",e,t,n),T("shape",e,t,n))];case"MirrorPad":return[r.mirrorPad(T("x",e,t,n),T("padding",e,t,n),T("mode",e,t,n))];case"PadV2":case"Pad":return[r.pad(T("x",e,t,n),T("padding",e,t,n),T("constantValue",e,t,n))];case"SpaceToBatchND":{const s=T("blockShape",e,t,n),a=T("paddings",e,t,n);return[r.spaceToBatchND(T("x",e,t,n),s,a)]}case"BatchToSpaceND":{const s=T("blockShape",e,t,n),a=T("crops",e,t,n);return[r.batchToSpaceND(T("x",e,t,n),s,a)]}case"DepthToSpace":{const s=T("blockSize",e,t,n),a=T("dataFormat",e,t,n).toUpperCase();return[r.depthToSpace(T("x",e,t,n),s,a)]}case"BroadcastTo":return[r.broadcastTo(T("x",e,t,n),T("shape",e,t,n))];case"BroadcastArgs":return[r.broadcastArgs(T("s0",e,t,n),T("s1",e,t,n))];default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r)));case"hash_table":return(async(e,t,n,r)=>{switch(e.op){case"HashTable":case"HashTableV2":{const s=r.getHashTableHandleByName(e.name);if(null!=s)return[s];{const s=T("keyDType",e,t,n),a=T("valueDType",e,t,n),o=new Ni(s,a);return r.addHashTable(e.name,o),[o.handle]}}case"InitializeTable":case"InitializeTableV2":case"LookupTableImport":case"LookupTableImportV2":{const s=T("tableHandle",e,t,n,r),a=T("keys",e,t,n),o=T("values",e,t,n),i=r.getHashTableById(s.id);return[await i.import(a,o)]}case"LookupTableFind":case"LookupTableFindV2":{const s=T("tableHandle",e,t,n,r),a=T("keys",e,t,n),o=T("defaultValue",e,t,n),i=r.getHashTableById(s.id);return[await i.find(a,o)]}case"LookupTableSize":case"LookupTableSizeV2":{const s=T("tableHandle",e,t,n,r);return[r.getHashTableById(s.id).tensorSize()]}default:throw TypeError(`Node type ${e.op} is not implemented`)}})(e,t,r,a);case"custom":const s=w(e.op);if(s&&s.customExecutor)return s.customExecutor(new le(e,t,r));throw TypeError(`Custom op ${e.op} is not registered.`);default:throw TypeError(`Unknown op '${e.op}'. File an issue at https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()`)}})(t,r,s);return e.util.isPromise(i)?i.then((e=>[].concat(e))):[].concat(i)}class ki{constructor(e={},t={},n={},r={}){this.weightMap=e,this.tensorArrayMap=t,this.tensorListMap=n,this.functionMap=r,this.rootContext={id:0,frameName:"",iterationId:0},this.contexts=[this.rootContext],this.lastId=0,this.generateCurrentContextIds()}newFrame(e,t){return{id:e,frameName:t,iterationId:0}}set currentContext(e){this.contexts!==e&&(this.contexts=e,this.generateCurrentContextIds())}get currentContext(){return this.contexts}get currentContextId(){return this._currentContextIds[0]}get currentContextIds(){return this._currentContextIds}generateCurrentContextIds(){const e=[];for(let t=0;t<this.contexts.length-1;t++){const n=this.contexts.slice(0,this.contexts.length-t);e.push(this.contextIdforContexts(n))}e.push(""),this._currentContextIds=e}contextIdforContexts(e){return e?e.map((e=>0===e.id&&0===e.iterationId?"":`${e.frameName}-${e.iterationId}`)).join("/"):""}enterFrame(e){this.contexts&&(this.lastId++,this.contexts=this.contexts.slice(),this.contexts.push(this.newFrame(this.lastId,e)),this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)))}exitFrame(){if(!(this.contexts&&this.contexts.length>1))throw new Error("Cannot exit frame, the context is empty");this.contexts=this.contexts.slice(),this.contexts.splice(-1),this.currentContextIds.shift()}nextIteration(){if(!(this.contexts&&this.contexts.length>0))throw new Error("Cannot increase frame iteration, the context is empty");{this.contexts=this.contexts.slice(),this.lastId++;const e=Object.assign({},this.contexts[this.contexts.length-1]);e.iterationId+=1,e.id=this.lastId,this.contexts.splice(-1,1,e),this._currentContextIds.splice(0,1,this.contextIdforContexts(this.contexts))}}getWeight(e){return this.weightMap[e]}addTensorArray(e){this.tensorArrayMap[e.id]=e}getTensorArray(e){return this.tensorArrayMap[e]}addTensorList(e){this.tensorListMap[e.id]=e}getTensorList(e){return this.tensorListMap[e]}dispose(e){for(const t in this.tensorArrayMap)this.tensorArrayMap[t].clearAndClose(e);for(const t in this.tensorListMap)this.tensorListMap[t].clearAndClose(e)}}function Ti(e,t,n,r){const s=new Set,a=[];let o=null,i=null;const u=new Set,p=Object.keys(e).map((e=>E(e)[0]));let l=[];null!=r&&(l=r.map((e=>E(e.name)[0])));const c=[...t];for(;c.length>0;){const e=c.pop();(Ei(e)||Ii(e)||$i(e))&&null==o&&(o=e,i=o.children.map((e=>e.name)).filter((e=>s.has(e)))),s.add(e.name),null==n[e.name]&&(-1===p.indexOf(e.name)&&-1===l.indexOf(e.name)&&(0!==e.inputs.length?e.inputs.forEach((e=>{u.has(e.name)||(u.add(e.name),c.push(e))})):a.push(e.name)))}return{inputs:e,outputs:t,usedNodes:s,missingInputs:a,dynamicNode:o,syncInputs:i}}const vi=["Switch","Merge","Enter","Exit","NextIteration","StatelessIf","StatelessWhile","if","While"],_i=["NonMaxSuppressionV2","NonMaxSuppressionV3","NonMaxSuppressionV5","Where"],Si=["HashTable","HashTableV2","LookupTableImport","LookupTableImportV2","LookupTableFind","LookupTableFindV2","LookupTableSize","LookupTableSizeV2"];function Ei(e){return vi.indexOf(e.op)>=0}function Ii(e){return _i.indexOf(e.op)>=0}function $i(e){return Si.indexOf(e.op)>=0}class Di{constructor(e,t){this.graph=e,this.parent=t,this.compiledMap=new Map,this._weightMap={},this.SEPERATOR=",",this._functions={},this._functionExecutorMap={},this.keepIntermediateTensors=!1,this._outputs=e.outputs,this._inputs=e.inputs,this._initNodes=e.initNodes,this._signature=e.signature,this._functions=e.functions,null!=e.functions&&Object.keys(e.functions).forEach((t=>{this._functionExecutorMap[t]=new Di(e.functions[t],this)}))}get weightIds(){return this.parent?this.parent.weightIds:this._weightIds}get functionExecutorMap(){return this.parent?this.parent.functionExecutorMap:this._functionExecutorMap}get weightMap(){return this.parent?this.parent.weightMap:this._weightMap}set weightMap(e){const t=Object.keys(e).map((t=>e[t].map((e=>e.id))));this._weightIds=[].concat(...t),this._weightMap=e}set resourceManager(e){this._resourceManager=e}get inputs(){return this._inputs.map((e=>({name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0})))}get outputs(){return this._outputs.map((e=>({name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0})))}get inputNodes(){return this._inputs.map((e=>e.signatureKey||e.name))}get outputNodes(){return this._outputs.map((e=>{const t=e.signatureKey||e.name;return e.defaultOutput?`${t}:${e.defaultOutput}`:t}))}get functions(){return Object.keys(this._functions).reduce(((e,t)=>(e[t]=this._functions[t].signature,e)),{})}getCompilationKey(e,t){const n=e.map((e=>e.name)).sort(),r=t.map((e=>e.name)).sort();return n.join(this.SEPERATOR)+"--"+r.join(this.SEPERATOR)}compile(e,t){const n=Ti(e,t,this.weightMap,this._initNodes),{missingInputs:r,dynamicNode:s,syncInputs:a}=n;if(null!=s)throw new Error(`This execution contains the node '${s.name}', which has the dynamic op '${s.op}'. Please use model.executeAsync() instead. Alternatively, to avoid the dynamic ops, specify the inputs [${a}]`);if(r.length>0){const n=t.map((e=>e.name)),s=Object.keys(e);throw new Error(`Cannot compute the outputs [${n}] from the provided inputs [${s}]. Missing the following inputs: [${r}]`)}return function(e,t,n){const{usedNodes:r,inputs:s}=n,a=[],o=Object.keys(s).map((e=>E(e)[0])).map((t=>e.nodes[t])),i=e.initNodes;o.forEach((e=>{r.has(e.name)&&a.push(e)})),e.weights.forEach((e=>{r.has(e.name)&&a.push(e)})),null!=i&&i.forEach((e=>{r.has(e.name)&&a.push(e)}));const u=new Set,p=[];for(;a.length>0;){const e=a.pop();u.add(e.name),t[e.name]||p.push(e),e.children.forEach((e=>{!u.has(e.name)&&r.has(e.name)&&e.inputs.every((e=>u.has(e.name)))&&a.push(e)}))}return p}(this.graph,this.weightMap,n)}cloneAndKeepTensor(e){if(null==e)return null;const t=e.clone();return a(t),t}cloneTensorList(e){if(!e)return null;const t=e.map((e=>this.cloneAndKeepTensor(e)));return t}cloneTensorMap(e){return Object.fromEntries(Object.entries(e).map((([e,t])=>[e,this.cloneTensorList(t)])))}execute(e,r){this.disposeIntermediateTensors(),e=this.mapInputs(e);const s=Object.keys(e).sort();this.checkInputs(e),this.checkInputShapeAndType(e),r=this.mapOutputs(r),this.checkOutputs(r);const a=s.map((e=>this.graph.nodes[E(e)[0]])),o=r.map((e=>E(e)[0]));let i=o.map((e=>this.graph.nodes[e]));0===i.length&&(i=this._outputs);const u=this.getCompilationKey(a,i);let p=this.compiledMap.get(u);null==p&&(p=this.compile(e,i),this.compiledMap.set(u,p));try{this.keepIntermediateTensors=t().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(e){this.keepIntermediateTensors=!1,console.warn(e.message)}const c={},h={};return l((()=>{const t=new ki(this.weightMap,c,h,this.functionExecutorMap),s=Object.assign({},this.weightMap);this.keepIntermediateTensors&&(this.clonedTensorsMap=this.cloneTensorMap(this.weightMap)),Object.keys(e).forEach((t=>{const[n,r]=E(t),a=[];a[r]=e[t],s[n]=a,this.keepIntermediateTensors&&(this.clonedTensorsMap[n]=this.cloneTensorList(a))}));const a=this.getFrozenTensorIds(s),i={};for(let e=0;e<p.length;e++){const r=p[e];if(!s[r.name]){const e=wi(r,s,t,this._resourceManager);if(n.isPromise(e))throw new Error(`The execution of the op '${r.op}' returned a promise. Please use model.executeAsync() instead.`);s[r.name]=e,this.keepIntermediateTensors&&(this.clonedTensorsMap[r.name]=this.cloneTensorList(e)),this.checkTensorForDisposal(r.name,r,s,t,a,o,i)}}return null==this.parent&&t.dispose(a),r.map((e=>v(e,s,t)))}))}getFrozenTensorIds(e){const t=[].concat.apply([],Object.keys(e).map((t=>e[t])).map((e=>e.map((e=>e.id)))));return new Set(t)}checkTensorForDisposal(e,t,n,r,s,a,o){"control"!==t.category&&-1===a.indexOf(e)&&(n[e].forEach((e=>{null!=e&&(o[e.id]=(o[e.id]||0)+t.children.length)})),t.inputs.forEach((e=>{if("control"!==e.category){const t=function(e,t,n){return t[S(e,n.currentContextId)]}(e.name,n,r);null!=t&&t.forEach((e=>{if(e&&!e.kept&&!s.has(e.id)){const t=o[e.id];1===t?(e.dispose(),delete o[e.id]):null!=t&&o[e.id]--}}))}})))}async executeAsync(e,t){return this._executeAsync(e,t)}disposeIntermediateTensors(){this.clonedTensorsMap&&(Object.values(this.clonedTensorsMap).forEach((e=>{for(const t of e)t&&!t.isDisposed&&t.dispose()})),this.clonedTensorsMap=null)}getIntermediateTensors(){return this.clonedTensorsMap}async _executeAsync(e,n,r=!1,s={},a={}){this.disposeIntermediateTensors(),r||(e=this.mapInputs(e),this.checkInputs(e),this.checkInputShapeAndType(e),n=this.mapOutputs(n),this.checkOutputs(n));try{this.keepIntermediateTensors=t().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(e){this.keepIntermediateTensors=!1,console.warn(e.message)}const o=new ki(this.weightMap,s,a,this.functionExecutorMap);this.keepIntermediateTensors&&(this.clonedTensorsMap=this.cloneTensorMap(this.weightMap));const i=await this.executeWithControlFlow(e,o,n,r),u=n.map((e=>v(e,i,o))),p=u.map((e=>e.id)),l=Object.keys(e).map((t=>e[t].id)),c=new Set([...p,...l,...this.weightIds]);return Object.values(i).forEach((e=>{e.forEach((e=>{!e||e.isDisposed||c.has(e.id)||e.dispose()}))})),null==this.parent&&o.dispose(c),u}async executeFunctionAsync(e,t,n){const r=e.reduce(((e,t,n)=>(e[this.inputs[n].name]=t,e)),{});return this._executeAsync(r,this.outputNodes,!0,t,n)}async executeWithControlFlow(e,t,n,r){const s=Object.keys(e),a=s.map((e=>this.graph.nodes[E(e)[0]])),o=n.map((e=>E(e)[0]));let i=o.map((e=>this.graph.nodes[e]));0===i.length&&(i=this._outputs);const{usedNodes:u,missingInputs:p,dynamicNode:l,syncInputs:c}=Ti(e,i,this.weightMap,this._initNodes),h=[...a,...this.graph.weights,...this._initNodes||[]].map((e=>({node:e,contexts:t.currentContext}))),d=Object.assign({},this.weightMap);Object.keys(e).forEach((t=>{const[n,r]=E(t),s=[];s[r]=e[t],d[n]=s}));const m={},f=this.getFrozenTensorIds(d),y={};for(;h.length>0;){const e=this.processStack(a,h,t,d,y,f,o,m,u);await Promise.all(e)}null!=l||r||console.warn("This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead.");const g=i.filter((e=>!Ei(e)&&!v(e.name,d,t))).map((e=>e.name));if(g.length>0){let e="";throw null!=l&&(e=`Alternatively, to avoid the dynamic ops, use model.execute() and specify the inputs [${c}]`),new Error(`Cannot compute the outputs [${g}] from the provided inputs [${s}]. Consider providing the following inputs: [${p}]. ${e}`)}return d}processStack(e,t,r,s,a,o,i,u,p){const l=[];for(;t.length>0;){const e=t.pop();r.currentContext=e.contexts;let c="";if("Enter"===e.node.op&&T("isConstant",e.node,s,r)&&([c]=_(e.node.name,r)),null==s[e.node.name]){const h=wi(e.node,s,r,this._resourceManager);c||([c]=_(e.node.name,r));const d=r.currentContext;n.isPromise(h)?l.push(h.then((n=>(s[c]=n,this.keepIntermediateTensors&&(this.clonedTensorsMap[c]=this.cloneTensorList(n)),r.currentContext=d,this.checkTensorForDisposal(c,e.node,s,r,o,i,u),this.processChildNodes(e.node,t,r,s,a,p),n)))):(s[c]=h,this.keepIntermediateTensors&&(this.clonedTensorsMap[c]=this.cloneTensorList(h)),this.checkTensorForDisposal(c,e.node,s,r,o,i,u),this.processChildNodes(e.node,t,r,s,a,p))}else this.processChildNodes(e.node,t,r,s,a,p)}return l}processChildNodes(e,t,n,r,s,a){e.children.forEach((e=>{const[o]=_(e.name,n);!s[o]&&a.has(e.name)&&("Merge"===e.op?e.inputNames.some((e=>!!v(e,r,n)))&&(s[o]=!0,t.push({contexts:n.currentContext,node:e})):e.inputNames.every((e=>!!v(e,r,n)))&&(s[o]=!0,t.push({contexts:n.currentContext,node:e})))}))}dispose(){Object.keys(this.weightMap).forEach((e=>this.weightMap[e].forEach((e=>e.dispose()))))}checkInputShapeAndType(e){Object.keys(e).forEach((t=>{const r=e[t],[s]=E(t),a=this.graph.nodes[s];if(a.attrParams.shape&&a.attrParams.shape.value){const e=a.attrParams.shape.value,t=e.length===r.shape.length&&r.shape.every(((t,n)=>-1===e[n]||e[n]===t));n.assert(t,(()=>`The shape of dict['${a.name}'] provided in model.execute(dict) must be [${e}], but was [${r.shape}]`))}a.attrParams.dtype&&a.attrParams.dtype.value&&n.assert(r.dtype===a.attrParams.dtype.value,(()=>`The dtype of dict['${a.name}'] provided in model.execute(dict) must be ${a.attrParams.dtype.value}, but was ${r.dtype}`))}))}mapInputs(e){var t,n;const r={};for(const s in e){const a=null===(n=null===(t=this._signature)||void 0===t?void 0:t.inputs)||void 0===n?void 0:n[s];null!=a?r[a.name]=e[s]:r[s]=e[s]}return r}checkInputs(e){const t=Object.keys(e).filter((e=>{const[t]=E(e);return null==this.graph.nodes[t]}));if(t.length>0)throw new Error(`The dict provided in model.execute(dict) has keys: [${t}] that are not part of graph`)}mapOutputs(e){return e.map((e=>{var t,n;const r=null===(n=null===(t=this._signature)||void 0===t?void 0:t.outputs)||void 0===n?void 0:n[e];return null!=r?r.name:e}),{})}checkOutputs(e){e.forEach((e=>{const[t]=E(e);if(!this.graph.nodes[t])throw new Error(`The output '${e}' is not found in the graph`)}))}}class Ai{constructor(e={},t={}){this.hashTableNameToHandle=e,this.hashTableMap=t}addHashTable(e,t){this.hashTableNameToHandle[e]=t.handle,this.hashTableMap[t.id]=t}getHashTableHandleByName(e){return this.hashTableNameToHandle[e]}getHashTableById(e){return this.hashTableMap[e]}dispose(){for(const e in this.hashTableMap)this.hashTableMap[e].clearAndClose(),delete this.hashTableMap[e];for(const e in this.hashTableNameToHandle)this.hashTableNameToHandle[e].dispose(),delete this.hashTableNameToHandle[e]}}class Oi{constructor(e,t={},n=d){this.modelUrl=e,this.loadOptions=t,this.version="n/a",this.io=n,null==t&&(this.loadOptions={}),this.resourceManager=new Ai}get modelVersion(){return this.version}get inputNodes(){return this.executor.inputNodes}get outputNodes(){return this.executor.outputNodes}get inputs(){return this.executor.inputs}get outputs(){return this.executor.outputs}get weights(){return this.executor.weightMap}get metadata(){return this.artifacts.userDefinedMetadata}get modelSignature(){return this.signature}get modelStructuredOutputKeys(){return this.structuredOutputKeys}findIOHandler(){const e=this.modelUrl;if(null!=e.load)this.handler=e;else if(null!=this.loadOptions.requestInit)this.handler=this.io.browserHTTPRequest(e,this.loadOptions);else{const t=this.io.getLoadHandlers(e,this.loadOptions);if(0===t.length)t.push(this.io.browserHTTPRequest(e,this.loadOptions));else if(t.length>1)throw new Error(`Found more than one (${t.length}) load handlers for URL '${[e]}'`);this.handler=t[0]}}load(){if(this.findIOHandler(),null==this.handler.load)throw new Error("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");const e=this.handler.load();return n.isPromise(e)?e.then((e=>this.loadSync(e))):this.loadSync(e)}loadSync(e){this.artifacts=e;const t=this.artifacts.modelTopology;let n=this.artifacts.signature;if(null!=this.artifacts.userDefinedMetadata){const e=this.artifacts.userDefinedMetadata;null!=e.signature&&(n=e.signature),null!=e.structuredOutputKeys&&(this.structuredOutputKeys=e.structuredOutputKeys)}this.signature=n,this.version=`${t.versions.producer}.${t.versions.minConsumer}`;const r=this.io.decodeWeights(this.artifacts.weightData,this.artifacts.weightSpecs);if(this.executor=new Di(Z.Instance.transformGraph(t,this.signature)),this.executor.weightMap=this.convertTensorMapToTensorsMap(r),this.executor.resourceManager=this.resourceManager,null!=e.modelInitializer&&null!=e.modelInitializer.node){const t=Z.Instance.transformGraph(e.modelInitializer);this.initializer=new Di(t),this.initializer.weightMap=this.executor.weightMap,this.initializer.resourceManager=this.resourceManager,this.initializerSignature=e.initializerSignature}return!0}async save(e,t){if("string"==typeof e){const t=this.io.getSaveHandlers(e);if(0===t.length)throw new Error(`Cannot find any save handlers for URL '${e}'`);if(t.length>1)throw new Error(`Found more than one (${t.length}) save handlers for URL '${e}'`);e=t[0]}if(null==e.save)throw new Error("GraphModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");return e.save(this.artifacts)}addStructuredOutputNames(e){if(this.structuredOutputKeys){const t={};return(e instanceof m?[e]:e).forEach(((e,n)=>t[this.structuredOutputKeys[n]]=e)),t}return e}predict(e,t){const n=this.execute(e,this.outputNodes);return this.addStructuredOutputNames(n)}async predictAsync(e,t){const n=await this.executeAsync(e,this.outputNodes);return this.addStructuredOutputNames(n)}normalizeInputs(e){var t;if(!(e instanceof m||Array.isArray(e))){const n=null===(t=this.signature)||void 0===t?void 0:t.inputs;if(null!=n)for(const t in n){const r=n[t];null!=r.resourceId&&(e[t]=this.resourceIdToCapturedInput[r.resourceId])}return e}e=Array.isArray(e)?e:[e];const n=Object.keys(this.resourceIdToCapturedInput).length;if(e.length+n!==this.inputNodes.length)throw new Error(`Input tensor count mismatch, the graph model has ${this.inputNodes.length-n} non-resource placeholders, while there are ${e.length} input tensors provided.`);let r=0;return this.inputNodes.reduce(((t,n)=>{var s,a,o;const i=null===(o=null===(a=null===(s=this.signature)||void 0===s?void 0:s.inputs)||void 0===a?void 0:a[n])||void 0===o?void 0:o.resourceId;return t[n]=null!=i?this.resourceIdToCapturedInput[i]:e[r++],t}),{})}normalizeOutputs(e){return e=e||this.outputNodes,Array.isArray(e)?e:[e]}executeInitializerGraph(){return null==this.initializer?[]:null==this.initializerSignature?this.initializer.execute({},[]):this.initializer.execute({},Object.keys(this.initializerSignature.outputs))}async executeInitializerGraphAsync(){return null==this.initializer?[]:null==this.initializerSignature?this.initializer.executeAsync({},[]):this.initializer.executeAsync({},Object.keys(this.initializerSignature.outputs))}setResourceIdToCapturedInput(e){if(this.resourceIdToCapturedInput={},this.initializerSignature){const t=this.initializerSignature.outputs,n=Object.keys(t);for(let r=0;r<n.length;r++){const s=t[n[r]];this.resourceIdToCapturedInput[s.resourceId]=e[r]}}}execute(e,t){null==this.resourceIdToCapturedInput&&this.setResourceIdToCapturedInput(this.executeInitializerGraph()),e=this.normalizeInputs(e),t=this.normalizeOutputs(t);const n=this.executor.execute(e,t);return n.length>1?n:n[0]}async executeAsync(e,t){null==this.resourceIdToCapturedInput&&this.setResourceIdToCapturedInput(await this.executeInitializerGraphAsync()),e=this.normalizeInputs(e),t=this.normalizeOutputs(t);const n=await this.executor.executeAsync(e,t);return n.length>1?n:n[0]}getIntermediateTensors(){return this.executor.getIntermediateTensors()}disposeIntermediateTensors(){this.executor.disposeIntermediateTensors()}convertTensorMapToTensorsMap(e){return Object.keys(e).reduce(((t,n)=>(t[n]=[e[n]],t)),{})}dispose(){this.executor.dispose(),this.initializer&&(this.initializer.dispose(),this.resourceIdToCapturedInput&&f(this.resourceIdToCapturedInput)),this.resourceManager.dispose()}}async function Mi(e,t={},n=d){if(null==e)throw new Error("modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model");null==t&&(t={}),t.fromTFHub&&"string"==typeof e&&(e=function(e){e.endsWith("/")||(e+="/");return`${e}model.json?tfjs-format=file`}(e));const r=new Oi(e,t,n);return await r.load(),r}function Ci(e){if(null==e)throw new Error("modelUrl in loadGraphModelSync() cannot be null. Please provide model artifacts or an IOHandler that loads the model");let t;if(e instanceof Array){const[n,r]=e;if(!n)throw new Error("modelJSON must be the first element of the array");if(!(r&&r instanceof ArrayBuffer))throw new Error("An ArrayBuffer of weights must be the second element of the array");if(!("modelTopology"in n))throw new Error("Model JSON is missing 'modelTopology'");if(!("weightsManifest"in n))throw new Error("Model JSON is missing 'weightsManifest'");const s=d.getWeightSpecs(n.weightsManifest),a=d.getModelArtifactsForJSONSync(n,s,r);t=d.fromMemorySync(a)}else if("load"in e)t=e;else{if(!("modelTopology"in e&&"weightSpecs"in e&&"weightData"in e))throw new Error("Unknown model format");t=d.fromMemorySync(e)}const n=new Oi(t);return n.load(),n}const Fi="4.2.0";export{Oi as GraphModel,k as deregisterOp,Mi as loadGraphModel,Ci as loadGraphModelSync,N as registerOp,Fi as version_converter};
//# sourceMappingURL=tf-converter.fesm.min.js.map
