/**
 * @license
 * Copyright 2023 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{},e.tf)}(this,(function(e,t){"use strict";function n(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var r=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,r.get?r:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,t}function r(e,t){return t.forEach((function(t){Object.keys(t).forEach((function(n){if("default"!==n&&!(n in e)){var r=Object.getOwnPropertyDescriptor(t,n);Object.defineProperty(e,n,r.get?r:{enumerable:!0,get:function(){return t[n]}})}}))})),e}var a=n(t);t.env().registerFlag("KEEP_INTERMEDIATE_TENSORS",(function(){return!1}),(function(e){e&&console.warn("Keep intermediate tensors is ON. This will print the values of all intermediate tensors during model inference. Not all models support this mode. For details, check e2e/benchmarks/ model_config.js. This significantly impacts performance.")}));var o,s,i=function(e,t){return i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])},i(e,t)};function u(e,t,n,r){return new(n||(n=Promise))((function(a,o){function s(e){try{u(r.next(e))}catch(e){o(e)}}function i(e){try{u(r.throw(e))}catch(e){o(e)}}function u(e){var t;e.done?a(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(s,i)}u((r=r.apply(e,t||[])).next())}))}function p(e,t){var n,r,a,o,s={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:i(0),throw:i(1),return:i(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function i(o){return function(i){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;s;)try{if(n=1,r&&(a=2&o[0]?r.return:o[0]?r.throw||((a=r.return)&&a.call(r),0):r.next)&&!(a=a.call(r,o[1])).done)return a;switch(r=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return s.label++,{value:o[1],done:!1};case 5:s.label++,r=o[1],o=[0];continue;case 7:o=s.ops.pop(),s.trys.pop();continue;default:if(!(a=s.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){s=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){s.label=o[1];break}if(6===o[0]&&s.label<a[1]){s.label=a[1],a=o;break}if(a&&s.label<a[2]){s.label=a[2],s.ops.push(o);break}a[2]&&s.ops.pop(),s.trys.pop();continue}o=t.call(e,s)}catch(e){o=[6,e],r=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,i])}}}function c(e){var t="function"==typeof Symbol&&Symbol.iterator,n=t&&e[t],r=0;if(n)return n.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&r>=e.length&&(e=void 0),{value:e&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function l(e,t){var n="function"==typeof Symbol&&e[Symbol.iterator];if(!n)return e;var r,a,o=n.call(e),s=[];try{for(;(void 0===t||t-- >0)&&!(r=o.next()).done;)s.push(r.value)}catch(e){a={error:e}}finally{try{r&&!r.done&&(n=o.return)&&n.call(o)}finally{if(a)throw a.error}}return s}function d(e,t,n){if(n||2===arguments.length)for(var r,a=0,o=t.length;a<o;a++)!r&&a in t||(r||(r=Array.prototype.slice.call(t,0,a)),r[a]=t[a]);return e.concat(r||Array.prototype.slice.call(t))}!function(e){e[e.DT_INVALID=0]="DT_INVALID",e[e.DT_FLOAT=1]="DT_FLOAT",e[e.DT_DOUBLE=2]="DT_DOUBLE",e[e.DT_INT32=3]="DT_INT32",e[e.DT_UINT8=4]="DT_UINT8",e[e.DT_INT16=5]="DT_INT16",e[e.DT_INT8=6]="DT_INT8",e[e.DT_STRING=7]="DT_STRING",e[e.DT_COMPLEX64=8]="DT_COMPLEX64",e[e.DT_INT64=9]="DT_INT64",e[e.DT_BOOL=10]="DT_BOOL",e[e.DT_QINT8=11]="DT_QINT8",e[e.DT_QUINT8=12]="DT_QUINT8",e[e.DT_QINT32=13]="DT_QINT32",e[e.DT_BFLOAT16=14]="DT_BFLOAT16",e[e.DT_QINT16=15]="DT_QINT16",e[e.DT_QUINT16=16]="DT_QUINT16",e[e.DT_UINT16=17]="DT_UINT16",e[e.DT_COMPLEX128=18]="DT_COMPLEX128",e[e.DT_HALF=19]="DT_HALF",e[e.DT_RESOURCE=20]="DT_RESOURCE",e[e.DT_VARIANT=21]="DT_VARIANT",e[e.DT_UINT32=22]="DT_UINT32",e[e.DT_UINT64=23]="DT_UINT64",e[e.DT_FLOAT_REF=101]="DT_FLOAT_REF",e[e.DT_DOUBLE_REF=102]="DT_DOUBLE_REF",e[e.DT_INT32_REF=103]="DT_INT32_REF",e[e.DT_UINT8_REF=104]="DT_UINT8_REF",e[e.DT_INT16_REF=105]="DT_INT16_REF",e[e.DT_INT8_REF=106]="DT_INT8_REF",e[e.DT_STRING_REF=107]="DT_STRING_REF",e[e.DT_COMPLEX64_REF=108]="DT_COMPLEX64_REF",e[e.DT_INT64_REF=109]="DT_INT64_REF",e[e.DT_BOOL_REF=110]="DT_BOOL_REF",e[e.DT_QINT8_REF=111]="DT_QINT8_REF",e[e.DT_QUINT8_REF=112]="DT_QUINT8_REF",e[e.DT_QINT32_REF=113]="DT_QINT32_REF",e[e.DT_BFLOAT16_REF=114]="DT_BFLOAT16_REF",e[e.DT_QINT16_REF=115]="DT_QINT16_REF",e[e.DT_QUINT16_REF=116]="DT_QUINT16_REF",e[e.DT_UINT16_REF=117]="DT_UINT16_REF",e[e.DT_COMPLEX128_REF=118]="DT_COMPLEX128_REF",e[e.DT_HALF_REF=119]="DT_HALF_REF",e[e.DT_RESOURCE_REF=120]="DT_RESOURCE_REF",e[e.DT_VARIANT_REF=121]="DT_VARIANT_REF",e[e.DT_UINT32_REF=122]="DT_UINT32_REF",e[e.DT_UINT64_REF=123]="DT_UINT64_REF"}(o||(o={})),function(e){var t;(t=e.CheckpointFormatVersion||(e.CheckpointFormatVersion={}))[t.LEGACY=0]="LEGACY",t[t.V1=1]="V1",t[t.V2=2]="V2"}(s||(s={}));var h={};function f(e){return h[e]}function m(e,n,r,a,o){var s=n.inputParams[e];if(s&&void 0!==s.inputIndexStart){var i=s.inputIndexStart,u=0===s.inputIndexEnd?void 0:void 0===s.inputIndexEnd?i+1:s.inputIndexEnd;if("tensor"===s.type)return y(n.inputNames[s.inputIndexStart],r,a,o);if("tensors"===s.type)return n.inputNames.slice(i,u).map((function(e){return y(e,r,a,o)}));var p=y(n.inputNames.slice(i)[0],r,a,o),c=p.dataSync();return"number"===s.type?c[0]:t.util.toNestedArray(p.shape,c)}var l=n.attrParams[e];return l&&l.value}function y(e,t,n,r){var a=l(b(e),2),o=a[0],s=a[1];if(null!=r){var i=r.getHashTableHandleByName(o);if(null!=i)return i}var u=n.currentContextIds.find((function(e){return!!t[v(o,e)]}));return void 0!==u?t[v(o,u)][s]:void 0}function g(e,t){var n=l(b(e),3),r=n[0],a=n[1],o=n[2];return[v(r,t&&t.currentContextId),a,o]}function v(e,t){return t?"".concat(e,"-").concat(t):e}function b(e){var t=e.split(":");if(1===t.length)return[e,0,void 0];var n=t[0],r=3===t.length?t[1]:void 0;return[n,Number(t[t.length-1]),r]}function x(e,t,n){var r=m("pad",e,t,n);if("explicit"===r){r=m("explicitPaddings",e,t,n);for(var a=[[0,0],[0,0],[0,0],[0,0]],o=0;o<4;o++)a[o][0]=r[2*o],a[o][1]=r[2*o+1];return a}return r}function N(e){return e.kept?e:t.clone(e)}var w={__proto__:null,json:[{tfOpName:"Add",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddV2",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddN",category:"arithmetic",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"BiasAdd",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"Sub",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"RealDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Div",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"DivNoNan",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mul",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Maximum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Minimum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Pow",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SquaredDifference",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorMod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},k={__proto__:null,json:[{tfOpName:"Abs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan2",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Ceil",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ClipByValue",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"clipValueMin",type:"number"},{start:2,name:"clipValueMax",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Complex",category:"basic_math",inputs:[{start:0,name:"real",type:"tensor"},{start:1,name:"imag",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ComplexAbs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Elu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Exp",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Floor",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Imag",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Neg",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Real",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Prelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"alpha",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu6",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Selu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sigmoid",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Rsqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Square",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sign",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Round",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Expm1",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log1p",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Reciprocal",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Softplus",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Erf",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Prod",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axes",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LeakyRelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"alpha",name:"alpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"IsNan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},T={__proto__:null,json:[{tfOpName:"EmptyTensorList",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"maxNumElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"LoopCond",category:"control",inputs:[{start:0,name:"pred",type:"tensor"}]},{tfOpName:"Switch",category:"control",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"pred",type:"tensor"}]},{tfOpName:"Merge",category:"control",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"Enter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"frame_name",name:"frameName",type:"string"},{tfName:"is_constant",name:"isConstant",type:"bool"}]},{tfOpName:"Exit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NextIteration",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayV3",category:"control",inputs:[{start:0,name:"size",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"dynamic_size",name:"dynamicSize",type:"bool"},{tfName:"clear_after_read",name:"clearAfterRead",type:"bool"},{tfName:"identical_element_shapes",name:"identicalElementShapes",type:"bool"},{tfName:"tensor_array_name",name:"name",type:"string"}]},{tfOpName:"TensorArrayWriteV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayReadV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayGatherV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"}]},{tfOpName:"TensorArrayScatterV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArrayConcatV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape_except0",name:"elementShapeExcept0",type:"shape",notSupported:!0}]},{tfOpName:"TensorArraySplitV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"tensor",type:"tensor"},{start:2,name:"lengths",type:"number[]"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArraySizeV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"},{start:1,name:"flowIn",type:"number"}]},{tfOpName:"TensorArrayCloseV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"tensor"}]},{tfOpName:"StatelessIf",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"If",category:"control",inputs:[{start:0,name:"cond",type:"tensor"},{start:1,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"then_branch",name:"thenBranch",type:"func"},{tfName:"else_branch",name:"elseBranch",type:"func"}]},{tfOpName:"StatelessWhile",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"While",category:"control",inputs:[{start:0,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"cond",name:"cond",type:"func"},{tfName:"body",name:"body",type:"func"}]},{tfOpName:"TensorListScatter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListScatterV2",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"},{start:3,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGather",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"indices",type:"number[]"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListGetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListSetItem",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListReserve",category:"control",inputs:[{start:0,name:"elementShape",type:"shape"},{start:1,name:"numElements",type:"number"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListFromTensor",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListStack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"},{tfName:"num_elements",name:"numElements",type:"dtype"}]},{tfOpName:"TensorListSplit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"},{start:1,name:"elementShape",type:"shape"},{start:2,name:"lengths",type:"number[]"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcat",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListConcatV2",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}],attrs:[{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPopBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"elementShape",type:"shape"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListPushBack",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"tensor",type:"tensor"}],attrs:[{tfName:"element_dtype",name:"elementDType",type:"dtype"}]},{tfOpName:"TensorListLength",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"}]},{tfOpName:"TensorListResize",category:"control",inputs:[{start:0,name:"tensorListId",type:"tensor"},{start:1,name:"size",type:"number"}]}]},_={__proto__:null,json:[{tfOpName:"AvgPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[],notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPoolWithArgmax",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"include_batch_in_index",name:"includeBatchInIndex",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AvgPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Conv1D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"stride",name:"stride",type:"number"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NWC"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"dilation",name:"dilation",type:"number",defaultValue:1}]},{tfOpName:"Conv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"useCudnnOnGpu",name:"useCudnnOnGpu",type:"bool"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"_FusedConv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"use_cudnn_on_gpu",name:"useCudnnOnGpu",type:"bool",defaultValue:!0},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2}]},{tfOpName:"Conv2DBackpropInput",category:"convolution",inputs:[{start:2,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:0,name:"outputShape",type:"number[]"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]",notSupported:!0}]},{tfOpName:"DepthwiseConv2d",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"DepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"FusedDepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]}]},{tfOpName:"Conv3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"Dilation2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"rates",name:"dilations",type:"number[]"},{tfName:"padding",name:"pad",type:"string"}]}]},S={__proto__:null,json:[{tfOpName:"Fill",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"},{start:1,name:"value",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"LinSpace",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"num",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"OneHot",category:"creation",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"depth",type:"number"},{start:2,name:"onValue",type:"number",defaultValue:1},{start:3,name:"offValue",type:"number",defaultValue:0}],attrs:[{tfName:"axis",name:"axis",type:"number",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Ones",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"OnesLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"RandomStandardNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"RandomUniform",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"minval",name:"minval",type:"number",defaultValue:0},{tfName:"maxval",name:"maxval",type:"number",defaultValue:1},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Range",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"step",type:"number",defaultValue:0}],attrs:[{tfName:"Tidx",name:"dtype",type:"dtype"}]},{tfOpName:"TruncatedNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"means",name:"mean",type:"number",defaultValue:0},{tfName:"stddev",name:"stdDev",type:"number",defaultValue:1},{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Zeros",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"ZerosLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Multinomial",category:"creation",inputs:[{start:0,name:"logits",type:"tensor"},{start:1,name:"numSamples",type:"number"}],attrs:[{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number"},{tfName:"T",name:"dtype",type:"dtype"},{tfName:"output_dtype",name:"output_dtype",type:"dtype"}]}]},E={__proto__:null,json:[{tfOpName:"NonMaxSuppressionV2",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV3",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV4",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"T_threshold",name:"threshold",type:"dtype",notSupported:!0},{tfName:"pad_to_max_output_size",name:"padToMaxOutputSize",type:"bool"}]},{tfOpName:"NonMaxSuppressionV5",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"},{start:5,name:"softNmsSigma",type:"number"}]},{tfOpName:"Where",category:"dynamic",inputs:[{start:0,name:"condition",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ListDiff",category:"dynamic",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},I={__proto__:null,json:[{tfOpName:"LowerBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"TopKV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"k",type:"number"}],attrs:[{tfName:"sorted",name:"sorted",type:"bool"}]},{tfOpName:"UpperBound",category:"evaluation",inputs:[{start:0,name:"sortedSequence",type:"tensor"},{start:1,name:"values",type:"tensor"}]},{tfOpName:"Unique",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"UniqueV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]}]},O={__proto__:null,json:[{tfOpName:"PlaceholderWithDefault",category:"graph",inputs:[{start:0,name:"default",type:"tensor"}],attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Placeholder",category:"graph",attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Const",category:"graph"},{tfOpName:"Identity",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IdentityN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Snapshot",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Rank",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Size",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Shape",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"ShapeN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Print",category:"graph",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"data",type:"tensors"}],attrs:[{tfName:"message",name:"message",type:"string"},{tfName:"first_n",name:"firstN",type:"number",notSupported:!0},{tfName:"summarize",name:"summarize",type:"number",defaultValue:3}]},{tfOpName:"NoOp",category:"graph",inputs:[]},{tfOpName:"StopGradient",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"FakeQuantWithMinMaxVars",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"min",name:"min",type:"number"},{tfName:"max",name:"max",type:"number"}]}]},D={__proto__:null,json:[{tfOpName:"HashTable",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"HashTableV2",category:"hash_table",inputs:[],attrs:[{tfName:"shared_name",name:"sharedName",type:"string"},{tfName:"use_node_name_sharing",name:"useNodeNameSharing",type:"bool"},{tfName:"key_dtype",name:"keyDType",type:"dtype"},{tfName:"value_dtype",name:"valueDType",type:"dtype"}]},{tfOpName:"LookupTableImport",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableImportV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFind",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableFindV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"Tin",name:"tIn",type:"dtype",notSupported:!0},{tfName:"Tout",name:"tOut",type:"dtype",notSupported:!0}]},{tfOpName:"LookupTableSize",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"LookupTableSizeV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"}]},{tfOpName:"InitializeTable",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}]},{tfOpName:"InitializeTableV2",category:"hash_table",inputs:[{start:0,name:"tableHandle",type:"tensor"},{start:1,name:"keys",type:"tensor"},{start:2,name:"values",type:"tensor"}]}]},A={__proto__:null,json:[{tfOpName:"ResizeBilinear",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ResizeNearestNeighbor",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"half_pixel_centers",name:"halfPixelCenters",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"CropAndResize",category:"image",inputs:[{start:0,name:"image",type:"tensor"},{start:1,name:"boxes",type:"tensor"},{start:2,name:"boxInd",type:"tensor"},{start:3,name:"cropSize",type:"number[]"}],attrs:[{tfName:"method",name:"method",type:"string"},{tfName:"extrapolation_value",name:"extrapolationValue",type:"number"}]},{tfOpName:"ImageProjectiveTransformV3",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"transforms",type:"tensor"},{start:2,name:"outputShape",type:"number[]"},{start:3,name:"fillValue",type:"number"}],attrs:[{tfName:"interpolation",name:"interpolation",type:"string"},{tfName:"fill_mode",name:"fillMode",type:"string"}]}]},M={__proto__:null,json:[{tfOpName:"Equal",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NotEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Greater",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"GreaterEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Less",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LessEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalAnd",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalNot",category:"logical",inputs:[{start:0,name:"a",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalOr",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Select",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SelectV2",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}]},C={__proto__:null,json:[{tfOpName:"_FusedMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"leakyrelu_alpha",name:"leakyreluAlpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMulV2",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Transpose",category:"matrices",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"perm",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Einsum",category:"matrices",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"equation",name:"equation",type:"string"},{tfName:"N",name:"n",type:"number",defaultValue:2},{tfName:"T",name:"dtype",type:"dtype"}]}]},F={__proto__:null,json:[{tfOpName:"EuclideanNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",defaultValue:!1}]},{tfOpName:"FusedBatchNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV2",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV3",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"LRN",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"depth_radius",name:"radius",type:"number",defaultValue:5},{tfName:"bias",name:"bias",type:"number",defaultValue:1},{tfName:"alpha",name:"alpha",type:"number",defaultValue:1},{tfName:"beta",name:"beta",type:"number",defaultValue:.5}]},{tfOpName:"Softmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"LogSoftmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"SparseToDense",category:"normalization",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!0,notSupported:!0}]}]},R={__proto__:null,json:[{tfOpName:"Bincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}]},{tfOpName:"DenseBincount",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"size",type:"number"},{start:2,name:"weights",type:"tensor"}],attrs:[{tfName:"binary_output",name:"binaryOutput",type:"bool"}]},{tfOpName:"Max",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Mean",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Min",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Sum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"All",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Any",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"ArgMax",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"ArgMin",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"Prod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Cumprod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]},{tfOpName:"Cumsum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}],attrs:[{tfName:"exclusive",name:"exclusive",type:"bool"},{tfName:"reverse",name:"reverse",type:"bool"}]}]},z={__proto__:null,json:[{tfOpName:"ConcatV2",category:"slice_join",inputs:[{start:0,end:-1,name:"tensors",type:"tensors"},{start:-1,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"Concat",category:"slice_join",inputs:[{start:1,end:0,name:"tensors",type:"tensors"},{start:0,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"GatherV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"axis",type:"number",defaultValue:0}],attrs:[{tfName:"batch_dims",name:"batchDims",type:"number",defaultValue:0}]},{tfOpName:"Gather",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",notSupported:!0}]},{tfOpName:"Reverse",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"dims",type:"bool[]"}]},{tfOpName:"ReverseV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}]},{tfOpName:"Slice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"size",type:"number[]"}]},{tfOpName:"StridedSlice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"end",type:"number[]"},{start:3,name:"strides",type:"number[]"}],attrs:[{tfName:"begin_mask",name:"beginMask",type:"number",defaultValue:0},{tfName:"end_mask",name:"endMask",type:"number",defaultValue:0},{tfName:"new_axis_mask",name:"newAxisMask",type:"number",defaultValue:0},{tfName:"ellipsis_mask",name:"ellipsisMask",type:"number",defaultValue:0},{tfName:"shrink_axis_mask",name:"shrinkAxisMask",type:"number",defaultValue:0}]},{tfOpName:"Pack",category:"slice_join",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0}]},{tfOpName:"Unpack",category:"slice_join",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0},{tfName:"num",name:"num",type:"number",defaultValue:0,notSupported:!0}]},{tfOpName:"Tile",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"reps",type:"number[]"}]},{tfOpName:"Split",category:"slice_join",inputs:[{start:0,name:"axis",type:"number",defaultValue:0},{start:1,name:"x",type:"tensor"}],attrs:[{tfName:"num_split",name:"numOrSizeSplits",type:"number",defaultValue:1}]},{tfOpName:"SplitV",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"numOrSizeSplits",type:"number[]"},{start:2,name:"axis",type:"number",defaultValue:0}]},{tfOpName:"ScatterNd",category:"slice_join",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"shape",type:"number[]"}]},{tfOpName:"GatherNd",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}]},{tfOpName:"SparseToDense",category:"slice_join",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!1,notSupported:!0}]}]},V={__proto__:null,json:[{tfOpName:"SparseFillEmptyRows",category:"sparse",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"denseShape",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}]},{tfOpName:"SparseReshape",category:"sparse",inputs:[{start:0,name:"inputIndices",type:"tensor"},{start:1,name:"inputShape",type:"tensor"},{start:2,name:"newShape",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SparseSegmentMean",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]},{tfOpName:"SparseSegmentSum",category:"sparse",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"segmentIds",type:"tensor"}]}]},L={__proto__:null,json:[{tfOpName:"FFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"RFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]},{tfOpName:"IRFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]}]},P={__proto__:null,json:[{tfOpName:"StringNGrams",category:"string",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"dataSplits",type:"tensor"}],attrs:[{tfName:"separator",name:"separator",type:"string"},{tfName:"ngram_widths",name:"nGramWidths",type:"number[]"},{tfName:"left_pad",name:"leftPad",type:"string"},{tfName:"right_pad",name:"rightPad",type:"string"},{tfName:"pad_width",name:"padWidth",type:"number"},{tfName:"preserve_short_sequences",name:"preserveShortSequences",type:"bool"}],outputs:["ngrams","ngrams_splits"]},{tfOpName:"StringSplit",category:"string",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"delimiter",type:"tensor"}],attrs:[{tfName:"skip_empty",name:"skipEmpty",type:"bool"}],outputs:["indices","values","shape"]},{tfOpName:"StringToHashBucketFast",category:"string",inputs:[{start:0,name:"input",type:"tensor"}],attrs:[{tfName:"num_buckets",name:"numBuckets",type:"number"}]}]},B={__proto__:null,json:[{tfOpName:"Cast",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"SrcT",name:"sdtype",type:"dtype",notSupported:!0},{tfName:"DstT",name:"dtype",type:"dtype"}]},{tfOpName:"ExpandDims",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"MirrorPad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"mode",name:"mode",type:"string"}]},{tfOpName:"Pad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"constant_value",name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"PadV2",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"},{start:2,name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"Reshape",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}]},{tfOpName:"Squeeze",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"axis",tfDeprecatedName:"squeeze_dims",name:"axis",type:"number[]"}]},{tfOpName:"SpaceToBatchND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"paddings",type:"number[]"}]},{tfOpName:"BatchToSpaceND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"crops",type:"number[]"}]},{tfOpName:"DepthToSpace",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"block_size",name:"blockSize",type:"number"},{tfName:"data_format",name:"dataFormat",type:"string"}]},{tfOpName:"BroadcastTo",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}],attrs:[]},{tfOpName:"BroadcastArgs",category:"transformation",inputs:[{start:0,name:"s0",type:"tensor"},{start:1,name:"s1",type:"tensor"}],attrs:[]}]},K=function(){function e(){var e=[w,k,T,_,S,E,I,O,D,A,M,C,F,R,z,V,L,P,B],t=[].concat.apply([],d([],l(e.map((function(e){return e.json}))),!1));this.opMappers=t.reduce((function(e,t){return e[t.tfOpName]=t,e}),{})}return Object.defineProperty(e,"Instance",{get:function(){return this._instance||(this._instance=new this)},enumerable:!1,configurable:!0}),e.prototype.transformGraph=function(e,t){var n=this;void 0===t&&(t={});var r=e.node,a=[],o=[],s=[],i=r.reduce((function(e,t){return e[t.name]=n.mapNode(t),t.op.startsWith("Placeholder")?a.push(e[t.name]):"Const"===t.op?o.push(e[t.name]):null!=t.input&&0!==t.input.length||s.push(e[t.name]),e}),{}),u=[],p=[],c={},d={};null!=t&&(c=this.mapSignatureEntries(t.inputs),d=this.mapSignatureEntries(t.outputs));var h=Object.keys(i);h.forEach((function(e){var t=i[e];t.inputNames.forEach((function(e,n){var r=l(g(e),3),a=r[0],o=r[2],s=i[a];if(null!=s.outputs){var u=s.outputs.indexOf(o);if(-1!==u){var p="".concat(a,":").concat(u);t.inputNames[n]=p}}t.inputs.push(s),s.children.push(t)}))})),0===Object.keys(d).length?h.forEach((function(e){var t=i[e];0===t.children.length&&p.push(t)})):Object.keys(d).forEach((function(e){var t=l(g(e),1)[0],n=i[t];null!=n&&(n.signatureKey=d[e],p.push(n))})),Object.keys(c).length>0?Object.keys(c).forEach((function(e){var t=l(g(e),1)[0],n=i[t];n&&(n.signatureKey=c[e],u.push(n))})):u=a;var f={};null!=e.library&&null!=e.library.function&&(f=e.library.function.reduce((function(e,t){return e[t.signature.name]=n.mapFunction(t),e}),{}));var m={nodes:i,inputs:u,outputs:p,weights:o,placeholders:a,signature:t,functions:f};return s.length>0&&(m.initNodes=s),m},e.prototype.mapSignatureEntries=function(e){return Object.keys(e||{}).reduce((function(t,n){return t[e[n].name]=n,t}),{})},e.prototype.mapNode=function(e){var t=f(e.op)||this.opMappers[e.op]||{};null==e.attr&&(e.attr={});var n={name:e.name,op:e.op,category:t.category,inputNames:(e.input||[]).map((function(e){return e.startsWith("^")?e.slice(1):e})),inputs:[],children:[],inputParams:{},attrParams:{},rawAttrs:e.attr,outputs:t.outputs};return null!=t.inputs&&(n.inputParams=t.inputs.reduce((function(e,t){return e[t.name]={type:t.type,inputIndexStart:t.start,inputIndexEnd:t.end},e}),{})),null!=t.attrs&&(n.attrParams=t.attrs.reduce((function(t,n){var r=n.type,a=void 0;switch(n.type){case"string":void 0===(a=q(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=q(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"string[]":void 0===(a=$(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=$(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"number":void 0===(a=W(e.attr,n.tfName,n.defaultValue||0))&&n.tfDeprecatedName&&(a=W(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"number[]":void 0===(a=J(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=J(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool":void 0===(a=U(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=U(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"bool[]":void 0===(a=te(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=te(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape":void 0===(a=X(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=X(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"shape[]":void 0===(a=ee(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=ee(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype":void 0===(a=Z(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=Z(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"dtype[]":void 0===(a=Q(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=Q(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"func":void 0===(a=G(e.attr,n.tfName,n.defaultValue))&&n.tfDeprecatedName&&(a=G(e.attr,n.tfDeprecatedName,n.defaultValue));break;case"tensor":case"tensors":break;default:throw new Error("Unsupported param type: ".concat(n.type," for op: ").concat(e.op))}return t[n.name]={value:a,type:r},t}),{})),n},e.prototype.mapFunction=function(e){var t=this,n=e.nodeDef,r=[],a={};null!=n&&(a=n.reduce((function(e,n){return e[n.name]=t.mapNode(n),"Const"===n.op&&r.push(e[n.name]),e}),{}));var o=[],s=[];e.signature.inputArg.forEach((function(e){var t=l(g(e.name),1)[0],n={name:t,op:"Placeholder",inputs:[],inputNames:[],category:"graph",inputParams:{},attrParams:{dtype:{value:H(e.type),type:"dtype"}},children:[]};n.signatureKey=e.name,o.push(n),a[t]=n})),Object.keys(a).forEach((function(e){var t=a[e];t.inputNames.forEach((function(e,n){var r=l(g(e),3),o=r[0],s=r[2],i=a[o];if(null!=i.outputs){var u=i.outputs.indexOf(s);if(-1!==u){var p="".concat(o,":").concat(u);t.inputNames[n]=p}}t.inputs.push(i),i.children.push(t)}))}));var i=e.ret;e.signature.outputArg.forEach((function(e){var t=l(g(i[e.name]),2),n=t[0],r=t[1],o=a[n];null!=o&&(o.defaultOutput=r,s.push(o))}));var u=this.mapArgsToSignature(e);return{nodes:a,inputs:o,outputs:s,weights:r,placeholders:[],signature:u}},e.prototype.mapArgsToSignature=function(e){var t=this;return{methodName:e.signature.name,inputs:e.signature.inputArg.reduce((function(e,n){return e[n.name]=t.mapArgToTensorInfo(n),e}),{}),outputs:e.signature.outputArg.reduce((function(n,r){return n[r.name]=t.mapArgToTensorInfo(r,e.ret),n}),{})}},e.prototype.mapArgToTensorInfo=function(e,t){var n=e.name;return null!=t&&(n=t[n]),{name:n,dtype:e.type}},e}();function j(e,n){var r=Array.isArray(e)?String.fromCharCode.apply(null,e):function(e){var n=t.env().global;if("undefined"!=typeof n.atob)return n.atob(e);if("undefined"!=typeof Buffer)return new Buffer(e,"base64").toString();throw new Error("Unable to decode base64 in this environment. Missing built-in atob() or Buffer()")}(e);return n?r:r.toLowerCase()}function q(e,t,n,r){void 0===r&&(r=!1);var a=e[t];return null!=a?j(a.s,r):n}function U(e,t,n){var r=e[t];return r?r.b:n}function W(e,t,n){var r=e[t]||{},a=null!=r.i?r.i:null!=r.f?r.f:n;return"number"==typeof a?a:parseInt(a,10)}function H(e){switch("string"==typeof e&&(e=o[e]),e){case o.DT_FLOAT:case o.DT_HALF:return"float32";case o.DT_INT32:case o.DT_INT64:case o.DT_INT8:case o.DT_UINT8:return"int32";case o.DT_BOOL:return"bool";case o.DT_DOUBLE:return"float32";case o.DT_STRING:return"string";default:return null}}function G(e,t,n){var r=e[t];return r&&r.func?r.func.name:n}function Z(e,t,n){var r=e[t];return r&&r.type?H(r.type):n}function Q(e,t,n){var r=e[t];return r&&r.list&&r.list.type?r.list.type.map((function(e){return H(e)})):n}function Y(e){if(!e.unknownRank)return null!=e.dim?e.dim.map((function(e){return"number"==typeof e.size?e.size:parseInt(e.size,10)})):[]}function X(e,t,n){var r=e[t];return r&&r.shape?Y(r.shape):n}function J(e,t,n){var r=e[t];return r?((r.list.f&&r.list.f.length?r.list.f:r.list.i)||[]).map((function(e){return"number"==typeof e?e:parseInt(e,10)})):n}function $(e,t,n,r){void 0===r&&(r=!1);var a=e[t];return a&&a.list&&a.list.s?a.list.s.map((function(e){return j(e,r)})):n}function ee(e,t,n){var r=e[t];return r&&r.list&&r.list.shape?r.list.shape.map((function(e){return Y(e)})):n}function te(e,t,n){var r=e[t];return r&&r.list&&r.list.b?r.list.b:n}var ne=function(){function e(e,t,n){var r=this;this.node=e,this.tensorMap=t,this.context=n,this.inputs=[],this.attrs={},this.inputs=e.inputNames.map((function(e){return r.getInput(e)})),null!=e.rawAttrs&&(this.attrs=Object.keys(e.rawAttrs).reduce((function(e,t){return e[t]=r.getAttr(t),e}),{}))}return e.prototype.getInput=function(e){return y(e,this.tensorMap,this.context)},e.prototype.getAttr=function(e,t){var n=this.node.rawAttrs[e];if(null!=n.tensor)return y(e,this.tensorMap,this.context);if(null!=n.i||null!=n.f)return W(this.node.rawAttrs,e,t);if(null!=n.s)return q(this.node.rawAttrs,e,t);if(null!=n.b)return U(this.node.rawAttrs,e,t);if(null!=n.shape)return X(this.node.rawAttrs,e,t);if(null!=n.type)return Z(this.node.rawAttrs,e,t);if(null!=n.list){if(null!=n.list.i||null!=n.list.f)return J(this.node.rawAttrs,e,t);if(null!=n.list.s)return $(this.node.rawAttrs,e,t);if(null!=n.list.shape)return ee(this.node.rawAttrs,e,t);if(null!=n.list.b)return te(this.node.rawAttrs,e,t);if(null!=n.list.type)return Q(this.node.rawAttrs,e,t)}return t},e}(),re=function(){function e(){}return e.prototype.refCount=function(e){return ae("refCount")},e.prototype.incRef=function(e){return ae("incRef")},e.prototype.timerAvailable=function(){return!0},e.prototype.time=function(e){return ae("time")},e.prototype.read=function(e){return ae("read")},e.prototype.readSync=function(e){return ae("readSync")},e.prototype.readToGPU=function(e,t){return ae("readToGPU")},e.prototype.numDataIds=function(){return ae("numDataIds")},e.prototype.disposeData=function(e,t){return ae("disposeData")},e.prototype.write=function(e,t,n){return ae("write")},e.prototype.move=function(e,t,n,r,a){return ae("move")},e.prototype.createTensorFromGPUData=function(e,t,n){return ae("createTensorFromGPUData")},e.prototype.memory=function(){return ae("memory")},e.prototype.floatPrecision=function(){return ae("floatPrecision")},e.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},e.prototype.dispose=function(){return ae("dispose")},e}();function ae(e){throw new Error("'".concat(e,"' not yet implemented or not found in the registry. ")+"This kernel may not be supported by the tfjs backend you have chosen")}function oe(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function se(e,t,n){void 0===n&&(n=""),oe(pe(e,t),(function(){return n+" Shapes ".concat(e," and ").concat(t," must match")}))}function ie(e){oe(null!=e,(function(){return"The input to the tensor constructor must be a non-null value."}))}function ue(e){if(0===e.length)return 1;for(var t=e[0],n=1;n<e.length;n++)t*=e[n];return t}function pe(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(var n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function ce(e){return e%1==0}function le(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function de(e,t){var n=t.length;return oe((e=null==e?t.map((function(e,t){return t})):[].concat(e)).every((function(e){return e>=-n&&e<n})),(function(){return"All values in axis param must be in range [-".concat(n,", ").concat(n,") but ")+"got axis ".concat(e)})),oe(e.every((function(e){return ce(e)})),(function(){return"All values in axis param must be integers but "+"got axis ".concat(e)})),e.map((function(e){return e<0?n+e:e}))}function he(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error("Unknown dtype ".concat(e))}function fe(e){return"string"==typeof e||e instanceof String}function me(e){return Array.isArray(e)?me(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray?"int32":"number"==typeof e?"float32":fe(e)?"string":function(e){return"boolean"==typeof e}(e)?"bool":"float32"}function ye(e){return!!(e&&e.constructor&&e.call&&e.apply)}function ge(e){var t=e.length;if(t<2)return[];var n=new Array(t-1);n[t-2]=e[t-1];for(var r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function ve(e,t,n,r){void 0===r&&(r=!1);var a=new Array;if(1===t.length)for(var o=t[0]*(r?2:1),s=0;s<o;s++)a[s]=n[e+s];else{o=t[0];var i=t.slice(1),u=i.reduce((function(e,t){return e*t}))*(r?2:1);for(s=0;s<o;s++)a[s]=ve(e+s*u,i,n,r)}return a}function be(e,t,n){if(void 0===n&&(n=!1),0===e.length)return t[0];var r=e.reduce((function(e,t){return e*t}))*(n?2:1);if(0===r)return[];if(r!==t.length)throw new Error("[".concat(e,"] does not match the input size ").concat(t.length).concat(n?" for a complex tensor":"","."));return ve(0,e,t,n)}function xe(e,t){for(var n=Ne(e,t),r=0;r<n.length;r++)n[r]=1;return n}function Ne(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error("Unknown data type ".concat(t))}function we(e){e.forEach((function(t){oe(Number.isInteger(t)&&t>=0,(function(){return"Tensor must have a shape comprised of positive integers but got "+"shape [".concat(e,"].")}))}))}function ke(e){return e&&e.then&&"function"==typeof e.then}var Te="tfjsflags",_e=function(){function e(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=Se,this.populateURLFlags()}return e.prototype.setPlatform=function(e,t){null!=this.platform&&(Ie().getBool("IS_TEST")||Ie().getBool("PROD")||console.warn("Platform ".concat(this.platformName," has already been set. ")+"Overwriting the platform with ".concat(e,"."))),this.platformName=e,this.platform=t},e.prototype.registerFlag=function(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){var r=this.urlFlags[e];Ie().getBool("IS_TEST")||Ie().getBool("PROD")||console.warn("Setting feature override from URL ".concat(e,": ").concat(r,".")),this.set(e,r)}},e.prototype.getAsync=function(e){return u(this,void 0,void 0,(function(){var t,n;return p(this,(function(r){switch(r.label){case 0:return e in this.flags?[2,this.flags[e]]:(t=this.flags,n=e,[4,this.evaluateFlag(e)]);case 1:return t[n]=r.sent(),[2,this.flags[e]]}}))}))},e.prototype.get=function(e){if(e in this.flags)return this.flags[e];var t=this.evaluateFlag(e);if(ke(t))throw new Error("Flag ".concat(e," cannot be synchronously evaluated. ")+"Please use getAsync() instead.");return this.flags[e]=t,this.flags[e]},e.prototype.getNumber=function(e){return this.get(e)},e.prototype.getBool=function(e){return this.get(e)},e.prototype.getFlags=function(){return this.flags},Object.defineProperty(e.prototype,"features",{get:function(){return this.flags},enumerable:!1,configurable:!0}),e.prototype.set=function(e,t){if(null==this.flagRegistry[e])throw new Error("Cannot set flag ".concat(e," as it has not been registered."));this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)},e.prototype.evaluateFlag=function(e){if(null==this.flagRegistry[e])throw new Error("Cannot evaluate flag '".concat(e,"': no evaluation function found."));return this.flagRegistry[e].evaluationFn()},e.prototype.setFlags=function(e){this.flags=Object.assign({},e)},e.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},e.prototype.populateURLFlags=function(){var e=this;if("undefined"!=typeof this.global&&"undefined"!=typeof this.global.location&&"undefined"!=typeof this.global.location.search){var t=this.getQueryParams(this.global.location.search);if(Te in t)t.tfjsflags.split(",").forEach((function(t){var n=l(t.split(":"),2),r=n[0],a=n[1];e.urlFlags[r]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if("".concat(+t)===t)return+t;throw new Error("Could not parse value flag value ".concat(t," for flag ").concat(e,"."))}(r,a)}))}},e}();function Se(e){var t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];return Ee(t,n[0],n[1]),n.join("=")})),t}function Ee(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}function Ie(){return De}var Oe,De=null;function Ae(){if(null==Oe){var e=void 0;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}Oe=e}return Oe}function Me(e,t){var n,r=(null==(n=Ae())._tfGlobals&&(n._tfGlobals=new Map),n._tfGlobals);if(r.has(e))return r.get(e);var a=t();return r.set(e,a),r.get(e)}var Ce="Cast",Fe="Einsum",Re="Identity",ze="Tile",Ve="Transpose",Le="_FusedMatMul",Pe="FusedConv2D",Be="FusedDepthwiseConv2D";function Ke(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];Ie().getBool("IS_TEST")||Ie().getBool("PROD")||console.warn.apply(console,d([],l(e),!1))}var je=Me("kernelRegistry",(function(){return new Map})),qe=Me("gradRegistry",(function(){return new Map}));function Ue(e,t){var n=function(e,t){return"".concat(t,"_").concat(e)}(e,t);return je.get(n)}function We(e){return qe.get(e)}function He(e){for(var t=je.entries(),n=[];;){var r=t.next(),a=r.done,o=r.value;if(a)break;var s=l(o,2),i=s[0],u=s[1];l(i.split("_"),1)[0]===e&&n.push(u)}return n}var Ge=Qe,Ze=null;try{Ze=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(e){}function Qe(e,t,n){this.low=0|e,this.high=0|t,this.unsigned=!!n}function Ye(e){return!0===(e&&e.__isLong__)}Qe.prototype.__isLong__,Object.defineProperty(Qe.prototype,"__isLong__",{value:!0}),Qe.isLong=Ye;var Xe={},Je={};function $e(e,t){var n,r,a;return t?(a=0<=(e>>>=0)&&e<256)&&(r=Je[e])?r:(n=tt(e,(0|e)<0?-1:0,!0),a&&(Je[e]=n),n):(a=-128<=(e|=0)&&e<128)&&(r=Xe[e])?r:(n=tt(e,e<0?-1:0,!1),a&&(Xe[e]=n),n)}function et(e,t){if(isNaN(e))return t?ct:pt;if(t){if(e<0)return ct;if(e>=st)return mt}else{if(e<=-it)return yt;if(e+1>=it)return ft}return e<0?et(-e,t).neg():tt(e%ot|0,e/ot|0,t)}function tt(e,t,n){return new Qe(e,t,n)}Qe.fromInt=$e,Qe.fromNumber=et,Qe.fromBits=tt;var nt=Math.pow;function rt(e,t,n){if(0===e.length)throw Error("empty string");if("NaN"===e||"Infinity"===e||"+Infinity"===e||"-Infinity"===e)return pt;if("number"==typeof t?(n=t,t=!1):t=!!t,(n=n||10)<2||36<n)throw RangeError("radix");var r;if((r=e.indexOf("-"))>0)throw Error("interior hyphen");if(0===r)return rt(e.substring(1),t,n).neg();for(var a=et(nt(n,8)),o=pt,s=0;s<e.length;s+=8){var i=Math.min(8,e.length-s),u=parseInt(e.substring(s,s+i),n);if(i<8){var p=et(nt(n,i));o=o.mul(p).add(et(u))}else o=(o=o.mul(a)).add(et(u))}return o.unsigned=t,o}function at(e,t){return"number"==typeof e?et(e,t):"string"==typeof e?rt(e,t):tt(e.low,e.high,"boolean"==typeof t?t:e.unsigned)}Qe.fromString=rt,Qe.fromValue=at;var ot=4294967296,st=ot*ot,it=st/2,ut=$e(1<<24),pt=$e(0);Qe.ZERO=pt;var ct=$e(0,!0);Qe.UZERO=ct;var lt=$e(1);Qe.ONE=lt;var dt=$e(1,!0);Qe.UONE=dt;var ht=$e(-1);Qe.NEG_ONE=ht;var ft=tt(-1,2147483647,!1);Qe.MAX_VALUE=ft;var mt=tt(-1,-1,!0);Qe.MAX_UNSIGNED_VALUE=mt;var yt=tt(0,-2147483648,!1);Qe.MIN_VALUE=yt;var gt=Qe.prototype;gt.toInt=function(){return this.unsigned?this.low>>>0:this.low},gt.toNumber=function(){return this.unsigned?(this.high>>>0)*ot+(this.low>>>0):this.high*ot+(this.low>>>0)},gt.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(yt)){var t=et(e),n=this.div(t),r=n.mul(t).sub(this);return n.toString(e)+r.toInt().toString(e)}return"-"+this.neg().toString(e)}for(var a=et(nt(e,6),this.unsigned),o=this,s="";;){var i=o.div(a),u=(o.sub(i.mul(a)).toInt()>>>0).toString(e);if((o=i).isZero())return u+s;for(;u.length<6;)u="0"+u;s=""+u+s}},gt.getHighBits=function(){return this.high},gt.getHighBitsUnsigned=function(){return this.high>>>0},gt.getLowBits=function(){return this.low},gt.getLowBitsUnsigned=function(){return this.low>>>0},gt.getNumBitsAbs=function(){if(this.isNegative())return this.eq(yt)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;t>0&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},gt.isZero=function(){return 0===this.high&&0===this.low},gt.eqz=gt.isZero,gt.isNegative=function(){return!this.unsigned&&this.high<0},gt.isPositive=function(){return this.unsigned||this.high>=0},gt.isOdd=function(){return 1==(1&this.low)},gt.isEven=function(){return 0==(1&this.low)},gt.equals=function(e){return Ye(e)||(e=at(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&(this.high===e.high&&this.low===e.low)},gt.eq=gt.equals,gt.notEquals=function(e){return!this.eq(e)},gt.neq=gt.notEquals,gt.ne=gt.notEquals,gt.lessThan=function(e){return this.comp(e)<0},gt.lt=gt.lessThan,gt.lessThanOrEqual=function(e){return this.comp(e)<=0},gt.lte=gt.lessThanOrEqual,gt.le=gt.lessThanOrEqual,gt.greaterThan=function(e){return this.comp(e)>0},gt.gt=gt.greaterThan,gt.greaterThanOrEqual=function(e){return this.comp(e)>=0},gt.gte=gt.greaterThanOrEqual,gt.ge=gt.greaterThanOrEqual,gt.compare=function(e){if(Ye(e)||(e=at(e)),this.eq(e))return 0;var t=this.isNegative(),n=e.isNegative();return t&&!n?-1:!t&&n?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},gt.comp=gt.compare,gt.negate=function(){return!this.unsigned&&this.eq(yt)?yt:this.not().add(lt)},gt.neg=gt.negate,gt.add=function(e){Ye(e)||(e=at(e));var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,a=65535&this.low,o=e.high>>>16,s=65535&e.high,i=e.low>>>16,u=0,p=0,c=0,l=0;return c+=(l+=a+(65535&e.low))>>>16,p+=(c+=r+i)>>>16,u+=(p+=n+s)>>>16,u+=t+o,tt((c&=65535)<<16|(l&=65535),(u&=65535)<<16|(p&=65535),this.unsigned)},gt.subtract=function(e){return Ye(e)||(e=at(e)),this.add(e.neg())},gt.sub=gt.subtract,gt.multiply=function(e){if(this.isZero())return pt;if(Ye(e)||(e=at(e)),Ze)return tt(Ze.mul(this.low,this.high,e.low,e.high),Ze.get_high(),this.unsigned);if(e.isZero())return pt;if(this.eq(yt))return e.isOdd()?yt:pt;if(e.eq(yt))return this.isOdd()?yt:pt;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(ut)&&e.lt(ut))return et(this.toNumber()*e.toNumber(),this.unsigned);var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,a=65535&this.low,o=e.high>>>16,s=65535&e.high,i=e.low>>>16,u=65535&e.low,p=0,c=0,l=0,d=0;return l+=(d+=a*u)>>>16,c+=(l+=r*u)>>>16,l&=65535,c+=(l+=a*i)>>>16,p+=(c+=n*u)>>>16,c&=65535,p+=(c+=r*i)>>>16,c&=65535,p+=(c+=a*s)>>>16,p+=t*u+n*i+r*s+a*o,tt((l&=65535)<<16|(d&=65535),(p&=65535)<<16|(c&=65535),this.unsigned)},gt.mul=gt.multiply,gt.divide=function(e){if(Ye(e)||(e=at(e)),e.isZero())throw Error("division by zero");var t,n,r;if(Ze)return this.unsigned||-2147483648!==this.high||-1!==e.low||-1!==e.high?tt((this.unsigned?Ze.div_u:Ze.div_s)(this.low,this.high,e.low,e.high),Ze.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?ct:pt;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return ct;if(e.gt(this.shru(1)))return dt;r=ct}else{if(this.eq(yt))return e.eq(lt)||e.eq(ht)?yt:e.eq(yt)?lt:(t=this.shr(1).div(e).shl(1)).eq(pt)?e.isNegative()?lt:ht:(n=this.sub(e.mul(t)),r=t.add(n.div(e)));if(e.eq(yt))return this.unsigned?ct:pt;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();r=pt}for(n=this;n.gte(e);){t=Math.max(1,Math.floor(n.toNumber()/e.toNumber()));for(var a=Math.ceil(Math.log(t)/Math.LN2),o=a<=48?1:nt(2,a-48),s=et(t),i=s.mul(e);i.isNegative()||i.gt(n);)i=(s=et(t-=o,this.unsigned)).mul(e);s.isZero()&&(s=lt),r=r.add(s),n=n.sub(i)}return r},gt.div=gt.divide,gt.modulo=function(e){return Ye(e)||(e=at(e)),Ze?tt((this.unsigned?Ze.rem_u:Ze.rem_s)(this.low,this.high,e.low,e.high),Ze.get_high(),this.unsigned):this.sub(this.div(e).mul(e))},gt.mod=gt.modulo,gt.rem=gt.modulo,gt.not=function(){return tt(~this.low,~this.high,this.unsigned)},gt.and=function(e){return Ye(e)||(e=at(e)),tt(this.low&e.low,this.high&e.high,this.unsigned)},gt.or=function(e){return Ye(e)||(e=at(e)),tt(this.low|e.low,this.high|e.high,this.unsigned)},gt.xor=function(e){return Ye(e)||(e=at(e)),tt(this.low^e.low,this.high^e.high,this.unsigned)},gt.shiftLeft=function(e){return Ye(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?tt(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):tt(0,this.low<<e-32,this.unsigned)},gt.shl=gt.shiftLeft,gt.shiftRight=function(e){return Ye(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?tt(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):tt(this.high>>e-32,this.high>=0?0:-1,this.unsigned)},gt.shr=gt.shiftRight,gt.shiftRightUnsigned=function(e){if(Ye(e)&&(e=e.toInt()),0===(e&=63))return this;var t=this.high;return e<32?tt(this.low>>>e|t<<32-e,t>>>e,this.unsigned):tt(32===e?t:t>>>e-32,0,this.unsigned)},gt.shru=gt.shiftRightUnsigned,gt.shr_u=gt.shiftRightUnsigned,gt.toSigned=function(){return this.unsigned?tt(this.low,this.high,!1):this},gt.toUnsigned=function(){return this.unsigned?this:tt(this.low,this.high,!0)},gt.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},gt.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},gt.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},Qe.fromBytes=function(e,t,n){return n?Qe.fromBytesLE(e,t):Qe.fromBytesBE(e,t)},Qe.fromBytesLE=function(e,t){return new Qe(e[0]|e[1]<<8|e[2]<<16|e[3]<<24,e[4]|e[5]<<8|e[6]<<16|e[7]<<24,t)},Qe.fromBytesBE=function(e,t){return new Qe(e[4]<<24|e[5]<<16|e[6]<<8|e[7],e[0]<<24|e[1]<<16|e[2]<<8|e[3],t)};var vt=Ge||r({__proto__:null,default:Ge},[Ge]);function bt(e){return vt.fromString(e,!0,16)}function xt(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=Tt(e)),Ie().getBool("DEBUG")&&function(e,t){for(var n=0;n<e.length;n++){var r=e[n];if(isNaN(r)||!isFinite(r))throw Error("A tensor of type ".concat(t," being uploaded contains ").concat(r,"."))}}(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){for(var n=new Uint8Array(e.length),r=0;r<n.length;++r)0!==Math.round(e[r])&&(n[r]=1);return n}throw new Error("Unknown data type ".concat(t))}function Nt(){return Ie().platform.now()}function wt(e,t){return void 0===t&&(t="utf-8"),t=t||"utf-8",Ie().platform.decode(e,t)}function kt(e){return Ie().platform.isTypedArray(e)}function Tt(e,t,n){var r,a;if(void 0===t&&(t=[]),void 0===n&&(n=!1),null==t&&(t=[]),"boolean"==typeof e||"number"==typeof e||"string"==typeof e||ke(e)||null==e||kt(e)&&n)t.push(e);else if(Array.isArray(e)||kt(e))for(var o=0;o<e.length;++o)Tt(e[o],t,n);else{var s=-1;try{for(var i=c(Object.keys(e)),u=i.next();!u.done;u=i.next()){var p=u.value;/^([1-9]+[0-9]*|0)$/.test(p)&&(s=Math.max(s,Number(p)))}}catch(e){r={error:e}}finally{try{u&&!u.done&&(a=i.return)&&a.call(i)}finally{if(r)throw r.error}}for(o=0;o<=s;o++)Tt(e[o],t,n)}return t}bt("c3a5c85c97cb3127"),bt("b492b66fbe98f273"),bt("9ae16a3b2f90404f");var _t=function(){function e(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new St)}return e.prototype.profileKernel=function(e,t,n){var r,a,o,s,i=function(){o=n()},u=Nt();if(this.backendTimer.timerAvailable())s=this.backendTimer.time(i);else{i();try{for(var p=c(o),l=p.next();!l.done;l=p.next()){l.value.dataSync()}}catch(e){r={error:e}}finally{try{l&&!l.done&&(a=p.return)&&a.call(p)}finally{if(r)throw r.error}}s=Promise.resolve({kernelMs:Nt()-u})}if(Ie().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(var d=function(t){var n=o[t];n.data().then((function(t){!function(e,t,n){if("float32"!==t)return!1;for(var r=0;r<e.length;r++){var a=e[r];if(isNaN(a)||!isFinite(a))return console.warn("Found ".concat(a," in the result of '").concat(n,"'")),!0}}(t,n.dtype,e)}))},h=0;h<o.length;h++)d(h);return{kernelName:e,outputs:o,inputs:t,timeMs:s.then((function(e){return e.kernelMs})),extraInfo:s.then((function(e){return null!=e.getExtraProfileInfo?e.getExtraProfileInfo():""}))}},e.prototype.logKernelProfile=function(e){var t=this,n=e.kernelName,r=e.outputs,a=e.timeMs,o=e.inputs,s=e.extraInfo;r.forEach((function(e){Promise.all([e.data(),a,s]).then((function(r){t.logger.logKernelProfile(n,e,r[0],r[1],o,r[2])}))}))},e}();var St=function(){function e(){}return e.prototype.logKernelProfile=function(e,t,n,r,a,o){var s="number"==typeof r?le("".concat(r,"ms"),9):r.error,i=le(e,25),u=t.rank,p=t.size,c=le(t.shape.toString(),14),l="";for(var d in a){var h=a[d];if(null!=h){var f=h.shape||t.shape,m=f.length;l+="".concat(d,": ").concat(m,"D ").concat(m>0?f:""," ")}}console.log("%c".concat(i,"\t%c").concat(s,"\t%c").concat(u,"D ").concat(c,"\t%c").concat(p,"\t%c").concat(l,"\t%c").concat(o),"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")},e}();function Et(e,t,n,r){var a=ge(t),o=function(e,t,n,r){var a=ue(t),o=r[r.length-1],s=new Array(o).fill(0),i=t.length,u="complex64"===n?At(e):e;if(i>1)for(var p=0;p<a/o;p++)for(var c=p*o,l=0;l<o;l++)s[l]=Math.max(s[l],It(u[c+l],0,n).length);return s}(e,t,n,a),s=t.length,i=Dt(e,t,n,a,o),u=["Tensor"];return r&&(u.push("  dtype: ".concat(n)),u.push("  rank: ".concat(s)),u.push("  shape: [".concat(t,"]")),u.push("  values:")),u.push(i.map((function(e){return"    "+e})).join("\n")),u.join("\n")}function It(e,t,n){return le(Array.isArray(e)?"".concat(parseFloat(e[0].toFixed(7))," + ")+"".concat(parseFloat(e[1].toFixed(7)),"j"):fe(e)?"'".concat(e,"'"):"bool"===n?Ot(e):parseFloat(e.toFixed(7)).toString(),t)}function Ot(e){return 0===e?"false":"true"}function Dt(e,t,n,r,a,o){void 0===o&&(o=!0);var s="complex64"===n?2:1,i=t[0],u=t.length;if(0===u)return"complex64"===n?[It(At(e)[0],0,n)]:"bool"===n?[Ot(e[0])]:[e[0].toString()];if(1===u){if(i>20){var p=3*s,c=Array.from(e.slice(0,p)),h=Array.from(e.slice((i-3)*s,i*s));return"complex64"===n&&(c=At(c),h=At(h)),["["+c.map((function(e,t){return It(e,a[t],n)})).join(", ")+", ..., "+h.map((function(e,t){return It(e,a[i-3+t],n)})).join(", ")+"]"]}return["["+("complex64"===n?At(e):Array.from(e)).map((function(e,t){return It(e,a[t],n)})).join(", ")+"]"]}var f=t.slice(1),m=r.slice(1),y=r[0]*s,g=[];if(i>20){for(var v=0;v<3;v++){var b=(x=v*y)+y;g.push.apply(g,d([],l(Dt(e.slice(x,b),f,n,m,a,!1)),!1))}g.push("...");for(v=i-3;v<i;v++){b=(x=v*y)+y;g.push.apply(g,d([],l(Dt(e.slice(x,b),f,n,m,a,v===i-1)),!1))}}else for(v=0;v<i;v++){var x;b=(x=v*y)+y;g.push.apply(g,d([],l(Dt(e.slice(x,b),f,n,m,a,v===i-1)),!1))}var N=2===u?",":"";g[0]="["+(i>0?g[0]+N:"");for(v=1;v<g.length-1;v++)g[v]=" "+g[v]+N;var w=",\n";for(v=2;v<u;v++)w+="\n";return g[g.length-1]=" "+g[g.length-1]+"]"+(o?"":w),g}function At(e){for(var t=[],n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}var Mt=function(){function e(e,t,n){var r=this;if(this.dtype=t,this.shape=e.slice(),this.size=ue(e),null!=n){var a=n.length;oe(a===this.size,(function(){return"Length of values '".concat(a,"' does not match the size ")+"inferred by the shape '".concat(r.size,"'.")}))}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||function(e,t){var n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error("Unknown data type ".concat(e));n=new Array(t)}return n}(t,this.size),this.strides=ge(e)}return e.prototype.set=function(e){for(var t=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),oe(n.length===this.rank,(function(){return"The number of provided coordinates (".concat(n.length,") must ")+"match the rank (".concat(t.rank,")")}));var a=this.locToIndex(n);this.values[a]=e},e.prototype.get=function(){for(var e,t,n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];0===n.length&&(n=[0]);var a=0;try{for(var o=c(n),s=o.next();!s.done;s=o.next()){var i=s.value;if(i<0||i>=this.shape[a]){var u="Requested out of range element at ".concat(n,". ")+"  Buffer shape=".concat(this.shape);throw new Error(u)}a++}}catch(t){e={error:t}}finally{try{s&&!s.done&&(t=o.return)&&t.call(o)}finally{if(e)throw e.error}}for(var p=n[n.length-1],l=0;l<n.length-1;++l)p+=this.strides[l]*n[l];return this.values[p]},e.prototype.locToIndex=function(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];for(var t=e[e.length-1],n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t},e.prototype.indexToLoc=function(e){if(0===this.rank)return[];if(1===this.rank)return[e];for(var t=new Array(this.shape.length),n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t},Object.defineProperty(e.prototype,"rank",{get:function(){return this.shape.length},enumerable:!1,configurable:!0}),e.prototype.toTensor=function(){return Ct().makeTensor(this.values,this.shape,this.dtype)},e}(),Ct=null,Ft=null;var Rt=function(){function e(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=ue(e),this.strides=ge(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}return Object.defineProperty(e.prototype,"rank",{get:function(){return this.shape.length},enumerable:!1,configurable:!0}),e.prototype.buffer=function(){return u(this,void 0,void 0,(function(){var e;return p(this,(function(t){switch(t.label){case 0:return[4,this.data()];case 1:return e=t.sent(),[2,Ft.buffer(this.shape,this.dtype,e)]}}))}))},e.prototype.bufferSync=function(){return Ft.buffer(this.shape,this.dtype,this.dataSync())},e.prototype.array=function(){return u(this,void 0,void 0,(function(){var e;return p(this,(function(t){switch(t.label){case 0:return[4,this.data()];case 1:return e=t.sent(),[2,be(this.shape,e,"complex64"===this.dtype)]}}))}))},e.prototype.arraySync=function(){return be(this.shape,this.dataSync(),"complex64"===this.dtype)},e.prototype.data=function(){return u(this,void 0,void 0,(function(){var e,t;return p(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),e=Ct().read(this.dataId),"string"!==this.dtype?[3,2]:[4,e];case 1:t=n.sent();try{return[2,t.map((function(e){return wt(e)}))]}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}n.label=2;case 2:return[2,e]}}))}))},e.prototype.dataToGPU=function(e){return this.throwIfDisposed(),Ct().readToGPU(this.dataId,e)},e.prototype.dataSync=function(){this.throwIfDisposed();var e=Ct().readSync(this.dataId);if("string"===this.dtype)try{return e.map((function(e){return wt(e)}))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e},e.prototype.bytes=function(){return u(this,void 0,void 0,(function(){var e;return p(this,(function(t){switch(t.label){case 0:return this.throwIfDisposed(),[4,Ct().read(this.dataId)];case 1:return e=t.sent(),"string"===this.dtype?[2,e]:[2,new Uint8Array(e.buffer)]}}))}))},e.prototype.dispose=function(){this.isDisposed||(Ct().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(e.prototype,"isDisposed",{get:function(){return this.isDisposedInternal},enumerable:!1,configurable:!0}),e.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error("Tensor is disposed.")},e.prototype.print=function(e){return void 0===e&&(e=!1),Ft.print(this,e)},e.prototype.clone=function(){return this.throwIfDisposed(),Ft.clone(this)},e.prototype.toString=function(e){return void 0===e&&(e=!1),Et(this.dataSync(),this.shape,this.dtype,e)},e.prototype.cast=function(e){return this.throwIfDisposed(),Ft.cast(this,e)},e.prototype.variable=function(e,t,n){return void 0===e&&(e=!0),this.throwIfDisposed(),Ct().makeVariable(this,e,t,n)},e}();Object.defineProperty(Rt,Symbol.hasInstance,{value:function(e){return!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed}}),Me("Tensor",(function(){return Rt}));var zt,Vt,Lt,Pt,Bt,Kt=function(e){function t(t,n,r,a){var o=e.call(this,t.shape,t.dtype,t.dataId,a)||this;return o.trainable=n,o.name=r,o}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}(t,e),t.prototype.assign=function(e){if(e.dtype!==this.dtype)throw new Error("dtype of the new value (".concat(e.dtype,") and ")+"previous value (".concat(this.dtype,") must match"));if(!pe(e.shape,this.shape))throw new Error("shape of the new value (".concat(e.shape,") and ")+"previous value (".concat(this.shape,") must match"));Ct().disposeTensor(this),this.dataId=e.dataId,Ct().incRef(this,null)},t.prototype.dispose=function(){Ct().disposeVariable(this),this.isDisposedInternal=!0},t}(Rt);Object.defineProperty(Kt,Symbol.hasInstance,{value:function(e){return e instanceof Rt&&null!=e.assign&&e.assign instanceof Function}}),function(e){e.R0="R0",e.R1="R1",e.R2="R2",e.R3="R3",e.R4="R4",e.R5="R5",e.R6="R6"}(zt||(zt={})),function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(Vt||(Vt={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(Lt||(Lt={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(Pt||(Pt={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(Bt||(Bt={}));var jt={float32:Pt,int32:Vt,bool:Lt,complex64:Bt};function qt(e,t){if(e.dtype===t.dtype)return[e,t];var n=function(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error("Can not upcast ".concat(e," with ").concat(t))}return jt[e][t]}(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function Ut(e){var t=[];return Wt(e,t,new Set),t}function Wt(e,t,n){if(null!=e)if(e instanceof Rt)t.push(e);else if(r=e,Array.isArray(r)||"object"==typeof r){var r,a=e;for(var o in a){var s=a[o];n.has(s)||(n.add(s),Wt(s,t,n))}}}function Ht(e){return null!=e.kernelName}var Gt=function(){function e(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map((function(e){return e.name}))))}}}return e.prototype.dispose=function(){for(var e in this.registeredVariables)this.registeredVariables[e].dispose()},e}(),Zt=function(){function e(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Gt}return e.prototype.ready=function(){return u(this,void 0,void 0,(function(){var e,t,n;return p(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];e=this.getSortedBackends(),t=0,r.label=1;case 1:return t<e.length?(n=e[t],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return t++,[3,1];case 5:throw new Error("Could not initialize any backends, all backend initializations failed.")}}))}))},Object.defineProperty(e.prototype,"backend",{get:function(){if(null!=this.pendingBackendInit)throw new Error("Backend '".concat(this.backendName,"' has not yet been initialized. Make ")+"sure to await tf.ready() or await tf.setBackend() before calling other methods");if(null==this.backendInstance){var e=this.initializeBackendsAndReturnBest(),t=e.name;if(e.asyncInit)throw new Error("The highest priority backend '".concat(t,"' has not yet been ")+"initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");this.setBackend(t)}return this.backendInstance},enumerable:!1,configurable:!0}),e.prototype.backendNames=function(){return Object.keys(this.registryFactory)},e.prototype.findBackend=function(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;if(this.initializeBackend(e).asyncInit)return null}return this.registry[e]},e.prototype.findBackendFactory=function(e){return e in this.registryFactory?this.registryFactory[e].factory:null},e.prototype.registerBackend=function(e,t,n){return void 0===n&&(n=1),e in this.registryFactory?(Ke("".concat(e," backend was already registered. ")+"Reusing existing backend factory."),!1):(this.registryFactory[e]={factory:t,priority:n},!0)},e.prototype.setBackend=function(e){return u(this,void 0,void 0,(function(){var t,n,r;return p(this,(function(a){switch(a.label){case 0:if(null==this.registryFactory[e])throw new Error("Backend name '".concat(e,"' not found in registry"));return this.backendName=e,null!=this.registry[e]?[3,4]:(this.backendInstance=null,t=this.initializeBackend(e),n=t.success,t.asyncInit?[4,n]:[3,2]);case 1:return r=a.sent(),[3,3];case 2:r=n,a.label=3;case 3:if(!r)return[2,!1];a.label=4;case 4:return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new _t(this.backendInstance),[2,!0]}}))}))},e.prototype.setupRegisteredKernels=function(){var e=this;He(this.backendName).forEach((function(t){null!=t.setupFunc&&t.setupFunc(e.backendInstance)}))},e.prototype.disposeRegisteredKernels=function(e){var t=this;He(e).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(t.registry[e])}))},e.prototype.initializeBackend=function(e){var t=this,n=this.registryFactory[e];if(null==n)throw new Error("Cannot initialize backend ".concat(e,", no registration found."));try{var r=n.factory();if(!r||r instanceof re||"function"!=typeof r.then)return this.registry[e]=r,{success:!0,asyncInit:!1};var a=++this.pendingBackendInitId,o=r.then((function(n){return!(a<t.pendingBackendInitId)&&(t.registry[e]=n,t.pendingBackendInit=null,!0)})).catch((function(n){return a<t.pendingBackendInitId||(t.pendingBackendInit=null,Ke("Initialization of backend ".concat(e," failed")),Ke(n.stack||n.message)),!1}));return this.pendingBackendInit=o,{success:o,asyncInit:!0}}catch(t){return Ke("Initialization of backend ".concat(e," failed")),Ke(t.stack||t.message),{success:!1,asyncInit:!1}}},e.prototype.removeBackend=function(e){if(!(e in this.registryFactory))throw new Error("".concat(e," backend not found in registry"));this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},e.prototype.getSortedBackends=function(){var e=this;if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((function(t,n){return e.registryFactory[n].priority-e.registryFactory[t].priority}))},e.prototype.initializeBackendsAndReturnBest=function(){for(var e=this.getSortedBackends(),t=0;t<e.length;t++){var n=e[t],r=this.initializeBackend(n),a=r.success,o=r.asyncInit;if(o||a)return{name:n,asyncInit:o}}throw new Error("Could not initialize any backends, all backend initializations failed.")},e.prototype.moveData=function(e,t){var n=this.state.tensorInfo.get(t),r=n.backend,a=this.readSync(t),o=r.refCount(t);r.disposeData(t,!0),n.backend=e,e.move(t,a,n.shape,n.dtype,o),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},e.prototype.tidy=function(e,t){var n,r=this,a=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");a=e}return this.scopedRun((function(){return r.startScope(a)}),(function(){return r.endScope(n)}),(function(){return(n=t())instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n}))},e.prototype.scopedRun=function(e,t,n){e();try{var r=n();return t(),r}catch(e){throw t(),e}},e.prototype.nextTensorId=function(){return e.nextTensorId++},e.prototype.nextVariableId=function(){return e.nextVariableId++},e.prototype.clone=function(e){var t=Qt.runKernel(Re,{x:e}),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],(function(e){return{x:function(){var t={x:e},n={dtype:"float32"};return Qt.runKernel(Ce,t,n)}}}),[],{}),t},e.prototype.runKernel=function(e,t,n){if(null==this.backendName&&this.backend,!(null!=Ue(e,this.backendName)))throw new Error("Kernel '".concat(e,"' not registered for backend '").concat(this.backendName,"'"));return this.runKernelFunc({kernelName:e,inputs:t,attrs:n})},e.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool("IS_TEST")},e.prototype.checkKernelForMemLeak=function(e,t,n){var r=this.backend.numDataIds(),a=0;n.forEach((function(e){a+="complex64"===e.dtype?3:1}));var o=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],s=r-t-a-o;if(s>0)throw new Error("Backend '".concat(this.backendName,"' has an internal memory leak ")+"(".concat(s," data ids) after running '").concat(e,"'"))},e.prototype.runKernelFunc=function(e){var t,n,r,a=this,o=[],s=this.isTapeOn(),i=this.state.numBytes,u=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;var p=Ht(e)?e.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(Ht(e)){var c=e.kernelName,l=e.inputs,d=e.attrs;null==this.backendName&&this.backend;var h=Ue(c,this.backendName);oe(null!=h,(function(){return"Cannot find registered kernel '".concat(c,"' for backend '").concat(a.backendName,"'")})),n=function(){var e=a.backend.numDataIds();r=h.kernelFunc({inputs:l,attrs:d,backend:a.backend});var t=Array.isArray(r)?r:[r];a.shouldCheckForMemLeaks()&&a.checkKernelForMemLeak(c,e,t);var n=t.map((function(e){return null!=e.rank?e:a.makeTensorFromTensorInfo(e)}));if(s){var i=a.getTensorsForGradient(c,l,n);o=a.saveTensorsForBackwardMode(i)}return n}}else{var f=e.forwardFunc,m=function(e){s&&(o=e.map((function(e){return a.keep(a.clone(e))})))};n=function(){var e=a.backend.numDataIds();r=a.tidy((function(){return f(a.backend,m)}));var t=Array.isArray(r)?r:[r];return a.shouldCheckForMemLeaks()&&a.checkKernelForMemLeak(p,e,t),t}}var y,g=e.inputs,v=e.attrs,b=Ht(e)?null:e.backwardsFunc;return this.scopedRun((function(){return a.state.kernelDepth++}),(function(){return a.state.kernelDepth--}),(function(){a.ENV.getBool("DEBUG")||a.state.profiling?(y=a.profiler.profileKernel(p,g,(function(){return n()})),a.ENV.getBool("DEBUG")&&a.profiler.logKernelProfile(y),t=y.outputs):t=n()})),s&&this.addTapeNode(p,g,t,b,o,v),this.state.profiling&&this.state.activeProfile.kernels.push({name:p,bytesAdded:this.state.numBytes-i,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-u,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(g).map((function(e){return null!=g[e]?g[e].shape:null})),outputShapes:t.map((function(e){return e.shape})),kernelTimeMs:y.timeMs,extraInfo:y.extraInfo}),Array.isArray(r)?t:t[0]},e.prototype.saveTensorsForBackwardMode=function(e){var t=this,n=e.map((function(e){return t.keep(t.clone(e))}));return n},e.prototype.getTensorsForGradient=function(e,t,n){var r=We(e);if(null!=r){var a=r.inputsToSave||[],o=r.outputsToSave||[],s=void 0;r.saveAllInputs?(oe(Array.isArray(t),(function(){return"saveAllInputs is true, expected inputs to be an array."})),s=Object.keys(t).map((function(e){return t[e]}))):s=a.map((function(e){return t[e]}));var i=n.filter((function(e,t){return o[t]}));return s.concat(i)}return[]},e.prototype.makeTensor=function(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;var a=e;"string"===n&&fe(e[0])&&(a=e.map((function(e){return t=e,void 0===n&&(n="utf-8"),n=n||"utf-8",Ie().platform.encode(t,n);var t,n})));var o=r.write(a,t,n),s=new Rt(t,n,o,this.nextTensorId());if(this.trackTensor(s,r),"string"===n){var i=this.state.tensorInfo.get(o),u=function(e){if(null==e)return 0;var t=0;return e.forEach((function(e){return t+=e.length})),t}(a);this.state.numBytes+=u-i.bytes,i.bytes=u}return s},e.prototype.makeTensorFromDataId=function(e,t,n,r){var a={dataId:e,shape:t,dtype:n=n||"float32"};return this.makeTensorFromTensorInfo(a,r)},e.prototype.makeTensorFromTensorInfo=function(e,t){var n=e.dataId,r=e.shape,a=e.dtype,o=new Rt(r,a,n,this.nextTensorId());return this.trackTensor(o,t),o},e.prototype.makeVariable=function(e,t,n,r){void 0===t&&(t=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));var a=new Kt(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[a.name])throw new Error("Variable with name ".concat(a.name," was already registered"));return this.state.registeredVariables[a.name]=a,this.incRef(a,this.backend),a},e.prototype.trackTensor=function(e,t){this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++;var n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*he(e.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(e.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n})),e instanceof Kt||this.track(e)},e.prototype.incRef=function(e,t){this.trackTensor(e,t),this.backend.incRef(e.dataId)},e.prototype.removeDataId=function(e,t){this.state.tensorInfo.has(e)&&this.state.tensorInfo.get(e).backend===t&&(this.state.tensorInfo.delete(e),this.state.numDataBuffers--)},e.prototype.disposeTensor=function(e){if(this.state.tensorInfo.has(e.dataId)){var t=this.state.tensorInfo.get(e.dataId);if(this.state.numTensors--,"string"===e.dtype&&(this.state.numStringTensors--,this.state.numBytes-=t.bytes),"complex64"!==e.dtype&&"string"!==e.dtype){var n=e.size*he(e.dtype);this.state.numBytes-=n}t.backend.disposeData(e.dataId)&&this.removeDataId(e.dataId,t.backend)}},e.prototype.disposeVariables=function(){for(var e in this.state.registeredVariables){var t=this.state.registeredVariables[e];this.disposeVariable(t)}},e.prototype.disposeVariable=function(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]},e.prototype.memory=function(){var e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e},e.prototype.profile=function(e){return u(this,void 0,void 0,(function(){var t,n,r,a,o,s,i,u,h,f,m;return p(this,(function(p){switch(p.label){case 0:return this.state.profiling=!0,t=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],r=this.state.activeProfile,[4,e()];case 1:r.result=p.sent(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,d([],l(this.state.activeProfile.kernels.map((function(e){return e.totalBytesSnapshot}))),!1)),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n,p.label=2;case 2:p.trys.push([2,8,9,10]),a=c(this.state.activeProfile.kernels),o=a.next(),p.label=3;case 3:return o.done?[3,7]:(s=o.value,i=s,[4,s.kernelTimeMs]);case 4:return i.kernelTimeMs=p.sent(),u=s,[4,s.extraInfo];case 5:u.extraInfo=p.sent(),p.label=6;case 6:return o=a.next(),[3,3];case 7:return[3,10];case 8:return h=p.sent(),f={error:h},[3,10];case 9:try{o&&!o.done&&(m=a.return)&&m.call(a)}finally{if(f)throw f.error}return[7];case 10:return[2,this.state.activeProfile]}}))}))},e.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},e.prototype.addTapeNode=function(e,t,n,r,a,o){var s=this,i={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:a},u=We(e);null!=u&&(r=u.gradFunc),null!=r&&(i.gradient=function(e){return e=e.map((function(e,t){if(null==e){var r=n[t],a=Ne(r.size,r.dtype);return s.makeTensor(a,r.shape,r.dtype)}return e})),r(e.length>1?e:e[0],a,o)}),this.state.activeTape.push(i)},e.prototype.keep=function(e){return e.kept=!0,e},e.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},e.prototype.endTape=function(){this.state.gradientDepth--},e.prototype.startScope=function(e){var t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t},e.prototype.endScope=function(e){for(var t=this,n=Ut(e),r=new Set(n.map((function(e){return e.id}))),a=0;a<this.state.activeScope.track.length;a++){var o=this.state.activeScope.track[a];o.kept||r.has(o.id)||o.dispose()}var s=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(e){e.kept||e.scopeId!==s.id||t.track(e)}))},e.prototype.gradients=function(e,t,n,r){var a=this;if(void 0===r&&(r=!1),oe(t.length>0,(function(){return"gradients() received an empty list of xs."})),null!=n&&"float32"!==n.dtype)throw new Error("dy must have 'float32' dtype, but has '".concat(n.dtype,"'"));var o=this.scopedRun((function(){return a.startTape()}),(function(){return a.endTape()}),(function(){return a.tidy("forward",e)}));oe(o instanceof Rt,(function(){return"The result y returned by f() must be a tensor."}));var s=function(e,t,n){for(var r={},a={},o=0;o<t.length;o++)r[t[o].id]=!0;for(o=0;o<e.length;o++){var s=(f=e[o]).inputs;for(var i in s){for(var u=s[i],p=!1,c=0;c<t.length;c++)if(r[u.id]){f.outputs.forEach((function(e){return r[e.id]=!0})),p=!0,a[f.id]=!0;break}if(p)break}}var l={};l[n.id]=!0;var d={};for(o=e.length-1;o>=0;o--)for(s=(f=e[o]).inputs,c=0;c<f.outputs.length;c++)if(l[f.outputs[c].id]){for(var i in s)l[s[i].id]=!0,d[f.id]=!0;break}var h=[];for(o=0;o<e.length;o++){var f;if(a[(f=e[o]).id]&&d[f.id]){var m={};for(var i in f.inputs){var y=f.inputs[i];r[y.id]&&(m[i]=y)}var g=Object.assign({},f);g.inputs=m,g.outputs=f.outputs,h.push(g)}}return h}(this.state.activeTape,t,o);if(!r&&0===s.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(function(){var e,r,i={};i[o.id]=null==n?(e=o.shape,r=xe(ue(e),"float32"),Qt.makeTensor(r,e,"float32")):n,function(e,t,n,r){for(var a=function(a){var o=t[a],s=[];if(o.outputs.forEach((function(t){var n=e[t.id];null!=n?s.push(n):s.push(null)})),null==o.gradient)throw new Error("Cannot compute gradient: gradient function not found "+"for ".concat(o.kernelName,"."));var i=o.gradient(s),u=function(t){if(!(t in i))throw new Error("Cannot backprop through input ".concat(t,". ")+"Available gradients found: ".concat(Object.keys(i),"."));var a=n((function(){return i[t]()}));if("float32"!==a.dtype)throw new Error("Error in gradient for op ".concat(o.kernelName,". The gradient of input ")+"".concat(t," must have 'float32' dtype, but has '").concat(a.dtype,"'"));var s=o.inputs[t];if(!pe(a.shape,s.shape))throw new Error("Error in gradient for op ".concat(o.kernelName,". The gradient of input ")+"'".concat(t,"' has shape '").concat(a.shape,"', which does not match ")+"the shape of the input '".concat(s.shape,"'"));if(null==e[s.id])e[s.id]=a;else{var u=e[s.id];e[s.id]=r(u,a),u.dispose()}};for(var p in o.inputs)u(p)},o=t.length-1;o>=0;o--)a(o)}(i,s,(function(e){return a.tidy(e)}),Yt);var u=t.map((function(e){return i[e.id]}));return 0===a.state.gradientDepth&&(a.state.activeTape.forEach((function(e){var t,n;try{for(var r=c(e.saved),a=r.next();!a.done;a=r.next()){a.value.dispose()}}catch(e){t={error:e}}finally{try{a&&!a.done&&(n=r.return)&&n.call(r)}finally{if(t)throw t.error}}})),a.state.activeTape=null),{value:o,grads:u}}))},e.prototype.customGrad=function(e){var t=this;return oe(ye(e),(function(){return"The f passed in customGrad(f) must be a function."})),function(){for(var n,r=[],a=0;a<arguments.length;a++)r[a]=arguments[a];oe(r.every((function(e){return e instanceof Rt})),(function(){return"The args passed in customGrad(f)(x1, x2,...) must all be tensors"}));var o={};r.forEach((function(e,t){o[t]=e}));var s=function(t,a){return oe((n=e.apply(void 0,d([],l(d(d([],l(r),!1),[a],!1)),!1))).value instanceof Rt,(function(){return"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"})),oe(ye(n.gradFunc),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."})),n.value},i=function(e,t){var a=n.gradFunc(e,t),o=Array.isArray(a)?a:[a];oe(o.length===r.length,(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."})),oe(o.every((function(e){return e instanceof Rt})),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."}));var s={};return o.forEach((function(e,t){s[t]=function(){return e}})),s};return t.runKernelFunc({forwardFunc:s,backwardsFunc:i,inputs:o})}},e.prototype.readSync=function(e){return this.state.tensorInfo.get(e).backend.readSync(e)},e.prototype.read=function(e){return this.state.tensorInfo.get(e).backend.read(e)},e.prototype.readToGPU=function(e,t){return this.state.tensorInfo.get(e).backend.readToGPU(e,t)},e.prototype.time=function(e){return u(this,void 0,void 0,(function(){var t,n;return p(this,(function(r){switch(r.label){case 0:return t=Nt(),[4,this.backend.time(e)];case 1:return(n=r.sent()).wallMs=Nt()-t,[2,n]}}))}))},e.prototype.track=function(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e},Object.defineProperty(e.prototype,"registeredVariables",{get:function(){return this.state.registeredVariables},enumerable:!1,configurable:!0}),e.prototype.reset=function(){for(var e in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Gt,this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},e}();Zt.nextTensorId=0,Zt.nextVariableId=0;var Qt=function(){var e=Ae();if(null==e._tfengine){var t=new _e(e);e._tfengine=new Zt(t)}return function(e){De=e}(e._tfengine.ENV),Ct=function(){return e._tfengine},e._tfengine}();function Yt(e,t){var n={a:e,b:t};return Qt.runKernel("Add",n)}function Xt(e,t){var n=e;if(kt(e))return"string"===t?[]:[e.length];if("object"==typeof e){if("texture"in e){var r=e.channels||"RGBA";return[e.height,e.width*r.length]}if("buffer"in e&&!(e.buffer instanceof ArrayBuffer))return[e.buffer.size/(null==t?4:he(t))]}if(!Array.isArray(e))return[];for(var a=[];Array.isArray(n)||kt(n)&&"string"!==t;)a.push(n.length),n=n[0];return Array.isArray(e)&&Ie().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&Jt(e,a,[]),a}function Jt(e,t,n){if(n=n||[],Array.isArray(e)||kt(e)){oe(t.length>0,(function(){return"Element arr[".concat(n.join("]["),"] should be a primitive, ")+"but is an array of ".concat(e.length," elements")})),oe(e.length===t[0],(function(){return"Element arr[".concat(n.join("]["),"] should have ").concat(t[0]," ")+"elements, but has ".concat(e.length," elements")}));for(var r=t.slice(1),a=0;a<e.length;++a)Jt(e[a],r,n.concat(a))}else oe(0===t.length,(function(){return"Element arr[".concat(n.join("]["),"] is a primitive, ")+"but should be an array/TypedArray of ".concat(t[0]," elements")}))}function $t(e,t,n,r){if("string_or_numeric"!==e){if(null==e)throw new Error("Expected dtype cannot be null.");if("numeric"!==e&&e!==t||"numeric"===e&&"string"===t)throw new Error("Argument '".concat(n,"' passed to '").concat(r,"' must ")+"be ".concat(e," tensor, but got ").concat(t," tensor"))}}function en(e,t,n,r){if(void 0===r&&(r="numeric"),e instanceof Rt)return $t(r,e.dtype,t,n),e;var a=me(e);if("string"!==a&&["bool","int32","float32"].indexOf(r)>=0&&(a=r),$t(r,a,t,n),null==e||!kt(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){var o=null==e?"null":e.constructor.name;throw new Error("Argument '".concat(t,"' passed to '").concat(n,"' must be a ")+"Tensor or TensorLike, but got '".concat(o,"'"))}var s=Xt(e,a);kt(e)||Array.isArray(e)||(e=[e]);var i="string"!==a?xt(e,a):Tt(e,[],!0);return Qt.makeTensor(i,s,a)}function tn(e,t,n,r){if(void 0===r&&(r="numeric"),!Array.isArray(e))throw new Error("Argument ".concat(t," passed to ").concat(n," must be a ")+"`Tensor[]` or `TensorLike[]`");return e.map((function(e,a){return en(e,"".concat(t,"[").concat(a,"]"),n,r)}))}var nn="__op";function rn(e){var t=Object.keys(e);if(1!==t.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+"".concat(t.length," keys."));var n=t[0],r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+=nn;var a=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];Qt.startScope(n);try{var a=r.apply(void 0,d([],l(e),!1));return ke(a)&&console.error("Cannot return a Promise inside of tidy."),Qt.endScope(a),a}catch(e){throw Qt.endScope(null),e}};return Object.defineProperty(a,"name",{value:n,configurable:!0}),a}var an=rn({abs_:function(e){var t=en(e,"x","abs");if("complex64"===t.dtype){var n={x:t};return Qt.runKernel("ComplexAbs",n)}return n={x:t},Qt.runKernel("Abs",n)}});var on=rn({acos_:function(e){var t={x:en(e,"x","acos")};return Qt.runKernel("Acos",t)}});var sn=rn({acosh_:function(e){var t={x:en(e,"x","acosh")};return Qt.runKernel("Acosh",t)}});var un=rn({add_:function(e,t){var n,r=en(e,"a","add"),a=en(t,"b","add"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("Add",o)}});var pn=rn({addN_:function(e){oe(Array.isArray(e),(function(){return"The argument passed to tf.addN() must be a list of tensors"})),oe(e.length>=1,(function(){return"Must pass at least one tensor to tf.addN(), but got "+"".concat(e.length)}));var t=e.map((function(e,t){return en(e,"tensors".concat(t),"addN")})),n=t[0];t.forEach((function(e){if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),t.forEach((function(e){if(!pe(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));var r=t;return Qt.runKernel("AddN",r)}});var cn=rn({all_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:en(e,"x","all","bool")},a={axis:t,keepDims:n};return Qt.runKernel("All",r,a)}});var ln=rn({any_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:en(e,"x","any","bool")},a={axis:t,keepDims:n};return Qt.runKernel("Any",r,a)}});var dn=rn({argMax_:function(e,t){void 0===t&&(t=0);var n={x:en(e,"x","argMax")},r={axis:t};return Qt.runKernel("ArgMax",n,r)}});var hn=rn({argMin_:function(e,t){void 0===t&&(t=0);var n={x:en(e,"x","argMin")},r={axis:t};return Qt.runKernel("ArgMin",n,r)}});var fn=rn({asin_:function(e){var t={x:en(e,"x","asin")};return Qt.runKernel("Asin",t)}});var mn=rn({asinh_:function(e){var t={x:en(e,"x","asinh")};return Qt.runKernel("Asinh",t)}});var yn=rn({atan_:function(e){var t={x:en(e,"x","atan")};return Qt.runKernel("Atan",t)}});var gn=rn({atan2_:function(e,t){var n,r=en(e,"a","atan2"),a=en(t,"b","atan2"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("Atan2",o)}});var vn=rn({atanh_:function(e){var t={x:en(e,"x","atanh")};return Qt.runKernel("Atanh",t)}});var bn=rn({cast_:function(e,t){var n=en(e,"x","cast");if(!function(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}(t))throw new Error("Failed to cast to unknown dtype ".concat(t));if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");var r={x:n},a={dtype:t};return Qt.runKernel(Ce,r,a)}});function xn(e,t,n,r,a,o,s,i){var u,p;void 0===s&&(s=!1),void 0===i&&(i="channelsLast");var c=l([-1,-1,-1,-1],4),d=c[0],h=c[1],f=c[2],m=c[3];if("channelsLast"===i)d=(u=l(e,4))[0],h=u[1],f=u[2],m=u[3];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat ".concat(i));d=(p=l(e,4))[0],m=p[1],h=p[2],f=p[3]}var y,g=l(t,4),v=g[0],b=g[1],x=g[3],N=l(Nn(n),2),w=N[0],k=N[1],T=l(Nn(r),2),_=T[0],S=T[1],E=wn(v,_),I=wn(b,S),O=function(e,t,n,r,a,o,s,i,u){var p,c,l;if("number"==typeof e){p={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};var d=function(e,t,n,r,a){null==r&&(r=function(e,t,n,r){void 0===r&&(r=1);var a=wn(t,r);return Math.floor((e[0]*(n-1)-n+a)/2)}(e,t,n));var o=e[0],s=e[1],i=kn((o-t+2*r)/n+1,a),u=kn((s-t+2*r)/n+1,a);return[i,u]}([t,n],o,r,e,i);c=d[0],l=d[1]}else if("same"===e){c=Math.ceil(t/r),l=Math.ceil(n/a);var h=Math.max(0,(c-1)*r+o-t),f=Math.max(0,(l-1)*a+s-n);p={top:m=Math.floor(h/2),bottom:y=h-m,left:g=Math.floor(f/2),right:v=f-g,type:"SAME"}}else if("valid"===e)p={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((t-o+1)/r),l=Math.ceil((n-s+1)/a);else{if("object"!=typeof e)throw Error("Unknown padding parameter: ".concat(e));var m,y,g,v;p={top:m="channelsLast"===u?e[1][0]:e[2][0],bottom:y="channelsLast"===u?e[1][1]:e[2][1],left:g="channelsLast"===u?e[2][0]:e[3][0],right:v="channelsLast"===u?e[2][1]:e[3][1],type:0===m&&0===y&&0===g&&0===v?"VALID":"EXPLICIT"},c=kn((t-o+m+y)/r+1,i),l=kn((n-s+g+v)/a+1,i)}return{padInfo:p,outHeight:c,outWidth:l}}(a,h,f,w,k,E,I,o,i),D=O.padInfo,A=O.outHeight,M=O.outWidth,C=s?x*m:x;return"channelsFirst"===i?y=[d,C,A,M]:"channelsLast"===i&&(y=[d,A,M,C]),{batchSize:d,dataFormat:i,inHeight:h,inWidth:f,inChannels:m,outHeight:A,outWidth:M,outChannels:C,padInfo:D,strideHeight:w,strideWidth:k,filterHeight:v,filterWidth:b,effectiveFilterHeight:E,effectiveFilterWidth:I,dilationHeight:_,dilationWidth:S,inShape:e,outShape:y,filterShape:t}}function Nn(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function wn(e,t){return t<=1?e:e+(e-1)*(t-1)}function kn(e,t){if(!t)return Math.trunc(e);switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error("Unknown roundingMode ".concat(t))}}function Tn(e){var t=l(Nn(e),3),n=t[0],r=t[1],a=t[2];return 1===n&&1===r&&1===a}function _n(e,t){return Tn(e)||Tn(t)}function Sn(e){return Nn(e).every((function(e){return e>0}))}function En(e,t,n){if(null!=n){if("string"==typeof t)throw Error("Error in ".concat(e,": pad must be an integer when using ")+"dimRoundingMode ".concat(n," but got pad ").concat(t,"."));if("number"==typeof t)oe(ce(t),(function(){return"Error in ".concat(e,": pad must be an integer when using ")+"dimRoundingMode ".concat(n," but got pad ").concat(t,".")}));else{if("object"!=typeof t)throw Error("Error in ".concat(e,": Unknown padding parameter: ").concat(t));t.forEach((function(t){t.forEach((function(t){oe(ce(t),(function(){return"Error in ".concat(e,": pad must be an integer when using ")+"dimRoundingMode ".concat(n," but got pad ").concat(t,".")}))}))}))}}}var In=rn({reshape_:function(e,t){var n={x:en(e,"x","reshape","string_or_numeric")},r={shape:t};return Qt.runKernel("Reshape",n,r)}});var On=rn({avgPool_:function(e,t,n,r,a){var o=en(e,"x","avgPool","float32");oe(_n(n,1),(function(){return"Error in avgPool: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(1,"'")}));var s=o,i=!1;3===o.rank&&(i=!0,s=In(o,[1,o.shape[0],o.shape[1],o.shape[2]])),oe(4===s.rank,(function(){return"Error in avgPool: x must be rank 4 but got rank ".concat(s.rank,".")})),En("avgPool",r,a);var u={x:s},p={filterSize:t,strides:n,pad:r,dimRoundingMode:a},c=Qt.runKernel("AvgPool",u,p);return c=bn(c,o.dtype),i?In(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var Dn=rn({avgPool3d_:function(e,t,n,r,a,o){void 0===o&&(o="NDHWC");var s=en(e,"x","avgPool3d","float32"),i=s,u=!1;4===s.rank&&(u=!0,i=In(s,[1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]])),oe(5===i.rank,(function(){return"Error in avgPool3d: x must be rank 5 but got rank ".concat(i.rank,".")})),oe("NDHWC"===o,(function(){return"Error in avgPool3d: Only NDHWC is currently supported, "+"but got dataFormat of ".concat(o)})),oe("number"==typeof n&&n>0||Array.isArray(n)&&n[0]>0&&n[1]>0&&n[2]>0,(function(){return"Error in avgPool3d: Stride must be > 0, but got '".concat(n,"'")})),En("avgPool3d",r,a);var p={x:i},c={filterSize:t,strides:n,pad:r,dimRoundingMode:a,dataFormat:o},l=Qt.runKernel("AvgPool3D",p,c);return l=bn(l,i.dtype),u?In(l,[l.shape[1],l.shape[2],l.shape[3],l.shape[4]]):l}});var An=rn({clone_:function(e){var t={x:en(e,"x","clone","string_or_numeric")};return Qt.runKernel(Re,t)}});var Mn=rn({concat_:function(e,t){void 0===t&&(t=0),oe(e.length>=1,(function(){return"Pass at least one tensor to concat"}));var n=tn(e,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach((function(e){if("complex64"!==e.dtype)throw new Error("Cannot concatenate complex64 tensors with a tensor\n          with dtype ".concat(e.dtype,". "))})),1===n.length)return An(n[0]);var r=n,a={axis:t};return Qt.runKernel("Concat",r,a)}});var Cn=rn({matMul_:function(e,t,n,r){var a;void 0===n&&(n=!1),void 0===r&&(r=!1);var o=en(e,"a","matMul"),s=en(t,"b","matMul"),i={a:o=(a=l(qt(o,s),2))[0],b:s=a[1]},u={transposeA:n,transposeB:r};return Qt.runKernel("BatchMatMul",i,u)}});var Fn=rn({mul_:function(e,t){var n,r=en(e,"a","mul"),a=en(t,"b","mul"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("Multiply",o)}});var Rn=rn({sigmoid_:function(e){var t={x:en(e,"x","sigmoid","float32")};return Qt.runKernel("Sigmoid",t)}});var zn=rn({slice_:function(e,t,n){var r=en(e,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");var a={x:r},o={begin:t,size:n};return Qt.runKernel("Slice",a,o)}});var Vn=rn({tanh_:function(e){var t={x:en(e,"x","tanh","float32")};return Qt.runKernel("Tanh",t)}});var Ln=rn({basicLSTMCell_:function(e,t,n,r,a,o){var s=en(e,"forgetBias","basicLSTMCell"),i=en(t,"lstmKernel","basicLSTMCell"),u=en(n,"lstmBias","basicLSTMCell"),p=en(r,"data","basicLSTMCell"),c=en(a,"c","basicLSTMCell"),l=en(o,"h","basicLSTMCell"),d=Mn([p,l],1),h=Cn(d,i),f=un(h,u),m=f.shape[0],y=f.shape[1]/4,g=[m,y],v=zn(f,[0,0],g),b=zn(f,[0,y],g),x=zn(f,[0,2*y],g),N=zn(f,[0,3*y],g),w=un(Fn(Rn(v),Vn(b)),Fn(c,Rn(un(s,x))));return[w,Fn(Vn(w),Rn(N))]}});var Pn=rn({batchToSpaceND_:function(e,t,n){var r=en(e,"x","batchToSpaceND"),a=t.reduce((function(e,t){return e*t}));oe(r.rank>=1+t.length,(function(){return"input rank is ".concat(r.rank," but should be > than blockShape.length ").concat(t.length)})),oe(n.length===t.length,(function(){return"crops.length is ".concat(n.length," but should be equal to blockShape.length  ").concat(t.length)})),oe(r.shape[0]%a==0,(function(){return"input tensor batch is ".concat(r.shape[0]," but is not divisible by the product of ")+"the elements of blockShape ".concat(t.join(" * ")," === ").concat(a)}));var o={x:r},s={blockShape:t,crops:n};return Qt.runKernel("BatchToSpaceND",o,s)}});var Bn=rn({batchNorm_:function(e,t,n,r,a,o){null==o&&(o=.001);var s,i,u=en(e,"x","batchNorm"),p=en(t,"mean","batchNorm"),c=en(n,"variance","batchNorm");null!=a&&(s=en(a,"scale","batchNorm")),null!=r&&(i=en(r,"offset","batchNorm")),oe(p.rank===c.rank,(function(){return"Batch normalization gradient requires mean and variance to have equal ranks."})),oe(null==i||p.rank===i.rank,(function(){return"Batch normalization gradient requires mean and offset to have equal ranks."})),oe(null==s||p.rank===s.rank,(function(){return"Batch normalization gradient requires mean and scale to have equal ranks."}));var l=function(e){return 0===e.rank||1===e.rank?In(e,[1,1,1,e.size]):2===e.rank?In(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?In(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e}(u),d={x:l,scale:s,offset:i,mean:p,variance:c},h={varianceEpsilon:o},f=Qt.runKernel("FusedBatchNorm",d,h);return In(f,u.shape)}});var Kn=rn({batchNorm2d_:function(e,t,n,r,a,o){var s,i,u=en(e,"x","batchNorm"),p=en(t,"mean","batchNorm"),c=en(n,"variance","batchNorm");return null!=a&&(s=en(a,"scale","batchNorm")),null!=r&&(i=en(r,"offset","batchNorm")),oe(2===u.rank,(function(){return"Error in batchNorm2D: x must be rank 2 but got rank "+"".concat(u.rank,".")})),oe(2===p.rank||1===p.rank,(function(){return"Error in batchNorm2D: mean must be rank 2 or rank 1 but "+"got rank ".concat(p.rank,".")})),oe(2===c.rank||1===c.rank,(function(){return"Error in batchNorm2D: variance must be rank 2 or rank 1 "+"but got rank ".concat(c.rank,".")})),null!=s&&oe(2===s.rank||1===s.rank,(function(){return"Error in batchNorm2D: scale must be rank 2 or rank 1 "+"but got rank ".concat(s.rank,".")})),null!=i&&oe(2===i.rank||1===i.rank,(function(){return"Error in batchNorm2D: offset must be rank 2 or rank 1 "+"but got rank ".concat(i.rank,".")})),Bn(u,p,c,i,s,o)}});var jn=rn({batchNorm3d_:function(e,t,n,r,a,o){var s,i,u=en(e,"x","batchNorm"),p=en(t,"mean","batchNorm"),c=en(n,"variance","batchNorm");return null!=a&&(s=en(a,"scale","batchNorm")),null!=r&&(i=en(r,"offset","batchNorm")),oe(3===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+"".concat(u.rank,".")})),oe(3===p.rank||1===p.rank,(function(){return"Error in batchNorm3D: mean must be rank 3 or rank 1 but "+"got rank ".concat(p.rank,".")})),oe(3===c.rank||1===c.rank,(function(){return"Error in batchNorm3D: variance must be rank 3 or rank 1 "+"but got rank ".concat(c.rank,".")})),null!=s&&oe(3===s.rank||1===s.rank,(function(){return"Error in batchNorm3D: scale must be rank 3 or rank 1 "+"but got rank ".concat(s.rank,".")})),null!=i&&oe(3===i.rank||1===i.rank,(function(){return"Error in batchNorm3D: offset must be rank 3 or rank 1 "+"but got rank ".concat(i.rank,".")})),Bn(u,p,c,i,s,o)}});var qn=rn({batchNorm4d_:function(e,t,n,r,a,o){var s,i,u=en(e,"x","batchNorm"),p=en(t,"mean","batchNorm"),c=en(n,"variance","batchNorm");return null!=a&&(s=en(a,"scale","batchNorm")),null!=r&&(i=en(r,"offset","batchNorm")),oe(4===u.rank,(function(){return"Error in batchNorm4D: x must be rank 4 but got rank "+"".concat(u.rank,".")})),oe(4===p.rank||1===p.rank,(function(){return"Error in batchNorm4D: mean must be rank 4 or rank 1 but "+"got rank ".concat(p.rank,".")})),oe(4===c.rank||1===c.rank,(function(){return"Error in batchNorm4D: variance must be rank 4 or rank 1 "+"but got rank ".concat(c.rank,".")})),null!=s&&oe(4===s.rank||1===s.rank,(function(){return"Error in batchNorm4D: scale must be rank 4 or rank 1 "+"but got rank ".concat(s.rank,".")})),null!=i&&oe(4===i.rank||1===i.rank,(function(){return"Error in batchNorm4D: offset must be rank 4 or rank 1 "+"but got rank ".concat(i.rank,".")})),Bn(u,p,c,i,s,o)}});var Un=rn({bincount_:function(e,t,n){var r=en(e,"x","bincount"),a=en(t,"weights","bincount");oe("int32"===r.dtype,(function(){return"Error in bincount: input "+"dtype must be int32, but got ".concat(r.dtype)})),oe(n>=0,(function(){return"size must be non-negative, but got ".concat(n,".")})),oe(a.size===r.size||0===a.size,(function(){return"Error in bincount: weights must have the same size as input or"+"0-length, but got input shape: ".concat(r.shape,", weights shape: ")+"".concat(a.shape,".")}));var o={x:r,weights:a},s={size:n};return Qt.runKernel("Bincount",o,s)}});var Wn=rn({broadcastArgs_:function(e,t){var n=en(e,"s0","broadcastArgs","int32"),r=en(t,"s1","broadcastArgs","int32");if(1!==n.rank)throw new Error("broadcastArgs(): first input must be a vector (rank=1). "+"Has rank ".concat(n.rank));if(1!==r.rank)throw new Error("broadcastArgs(): second input must be a vector (rank=1). "+"Has rank ".concat(r.rank));var a={s0:n,s1:r};return Qt.runKernel("BroadcastArgs",a)}});var Hn=rn({broadcastTo_:function(e,t){var n=en(e,"broadcastTo","x"),r=n.shape;if(we(t),t.length<n.rank)throw new Error("broadcastTo(): shape.length=".concat(t.length," < input.rank=").concat(n.rank,"."));if(t.length>n.rank){for(var a=n.shape.slice();a.length<t.length;)a.unshift(1);n=In(n,a)}for(var o=n.shape,s=Array.from(t),i=t.length-1;i>=0;i--)if(o[i]===t[i])s[i]=1;else if(1!==n.shape[i])throw new Error("broadcastTo(): [".concat(r,"] cannot be broadcast to [").concat(t,"]."));var u=s.map((function(e,t){return e>1?t:-1})).filter((function(e){return e>=0}));if(0===u.length)return An(n);var p={x:n},c={reps:s};return Qt.runKernel(ze,p,c)}});function Gn(e,t,n){return void 0===t&&(t="float32"),t=t||"float32",we(e),new Mt(e,t,n)}var Zn=rn({ceil_:function(e){var t={x:en(e,"x","ceil","float32")};return Qt.runKernel("Ceil",t)}});function Qn(e,t,n){we(e);var r={shape:e,value:t,dtype:n};return Qt.runKernel("Fill",{},r)}var Yn=rn({clipByValue_:function(e,t,n){var r=en(e,"x","clipByValue");if(oe(t<=n,(function(){return"Error in clip: min (".concat(t,") must be ")+"less than or equal to max (".concat(n,").")})),t===n)return Qn(r.shape,t,r.dtype);var a={x:r},o={clipValueMin:t,clipValueMax:n};return Qt.runKernel("ClipByValue",a,o)}});var Xn=rn({complex_:function(e,t){var n=en(e,"real","complex"),r=en(t,"imag","complex");se(n.shape,r.shape,"real and imag shapes, ".concat(n.shape," and ").concat(r.shape,", ")+"must match in call to tf.complex().");var a={real:n,imag:r};return Qt.runKernel("Complex",a)}});var Jn=rn({concat1d_:function(e){return Mn(e,0)}});var $n=rn({concat2d_:function(e,t){return Mn(e,t)}});var er=rn({concat3d_:function(e,t){return Mn(e,t)}});var tr=rn({concat4d_:function(e,t){return Mn(e,t)}});var nr=rn({conv2d_:function(e,t,n,r,a,o,s){void 0===a&&(a="NHWC"),void 0===o&&(o=[1,1]);var i=en(e,"x","conv2d","float32"),u=en(t,"filter","conv2d","float32"),p=i,c=!1;3===i.rank&&(c=!0,p=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),oe(4===p.rank,(function(){return"Error in conv2d: input must be rank 4, but got rank ".concat(p.rank,".")})),oe(4===u.rank,(function(){return"Error in conv2d: filter must be rank 4, but got rank "+"".concat(u.rank,".")})),En("conv2d",r,s);var l="NHWC"===a?p.shape[3]:p.shape[1];oe(l===u.shape[2],(function(){return"Error in conv2d: depth of input (".concat(l,") must match ")+"input depth for filter ".concat(u.shape[2],".")})),oe(_n(n,o),(function(){return"Error in conv2D: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(o,"'")})),oe(Sn(o),(function(){return"Error in conv2D: Dilated rates should be larger than 0."})),oe(Sn(n),(function(){return"Error in conv2D: Strides should be larger than 0."}));var d={x:p,filter:u},h={strides:n,pad:r,dataFormat:a,dilations:o,dimRoundingMode:s},f=Qt.runKernel("Conv2D",d,h);return c?In(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});var rr=rn({conv1d_:function(e,t,n,r,a,o,s){void 0===a&&(a="NWC"),void 0===o&&(o=1);var i=en(e,"x","conv1d"),u=en(t,"filter","conv1d"),p=i,c=!1;2===i.rank&&(c=!0,p=In(i,[1,i.shape[0],i.shape[1]])),oe(3===p.rank,(function(){return"Error in conv1d: input must be rank 3, but got rank ".concat(p.rank,".")})),oe(3===u.rank,(function(){return"Error in conv1d: filter must be rank 3, but got rank "+"".concat(u.rank,".")})),En("conv1d",r,s),oe(p.shape[2]===u.shape[1],(function(){return"Error in conv1d: depth of input (".concat(p.shape[2],") must match ")+"input depth for filter ".concat(u.shape[1],".")})),oe(_n(n,o),(function(){return"Error in conv1D: Either stride or dilation must be 1. "+"Got stride ".concat(n," and dilation '").concat(o,"'")})),oe(Sn(o),(function(){return"Error in conv1D: Dilated rates should be larger than 0."})),oe(Sn(n),(function(){return"Error in conv1D: Stride should be larger than 0."})),oe("NWC"===a,(function(){return"Error in conv1d: got dataFormat of ".concat(a," but only NWC is currently supported.")}));var l=In(u,[1,u.shape[0],u.shape[1],u.shape[2]]),d=In(p,[p.shape[0],1,p.shape[1],p.shape[2]]),h=nr(d,l,[1,n],r,"NHWC",[1,o],s);return In(h,c?[h.shape[2],h.shape[3]]:[h.shape[0],h.shape[2],h.shape[3]])}});var ar=rn({conv2DBackpropInput_:function(e,t,n,r,a,o,s){void 0===o&&(o="NHWC"),oe(e.length===t.rank,(function(){return"Length of inShape "+"(".concat(e.length,") and rank of dy (").concat(t.rank,") must match")}));var i=e,u=t,p=!1;3===t.rank&&(p=!0,u=In(t,[1,t.shape[0],t.shape[1],t.shape[2]]),i=[1,e[0],e[1],e[2]]),oe(4===i.length,(function(){return"Error in conv2dDerInput: inShape must be length 4, but got length "+"".concat(i.length,".")})),oe(4===u.rank,(function(){return"Error in conv2dDerInput: dy must be rank 4, but got "+"rank ".concat(u.rank)})),oe(4===n.rank,(function(){return"Error in conv2dDerInput: filter must be rank 4, but got "+"rank ".concat(n.rank)}));var c="NHWC"===o?i[3]:i[1],l="NHWC"===o?u.shape[3]:u.shape[1];oe(c===n.shape[2],(function(){return"Error in conv2dDerInput: depth of input (".concat(c,") must ")+"match input depth for filter ".concat(n.shape[2],".")})),oe(l===n.shape[3],(function(){return"Error in conv2dDerInput: depth of output (".concat(l,") must ")+"match output depth for filter ".concat(n.shape[3],".")})),En("conv2dDerInput",a,s);var d={dy:u,filter:n},h={strides:r,pad:a,dataFormat:o,dimRoundingMode:s,inputShape:i},f=Qt.runKernel("Conv2DBackpropInput",d,h);return p?In(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});var or=rn({conv2dTranspose_:function(e,t,n,r,a,o){var s=en(e,"x","conv2dTranspose"),i=en(t,"filter","conv2dTranspose");return ar(n,s,i,r,a,"NHWC",o)}});var sr=rn({conv3d_:function(e,t,n,r,a,o){void 0===a&&(a="NDHWC"),void 0===o&&(o=[1,1,1]);var s=en(e,"x","conv3d"),i=en(t,"filter","conv3d"),u=s,p=!1;4===s.rank&&(p=!0,u=In(s,[1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]])),oe(5===u.rank,(function(){return"Error in conv3d: input must be rank 5, but got rank ".concat(u.rank,".")})),oe(5===i.rank,(function(){return"Error in conv3d: filter must be rank 5, but got rank "+"".concat(i.rank,".")})),oe(u.shape[4]===i.shape[3],(function(){return"Error in conv3d: depth of input (".concat(u.shape[4],") must match ")+"input depth for filter ".concat(i.shape[3],".")})),oe(_n(n,o),(function(){return"Error in conv3D: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(o,"'")})),oe("NDHWC"===a,(function(){return"Error in conv3d: got dataFormat of ".concat(a," but only NDHWC is currently supported.")})),oe(Sn(o),(function(){return"Error in conv3D: Dilated rates should be larger than 0."})),oe(Sn(n),(function(){return"Error in conv3D: Strides should be larger than 0."}));var c={x:u,filter:i},l={strides:n,pad:r,dataFormat:a,dilations:o},d=Qt.runKernel("Conv3D",c,l);return p?In(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});var ir=rn({conv3DBackpropInput_:function(e,t,n,r,a){oe(e.length===t.rank,(function(){return"Length of inShape "+"(".concat(e.length,") and rank of dy (").concat(t.rank,") must match")}));var o=e,s=t,i=!1;4===t.rank&&(i=!0,s=In(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),o=[1,e[0],e[1],e[2],e[3]]);var u=o[4],p=s.shape[4];oe(5===o.length,(function(){return"Error in conv3dDerInput: inShape must be length 5, but got length "+"".concat(o.length,".")})),oe(5===s.rank,(function(){return"Error in conv3dDerInput: dy must be rank 5, but got "+"rank ".concat(s.rank)})),oe(5===n.rank,(function(){return"Error in conv3dDerInput: filter must be rank 5, but got "+"rank ".concat(n.rank)})),oe(u===n.shape[3],(function(){return"Error in conv3dDerInput: depth of input (".concat(u,") must ")+"match input depth for filter ".concat(n.shape[3],".")})),oe(p===n.shape[4],(function(){return"Error in conv3dDerInput: depth of output (".concat(p,") must ")+"match output depth for filter ".concat(n.shape[4],".")}));var c={dy:s,filter:n},l={pad:a,strides:r,inputShape:o},d=Qt.runKernel("Conv3DBackpropInputV2",c,l);return i?In(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});var ur=rn({conv3dTranspose_:function(e,t,n,r,a){var o=en(e,"x","conv3dTranspose"),s=en(t,"filter","conv3dTranspose");return ir(n,o,s,r,a)}});var pr=rn({cos_:function(e){var t={x:en(e,"x","cos","float32")};return Qt.runKernel("Cos",t)}});var cr=rn({cosh_:function(e){var t={x:en(e,"x","cosh","float32")};return Qt.runKernel("Cosh",t)}});var lr=rn({cumprod_:function(e,t,n,r){void 0===t&&(t=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var a={x:en(e,"x","cumprod")},o={axis:t,exclusive:n,reverse:r};return Qt.runKernel("Cumprod",a,o)}});var dr=rn({cumsum_:function(e,t,n,r){void 0===t&&(t=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var a={x:en(e,"x","cumsum")},o={axis:t,exclusive:n,reverse:r};return Qt.runKernel("Cumsum",a,o)}});var hr=rn({denseBincount_:function(e,t,n,r){void 0===r&&(r=!1);var a=en(e,"x","denseBincount"),o=en(t,"weights","denseBincount");oe("int32"===a.dtype,(function(){return"Error in denseBincount: input "+"dtype must be int32, but got ".concat(a.dtype)})),oe(a.rank<=2,(function(){return"Error in denseBincount: input must be at most rank 2, but got "+"rank ".concat(a.rank,".")})),oe(n>=0,(function(){return"size must be non-negative, but got ".concat(n,".")})),oe(o.size===a.size||0===o.size,(function(){return"Error in denseBincount: weights must have the same shape as x or "+"0-length, but got x shape: ".concat(a.shape,", weights shape: ")+"".concat(o.shape,".")}));var s={x:a,weights:o},i={size:n,binaryOutput:r};return Qt.runKernel("DenseBincount",s,i)}});var fr=rn({depthToSpace_:function(e,t,n){void 0===n&&(n="NHWC");var r=en(e,"x","depthToSpace","float32"),a="NHWC"===n?r.shape[1]:r.shape[2],o="NHWC"===n?r.shape[2]:r.shape[3],s="NHWC"===n?r.shape[3]:r.shape[1];oe(t>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: ".concat(t)})),oe(a*t>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n    ".concat(a," and ").concat(t,"  for depthToSpace with input shape\n    ").concat(r.shape)})),oe(o*t>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n    ".concat(o," and ").concat(t," for depthToSpace with input shape\n        ").concat(r.shape)})),oe(s%(t*t)==0,(function(){return"Dimension size must be evenly divisible by ".concat(t*t," but is ").concat(s," for depthToSpace with input shape ").concat(r.shape)}));var i={x:r},u={blockSize:t,dataFormat:n};return Qt.runKernel("DepthToSpace",i,u)}});var mr=rn({depthwiseConv2d_:function(e,t,n,r,a,o,s){void 0===a&&(a="NHWC"),void 0===o&&(o=[1,1]);var i=en(e,"x","depthwiseConv2d","float32"),u=en(t,"filter","depthwiseConv2d","float32"),p=i,c=!1;3===i.rank&&(c=!0,p=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),oe(4===p.rank,(function(){return"Error in depthwiseConv2d: input must be rank 4, but got "+"rank ".concat(p.rank,".")})),oe(4===u.rank,(function(){return"Error in depthwiseConv2d: filter must be rank 4, but got rank "+"".concat(u.rank,".")}));var l="NHWC"===a?p.shape[3]:p.shape[1];oe(l===u.shape[2],(function(){return"Error in depthwiseConv2d: number of input channels "+"(".concat(l,") must match the inChannels dimension in ")+"filter ".concat(u.shape[2],".")})),En("depthwiseConv2d",r,s);var d={x:p,filter:u},h={strides:n,pad:r,dataFormat:a,dilations:o,dimRoundingMode:s},f=Qt.runKernel("DepthwiseConv2dNative",d,h);return c?In(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});var yr=rn({diag_:function(e){var t={x:en(e,"x","diag")};return Qt.runKernel("Diag",t)}});var gr=rn({dilation2d_:function(e,t,n,r,a,o){void 0===a&&(a=[1,1]),void 0===o&&(o="NHWC");var s=en(e,"x","dilation2d"),i=en(t,"filter","dilation2d");oe(3===s.rank||4===s.rank,(function(){return"Error in dilation2d: input must be rank 3 or 4, but got rank "+"".concat(s.rank,".")})),oe(3===i.rank,(function(){return"Error in dilation2d: filter must be rank 3, but got rank "+"".concat(i.rank,".")})),oe("NHWC"===o,(function(){return"Error in dilation2d: Only NHWC is currently supported, "+"but got dataFormat of ".concat(o)}));var u=s,p=!1;3===s.rank&&(u=In(s,[1,s.shape[0],s.shape[1],s.shape[2]]),p=!0),oe(u.shape[3]===i.shape[2],(function(){return"Error in dilation2d:  input and filter must have the same depth: ".concat(u.shape[3]," vs ").concat(i.shape[2])}));var c={x:u,filter:i},l={strides:n,pad:r,dilations:a},d=Qt.runKernel("Dilation2D",c,l);return p?In(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});var vr=rn({floorDiv_:function(e,t){var n,r=en(e,"a","floorDiv"),a=en(t,"b","floorDiv"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("FloorDiv",o)}});var br=rn({div_:function(e,t){var n,r=en(e,"a","div"),a=en(t,"b","div");if(r=(n=l(qt(r,a),2))[0],a=n[1],"int32"===r.dtype&&"int32"===a.dtype)return vr(r,a);var o={a:r,b:a};return Qt.runKernel("RealDiv",o,{})}});function xr(e,t){for(var n=[],r=Math.max(e.length,t.length),a=0;a<r;a++){var o=e[e.length-a-1];null==o&&(o=1);var s=t[t.length-a-1];if(null==s&&(s=1),1===o)n.unshift(s);else if(1===s)n.unshift(o);else{if(o!==s){var i="Operands could not be broadcast together with shapes "+"".concat(e," and ").concat(t,".");throw Error(i)}n.unshift(o)}}return n}var Nr=rn({equal_:function(e,t){var n,r=en(e,"a","equal","string_or_numeric"),a=en(t,"b","equal","string_or_numeric");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("Equal",o)}});var wr=rn({where_:function(e,t,n){var r=en(t,"a","where"),a=en(n,"b","where"),o=en(e,"condition","where","bool"),s=xr(xr(o.shape,r.shape),a.shape),i={condition:Hn(o,s),t:Hn(r,s),e:Hn(a,s)};return Qt.runKernel("Select",i)}});var kr=rn({zerosLike_:function(e){var t={x:en(e,"x","zerosLike")};return Qt.runKernel("ZerosLike",t)}});var Tr=rn({divNoNan_:function(e,t){var n,r=en(e,"a","div"),a=en(t,"b","div");r=(n=l(qt(r,a),2))[0],a=n[1];var o=br(r,a),s=kr(o),i=Nr(a,s);return wr(i,s,o)}});var _r=rn({dot_:function(e,t){var n=en(e,"t1","dot"),r=en(t,"t2","dot");oe(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return"Error in dot: inputs must all be rank 1 or 2, but got ranks "+"".concat(n.rank," and ").concat(r.rank,".")}));var a=1===n.rank?n.size:n.shape[1],o=1===r.rank?r.size:r.shape[0];if(oe(a===o,(function(){return"Error in dot: inner dimensions of inputs must match, but got "+"".concat(a," and ").concat(o,".")})),1===n.rank&&1===r.rank){var s=In(n,[1,-1]),i=In(r,[-1,1]),u=Cn(s,i);return In(u,[])}if(1===n.rank&&2===r.rank){s=In(n,[1,-1]),i=In(r,[r.shape[0],r.shape[1]]),u=Cn(s,i);return In(u,[u.size])}if(2===n.rank&&1===r.rank){i=In(r,[-1,1]),u=Cn(n,i);return In(u,[u.size])}return i=In(r,[r.shape[0],r.shape[1]]),u=Cn(n,i)}});var Sr=rn({einsum_:function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=t.map((function(e,t){return en(e,"tensors".concat(t),"einsum")})),a={equation:e};return Qt.runKernel(Fe,r,a)}});var Er=rn({elu_:function(e){var t={x:en(e,"x","elu","float32")};return Qt.runKernel("Elu",t)}});var Ir=rn({erf_:function(e){var t=en(e,"x","erf");oe("int32"===t.dtype||"float32"===t.dtype,(function(){return"Input dtype must be `int32` or `float32`."})),"int32"===t.dtype&&(t=bn(t,"float32"));var n={x:t};return Qt.runKernel("Erf",n)}});function Or(e,t){return function(e,t,n){for(var r=e.length+t.length,a=[],o=0,s=0,i=0;i<r;i++)-1===n.indexOf(i)?a.push(e[o++]):a.push(t[s++]);return a}(e,t.map((function(e){return 1})),t)}var Dr=rn({max_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:en(e,"x","max")},a={reductionIndices:t,keepDims:n};return Qt.runKernel("Max",r,a)}});var Ar=rn({min_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:en(e,"x","min")},a={axis:t,keepDims:n};return Qt.runKernel("Min",r,a)}});var Mr=rn({pow_:function(e,t){var n,r=en(e,"base","pow"),a=en(t,"exp","pow"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("Pow",o)}});function Cr(e,t,n,r){if(null==r)r=me(e);else if("complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if("object"==typeof e&&("texture"in e||"buffer"in e&&!(e.buffer instanceof ArrayBuffer))){if("float32"!==r&&"int32"!==r)throw new Error("Creating tensor from GPU data only supports "+"'float32'|'int32' dtype, while the dtype is ".concat(r,"."));return Qt.backend.createTensorFromGPUData(e,t||n,r)}if(!kt(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){we(t);var a=ue(t),o=ue(n);oe(a===o,(function(){return"Based on the provided shape, [".concat(t,"], the tensor should have ")+"".concat(a," values but has ").concat(o)}));for(var s=0;s<n.length;++s){var i=n[s],u=s!==n.length-1||i!==ue(t.slice(s));oe(n[s]===t[s]||!u,(function(){return"Error creating a new Tensor. Inferred shape "+"(".concat(n,") does not match the provided ")+"shape (".concat(t,"). ")}))}}return kt(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?xt(e,r):Tt(e,[],!0),Qt.makeTensor(e,t,r)}function Fr(e,t){if((kt(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&kt(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return Cr(e,[],[],t)}var Rr=rn({sqrt_:function(e){var t={x:en(e,"x","sqrt","float32")};return Qt.runKernel("Sqrt",t)}});var zr=rn({square_:function(e){var t=en(e,"x","square");return Qt.runKernel("Square",{x:t},{})}});var Vr=rn({sum_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=en(e,"x","sum");"bool"===r.dtype&&(r=bn(r,"int32"));var a={x:r},o={axis:t,keepDims:n};return Qt.runKernel("Sum",a,o)}});function Lr(e,t,n){if(void 0===n&&(n=null),0===e.rank)return an(e);if(1!==e.rank&&null===n)return Lr(In(e,[-1]),t,n);if(1===e.rank||"number"==typeof n||Array.isArray(n)&&1===n.length){if(1===t)return Vr(an(e),n);if(t===1/0)return Dr(an(e),n);if(t===-1/0)return Ar(an(e),n);if("euclidean"===t||2===t)return Rr(Vr(Mr(an(e),Fr(2,"int32")),n));throw new Error("Error in norm: invalid ord value: ".concat(t))}if(Array.isArray(n)&&2===n.length){if(1===t)return Dr(Vr(an(e),n[0]),n[1]-1);if(t===1/0)return Dr(Vr(an(e),n[1]),n[0]);if(t===-1/0)return Ar(Vr(an(e),n[1]),n[0]);if("fro"===t||"euclidean"===t)return Rr(Vr(zr(e),n));throw new Error("Error in norm: invalid ord value: ".concat(t))}throw new Error("Error in norm: invalid axis: ".concat(n))}var Pr=rn({norm_:function(e,t,n,r){void 0===t&&(t="euclidean"),void 0===n&&(n=null),void 0===r&&(r=!1);var a=Lr(e=en(e,"x","norm"),t,n),o=a.shape;if(r){var s=de(n,e.shape);o=Or(a.shape,s)}return In(a,o)}});var Br=rn({euclideanNorm_:function(e,t,n){return void 0===t&&(t=null),void 0===n&&(n=!1),Pr(e,"euclidean",t,n)}});var Kr=rn({exp_:function(e){var t={x:en(e,"x","exp")};return Qt.runKernel("Exp",t)}});var jr=rn({expandDims_:function(e,t){void 0===t&&(t=0);var n=en(e,"x","expandDims","string_or_numeric");oe(t<=n.rank,(function(){return"Axis must be <= rank of the tensor"}));var r={input:n},a={dim:t};return Qt.runKernel("ExpandDims",r,a)}});var qr=rn({expm1_:function(e){var t={x:en(e,"x","expm1")};return Qt.runKernel("Expm1",t)}});var Ur=rn({tile_:function(e,t){var n=en(e,"x","tile","string_or_numeric");oe(n.rank===t.length,(function(){return"Error in transpose: rank of input ".concat(n.rank," ")+"must match length of reps ".concat(t,".")}));var r={x:n},a={reps:t};return Qt.runKernel(ze,r,a)}});var Wr=rn({eye_:function(e,t,n,r){void 0===r&&(r="float32"),null==t&&(t=e);for(var a=Gn([e,t],r),o=e<=t?e:t,s=0;s<o;++s)a.set(1,s,s);var i=In(a.toTensor(),[e,t]);if(null==n)return i;if(1===n.length)return Ur(jr(i,0),[n[0],1,1]);if(2===n.length)return Ur(jr(jr(i,0),0),[n[0],n[1],1,1]);if(3===n.length)return Ur(jr(jr(jr(i,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error("eye() currently supports only 1D and 2D "+"batchShapes, but received ".concat(n.length,"D."))}});var Hr=rn({floor_:function(e){var t={x:en(e,"x","floor","float32")};return Qt.runKernel("Floor",t)}});var Gr=rn({gather_:function(e,t,n,r){void 0===n&&(n=0),void 0===r&&(r=0);var a={x:en(e,"x","gather"),indices:en(t,"indices","gather","int32")},o={axis:n,batchDims:r};return Qt.runKernel("GatherV2",a,o)}});var Zr=rn({greater_:function(e,t){var n,r=en(e,"a","greater","string_or_numeric"),a=en(t,"b","greater","string_or_numeric");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("Greater",o)}});var Qr=rn({greaterEqual_:function(e,t){var n,r=en(e,"a","greaterEqual","string_or_numeric"),a=en(t,"b","greaterEqual","string_or_numeric");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("GreaterEqual",o)}});var Yr=rn({imag_:function(e){var t={input:en(e,"input","imag")};return Qt.runKernel("Imag",t)}});var Xr=rn({isFinite_:function(e){var t={x:en(e,"x","isFinite")};return Qt.runKernel("IsFinite",t)}});var Jr=rn({isInf_:function(e){var t={x:en(e,"x","isInf")};return Qt.runKernel("IsInf",t)}});var $r=rn({isNaN_:function(e){var t={x:en(e,"x","isNaN")};return Qt.runKernel("IsNan",t)}});var ea=rn({leakyRelu_:function(e,t){void 0===t&&(t=.2);var n={x:en(e,"x","leakyRelu")},r={alpha:t};return Qt.runKernel("LeakyRelu",n,r)}});var ta=rn({less_:function(e,t){var n,r=en(e,"a","less","string_or_numeric"),a=en(t,"b","less","string_or_numeric");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("Less",o)}});var na=rn({lessEqual_:function(e,t){var n,r=en(e,"a","lessEqual","string_or_numeric"),a=en(t,"b","lessEqual","string_or_numeric");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("LessEqual",o)}});var ra=rn({localResponseNormalization_:function(e,t,n,r,a){void 0===t&&(t=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===a&&(a=.5);var o=en(e,"x","localResponseNormalization");oe(4===o.rank||3===o.rank,(function(){return"Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ".concat(o.rank,".")})),oe(ce(t),(function(){return"Error in localResponseNormalization: depthRadius must be an "+"integer but got depthRadius ".concat(t,".")}));var s=o,i=!1;3===o.rank&&(i=!0,s=In(o,[1,o.shape[0],o.shape[1],o.shape[2]]));var u={x:s},p={depthRadius:t,bias:n,alpha:r,beta:a},c=Qt.runKernel("LRN",u,p);return i?In(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var aa=rn({log_:function(e){var t={x:en(e,"x","log","float32")};return Qt.runKernel("Log",t)}});var oa=rn({log1p_:function(e){var t={x:en(e,"x","log1p")};return Qt.runKernel("Log1p",t)}});function sa(e){return Qt.customGrad(e)}var ia=rn({neg_:function(e){var t={x:en(e,"x","neg")};return Qt.runKernel("Neg",t)}});var ua=rn({softplus_:function(e){var t={x:en(e,"x","softplus")};return Qt.runKernel("Softplus",t)}});var pa=rn({logSigmoid_:function(e){var t=en(e,"x","logSigmoid"),n=sa((function(e){return{value:ia(ua(ia(e))),gradFunc:function(t){return Fn(t,Rn(ia(e)))}}}));return n(t)}});var ca=rn({sub_:function(e,t){var n,r=en(e,"a","sub"),a=en(t,"b","sub"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("Sub",o)}});var la=rn({logSoftmax_:function(e,t){void 0===t&&(t=-1);var n=en(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error("Log Softmax along a non-last dimension is not yet supported. "+"Logits was rank ".concat(n.rank," and axis was ").concat(t));var r=sa((function(e,n){var r=Dr(e,t,!0),a=ca(e,r),o=ca(bn(a,"float32"),aa(Vr(Kr(a),t,!0)));n([o]);return{value:o,gradFunc:function(e,n){var r=l(n,1)[0],a=Kr(r);return ca(e,Fn(Vr(e,t,!0),a))}}}));return r(n)}});var da=rn({logSumExp_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=en(e,"x","logSumExp"),a=de(t,r.shape),o=Dr(r,a,!0),s=ca(r,o),i=Kr(s),u=Vr(i,a),p=aa(u),c=un(In(o,p.shape),p);if(n){var l=Or(c.shape,a);return In(c,l)}return c}});var ha=rn({logicalAnd_:function(e,t){var n=en(e,"a","logicalAnd","bool"),r=en(t,"b","logicalAnd","bool");xr(n.shape,r.shape);var a={a:n,b:r};return Qt.runKernel("LogicalAnd",a)}});var fa=rn({logicalNot_:function(e){var t={x:en(e,"x","logicalNot","bool")};return Qt.runKernel("LogicalNot",t)}});var ma=rn({logicalOr_:function(e,t){var n=en(e,"a","logicalOr","bool"),r=en(t,"b","logicalOr","bool");xr(n.shape,r.shape);var a={a:n,b:r};return Qt.runKernel("LogicalOr",a)}});var ya=rn({logicalXor_:function(e,t){var n=en(e,"a","logicalXor","bool"),r=en(t,"b","logicalXor","bool");return xr(n.shape,r.shape),ha(ma(e,t),fa(ha(e,t)))}}),ga=2147483648;var va=rn({searchSorted_:function(e,t,n){void 0===n&&(n="left");var r=en(e,"sortedSequence","searchSorted"),a=en(t,"values","searchSorted"),o=r.shape[r.shape.length-1],s=a.shape[a.shape.length-1],i=In(r,[-1,o]),u=In(a,[-1,s]);if(i.rank<2)throw new Error("Sorted input argument must be at least 2-dimensional");if(i.shape[0]!==u.shape[0])throw new Error("Leading dimension of 'sortedSequence' and 'values' must match.");if(ue(u.shape)>=ga)throw new Error("values tensor size must less than ".concat(ga));if(i.shape[1]>=ga)throw new Error("trailing dim_size must less than ".concat(ga," for int32 output type, was ").concat(i.shape[1]));var p={sortedSequence:i,values:u},c={side:n};return Qt.runKernel("SearchSorted",p,c)}});var ba=rn({maxPool_:function(e,t,n,r,a){var o=en(e,"x","maxPool"),s=o,i=!1;3===o.rank&&(i=!0,s=In(o,[1,o.shape[0],o.shape[1],o.shape[2]])),oe(4===s.rank,(function(){return"Error in maxPool: input must be rank 4 but got rank ".concat(s.rank,".")})),oe(_n(n,1),(function(){return"Error in maxPool: Either strides or dilations must be 1. "+"Got strides ".concat(n," and dilations '").concat(1,"'")})),En("maxPool",r,a);var u={x:s},p={filterSize:t,strides:n,pad:r,dimRoundingMode:a},c=Qt.runKernel("MaxPool",u,p);return i?In(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var xa=rn({maxPool3d_:function(e,t,n,r,a,o){void 0===t&&(t=[1,1,1]),void 0===o&&(o="NDHWC");var s=en(e,"x","maxPool3d"),i=s,u=!1;4===s.rank&&(u=!0,i=In(s,[1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]])),oe(5===i.rank,(function(){return"Error in maxPool3d: x must be rank 5 but got rank ".concat(i.rank,".")})),oe("NDHWC"===o,(function(){return"Error in maxPool3d: Only NDHWC is currently supported, "+"but got dataFormat of ".concat(o)})),En("maxPool3d",r,a);var p={x:i},c={filterSize:t,strides:n,pad:r,dimRoundingMode:a,dataFormat:o},l=Qt.runKernel("MaxPool3D",p,c);return u?In(l,[l.shape[1],l.shape[2],l.shape[3],l.shape[4]]):l}});var Na=rn({maxPoolWithArgmax_:function(e,t,n,r,a){void 0===a&&(a=!1);var o={x:en(e,"x","maxPoolWithArgmax")},s={filterSize:t,strides:n,pad:r,includeBatchInIndex:a},i=Qt.runKernel("MaxPoolWithArgmax",o,s);return{result:i[0],indexes:i[1]}}});var wa=rn({maximum_:function(e,t){var n,r=en(e,"a","maximum"),a=en(t,"b","maximum");r=(n=l(qt(r,a),2))[0],a=n[1],"bool"===r.dtype&&(r=bn(r,"int32"),a=bn(a,"int32")),xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("Maximum",o)}});var ka=rn({mean_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:en(e,"x","mean")},a={axis:t,keepDims:n};return Qt.runKernel("Mean",r,a)}});function Ta(e,t){if(void 0===t&&(t="float32"),we(e),"complex64"===t){var n=Ta(e,"float32"),r=Ta(e,"float32");return Xn(n,r)}var a=Ne(ue(e),t);return Qt.makeTensor(a,e,t)}function _a(e,t){if(void 0===t&&(t="float32"),we(e),"complex64"===t){var n=_a(e,"float32"),r=Ta(e,"float32");return Xn(n,r)}var a=xe(ue(e),t);return Qt.makeTensor(a,e,t)}var Sa=rn({minimum_:function(e,t){var n,r=en(e,"a","minimum"),a=en(t,"b","minimum");r=(n=l(qt(r,a),2))[0],a=n[1],"bool"===r.dtype&&(r=bn(r,"int32"),a=bn(a,"int32")),xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("Minimum",o)}});var Ea=rn({mirrorPad_:function(e,t,n){oe("reflect"===n||"symmetric"===n,(function(){return"Invalid mode. Mode must be either reflect or symmetric. "+"Got ".concat(n,".")}));var r=en(e,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");oe(t.length===r.rank,(function(){return"Padding doesn't match input. Must be ".concat(r.rank,". ")+"Got ".concat(t.length,".")}));for(var a="reflect"===n?1:0,o=function(e){oe(2===t[e].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),oe(t[e][0]>=0&&t[e][0]<=r.shape[e]-a&&t[e][1]>=0&&t[e][1]<=r.shape[e]-a,(function(){return"Padding in dimension ".concat(e," cannot be greater than or equal ")+"to ".concat(r.shape[e]-a," or less than 0 for input of ")+"shape ".concat(r.shape)}))},s=0;s<r.rank;s++)o(s);var i={paddings:t,mode:n},u={x:r};return Qt.runKernel("MirrorPad",u,i)}});var Ia=rn({mod_:function(e,t){var n,r=en(e,"a","mod"),a=en(t,"b","mod"),o={a:r=(n=l(qt(r,a),2))[0],b:a=n[1]};return Qt.runKernel("Mod",o)}});var Oa=rn({moments_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=de(t,(e=en(e,"x","moments")).shape),a=ka(e,r,n),o=a.shape;n||(o=Or(a.shape,r));var s=zr(ca(bn(e,"float32"),In(a,o)));return{mean:a,variance:ka(s,r,n)}}});var Da=rn({multiRNNCell_:function(e,t,n,r){for(var a=en(t,"data","multiRNNCell"),o=tn(n,"c","multiRNNCell"),s=tn(r,"h","multiRNNCell"),i=a,u=[],p=0;p<e.length;p++){var c=e[p](i,o[p],s[p]);u.push(c[0]),u.push(c[1]),i=c[1]}var l=[],d=[];for(p=0;p<u.length;p+=2)l.push(u[p]),d.push(u[p+1]);return[l,d]}});var Aa=rn({multinomial_:function(e,t,n,r){void 0===r&&(r=!1);var a=en(e,"logits","multinomial"),o=a.size,s=a.rank;if(o<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+"".concat(o,"."));if(s>2)throw new Error("Rank of probabilities must be 1 or 2, but is ".concat(s));n=n||Math.random();var i={logits:1===s?In(a,[1,-1]):a},u={numSamples:t,seed:n,normalized:r},p=Qt.runKernel("Multinomial",i,u);return 1===s?In(p,[p.size]):p}});var Ma=rn({notEqual_:function(e,t){var n,r=en(e,"a","notEqual","string_or_numeric"),a=en(t,"b","notEqual","string_or_numeric");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("NotEqual",o)}});var Ca=rn({oneHot_:function(e,t,n,r,a){if(void 0===n&&(n=1),void 0===r&&(r=0),void 0===a&&(a="int32"),t<2)throw new Error("Error in oneHot: depth must be >=2, but it is ".concat(t));var o={indices:en(e,"indices","oneHot","int32")},s={dtype:a,depth:t,onValue:n,offValue:r};return Qt.runKernel("OneHot",o,s)}});var Fa=rn({onesLike_:function(e){var t={x:en(e,"x","onesLike")};return Qt.runKernel("OnesLike",t)}});var Ra=rn({outerProduct_:function(e,t){var n=en(e,"v1","outerProduct"),r=en(t,"v2","outerProduct");oe(1===n.rank&&1===r.rank,(function(){return"Error in outerProduct: inputs must be rank 1, but got ranks "+"".concat(n.rank," and ").concat(r.rank,".")}));var a=In(n,[-1,1]),o=In(r,[1,-1]);return Cn(a,o)}});var za=rn({pad_:function(e,t,n){void 0===n&&(n=0);var r=en(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");var a={paddings:t,constantValue:n},o={x:r};return Qt.runKernel("PadV2",o,a)}});var Va=rn({pad1d_:function(e,t,n){return void 0===n&&(n=0),oe(2===t.length,(function(){return"Invalid number of paddings. Must be length of 2."})),za(e,[t],n)}});var La=rn({pad2d_:function(e,t,n){return void 0===n&&(n=0),oe(2===t.length&&2===t[0].length&&2===t[1].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),za(e,t,n)}});var Pa=rn({pad3d_:function(e,t,n){return void 0===n&&(n=0),oe(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),za(e,t,n)}});var Ba=rn({pad4d_:function(e,t,n){return void 0===n&&(n=0),oe(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),za(e,t,n)}});var Ka=rn({spaceToBatchND_:function(e,t,n){var r=en(e,"x","spaceToBatchND");oe(r.rank>=1+t.length,(function(){return"input rank ".concat(r.rank," should be > than [blockShape] ").concat(t.length)})),oe(n.length===t.length,(function(){return"paddings.shape[0] ".concat(n.length," must be equal to [blockShape] ").concat(t.length)})),oe(r.shape.reduce((function(e,r,a){return a>0&&a<=t.length?e&&(r+n[a-1][0]+n[a-1][1])%t[a-1]==0:e}),!0),(function(){return"input spatial dimensions ".concat(r.shape.slice(1)," with paddings ").concat(n.toString()," must be divisible by blockShapes ").concat(t.toString())}));var a={x:r},o={blockShape:t,paddings:n};return Qt.runKernel("SpaceToBatchND",a,o)}});var ja=rn({pool_:function(e,t,n,r,a,o,s){null==a&&(a=[1,1]),null==o&&(o=1),0===r&&(r="valid");var i=en(e,"x","maxPool"),u=i,p=!1;3===i.rank&&(p=!0,u=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),oe(_n(o,a),(function(){return"Error in pool: Either strides or dilations must be 1. "+"Got strides ".concat(o," and dilations '").concat(a,"'")}));var c,d=function(e,t,n,r,a,o,s){void 0===s&&(s="channelsLast");var i,u=l(Nn(t),2),p=u[0],c=u[1];if("channelsLast"===s)i=[p,c,e[3],e[3]];else{if("channelsFirst"!==s)throw new Error("Unknown dataFormat ".concat(s));i=[p,c,e[1],e[1]]}return xn(e,i,n,r,a,o,!1,s)}(u.shape,t,o,a,r),h=[d.dilationHeight,d.dilationWidth];c="same"===r?function(e,t){var n=e.map((function(e,n){return e+(e-1)*(t[n]-1)})).map((function(e){return e-1})),r=n.map((function(e){return Math.floor(e/2)})),a=n.map((function(e,t){return e-r[t]}));return n.map((function(e,t){return[r[t],a[t]]}))}([d.filterHeight,d.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],m=l(function(e,t,n){var r=n.map((function(e){return e[0]})),a=n.map((function(e){return e[1]})),o=e.concat(r,a),s=t.map((function(e,t){return(e-o[t]%e)%e})),i=a.map((function(e,t){return e+s[t]})),u=t.map((function(e,t){return[r[t],i[t]]})),p=t.map((function(e,t){return[0,s[t]]}));return[u,p]}([d.inHeight,d.inWidth],h,c),2),y=m[0],g=m[1],v=f?r:"valid",b=f?u:Ka(u,h,y),x=("avg"===n?function(){return On(b,t,o,v,s)}:function(){return ba(b,t,o,v,s)})(),N=f?x:Pn(x,h,g);return p?In(N,[N.shape[1],N.shape[2],N.shape[3]]):N}});var qa=rn({prelu_:function(e,t){var n={x:en(e,"x","prelu"),alpha:en(t,"alpha","prelu")};return Qt.runKernel("Prelu",n)}});var Ua=rn({prod_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=en(e,"x","prod");"bool"===r.dtype&&(r=bn(r,"int32"));var a={x:r},o={axis:t,keepDims:n};return Qt.runKernel("Prod",a,o)}});var Wa=rn({raggedGather_:function(e,t,n,r){var a={paramsNestedSplits:e.map((function(e,t){return en(e,"tensors".concat(t),"raggedGather","int32")})),paramsDenseValues:en(t,"paramsDenseValues","raggedGather"),indices:en(n,"indices","raggedGather","int32")},o={outputRaggedRank:r},s=Qt.runKernel("RaggedGather",a,o);return{outputNestedSplits:s.slice(0,s.length-1),outputDenseValues:s[s.length-1]}}});var Ha=rn({raggedRange_:function(e,t,n){var r=en(e,"starts","raggedRange"),a={starts:r,limits:en(t,"limits","raggedRange",r.dtype),deltas:en(n,"deltas","raggedRange",r.dtype)},o=Qt.runKernel("RaggedRange",a);return{rtNestedSplits:o[0],rtDenseValues:o[1]}}});var Ga=rn({raggedTensorToTensor_:function(e,t,n,r,a){var o=en(e,"shape","raggedTensorToTensor","int32"),s=en(t,"values","raggedTensorToTensor"),i={shape:o,values:s,defaultValue:en(n,"defaultValue","raggedTensorToTensor",s.dtype),rowPartitionTensors:r.map((function(e,t){return en(e,"tensors".concat(t),"raggedTensorToTensor","int32")}))},u={rowPartitionTypes:a};return Qt.runKernel("RaggedTensorToTensor",i,u)}});var Za=rn({rand_:function(e,t,n){we(e);var r=ue(e),a=null;if(null==n||"float32"===n)a=new Float32Array(r);else if("int32"===n)a=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type ".concat(n));a=new Uint8Array(r)}for(var o=0;o<r;o++)a[o]=t();return Qt.makeTensor(a,e,n)}}),Qa="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Ya(e){if(e.__esModule)return e;var t=Object.defineProperty({},"__esModule",{value:!0});return Object.keys(e).forEach((function(n){var r=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,r.get?r:{enumerable:!0,get:function(){return e[n]}})})),t}function Xa(e){var t={exports:{}};return e(t,t.exports),t.exports}var Ja=Xa((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=String(e);for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function a(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function o(e,t){var n=new r(e),o=t&&t.state,s=n.next;return s.int32=function(){return 4294967296*n.next()|0},s.double=function(){return s()+11102230246251565e-32*(2097152*s()|0)},s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.alea=o}(0,e,!1)})),$a=Xa((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function a(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function o(e,t){var n=new r(e),o=t&&t.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},s.int32=n.next,s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor128=o}(0,e,!1)})),eo=Xa((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function a(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},s.int32=n.next,s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorwow=o}(0,e,!1)})),to=Xa((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,a=t.i;return e=r[a],n=(e^=e>>>7)^e<<24,n^=(e=r[a+1&7])^e>>>10,n^=(e=r[a+3&7])^e>>>3,n^=(e=r[a+4&7])^e<<7,e=r[a+7&7],n^=(e^=e<<13)^e<<9,r[a]=n,t.i=a+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n&&(r[7]=-1),e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function a(e,t){return t.x=e.x.slice(),t.i=e.i,t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},s.int32=n.next,s.quick=s,o&&(o.x&&a(o,n),s.state=function(){return a(n,{})}),s}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorshift7=o}(0,e,!1)})),no=Xa((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,a=t.X,o=t.i;return t.w=r=r+1640531527|0,n=a[o+34&127],e=a[o=o+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=a[o]=n^e,t.i=o,n+(r^r>>>16)|0},function(e,t){var n,r,a,o,s,i=[],u=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,u=Math.max(u,t.length)),a=0,o=-32;o<u;++o)t&&(r^=t.charCodeAt((o+32)%t.length)),0===o&&(s=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,o>=0&&(s=s+1640531527|0,a=0==(n=i[127&o]^=r+s)?a+1:0);for(a>=128&&(i[127&(t&&t.length||0)]=-1),a=127,o=512;o>0;--o)r=i[a+34&127],n=i[a=a+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[a]=r^n;e.w=s,e.X=i,e.i=a}(t,e)}function a(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},s.int32=n.next,s.quick=s,o&&(o.X&&a(o,n),s.state=function(){return a(n,{})}),s}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor4096=o}(0,e,!1)})),ro=Xa((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,a=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^a,a=a-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^a,t.a=a-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function a(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,s=function(){return(n.next()>>>0)/4294967296};return s.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},s.int32=n.next,s.quick=s,o&&("object"==typeof o&&a(o,n),s.state=function(){return a(n,{})}),s}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.tychei=o}(0,e,!1)})),ao=Ya({__proto__:null,default:{}}),oo=Xa((function(e){!function(t,n,r){var a,o=256,s=r.pow(o,6),i=r.pow(2,52),u=2*i,p=255;function c(e,p,c){var y=[],g=f(h((p=1==p?{entropy:!0}:p||{}).entropy?[e,m(n)]:null==e?function(){try{var e;return a&&(e=a.randomBytes)?e=e(o):(e=new Uint8Array(o),(t.crypto||t.msCrypto).getRandomValues(e)),m(e)}catch(e){var r=t.navigator,s=r&&r.plugins;return[+new Date,t,s,t.screen,m(n)]}}():e,3),y),v=new l(y),b=function(){for(var e=v.g(6),t=s,n=0;e<i;)e=(e+n)*o,t*=o,n=v.g(1);for(;e>=u;)e/=2,t/=2,n>>>=1;return(e+n)/t};return b.int32=function(){return 0|v.g(4)},b.quick=function(){return v.g(4)/4294967296},b.double=b,f(m(v.S),n),(p.pass||c||function(e,t,n,a){return a&&(a.S&&d(a,v),e.state=function(){return d(v,{})}),n?(r.random=e,t):e})(b,g,"global"in p?p.global:this==r,p.state)}function l(e){var t,n=e.length,r=this,a=0,s=r.i=r.j=0,i=r.S=[];for(n||(e=[n++]);a<o;)i[a]=a++;for(a=0;a<o;a++)i[a]=i[s=p&s+e[a%n]+(t=i[a])],i[s]=t;(r.g=function(e){for(var t,n=0,a=r.i,s=r.j,i=r.S;e--;)t=i[a=p&a+1],n=n*o+i[p&(i[a]=i[s=p&s+t])+(i[s]=t)];return r.i=a,r.j=s,n})(o)}function d(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function h(e,t){var n,r=[],a=typeof e;if(t&&"object"==a)for(n in e)try{r.push(h(e[n],t-1))}catch(e){}return r.length?r:"string"==a?e:e+"\0"}function f(e,t){for(var n,r=e+"",a=0;a<r.length;)t[p&a]=p&(n^=19*t[p&a])+r.charCodeAt(a++);return m(t)}function m(e){return String.fromCharCode.apply(0,e)}if(f(r.random(),n),e.exports){e.exports=c;try{a=ao}catch(e){}}else r.seedrandom=c}("undefined"!=typeof self?self:Qa,[],Math)}));oo.alea=Ja,oo.xor128=$a,oo.xorwow=eo,oo.xorshift7=to,oo.xor4096=no,oo.tychei=ro;var so=oo,io=function(){function e(e,t,n,r,a){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var o=a||Math.random();this.random=so.alea(o.toString())}return e.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var e=this.nextVal;return this.nextVal=NaN,e}for(var t,n,r=!1;!r;){var a=void 0,o=void 0,s=void 0;do{s=(a=2*this.random()-1)*a+(o=2*this.random()-1)*o}while(s>=1||0===s);var i=Math.sqrt(-2*Math.log(s)/s);t=this.mean+this.stdDev*a*i,n=this.mean+this.stdDev*o*i,this.truncated&&!this.isValidTruncated(t)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(t)},e.prototype.convertValue=function(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)},e.prototype.isValidTruncated=function(e){return e<=this.upper&&e>=this.lower},e}(),uo=function(){function e(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;var a=r||Math.random();this.randu=so.alea(a.toString()),this.randn=new io(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}return e.prototype.nextValue=function(){for(var e,t,n,r,a,o;;){do{r=this.randn.nextValue(),o=1+this.c*r}while(o<=0);if(o*=o*o,t=1-.331*(e=r*r)*e,n=.5*e+this.d*(1-o+Math.log(o)),(a=this.randu())<t||Math.log(a)<n)break}return o=1/this.beta*this.d*o,this.alpha<1&&(o*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(o)},e.prototype.convertValue=function(e){return"float32"===this.dtype?e:Math.round(e)},e}(),po=function(){function e(e,t,n,r){void 0===e&&(e=0),void 0===t&&(t=1);var a=this;if(this.canReturnFloat=function(){return null==a.dtype||"float32"===a.dtype},this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error("The difference between ".concat(e," - ").concat(t," <= 1 and dtype is not float"));this.random=so.alea(r)}return e.prototype.convertValue=function(e){return this.canReturnFloat()?e:Math.round(e)},e.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},e}();var co=rn({randomGamma_:function(e,t,n,r,a){if(void 0===n&&(n=1),void 0===r&&(r="float32"),we(e),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type ".concat(r));for(var o=new uo(t,n,r,a),s=Gn(e,r),i=0;i<s.values.length;i++)s.values[i]=o.nextValue();return s.toTensor()}});var lo=rn({randomNormal_:function(e,t,n,r,a){if(void 0===t&&(t=0),void 0===n&&(n=1),we(e),null!=r&&"bool"===r)throw new Error("Unsupported data type ".concat(r));for(var o=new io(t,n,r,!1,a),s=Gn(e,r),i=0;i<s.values.length;i++)s.values[i]=o.nextValue();return s.toTensor()}});var ho=rn({randomStandardNormal_:function(e,t,n){if(null!=t&&"bool"===t)throw new Error("Unsupported data type ".concat(t));return lo(e,0,1,t,n)}});var fo=rn({randomUniform_:function(e,t,n,r,a){void 0===t&&(t=0),void 0===n&&(n=1),void 0===r&&(r="float32"),we(e);for(var o=Gn(e,r),s=new po(t,n,null,a),i=0;i<o.values.length;i++)o.values[i]=s.nextValue();return o.toTensor()}});function mo(e,t,n,r){if(void 0===n&&(n=1),void 0===r&&(r="float32"),0===n)throw new Error("Cannot have a step of zero");var a={start:e,stop:t,step:n,dtype:r};return Qt.runKernel("Range",{},a)}var yo=rn({real_:function(e){var t={input:en(e,"input","real")};return Qt.runKernel("Real",t)}});var go=rn({reciprocal_:function(e){var t={x:en(e,"x","reciprocal")};return Qt.runKernel("Reciprocal",t)}});var vo=rn({relu_:function(e){var t={x:en(e,"x","relu")};return Qt.runKernel("Relu",t)}});var bo=rn({relu6_:function(e){var t={x:en(e,"x","relu6")};return Qt.runKernel("Relu6",t)}});var xo=rn({reverse_:function(e,t){var n={x:en(e,"x","reverse")},r={dims:t};return Qt.runKernel("Reverse",n,r)}});var No=rn({reverse1d_:function(e){var t=en(e,"x","reverse");return oe(1===t.rank,(function(){return"Error in reverse1D: x must be rank 1 but got rank ".concat(t.rank,".")})),xo(t,0)}});var wo=rn({reverse2d_:function(e,t){var n=en(e,"x","reverse");return oe(2===n.rank,(function(){return"Error in reverse2D: x must be rank 2 but got rank ".concat(n.rank,".")})),xo(n,t)}});var ko=rn({reverse3d_:function(e,t){var n=en(e,"x","reverse");return oe(3===n.rank,(function(){return"Error in reverse3D: x must be rank 3 but got rank ".concat(n.rank,".")})),xo(n,t)}});var To=rn({reverse4d_:function(e,t){var n=en(e,"x","reverse");return oe(4===n.rank,(function(){return"Error in reverse4D: x must be rank 4 but got rank ".concat(n.rank,".")})),xo(n,t)}});var _o=rn({round_:function(e){var t={x:en(e,"x","round")};return Qt.runKernel("Round",t)}});var So=rn({rsqrt_:function(e){var t={x:en(e,"x","rsqrt","float32")};return Qt.runKernel("Rsqrt",t)}});var Eo=rn({selu_:function(e){var t={x:en(e,"x","selu")};return Qt.runKernel("Selu",t)}});var Io=rn({separableConv2d_:function(e,t,n,r,a,o,s){void 0===o&&(o=[1,1]),void 0===s&&(s="NHWC");var i=en(e,"x","separableConv2d"),u=en(t,"depthwiseFilter","separableConv2d"),p=en(n,"pointwiseFilter","separableConv2d"),c=i,l=!1;if(3===i.rank&&(l=!0,c=In(i,[1,i.shape[0],i.shape[1],i.shape[2]])),"NCHW"===s)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");oe(4===c.rank,(function(){return"Error in separableConv2d: input must be rank 4, but got "+"rank ".concat(c.rank,".")})),oe(4===u.rank,(function(){return"Error in separableConv2d: depthwise filter must be rank 4, but "+"got rank ".concat(u.rank,".")})),oe(4===p.rank,(function(){return"Error in separableConv2d: pointwise filter must be rank 4, but "+"got rank ".concat(u.rank,".")})),oe(1===p.shape[0],(function(){return"Error in separableConv2d: the first dimension of pointwise filter "+" must be 1, but got ".concat(p.shape[0],".")})),oe(1===p.shape[1],(function(){return"Error in separableConv2d: the second dimension of pointwise "+"filter must be 1, but got ".concat(p.shape[1],".")}));var d=u.shape[2],h=u.shape[3];oe(p.shape[2]===d*h,(function(){return"Error in separableConv2d: the third dimension of pointwise filter "+"must be ".concat(d*h,", ")+"but got ".concat(p.shape[2],".")}));var f=mr(c,u,r,a,s,o),m=nr(f,p,1,"valid",s);return l?In(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});var Oo=function(e,t){return u(this,void 0,void 0,(function(){var n,r,a,o,s,i,u,c,l,d;return p(this,(function(p){switch(p.label){case 0:return n=en(e,"x","setdiff1d"),r=en(t,"y","setdiff1d"),oe(n.dtype===r.dtype,(function(){return"x and y should have the same dtype, but got x (".concat(n.dtype,") and y (").concat(r.dtype,").")})),oe(1===n.rank,(function(){return"x should be 1D tensor, but got x (".concat(n.shape,").")})),oe(1===r.rank,(function(){return"y should be 1D tensor, but got y (".concat(r.shape,").")})),[4,n.data()];case 1:return a=p.sent(),[4,r.data()];case 2:for(o=p.sent(),s=new Set(o),i=0,l=0;l<a.length;l++)s.has(a[l])||i++;for(u=new Mt([i],n.dtype),c=new Mt([i],"int32"),l=0,d=0;l<a.length;l++)s.has(a[l])||(u.values[d]=a[l],c.values[d]=l,d++);return[2,[u.toTensor(),c.toTensor()]]}}))}))};var Do=rn({sign_:function(e){var t={x:en(e,"x","sign")};return Qt.runKernel("Sign",t)}});var Ao=rn({sin_:function(e){var t={x:en(e,"x","sin","float32")};return Qt.runKernel("Sin",t)}});var Mo=rn({sinh_:function(e){var t={x:en(e,"x","sinh")};return Qt.runKernel("Sinh",t)}});var Co=rn({slice1d_:function(e,t,n){var r=en(e,"x","slice1d");return oe(1===r.rank,(function(){return"slice1d expects a rank-1 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,[t],[n])}});var Fo=rn({slice2d_:function(e,t,n){var r=en(e,"x","slice2d");return oe(2===r.rank,(function(){return"slice2d expects a rank-2 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,t,n)}});var Ro=rn({slice3d_:function(e,t,n){var r=en(e,"x","slice3d");return oe(3===r.rank,(function(){return"slice3d expects a rank-3 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,t,n)}});var zo=rn({slice4d_:function(e,t,n){var r=en(e,"x","slice4d");return oe(4===r.rank,(function(){return"slice4d expects a rank-4 tensor, but got a rank-".concat(r.rank," tensor")})),zn(r,t,n)}});var Vo=rn({softmax_:function(e,t){void 0===t&&(t=-1);var n=en(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error("Softmax along a non-last dimension is not yet supported. "+"Logits was rank ".concat(n.rank," and dim was ").concat(t));var r={logits:n},a={dim:t};return Qt.runKernel("Softmax",r,a)}});var Lo=rn({fft_:function(e){oe("complex64"===e.dtype,(function(){return"The dtype for tf.spectral.fft() must be complex64 "+"but got ".concat(e.dtype,".")}));var t={input:e};return Qt.runKernel("FFT",t)}});var Po=rn({ifft_:function(e){oe("complex64"===e.dtype,(function(){return"The dtype for tf.spectral.ifft() must be complex64 "+"but got ".concat(e.dtype,".")}));var t={input:e};return Qt.runKernel("IFFT",t)}});var Bo=rn({irfft_:function(e){var t,n=e.shape[e.shape.length-1],r=e.size/n;if(n<=2){var a=In(e,[r,n]);t=Po(a)}else{var o=[r,2*(n-1)],s=In(yo(e),[r,n]),i=In(Yr(e),[r,n]),u=xo(zn(s,[0,1],[r,n-2]),1),p=Fn(xo(zn(i,[0,1],[r,n-2]),1),Fr(-1)),c=Mn([s,u],1),l=Mn([i,p],1);a=In(Xn(c,l),[o[0],o[1]]);t=Po(a)}if(t=yo(t),3===e.rank&&0!==e.shape[0]){var d=t,h=e.shape[0];t=In(t,[h,t.shape[0]/h,t.shape[1]]),d.dispose()}return t}});var Ko=rn({split_:function(e,t,n){void 0===n&&(n=0);var r={x:en(e,"x","split")},a={numOrSizeSplits:t,axis:n};return Qt.runKernel("SplitV",r,a)}});var jo=rn({rfft_:function(e,t){oe("float32"===e.dtype,(function(){return"The dtype for rfft() must be real value but got ".concat(e.dtype)}));var n,r=e.shape[e.shape.length-1],a=e.size/r;if(null!=t&&t<r){var o=e.shape.map((function(e){return 0})),s=e.shape.map((function(e){return e}));s[e.shape.length-1]=t,n=zn(e,o,s),r=t}else if(null!=t&&t>r){var i=e.shape.map((function(e){return e}));i[e.shape.length-1]=t-r,n=Mn([e,Ta(i)],e.shape.length-1),r=t}else n=e;var u=kr(n),p=In(Xn(n,u),[a,r]),c=Lo(p),l=Math.floor(r/2)+1,d=yo(c),h=Yr(c),f=Ko(d,[l,r-l],d.shape.length-1),m=Ko(h,[l,r-l],h.shape.length-1),y=n.shape.slice();return y[n.shape.length-1]=l,In(Xn(f[0],m[0]),y)}});var qo=rn({squaredDifference_:function(e,t){var n,r=en(e,"a","squaredDifference"),a=en(t,"b","squaredDifference");r=(n=l(qt(r,a),2))[0],a=n[1],xr(r.shape,a.shape);var o={a:r,b:a};return Qt.runKernel("SquaredDifference",o,{})}});var Uo=rn({squeeze_:function(e,t){var n=en(e,"x","squeeze","string_or_numeric");return In(n,function(e,t){for(var n=[],r=[],a=null!=t&&Array.isArray(t)&&0===t.length,o=null==t||a?null:de(t,e).sort(),s=0,i=0;i<e.length;++i){if(null!=o){if(o[s]===i&&1!==e[i])throw new Error("Can't squeeze axis ".concat(i," since its dim '").concat(e[i],"' is not 1"));(null==o[s]||o[s]>i)&&1===e[i]&&(n.push(e[i]),r.push(i)),o[s]<=i&&s++}1!==e[i]&&(n.push(e[i]),r.push(i))}return{newShape:n,keptDims:r}}(n.shape,t).newShape)}});var Wo=rn({stack_:function(e,t){void 0===t&&(t=0);var n=tn(e,"tensors","stack","string_or_numeric");oe(n.length>=1,(function(){return"Pass at least one tensor to tf.stack"})),n.length>0&&oe(t<=n[0].rank,(function(){return"Axis must be <= rank of the tensor"}));var r=n,a={axis:t};return Qt.runKernel("Pack",r,a)}});var Ho=rn({step_:function(e,t){void 0===t&&(t=0);var n={x:en(e,"x","step")},r={alpha:t};return Qt.runKernel("Step",n,r)}});var Go=rn({stridedSlice_:function(e,t,n,r,a,o,s,i,u){void 0===a&&(a=0),void 0===o&&(o=0),void 0===s&&(s=0),void 0===i&&(i=0),void 0===u&&(u=0);var p={x:en(e,"x","stridedSlice","string_or_numeric")},c={begin:t,end:n,strides:r,beginMask:a,endMask:o,ellipsisMask:s,newAxisMask:i,shrinkAxisMask:u};return Qt.runKernel("StridedSlice",p,c)}});var Zo=rn({tan_:function(e){var t={x:en(e,"x","tan","float32")};return Qt.runKernel("Tan",t)}});function Qo(e,t,n){return Cr(e,t,Xt(e,n),n)}function Yo(e,t){ie(e);var n=Xt(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return Cr(e,null,n,t)}function Xo(e,t,n){if(ie(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");var r=Xt(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return Cr(e,t,r,n)}var Jo=rn({topk_:function(e,t,n){void 0===t&&(t=1),void 0===n&&(n=!0);var r=en(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");var a=r.shape[r.shape.length-1];if(t<0)throw new Error("'k' passed to topk() must be >= 0 but got ".concat(t));if(t>a)throw new Error("'k' passed to topk() must be <= the last dimension (".concat(a,") ")+"but got ".concat(t));var o={x:r},s={k:t,sorted:n},i=l(Qt.runKernel("TopK",o,s),2);return{values:i[0],indices:i[1]}}});var $o=rn({truncatedNormal_:function(e,t,n,r,a){if(void 0===t&&(t=0),void 0===n&&(n=1),we(e),null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");for(var o=new io(t,n,r,!0,a),s=Gn(e,r),i=0;i<s.values.length;i++)s.values[i]=o.nextValue();return s.toTensor()}});var es=rn({unique_:function(e,t){void 0===t&&(t=0);var n=en(e,"x","unique","string_or_numeric");oe(n.rank>0,(function(){return"The input tensor must be at least 1D"}));var r={x:n},a={axis:t},o=l(Qt.runKernel("Unique",r,a),2);return{values:o[0],indices:o[1]}}});var ts=rn({unsortedSegmentSum_:function(e,t,n){var r=en(e,"x","unsortedSegmentSum"),a=en(t,"segmentIds","unsortedSegmentSum","int32");oe(ce(n),(function(){return"numSegments must be of dtype int"}));var o={x:r,segmentIds:a},s={numSegments:n};return Qt.runKernel("UnsortedSegmentSum",o,s)}});var ns=rn({unstack_:function(e,t){void 0===t&&(t=0);var n=en(e,"x","unstack","string_or_numeric");oe(t>=-n.shape.length&&t<n.shape.length,(function(){return"Axis = ".concat(t," is not in [-").concat(n.shape.length,", ").concat(n.shape.length,")")}));var r={value:n},a={axis:t};return Qt.runKernel("Unpack",r,a)}});var rs=function(e){return u(this,void 0,void 0,(function(){var t,n,r;return p(this,(function(a){switch(a.label){case 0:return[4,(t=en(e,"condition","whereAsync","bool")).data()];case 1:return n=a.sent(),r=function(e,t){for(var n=[],r=0;r<t.length;r++)t[r]&&n.push(r);var a=Gn(e,"int32"),o=Gn([n.length,e.length],"int32");for(r=0;r<n.length;r++){var s=a.indexToLoc(n[r]),i=r*e.length;o.values.set(s,i)}return o.toTensor()}(t.shape,n),e!==t&&t.dispose(),[2,r]}}))}))};var as=function(e,t,n){return u(this,void 0,void 0,(function(){var r,a,o,s,i,u,c,l,d,h,f,m,y;return p(this,(function(p){switch(p.label){case 0:for(r=en(e,"tensor","boolMask"),a=en(t,"mask","boolMask","bool"),o=null==n?0:n,s=a.rank,i=r.shape,oe(s>0,(function(){return"mask cannot be scalar"})),se(i.slice(o,o+s),a.shape,"mask's shape must match the first K dimensions of tensor's shape,"),u=1,c=o;c<o+s;c++)u*=i[c];return l=i.slice(0,o).concat([u],i.slice(o+s)),d=In(r,l),h=In(a,[-1]),[4,rs(h)];case 1:return f=p.sent(),m=Uo(f,[1]),y=Gr(d,m,o),e!==r&&r.dispose(),t!==a&&a.dispose(),m.dispose(),d.dispose(),h.dispose(),f.dispose(),[2,y]}}))}))};var os=rn({transpose_:function(e,t,n){var r=en(e,"x","transpose");if(null==t&&(t=r.shape.map((function(e,t){return t})).reverse()),oe(r.rank===t.length,(function(){return"Error in transpose: rank of input ".concat(r.rank," ")+"must match length of perm ".concat(t,".")})),t.forEach((function(e){oe(e>=0&&e<r.rank,(function(){return"All entries in 'perm' must be between 0 and ".concat(r.rank-1)+" but got ".concat(t)}))})),r.rank<=1)return r.clone();var a,o,s={x:r},i={perm:t};return"complex64"===r.dtype?(a=function(){var e=yo(r),t=Yr(r);return e=Qt.runKernel(Ve,{x:e},i),t=Qt.runKernel(Ve,{x:t},i),n&&(t=ia(t)),Xn(e,t)},Qt.tidy(a,o)):Qt.runKernel(Ve,s,i)}});var ss=rn({movingAverage_:function(e,t,n,r,a){void 0===a&&(a=!0);var o,s,i=en(e,"v","movingAverage"),u=en(t,"x","movingAverage"),p=en(n,"decay","movingAverage");s=u,oe((o=i).dtype===s.dtype,(function(){return"The dtypes of the first(".concat(o.dtype,") and")+" second(".concat(s.dtype,") input must match")})),oe(pe(i.shape,u.shape),(function(){return"Shape mismatch in v and x"}));var c=Fr(1),l=ca(c,p),d=Fn(ca(u,i),l);if(a){oe(null!=r,(function(){return"When using zeroDebias: true, step is required."}));var h=en(r,"step","movingAverage");d=br(d,ca(c,Mr(p,h)))}return un(i,d)}});function is(e,t,n){if(t.rank<1)throw new Error("tf.scatterND() expects the indices to be rank 1 or higher,"+" but the rank was ".concat(t.rank,"."));if(e.rank<1)throw new Error("tf.scatterND() expects the updates to be rank 1 or higher,"+" but the rank was ".concat(e.rank,"."));if("int32"!==t.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: ".concat(t.dtype));if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: ".concat(n));if(0===n.length){if(0===t.size)throw new Error("Indices specified for empty output. indices shape: ".concat(t.shape));if(0===e.size)throw new Error("Updates specified for empty output. updates shape: ".concat(e.shape))}!function(e,t,n){var r=t.rank>1?t.shape[t.rank-1]:1,a=t.rank>1?t.rank-1:1,o="Must have updates.shape = indices.shape[:batchDim] + "+"shape[sliceDim:], got updates.shape: ".concat(n.shape)+", indices.shape: ".concat(t.shape,", shape: ").concat(e)+", sliceDim: ".concat(r,", and batchDim: ").concat(a,".");if(n.rank<a)throw new Error(o+" update.rank < ".concat(a,". "));if(e.length<r+(n.rank-a))throw new Error(o+" Output shape length < ".concat(r+(n.rank-a)));if(n.rank!==a+e.length-r)throw new Error(o+" update.rank != ".concat(a+e.length-r));for(var s=0;s<a;++s)if(n.shape[s]!==t.shape[s])throw new Error(o+" updates.shape[".concat(s,"] (").concat(n.shape[s],") != indices.shape[").concat(s,"] (").concat(t.shape[s],")."));for(s=0;s<n.rank-a;++s)if(n.shape[s+a]!==e[s+r])throw new Error(o+" updates.shape[".concat(s+a,"] (").concat(n.shape[s+a],") != shape[").concat(s+a,"] (").concat(e[s+a],")"))}(n,t,e)}var us=rn({scatterND_:function(e,t,n){we(n);var r=en(e,"indices","scatterND","int32"),a=en(t,"updates","scatterND");is(a,r,n);var o={indices:r,updates:a},s={shape:n};return Qt.runKernel("ScatterNd",o,s)}});var ps=rn({sparseToDense_:function(e,t,n,r){void 0===r&&(r=0),we(n);var a=en(e,"sparseIndices","sparseToDense","int32"),o=en(t,"sparseValues","sparseToDense","string_or_numeric"),s=en(r,"defaultValue","sparseToDense",o.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error("tf.sparseToDense() expects the indices to be int32 type,"+" but the dtype was ".concat(e.dtype,"."));if(e.rank>2)throw new Error("sparseIndices should be a scalar, vector, or matrix,"+" but got shape ".concat(e.shape,"."));var a=e.rank>0?e.shape[0]:1,o=e.rank>1?e.shape[1]:1;if(n.length!==o)throw new Error("outputShape has incorrect number of elements:,"+" ".concat(n.length,", should be: ").concat(o,"."));var s=t.size;if(0!==t.rank&&(1!==t.rank||s!==a))throw new Error("sparseValues has incorrect shape "+"".concat(t.shape,", should be [] or [").concat(a,"]"));if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(a,o,n,s);var i={sparseIndices:a,sparseValues:o,defaultValue:s},u={outputShape:n};return Qt.runKernel("SparseToDense",i,u)}});var cs=rn({gatherND_:function(e,t){var n=en(t,"indices","gatherND","int32"),r={params:en(e,"x","gatherND","string_or_numeric"),indices:n};return Qt.runKernel("GatherNd",r)}});var ls=rn({dropout_:function(e,t,n,r){var a=en(e,"x","dropout");if(oe("float32"===a.dtype,(function(){return"x has to be a floating point tensor since it's going to be "+"scaled, but got a ".concat(a.dtype," tensor instead.")})),oe(t>=0&&t<1,(function(){return"rate must be a float in the range [0, 1), but got ".concat(t,".")})),0===t)return e instanceof Rt?a.clone():a;var o=function(e,t){if(null==t)return e.shape.slice();if(pe(e.shape,t))return t;if(e.shape.length===t.length){for(var n=[],r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(a,n),s=1-t,i=br(Hr(un(fo(o,0,1,"float32",r),s)),s);return Fn(a,i)}});function ds(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function hs(e,t,n){for(var r=1-e%2,a=new Float32Array(e),o=0;o<e;++o){var s=2*Math.PI*o/(e+r-1);a[o]=t-n*Math.cos(s)}return Yo(a,"float32")}var fs=function(e,t,n){return void 0===n&&(n=1),u(this,void 0,void 0,(function(){var r,a,o,s,i,u,c,d,h,f,m,y,g,v;return p(this,(function(p){switch(p.label){case 0:return r=en(e,"predictions","inTopK"),a=en(t,"targets","inTopK"),oe(r.rank>1,(function(){return"inTopK() expects the predictions to be of rank 2 or higher, "+"but got ".concat(r.rank)})),oe(r.rank-1===a.rank,(function(){return"predictions rank should be 1 larger than targets rank, but got predictions rank "+"".concat(r.rank," and targets rank ").concat(a.rank)})),se(r.shape.slice(0,r.shape.length-1),a.shape,"predictions's shape should be align with the targets' shape, except the last dimension."),o=r.shape[r.shape.length-1],oe(n>0&&n<=o,(function(){return"'k' passed to inTopK() must be > 0 && <= the predictions last "+"dimension (".concat(o,"), but got ").concat(n)})),[4,r.data()];case 1:return s=p.sent(),[4,a.data()];case 2:for(i=p.sent(),u=l([s.length/o,o],2),c=u[0],d=u[1],h=function(e,t){var n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else{if("bool"!==e)throw new Error("Unknown data type ".concat(e));n=new Uint8Array(t)}return n}("bool",c),f=0;f<c;f++){for(m=f*d,y=s.subarray(m,m+d),g=[],v=0;v<y.length;v++)g.push({value:y[v],index:v});for(g.sort((function(e,t){return t.value-e.value})),h[f]=0,v=0;v<n;v++)if(g[v].index===i[f]){h[f]=1;break}}return e!==r&&r.dispose(),t!==a&&a.dispose(),[2,Qo(h,a.shape,"bool")]}}))}))};var ms=rn({conv2DBackpropFilter_:function(e,t,n,r,a,o,s){void 0===o&&(o="NHWC");var i=e;3===e.rank&&(i=In(e,[1,e.shape[0],e.shape[1],e.shape[2]]));var u=t;3===u.rank&&(u=In(t,[1,t.shape[0],t.shape[1],t.shape[2]])),oe(4===i.rank,(function(){return"Error in conv2dDerFilter: input must be rank 4, but got shape "+"".concat(i.shape,".")})),oe(4===u.rank,(function(){return"Error in conv2dDerFilter: dy must be rank 4, but got shape "+"".concat(u.shape,".")})),oe(4===n.length,(function(){return"Error in conv2dDerFilter: filterShape must be length 4, but got "+"".concat(n,".")}));var p="NHWC"===o?i.shape[3]:i.shape[1],c="NHWC"===o?u.shape[3]:u.shape[1];oe(p===n[2],(function(){return"Error in conv2dDerFilter: depth of input ".concat(p,") must ")+"match input depth in filter (".concat(n[2],".")})),oe(c===n[3],(function(){return"Error in conv2dDerFilter: depth of dy (".concat(c,") must ")+"match output depth for filter (".concat(n[3],").")})),En("conv2dDerFilter",a,s);var l={x:i,dy:u},d={strides:r,pad:a,dataFormat:o,dimRoundingMode:s,filterShape:n};return Qt.runKernel("Conv2DBackpropFilter",l,d)}});function ys(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return Fn(e,Ho(t));throw new Error("Cannot compute gradient for fused activation ".concat(n,"."))}function gs(e,t){var n=t,r=function(e,t){for(var n=[],r=0;r<t.length;r++){var a=e[e.length-r-1],o=t.length-r-1,s=t[o];(null==a||1===a&&s>1)&&n.unshift(o)}return n}(e.shape,t.shape);return r.length>0&&(n=Vr(n,r)),In(n,e.shape)}function vs(e,t,n,r){if("linear"===t)return e;if("relu"===t)return vo(e);if("elu"===t)return Er(e);if("relu6"===t)return bo(e);if("prelu"===t)return qa(e,n);if("leakyrelu"===t)return ea(e,r);if("sigmoid"===t)return Rn(e);throw new Error("Unknown fused activation ".concat(t,"."))}var bs=function(e,t){return!(e>0)||"linear"===t};var xs=rn({fusedConv2d_:function(e){var t,n=e.x,r=e.filter,a=e.strides,o=e.pad,s=e.dataFormat,i=void 0===s?"NHWC":s,u=e.dilations,p=void 0===u?[1,1]:u,c=e.dimRoundingMode,d=e.bias,h=e.activation,f=void 0===h?"linear":h,m=e.preluActivationWeights,y=e.leakyreluAlpha;if(f=f||"linear",!1===bs(Qt.state.gradientDepth,f)){oe("NHWC"===i,(function(){return"Error in fused conv2d: got dataFormat of ".concat(i," but ")+"only NHWC is currently supported for the case of gradient depth is 0 and the activation is not linear."}));var g=nr(n,r,a,o,i,p,c);return null!=d&&(g=un(g,d)),vs(g,f,m,y)}var v=en(n,"x","conv2d","float32"),b=en(r,"filter","conv2d","float32"),x=v,N=!1;3===v.rank&&(N=!0,x=In(v,[1,v.shape[0],v.shape[1],v.shape[2]])),oe(4===x.rank,(function(){return"Error in fused conv2d: input must be rank 4, but got rank "+"".concat(x.rank,".")})),oe(4===b.rank,(function(){return"Error in fused conv2d: filter must be rank 4, but got rank "+"".concat(b.rank,".")})),En("fused conv2d",o,c);var w="NHWC"===i?x.shape[3]:x.shape[1];oe(b.shape[2]===w,(function(){return"Error in conv2d: depth of input (".concat(w,") must match ")+"input depth for filter ".concat(b.shape[2],".")})),oe(_n(a,p),(function(){return"Error in conv2D: Either strides or dilations must be 1. "+"Got strides ".concat(a," and dilations '").concat(p,"'")}));var k,T,_=xn(x.shape,b.shape,a,p,o,c);if(null!=d&&(t=l(qt(k=en(d,"bias","fused conv2d"),v),1),k=t[0],"NHWC"===i?xr(_.outShape,k.shape):(oe(k.shape.length<=1,(function(){return"Error in fused conv2d: only supports scalar or 1-D Tensor bias for NCHW format but got the bias of "+"rank-".concat(k.shape.length,".")})),oe(0===k.shape.length||k.shape[0]===_.outChannels||1===k.shape[0],(function(){return"Error in fused conv2d: bias shape (".concat(k.shape,") is not ")+"compatible with the number of output channels "+"(".concat(_.outChannels,")")})))),null!=m){var S=m.shape;if(oe(S.length<=1||3===S.length,(function(){return"Error in fused conv2d: only supports scalar, 1-D Tensor or 3-D Tensor PReLU activation weights but got a tensor of "+"rank-".concat(S.length,".")})),1===S.length)oe(1===S[0]||S[0]===_.outChannels,(function(){return"Error in fused conv2d: PReLU activation weights "+"(".concat(S,") is not compatible with the number of output ")+"channels (".concat(_.outChannels,").")}));else if(3===S.length)try{xr(S,_.outShape)}catch(e){var E="Error in fused conv2d: PReLU activation weights (".concat(S,") ")+"is not compatible with the output shape of the conv2d "+"(".concat(_.outShape,").");throw Error(E)}T=en(m,"prelu weights","fused conv2d")}var I=function(e,t){oe("NHWC"===i,(function(){return"Error in gradient of fused conv2D: got dataFormat of ".concat(i," but only NHWC is currently supported.")}));var n=l(t,4),r=n[0],s=n[1],u=n[2],c=n[3],d=ys(e,u,f);oe(Tn(p),(function(){return"Error in gradient of fused conv2D: dilation rates greater than 1 "+"are not yet supported in gradients. Got dilations '".concat(p,"'")}));var h=[ar(s.shape,d,r,a,o),ms(s,d,r.shape,a,o)];if(null!=c){var m=gs(c,d);h.push(m)}return h},O={x:x,filter:b,bias:k,preluActivationWeights:T},D={strides:a,pad:o,dataFormat:i,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:y};if(null==d){var A=sa((function(e,t,n){var r=Qt.runKernel(Pe,O,D);return n([t,e,r]),N&&(r=In(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:I}}));return A(x,b)}var M=sa((function(e,t,n,r){var a=Qt.runKernel(Pe,O,D);return r([t,e,a,n]),N&&(a=In(a,[a.shape[1],a.shape[2],a.shape[3]])),{value:a,gradFunc:I}}));return M(x,b,k)}});var Ns=rn({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r,a,o,s){void 0===o&&(o=[1,1]);var i=e;3===e.rank&&(i=In(e,[1,e.shape[0],e.shape[1],e.shape[2]]));var u=t;3===u.rank&&(u=In(t,[1,t.shape[0],t.shape[1],t.shape[2]]));var p={x:i,dy:u},c={strides:r,pad:a,dimRoundingMode:s,dilations:o,filterShape:n};return Qt.runKernel("DepthwiseConv2dNativeBackpropFilter",p,c)}});var ws=rn({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r,a,o,s){void 0===o&&(o=[1,1]);var i=t,u=!1;3===t.rank&&(u=!0,i=In(t,[1,t.shape[0],t.shape[1],t.shape[2]]));var p={dy:i,filter:n},c={strides:r,pad:a,dimRoundingMode:s,dilations:o,inputShape:e},l=Qt.runKernel("DepthwiseConv2dNativeBackpropInput",p,c);return u?In(l,[l.shape[1],l.shape[2],l.shape[3]]):l}});var ks=rn({fusedDepthwiseConv2d_:function(e){var t,n=e.x,r=e.filter,a=e.strides,o=e.pad,s=e.dataFormat,i=void 0===s?"NHWC":s,u=e.dilations,p=void 0===u?[1,1]:u,c=e.dimRoundingMode,d=e.bias,h=e.activation,f=void 0===h?"linear":h,m=e.preluActivationWeights,y=e.leakyreluAlpha;if(!1===bs(Qt.state.gradientDepth,f)){var g=mr(n,r,a,o,i,p,c);return null!=d&&(g=un(g,d)),vs(g,f,m,y)}var v=en(n,"x","depthwiseConv2d","float32"),b=en(r,"filter","depthwiseConv2d","float32"),x=v,N=!1;3===v.rank&&(N=!0,x=In(v,[1,v.shape[0],v.shape[1],v.shape[2]])),oe(4===x.rank,(function(){return"Error in fused depthwiseConv2d: input must be rank 4, but got "+"rank ".concat(x.rank,".")})),oe(4===b.rank,(function(){return"Error in fused depthwiseConv2d: filter must be rank 4, "+"but got rank ".concat(b.rank,".")})),oe(x.shape[3]===b.shape[2],(function(){return"Error in fused depthwiseConv2d: number of input channels "+"(".concat(x.shape[3],") must match the inChannels dimension in ")+"filter ".concat(b.shape[2],".")})),null==p&&(p=[1,1]),oe(_n(a,p),(function(){return"Error in fused depthwiseConv2d: Either strides or dilations must "+"be 1. Got strides ".concat(a," and dilations '").concat(p,"'")})),En("fused depthwiseConv2d",o,c);var w,k,T=xn(x.shape,b.shape,a,p,o,c,!0);null!=d&&(t=l(qt(w=en(d,"bias","fused conv2d"),v),1),w=t[0],xr(T.outShape,w.shape)),null!=m&&(k=en(m,"prelu weights","fused depthwiseConv2d"));var _=function(e,t){oe(Tn(p),(function(){return"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations "+"'".concat(p,"'")}));var n=l(t,4),r=n[0],s=n[1],i=n[2],u=n[3],d=ys(e,i,f),h=ws(s.shape,d,r,a,o,p,c),m=Ns(s,d,r.shape,a,o,p,c);return null!=u?[h,m,gs(w,d)]:[h,m]},S={x:x,filter:b,bias:w,preluActivationWeights:k},E={strides:a,pad:o,dataFormat:i,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:y};if(null==d){var I=sa((function(e,t,n){var r=Qt.runKernel(Be,S,E);return n([t,e,r]),N&&(r=In(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:_}}));return I(x,b)}var O=sa((function(e,t,n,r){var a=Qt.runKernel(Be,S,E);return r([t,e,a,n]),N&&(a=In(a,[a.shape[1],a.shape[2],a.shape[3]])),{value:a,gradFunc:_}}));return O(x,b,w)}});var Ts={__proto__:null,conv2d:xs,depthwiseConv2d:ks,matMul:rn({fusedMatMul_:function(e){var t,n=e.a,r=e.b,a=e.transposeA,o=void 0!==a&&a,s=e.transposeB,i=void 0!==s&&s,u=e.bias,p=e.activation,c=void 0===p?"linear":p,d=e.preluActivationWeights,h=e.leakyreluAlpha,f=void 0===h?.2:h;if(!1===bs(Qt.state.gradientDepth,c)){var m=Cn(n,r,o,i);return null!=u&&(m=un(m,u)),vs(m,c,d,f)}var y=en(n,"a","fused matMul"),g=en(r,"b","fused matMul");t=l(qt(y,g),2),y=t[0],g=t[1];var v=o?y.shape[y.rank-2]:y.shape[y.rank-1],b=i?g.shape[g.rank-1]:g.shape[g.rank-2],x=o?y.shape[y.rank-1]:y.shape[y.rank-2],N=i?g.shape[g.rank-2]:g.shape[g.rank-1],w=y.shape.slice(0,-2),k=g.shape.slice(0,-2),T=ue(w),_=ue(k);oe(v===b,(function(){return"Error in fused matMul: inner shapes (".concat(v,") and (")+"".concat(b,") of Tensors with shapes ").concat(y.shape," and ")+"".concat(g.shape," and transposeA=").concat(o)+" and transposeB=".concat(i," must match.")}));var S,E,I=xr(y.shape.slice(0,-2),g.shape.slice(0,-2)).concat([x,N]),O=In(y,o?[T,v,x]:[T,x,v]),D=In(g,i?[_,N,b]:[_,b,N]);null!=u&&(S=l(qt(S=en(u,"bias","fused matMul"),y),1)[0],xr(I,S.shape)),null!=d&&(E=en(d,"prelu weights","fused matMul"));var A=function(e,t){var n,r,a=l(t,4),s=a[0],p=a[1],d=a[2],h=a[3],f=ys(In(e,d.shape),d,c);return o||i?!o&&i?(n=Cn(f,p,!1,!1),r=Cn(f,s,!0,!1)):o&&!i?(n=Cn(p,f,!1,!0),r=Cn(s,f,!1,!1)):(n=Cn(p,f,!0,!0),r=Cn(f,s,!0,!0)):(n=Cn(f,p,!1,!0),r=Cn(s,f,!0,!1)),null!=u?[n,r,gs(h,f)]:[n,r]},M={a:O,b:D,bias:S,preluActivationWeights:E},C={transposeA:o,transposeB:i,activation:c,leakyreluAlpha:f};if(null==u){var F=sa((function(e,t,n){var r=Qt.runKernel(Le,M,C);return n([e,t,r]),{value:In(r,I),gradFunc:A}}));return F(O,D)}var R=sa((function(e,t,n,r){var a=Qt.runKernel(Le,M,C);return r([e,t,a,n]),{value:In(a,I),gradFunc:A}}));return R(O,D,S)}})};var _s=rn({hammingWindow_:function(e){return hs(e,.54,.46)}});var Ss=rn({hannWindow_:function(e){return hs(e,.5,.5)}});var Es=rn({frame_:function(e,t,n,r,a){void 0===r&&(r=!1),void 0===a&&(a=0);for(var o=0,s=[];o+t<=e.size;)s.push(zn(e,o,t)),o+=n;if(r)for(;o<e.size;){var i=o+t-e.size,u=Mn([zn(e,o,t-i),Qn([i],a)]);s.push(u),o+=n}return 0===s.length?Xo([],[0,t]):In(Mn(s),[s.length,t])}});var Is=rn({stft_:function(e,t,n,r,a){void 0===a&&(a=Ss),null==r&&(r=ds(t));var o=Es(e,t,n),s=Fn(o,a(t));return jo(s,r)}});var Os=rn({cropAndResize_:function(e,t,n,r,a,o){void 0===a&&(a="bilinear"),void 0===o&&(o=0);var s=en(e,"image","cropAndResize"),i=en(t,"boxes","cropAndResize","float32"),u=en(n,"boxInd","cropAndResize","int32"),p=i.shape[0];oe(4===s.rank,(function(){return"Error in cropAndResize: image must be rank 4,"+"but got rank ".concat(s.rank,".")})),oe(2===i.rank&&4===i.shape[1],(function(){return"Error in cropAndResize: boxes must be have size [".concat(p,",4] ")+"but had shape ".concat(i.shape,".")})),oe(1===u.rank&&u.shape[0]===p,(function(){return"Error in cropAndResize: boxInd must be have size [".concat(p,"] ")+"but had shape ".concat(i.shape,".")})),oe(2===r.length,(function(){return"Error in cropAndResize: cropSize must be of length 2, but got "+"length ".concat(r.length,".")})),oe(r[0]>=1&&r[1]>=1,(function(){return"cropSize must be atleast [1,1], but was ".concat(r)})),oe("bilinear"===a||"nearest"===a,(function(){return"method must be bilinear or nearest, but was ".concat(a)}));var c={image:s,boxes:i,boxInd:u},l={method:a,extrapolationValue:o,cropSize:r};return Qt.runKernel("CropAndResize",c,l)}});var Ds=rn({flipLeftRight_:function(e){var t=en(e,"image","flipLeftRight","float32");oe(4===t.rank,(function(){return"Error in flipLeftRight: image must be rank 4,"+"but got rank ".concat(t.rank,".")}));var n={image:t};return Qt.runKernel("FlipLeftRight",n,{})}});var As=rn({grayscaleToRGB_:function(e){var t=en(e,"image","grayscaleToRGB"),n=t.rank-1,r=t.shape[n];oe(t.rank>=2,(function(){return"Error in grayscaleToRGB: images must be at least rank 2, "+"but got rank ".concat(t.rank,".")})),oe(1===r,(function(){return"Error in grayscaleToRGB: last dimension of a grayscale image "+"should be size 1, but got size ".concat(r,".")}));var a=new Array(t.rank);return a.fill(1,0,n),a[n]=3,Ur(t,a)}});var Ms=rn({rotateWithOffset_:function(e,t,n,r){void 0===n&&(n=0),void 0===r&&(r=.5);var a=en(e,"image","rotateWithOffset","float32");oe(4===a.rank,(function(){return"Error in rotateWithOffset: image must be rank 4,"+"but got rank ".concat(a.rank,".")}));var o={image:a},s={radians:t,fillValue:n,center:r};return Qt.runKernel("RotateWithOffset",o,s)}});function Cs(e,t,n,r,a,o){null==r&&(r=.5),null==a&&(a=Number.NEGATIVE_INFINITY),null==o&&(o=0);var s=e.shape[0];return n=Math.min(n,s),oe(0<=r&&r<=1,(function(){return"iouThreshold must be in [0, 1], but was '".concat(r,"'")})),oe(2===e.rank,(function(){return"boxes must be a 2D tensor, but was of rank '".concat(e.rank,"'")})),oe(4===e.shape[1],(function(){return"boxes must have 4 columns, but 2nd dimension was ".concat(e.shape[1])})),oe(1===t.rank,(function(){return"scores must be a 1D tensor"})),oe(t.shape[0]===s,(function(){return"scores has incompatible shape with boxes. Expected ".concat(s,", ")+"but was ".concat(t.shape[0])})),oe(0<=o&&o<=1,(function(){return"softNmsSigma must be in [0, 1], but was '".concat(o,"'")})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:a,softNmsSigma:o}}var Fs=rn({nonMaxSuppression_:function(e,t,n,r,a){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY);var o=en(e,"boxes","nonMaxSuppression","float32"),s=en(t,"scores","nonMaxSuppression","float32"),i=Cs(o,s,n,r,a),u={maxOutputSize:n=i.maxOutputSize,iouThreshold:r=i.iouThreshold,scoreThreshold:a=i.scoreThreshold};return Qt.runKernel("NonMaxSuppressionV3",{boxes:o,scores:s},u)}});function Rs(e,t,n){var r=function(e,t,n){return function(e,t,n){var r=0,a=e.length,o=0,s=!1;for(;r<a;){var i=n(t,e[o=r+(a-r>>>1)]);i>0?r=o+1:(a=o,s=!i)}return s?r:-r-1}(e,t,n||zs)}(e,t,n),a=r<0?-(r+1):r;e.splice(a,0,t)}function zs(e,t){return e>t?1:e<t?-1:0}function Vs(e,t,n,r,a,o,s,i,u){void 0===s&&(s=!1),void 0===i&&(i=!1),void 0===u&&(u=!1);for(var p=[],c=0;c<t.length;c++)t[c]>a&&p.push({score:t[c],boxIndex:c,suppressBeginIndex:0});p.sort(Bs);for(var h=o>0?-.5/o:0,f=[],m=[];f.length<n&&p.length>0;){var y=p.pop(),g=y.score,v=y.boxIndex,b=y.suppressBeginIndex;if(g<a)break;for(var x=!1,N=f.length-1;N>=b;--N){var w=Ls(e,v,f[N]);if(w>=r){x=!0;break}if(y.score=y.score*Ps(r,h,w),y.score<=a)break}y.suppressBeginIndex=f.length,x||(y.score===g?(f.push(v),m.push(y.score)):y.score>a&&Rs(p,y,Bs))}var k=f.length,T=n-k;i&&T>0&&(f.push.apply(f,d([],l(new Array(T).fill(0)),!1)),m.push.apply(m,d([],l(new Array(T).fill(0)),!1)));var _={selectedIndices:f};return s&&(_.selectedScores=m),u&&(_.validOutputs=k),_}function Ls(e,t,n){var r=e.subarray(4*t,4*t+4),a=e.subarray(4*n,4*n+4),o=Math.min(r[0],r[2]),s=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),p=Math.min(a[0],a[2]),c=Math.min(a[1],a[3]),l=Math.max(a[0],a[2]),d=Math.max(a[1],a[3]),h=(i-o)*(u-s),f=(l-p)*(d-c);if(h<=0||f<=0)return 0;var m=Math.max(o,p),y=Math.max(s,c),g=Math.min(i,l),v=Math.min(u,d),b=Math.max(g-m,0)*Math.max(v-y,0);return b/(h+f-b)}function Ps(e,t,n){var r=Math.exp(t*n*n);return n<=e?r:0}function Bs(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}var Ks=function(e,t,n,r,a){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),u(this,void 0,void 0,(function(){var o,s,i,u,c,l,d;return p(this,(function(p){switch(p.label){case 0:return o=en(e,"boxes","nonMaxSuppressionAsync"),s=en(t,"scores","nonMaxSuppressionAsync"),i=Cs(o,s,n,r,a),n=i.maxOutputSize,r=i.iouThreshold,a=i.scoreThreshold,[4,Promise.all([o.data(),s.data()])];case 1:return u=p.sent(),c=u[0],l=u[1],d=function(e,t,n,r,a){return Vs(e,t,n,r,a,0)}(c,l,n,r,a).selectedIndices,o!==e&&o.dispose(),s!==t&&s.dispose(),[2,Yo(d,"int32")]}}))}))};var js=rn({nonMaxSuppressionWithScore_:function(e,t,n,r,a,o){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=0);var s=en(e,"boxes","nonMaxSuppression"),i=en(t,"scores","nonMaxSuppression"),u=Cs(s,i,n,r,a,o),p={boxes:s,scores:i},c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:a=u.scoreThreshold,softNmsSigma:o=u.softNmsSigma},l=Qt.runKernel("NonMaxSuppressionV5",p,c);return{selectedIndices:l[0],selectedScores:l[1]}}});var qs=function(e,t,n,r,a,o){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=0),u(this,void 0,void 0,(function(){var s,i,u,c,l,d,h,f,m;return p(this,(function(p){switch(p.label){case 0:return s=en(e,"boxes","nonMaxSuppressionAsync"),i=en(t,"scores","nonMaxSuppressionAsync"),u=Cs(s,i,n,r,a,o),n=u.maxOutputSize,r=u.iouThreshold,a=u.scoreThreshold,o=u.softNmsSigma,[4,Promise.all([s.data(),i.data()])];case 1:return c=p.sent(),l=c[0],d=c[1],h=function(e,t,n,r,a,o){return Vs(e,t,n,r,a,o,!0)}(l,d,n,r,a,o),f=h.selectedIndices,m=h.selectedScores,s!==e&&s.dispose(),i!==t&&i.dispose(),[2,{selectedIndices:Yo(f,"int32"),selectedScores:Yo(m)}]}}))}))};var Us=rn({nonMaxSuppressionPadded_:function(e,t,n,r,a,o){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=!1);var s=en(e,"boxes","nonMaxSuppression"),i=en(t,"scores","nonMaxSuppression"),u=Cs(s,i,n,r,a,null),p={boxes:s,scores:i},c={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:o},l=Qt.runKernel("NonMaxSuppressionV4",p,c);return{selectedIndices:l[0],validOutputs:l[1]}}});var Ws=function(e,t,n,r,a,o){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=!1),u(this,void 0,void 0,(function(){var s,i,u,c,d,h,f,m,y,g,v,b;return p(this,(function(p){switch(p.label){case 0:return s=en(e,"boxes","nonMaxSuppressionAsync"),i=en(t,"scores","nonMaxSuppressionAsync"),u=Cs(s,i,n,r,a,null),c=u.maxOutputSize,d=u.iouThreshold,h=u.scoreThreshold,[4,Promise.all([s.data(),i.data()])];case 1:return f=l.apply(void 0,[p.sent(),2]),m=f[0],y=f[1],g=function(e,t,n,r,a,o){return Vs(e,t,n,r,a,0,!1,o,!0)}(m,y,c,d,h,o),v=g.selectedIndices,b=g.validOutputs,s!==e&&s.dispose(),i!==t&&i.dispose(),[2,{selectedIndices:Yo(v,"int32"),validOutputs:Fr(b,"int32")}]}}))}))};var Hs=rn({resizeBilinear_:function(e,t,n,r){void 0===n&&(n=!1),void 0===r&&(r=!1);var a=en(e,"images","resizeBilinear");oe(3===a.rank||4===a.rank,(function(){return"Error in resizeBilinear: x must be rank 3 or 4, but got "+"rank ".concat(a.rank,".")})),oe(2===t.length,(function(){return"Error in resizeBilinear: new shape must 2D, but got shape "+"".concat(t,".")})),oe(!1===r||!1===n,(function(){return"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false."}));var o=a,s=!1;3===a.rank&&(s=!0,o=In(a,[1,a.shape[0],a.shape[1],a.shape[2]])),l(t,0);var i={images:o},u={alignCorners:n,halfPixelCenters:r,size:t},p=Qt.runKernel("ResizeBilinear",i,u);return s?In(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});var Gs=rn({resizeNearestNeighbor_:function(e,t,n,r){void 0===n&&(n=!1),void 0===r&&(r=!1);var a=en(e,"images","resizeNearestNeighbor");oe(3===a.rank||4===a.rank,(function(){return"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got "+"rank ".concat(a.rank,".")})),oe(2===t.length,(function(){return"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+"".concat(t,".")})),oe("float32"===a.dtype||"int32"===a.dtype,(function(){return"`images` must have `int32` or `float32` as dtype"})),oe(!1===r||!1===n,(function(){return"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false."}));var o=a,s=!1;3===a.rank&&(s=!0,o=In(a,[1,a.shape[0],a.shape[1],a.shape[2]])),l(t,0);var i={images:o},u={alignCorners:n,halfPixelCenters:r,size:t},p=Qt.runKernel("ResizeNearestNeighbor",i,u);return s?In(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});var Zs=rn({threshold_:function(e,t,n,r){var a;void 0===t&&(t="binary"),void 0===n&&(n=!1),void 0===r&&(r=.5);var o,s,i,u,p=en(e,"image","threshold"),c=p.shape[0]*p.shape[1],d=Fn(Yo([r]),255);if(oe(3===p.rank,(function(){return"Error in threshold: image must be rank 3,"+"but got rank ".concat(p.rank,".")})),oe(3===p.shape[2]||1===p.shape[2],(function(){return"Error in threshold: image color channel must be equal to 3 or 1"+"but got ".concat(p.shape[2],".")})),oe("int32"===p.dtype||"float32"===p.dtype,(function(){return"Error in dtype: image dtype must be int32 or float32,"+"but got dtype ".concat(p.dtype,".")})),oe("otsu"===t||"binary"===t,(function(){return"Method must be binary or otsu, but was ".concat(t)})),3===p.shape[2]){o=(a=l(Ko(p,[1,1,1],-1),3))[0],s=a[1],i=a[2];var h=Fn(o,.2989),f=Fn(s,.587),m=Fn(i,.114);u=un(un(h,f),m)}else u=e;"otsu"===t&&(d=function(e,t){for(var n,r,a,o,s,i,u=Yo([-1]),p=Yo([0]),c=Yo([0]),l=0;l<e.size-1;l++){n=zn(e,0,l+1),r=zn(e,l+1),s=br(Vr(n),t),i=br(Vr(r),t);var d=Vr(Fn(n,mo(0,n.size)));a=br(d,Vr(n));var h=Qn(r.shape,n.size),f=un(mo(0,r.size),h),m=Fn(r,f);o=br(Vr(m),Vr(r));var y=ca(a,o),g=ca(a,o),v=Fn(s,i);c=Fn(Fn(v,y),g);var b=Zr(c,p);p=wr(b,c,p),u=wr(b,Yo([l]),u)}return u}(Un(bn(_o(u),"int32"),Qo([]),256),c));var y=n?na(u,d):Zr(u,d);return bn(Fn(y,255),"int32")}});var Qs=rn({transform_:function(e,t,n,r,a,o){void 0===n&&(n="nearest"),void 0===r&&(r="constant"),void 0===a&&(a=0);var s=en(e,"image","transform","float32"),i=en(t,"transforms","transform","float32");oe(4===s.rank,(function(){return"Error in transform: image must be rank 4,"+"but got rank ".concat(s.rank,".")})),oe(2===i.rank&&(i.shape[0]===s.shape[0]||1===i.shape[0])&&8===i.shape[1],(function(){return"Error in transform: Input transform should be batch x 8 or 1 x 8"})),oe(null==o||2===o.length,(function(){return"Error in transform: outputShape must be [height, width] or null, "+"but got ".concat(o,".")}));var u={image:s,transforms:i},p={interpolation:n,fillMode:r,fillValue:a,outputShape:o};return Qt.runKernel("Transform",u,p)}});var Ys=rn({bandPart_:function(e,t,n){oe(t%1==0,(function(){return"bandPart(): numLower must be an integer, got ".concat(t,".")})),oe(n%1==0,(function(){return"bandPart(): numUpper must be an integer, got ".concat(n,".")}));var r=en(e,"a","bandPart");oe(r.rank>=2,(function(){return"bandPart(): Rank must be at least 2, got ".concat(r.rank,".")}));var a=r.shape,o=l(r.shape.slice(-2),2),s=o[0],i=o[1];if(!(t<=s))throw new Error("bandPart(): numLower (".concat(t,")")+" must not be greater than the number of rows (".concat(s,")."));if(!(n<=i))throw new Error("bandPart(): numUpper (".concat(n,")")+" must not be greater than the number of columns (".concat(i,")."));t<0&&(t=s),n<0&&(n=i);var u=In(mo(0,s,1,"int32"),[-1,1]),p=mo(0,i,1,"int32"),c=ca(u,p),d=ha(na(c,Fr(+t,"int32")),Qr(c,Fr(-n,"int32"))),h=Ta([s,i],r.dtype);return In(Wo(ns(In(r,[-1,s,i])).map((function(e){return wr(d,e,h)}))),a)}});var Xs=rn({gramSchmidt_:function(e){var t;if(Array.isArray(e)){t=!1,oe(null!=e&&e.length>0,(function(){return"Gram-Schmidt process: input must not be null, undefined, or empty"}));for(var n=e[0].shape[0],r=function(t){oe(e[t].shape[0]===n,(function(){return"Gram-Schmidt: Non-unique lengths found in the input vectors: "+"(".concat(e[t].shape[0]," vs. ").concat(n,")")}))},a=1;a<e.length;++a)r(a)}else t=!0,e=Ko(e,e.shape[0],0).map((function(e){return Uo(e,[0])}));oe(e.length<=e[0].shape[0],(function(){return"Gram-Schmidt: Number of vectors (".concat(e.length,") exceeds ")+"number of dimensions (".concat(e[0].shape[0],").")}));var o=[],s=e,i=function(e){o.push(Qt.tidy((function(){var t=s[e];if(e>0)for(var n=0;n<e;++n){var r=Fn(Vr(Fn(o[n],t)),o[n]);t=ca(t,r)}return br(t,Pr(t,"euclidean"))})))};for(a=0;a<e.length;++a)i(a);return t?Wo(o,0):o}});function Js(e,t){return void 0===t&&(t=!1),Qt.tidy((function(){oe(2===e.shape.length,(function(){return"qr2d() requires a 2D Tensor, but got a ".concat(e.shape.length,"D Tensor.")}));for(var n=e.shape[0],r=e.shape[1],a=Wr(n),o=An(e),s=Xo([[1]],[1,1]),i=An(s),u=n>=r?r:n,p=function(e){var t,u=o,p=i,c=a;t=l(Qt.tidy((function(){var t=zn(o,[e,e],[n-e,1]),u=Pr(t),p=zn(o,[e,e],[1,1]),c=wr(Zr(p,0),Xo([[-1]]),Xo([[1]])),l=ca(p,Fn(c,u)),d=br(t,l);i=1===d.shape[0]?An(s):Mn([s,zn(d,[1,0],[d.shape[0]-1,d.shape[1]])],0);var h=ia(br(Cn(c,l),u)),f=zn(o,[e,0],[n-e,r]),m=Fn(h,i),y=os(i);if(0===e)o=ca(f,Cn(m,Cn(y,f)));else{var g=ca(f,Cn(m,Cn(y,f)));o=Mn([zn(o,[0,0],[e,r]),g],0)}var v=os(m),b=zn(a,[0,e],[n,a.shape[1]-e]);if(0===e)a=ca(b,Cn(Cn(b,i),v));else{var x=ca(b,Cn(Cn(b,i),v));a=Mn([zn(a,[0,0],[n,e]),x],1)}return[i,o,a]})),3),i=t[0],o=t[1],a=t[2],Ut([u,p,c]).forEach((function(e){return e.dispose()}))},c=0;c<u;++c)p(c);return!t&&n>r&&(a=zn(a,[0,0],[n,r]),o=zn(o,[0,0],[r,r])),[a,o]}))}var $s,ei=rn({qr_:function(e,t){if(void 0===t&&(t=!1),oe(e.rank>=2,(function(){return"qr() requires input tensor to have a rank >= 2, but got rank ".concat(e.rank)})),2===e.rank)return Js(e,t);var n=e.shape.slice(0,e.shape.length-2).reduce((function(e,t){return e*t})),r=ns(In(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),a=[],o=[];return r.forEach((function(e){var n=l(Js(e,t),2),r=n[0],s=n[1];a.push(r),o.push(s)})),[In(Wo(a,0),e.shape),In(Wo(o,0),e.shape)]}});!function(e){e[e.NONE=0]="NONE",e[e.MEAN=1]="MEAN",e[e.SUM=2]="SUM",e[e.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}($s||($s={}));var ti=rn({computeWeightedLoss_:function(e,t,n){void 0===n&&(n=$s.SUM_BY_NONZERO_WEIGHTS);var r=en(e,"losses","computeWeightedLoss"),a=null;null!=t&&(a=en(t,"weights","computeWeightedLoss"));var o=null==a?r:Fn(r,a);if(n===$s.NONE)return o;if(n===$s.SUM)return Vr(o);if(n===$s.MEAN){if(null==a)return ka(o);var s=r.size/a.size,i=br(Vr(o),Vr(a));return s>1?br(i,Fr(s)):i}if(n===$s.SUM_BY_NONZERO_WEIGHTS){if(null==a)return br(Vr(o),Fr(r.size));var u=Fn(a,_a(r.shape)),p=bn(Vr(Ma(u,Fr(0))),"float32");return br(Vr(o),p)}throw Error("Unknown reduction: ".concat(n))}});var ni=rn({absoluteDifference_:function(e,t,n,r){void 0===r&&(r=$s.SUM_BY_NONZERO_WEIGHTS);var a=en(e,"labels","absoluteDifference"),o=en(t,"predictions","absoluteDifference"),s=null;null!=n&&(s=en(n,"weights","absoluteDifference")),se(a.shape,o.shape,"Error in absoluteDifference: ");var i=an(ca(a,o));return ti(i,s,r)}});var ri=rn({cosineDistance_:function(e,t,n,r,a){void 0===a&&(a=$s.SUM_BY_NONZERO_WEIGHTS);var o=en(e,"labels","cosineDistance"),s=en(t,"predictions","cosineDistance"),i=null;null!=r&&(i=en(r,"weights","cosineDistance")),se(o.shape,s.shape,"Error in cosineDistance: ");var u=Fr(1),p=ca(u,Vr(Fn(o,s),n,!0));return ti(p,i,a)}});var ai=rn({hingeLoss_:function(e,t,n,r){void 0===r&&(r=$s.SUM_BY_NONZERO_WEIGHTS);var a=en(e,"labels","hingeLoss"),o=en(t,"predictions","hingeLoss"),s=null;null!=n&&(s=en(n,"weights","hingeLoss")),se(a.shape,o.shape,"Error in hingeLoss: ");var i=Fr(1);a=ca(Fn(Fr(2),a),i);var u=vo(ca(i,Fn(a,o)));return ti(u,s,r)}});var oi=rn({huberLoss_:function(e,t,n,r,a){void 0===r&&(r=1),void 0===a&&(a=$s.SUM_BY_NONZERO_WEIGHTS);var o=en(e,"labels","huberLoss"),s=en(t,"predictions","huberLoss"),i=null;null!=n&&(i=en(n,"weights","huberLoss")),se(o.shape,s.shape,"Error in huberLoss: ");var u=Fr(r),p=an(ca(s,o)),c=Sa(p,u),l=ca(p,c),d=un(Fn(Fr(.5),zr(c)),Fn(u,l));return ti(d,i,a)}});var si=rn({logLoss_:function(e,t,n,r,a){void 0===r&&(r=1e-7),void 0===a&&(a=$s.SUM_BY_NONZERO_WEIGHTS);var o=en(e,"labels","logLoss"),s=en(t,"predictions","logLoss"),i=null;null!=n&&(i=en(n,"weights","logLoss")),se(o.shape,s.shape,"Error in logLoss: ");var u=Fr(1),p=Fr(r),c=ia(Fn(o,aa(un(s,p)))),l=Fn(ca(u,o),aa(un(ca(u,s),p))),d=ca(c,l);return ti(d,i,a)}});var ii=rn({meanSquaredError_:function(e,t,n,r){void 0===r&&(r=$s.SUM_BY_NONZERO_WEIGHTS);var a=en(e,"labels","meanSquaredError"),o=en(t,"predictions","meanSquaredError"),s=null;null!=n&&(s=en(n,"weights","meanSquaredError")),se(a.shape,o.shape,"Error in meanSquaredError: ");var i=qo(a,o);return ti(i,s,r)}});var ui=rn({sigmoidCrossEntropy_:function(e,t,n,r,a){void 0===r&&(r=0),void 0===a&&(a=$s.SUM_BY_NONZERO_WEIGHTS);var o=en(e,"multiClassLabels","sigmoidCrossEntropy"),s=en(t,"logits","sigmoidCrossEntropy"),i=null;if(null!=n&&(i=en(n,"weights","sigmoidCrossEntropy")),se(o.shape,s.shape,"Error in sigmoidCrossEntropy: "),r>0){var u=Fr(r),p=Fr(1),c=Fr(.5);o=un(Fn(o,ca(p,u)),Fn(c,u))}var l=function(e,t){var n=en(e,"labels","sigmoidCrossEntropyWithLogits"),r=en(t,"logits","sigmoidCrossEntropyWithLogits");se(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");var a=vo(r),o=Fn(r,n),s=oa(Kr(ia(an(r))));return un(ca(a,o),s)}(o,s);return ti(l,i,a)}});var pi=rn({softmaxCrossEntropy_:function(e,t,n,r,a){void 0===r&&(r=0),void 0===a&&(a=$s.SUM_BY_NONZERO_WEIGHTS);var o=en(e,"onehotLabels","softmaxCrossEntropy"),s=en(t,"logits","softmaxCrossEntropy"),i=null;if(null!=n&&(i=en(n,"weights","softmaxCrossEntropy")),se(o.shape,s.shape,"Error in softmaxCrossEntropy: "),r>0){var u=Fr(r),p=Fr(1),c=Fr(o.shape[1]);o=un(Fn(o,ca(p,u)),br(u,c))}var d=function(e,t,n){if(void 0===n&&(n=-1),-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error("Softmax cross entropy along a non-last dimension is not yet "+"supported. Labels / logits was rank ".concat(t.rank," ")+"and dim was ".concat(n));var r=sa((function(e,t,r){var a=da(t,[n],!0),o=ca(bn(t,"float32"),a);r([e,o]);var s=ia(Fn(o,e));return{value:Vr(s,[n]),gradFunc:function(e,t){var r=l(t,2),a=r[0],o=r[1],s=Or(e.shape,[n]);return[Fn(In(e,s),ca(bn(a,"float32"),Kr(o))),Fn(In(e,s),ca(Kr(o),bn(a,"float32")))]}}}));return r(e,t)}(o,s);return ti(d,i,a)}});var ci=rn({sparseFillEmptyRows_:function(e,t,n,r){var a=en(e,"indices","sparseFillEmptyRows","int32"),o=en(t,"values","sparseFillEmptyRows"),s=en(n,"denseShape","sparseFillEmptyRows","int32"),i=en(r,"defaultValue","sparseFillEmptyRows",o.dtype);if(2!==a.rank)throw new Error("Indices should be Tensor2D but received shape\n        ".concat(a.shape));if(1!==o.rank)throw new Error("Values should be Tensor1D but received shape ".concat(o.shape));if(1!==s.rank)throw new Error("Dense shape should be Tensor1D but received shape ".concat(s.shape));if(0!==i.rank)throw new Error("Default value should be a scalar but received shape ".concat(i.shape));var u={indices:a,values:o,denseShape:s,defaultValue:i},p=Qt.runKernel("SparseFillEmptyRows",u);return{outputIndices:p[0],outputValues:p[1],emptyRowIndicator:p[2],reverseIndexMap:p[3]}}});var li=rn({sparseReshape_:function(e,t,n){var r=en(e,"inputIndices","sparseReshape","int32"),a=en(t,"inputShape","sparseReshape","int32"),o=en(n,"newShape","sparseReshape","int32");if(2!==r.rank)throw new Error("Input indices should be Tensor2D but received shape\n        ".concat(r.shape));if(1!==a.rank)throw new Error("Input shape should be Tensor1D but received shape ".concat(a.shape));if(1!==o.rank)throw new Error("New shape should be Tensor1D but received shape ".concat(o.shape));var s={inputIndices:r,inputShape:a,newShape:o},i=Qt.runKernel("SparseReshape",s);return{outputIndices:i[0],outputShape:i[1]}}});var di=rn({sparseSegmentMean_:function(e,t,n){var r=en(e,"data","sparseSegmentMean"),a=en(t,"indices","sparseSegmentMean","int32"),o=en(n,"segmentIds","sparseSegmentMean","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==a.rank)throw new Error("Indices should be Tensor1D but received shape\n          ".concat(a.shape));if(1!==o.rank)throw new Error("Segment ids should be Tensor1D but received shape\n          ".concat(o.shape));var s={data:r,indices:a,segmentIds:o};return Qt.runKernel("SparseSegmentMean",s)}});var hi=rn({sparseSegmentSum_:function(e,t,n){var r=en(e,"data","sparseSegmentSum"),a=en(t,"indices","sparseSegmentSum","int32"),o=en(n,"segmentIds","sparseSegmentSum","int32");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==a.rank)throw new Error("Indices should be Tensor1D but received shape\n         ".concat(a.shape));if(1!==o.rank)throw new Error("Segment ids should be Tensor1D but received shape\n         ".concat(o.shape));var s={data:r,indices:a,segmentIds:o};return Qt.runKernel("SparseSegmentSum",s)}});var fi=rn({stringNGrams_:function(e,t,n,r,a,o,s,i){var u=en(e,"data","stringNGrams","string");if("string"!==u.dtype)throw new Error("Data must be of datatype string");if(1!==u.shape.length)throw new Error("Data must be a vector, saw: ".concat(u.shape));var p=en(t,"dataSplits","stringNGrams");if("int32"!==p.dtype)throw new Error("Data splits must be of datatype int32");var c={separator:n,nGramWidths:r,leftPad:a,rightPad:o,padWidth:s,preserveShortSequences:i},l={data:u,dataSplits:p},d=Qt.runKernel("StringNGrams",l,c);return{nGrams:d[0],nGramsSplits:d[1]}}});var mi={__proto__:null,abs:an,acos:on,acosh:sn,add:un,addN:pn,all:cn,any:ln,argMax:dn,argMin:hn,asin:fn,asinh:mn,atan:yn,atan2:gn,atanh:vn,avgPool:On,avgPool3d:Dn,basicLSTMCell:Ln,batchToSpaceND:Pn,batchNorm:Bn,batchNorm2d:Kn,batchNorm3d:jn,batchNorm4d:qn,bincount:Un,broadcastArgs:Wn,broadcastTo:Hn,buffer:Gn,cast:bn,ceil:Zn,clipByValue:Yn,clone:An,complex:Xn,concat:Mn,concat1d:Jn,concat2d:$n,concat3d:er,concat4d:tr,conv1d:rr,conv2d:nr,conv2dTranspose:or,conv3d:sr,conv3dTranspose:ur,cos:pr,cosh:cr,cumprod:lr,cumsum:dr,denseBincount:hr,depthToSpace:fr,depthwiseConv2d:mr,diag:yr,dilation2d:gr,div:br,divNoNan:Tr,dot:_r,einsum:Sr,elu:Er,equal:Nr,erf:Ir,euclideanNorm:Br,exp:Kr,expandDims:jr,expm1:qr,eye:Wr,fill:Qn,floor:Hr,floorDiv:vr,gather:Gr,greater:Zr,greaterEqual:Qr,imag:Yr,isFinite:Xr,isInf:Jr,isNaN:$r,leakyRelu:ea,less:ta,lessEqual:na,linspace:function(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");var r={start:e,stop:t,num:n};return Qt.runKernel("LinSpace",{},r)},localResponseNormalization:ra,log:aa,log1p:oa,logSigmoid:pa,logSoftmax:la,logSumExp:da,logicalAnd:ha,logicalNot:fa,logicalOr:ma,logicalXor:ya,lowerBound:function(e,t){return va(e,t,"left")},matMul:Cn,max:Dr,maxPool:ba,maxPool3d:xa,maxPoolWithArgmax:Na,maximum:wa,mean:ka,meshgrid:function(e,t,n){var r=(void 0===n?{}:n).indexing,a=void 0===r?"xy":r;if("xy"!==a&&"ij"!==a)throw new TypeError("".concat(a," is not a valid third argument to meshgrid"));if(void 0===e)return[];var o=en(e,"x","meshgrid",e instanceof Rt?e.dtype:"float32");if(void 0===t)return[o];var s=en(t,"y","meshgrid",t instanceof Rt?t.dtype:"float32"),i=ue(o.shape),u=ue(s.shape);return"xy"===a?(o=In(o,[1,-1]),s=In(s,[-1,1]),[Cn(_a([u,1],o.dtype),o),Cn(s,_a([1,i],s.dtype))]):(o=In(o,[-1,1]),s=In(s,[1,-1]),[Cn(o,_a([1,u],o.dtype)),Cn(_a([i,1],s.dtype),s)])},min:Ar,minimum:Sa,mirrorPad:Ea,mod:Ia,moments:Oa,mul:Fn,multiRNNCell:Da,multinomial:Aa,neg:ia,notEqual:Ma,oneHot:Ca,ones:_a,onesLike:Fa,outerProduct:Ra,pad:za,pad1d:Va,pad2d:La,pad3d:Pa,pad4d:Ba,pool:ja,pow:Mr,prelu:qa,print:function(e,t){void 0===t&&(t=!1),console.log(e.toString(t))},prod:Ua,raggedGather:Wa,raggedRange:Ha,raggedTensorToTensor:Ga,rand:Za,randomGamma:co,randomNormal:lo,randomStandardNormal:ho,randomUniform:fo,range:mo,real:yo,reciprocal:go,relu:vo,relu6:bo,reshape:In,reverse:xo,reverse1d:No,reverse2d:wo,reverse3d:ko,reverse4d:To,round:_o,rsqrt:So,scalar:Fr,selu:Eo,separableConv2d:Io,setdiff1dAsync:Oo,sigmoid:Rn,sign:Do,sin:Ao,sinh:Mo,slice:zn,slice1d:Co,slice2d:Fo,slice3d:Ro,slice4d:zo,softmax:Vo,softplus:ua,spaceToBatchND:Ka,fft:Lo,ifft:Po,irfft:Bo,rfft:jo,split:Ko,sqrt:Rr,square:zr,squaredDifference:qo,squeeze:Uo,stack:Wo,step:Ho,stridedSlice:Go,sub:ca,sum:Vr,tan:Zo,tanh:Vn,tensor:Qo,tensor1d:Yo,tensor2d:Xo,tensor3d:function(e,t,n){if(ie(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");var r=Xt(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return Cr(e,t,r,n)},tensor4d:function(e,t,n){if(ie(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");var r=Xt(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return Cr(e,t,r,n)},tensor5d:function(e,t,n){if(ie(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");var r=Xt(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return Cr(e,t,r,n)},tensor6d:function(e,t,n){if(ie(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");var r=Xt(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return Cr(e,t=t||r,r,n)},tile:Ur,topk:Jo,truncatedNormal:$o,unique:es,unsortedSegmentSum:ts,unstack:ns,upperBound:function(e,t){return va(e,t,"right")},variable:function(e,t,n,r){return void 0===t&&(t=!0),Qt.makeVariable(e,t,n,r)},where:wr,whereAsync:rs,zeros:Ta,zerosLike:kr,op:rn,OP_SCOPE_SUFFIX:nn,booleanMaskAsync:as,transpose:os,norm:Pr,movingAverage:ss,scatterND:us,searchSorted:va,sparseToDense:ps,gatherND:cs,dropout:ls,enclosingPowerOfTwo:ds,cosineWindow:hs,inTopKAsync:fs,image:{flipLeftRight:Ds,grayscaleToRGB:As,resizeNearestNeighbor:Gs,resizeBilinear:Hs,rotateWithOffset:Ms,cropAndResize:Os,nonMaxSuppression:Fs,nonMaxSuppressionAsync:Ks,nonMaxSuppressionWithScore:js,nonMaxSuppressionWithScoreAsync:qs,nonMaxSuppressionPadded:Us,nonMaxSuppressionPaddedAsync:Ws,threshold:Zs,transform:Qs},linalg:{bandPart:Ys,gramSchmidt:Xs,qr:ei},losses:{absoluteDifference:ni,computeWeightedLoss:ti,cosineDistance:ri,hingeLoss:ai,huberLoss:oi,logLoss:si,meanSquaredError:ii,sigmoidCrossEntropy:ui,softmaxCrossEntropy:pi},spectral:{fft:Lo,ifft:Po,rfft:jo,irfft:Bo},fused:Ts,signal:{hammingWindow:_s,hannWindow:Ss,frame:Es,stft:Is},sparse:{sparseFillEmptyRows:ci,sparseReshape:li,sparseSegmentMean:di,sparseSegmentSum:hi},string:{stringNGrams:fi,stringSplit:rn({stringSplit_:function(e,t,n){void 0===n&&(n=!0);var r=en(e,"input","stringSplit","string"),a=en(t,"delimiter","stringSplit","string");if(1!==r.rank)throw new Error("Input should be Tensor1D but received shape ".concat(r.shape));if(0!==a.rank)throw new Error("Delimiter should be a scalar but received shape ".concat(a.shape));var o={skipEmpty:n},s={input:r,delimiter:a},i=Qt.runKernel("StringSplit",s,o);return{indices:i[0],values:i[1],shape:i[2]}}}),stringToHashBucketFast:rn({stringToHashBucketFast_:function(e,t){var n=en(e,"input","stringToHashBucketFast","string"),r={numBuckets:t};if(t<=0)throw new Error("Number of buckets must be at least 1");var a={input:n};return Qt.runKernel("StringToHashBucketFast",a,r)}})}};function yi(e,n,r){if(void 0===r&&(r=""),"number"!=typeof e&&"number"!=typeof n){t.util.assert(e.length===n.length,(function(){return r+" Shapes ".concat(e," and ").concat(n," must match")}));for(var a=0;a<e.length;a++){var o=e[a],s=n[a];t.util.assert(o<0||s<0||o===s,(function(){return r+" Shapes ".concat(e," and ").concat(n," must match")}))}}}function gi(e){return"number"!=typeof e&&!e.some((function(e){return e<0}))}function vi(e,t,n){var r=bi(e,n),a=!gi(r);if(a&&0===t.length)throw new Error("Tried to calculate elements of an empty list"+" with non-fully-defined elementShape: ".concat(r));if(a&&t.forEach((function(e){r=bi(e.shape,r)})),!gi(r))throw new Error("Non-fully-defined elementShape: ".concat(r));return r}function bi(e,t){if("number"==typeof e)return t;if("number"==typeof t)return e;if(e.length!==t.length)throw new Error("Incompatible ranks during merge: ".concat(e," vs. ").concat(t));for(var n=[],r=0;r<e.length;++r){var a=e[r],o=t[r];if(a>=0&&o>=0&&a!==o)throw new Error("Incompatible shape during merge: ".concat(e," vs. ").concat(t));n[r]=a>=0?a:o}return n}var xi=function(){function e(e,n,r,a,o,s,i){this.name=e,this.dtype=n,this.maxSize=r,this.elementShape=a,this.identicalElementShapes=o,this.dynamicSize=s,this.clearAfterRead=i,this.tensors=[],this.closed_=!1,this.idTensor=t.scalar(0),t.keep(this.idTensor)}return Object.defineProperty(e.prototype,"id",{get:function(){return this.idTensor.id},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"closed",{get:function(){return this.closed_},enumerable:!1,configurable:!0}),e.prototype.clearAndClose=function(e){this.tensors.forEach((function(t){null!=e&&e.has(t.tensor.id)||t.tensor.dispose()})),this.tensors=[],this.closed_=!0,this.idTensor.dispose()},e.prototype.size=function(){return this.tensors.length},e.prototype.read=function(e){if(this.closed_)throw new Error("TensorArray ".concat(this.name," has already been closed."));if(e<0||e>=this.size())throw new Error("Tried to read from index ".concat(e,", but array size is: ").concat(this.size()));var t=this.tensors[e];if(t.cleared)throw new Error("TensorArray ".concat(this.name,": Could not read index ").concat(e," twice because it was cleared after a previous read ")+"(perhaps try setting clear_after_read = false?).");return this.clearAfterRead&&(t.cleared=!0),t.read=!0,t.tensor},e.prototype.readMany=function(e){var t=this;return e.map((function(e){return t.read(e)}))},e.prototype.write=function(e,n){if(this.closed_)throw new Error("TensorArray ".concat(this.name," has already been closed."));if(e<0||!this.dynamicSize&&e>=this.maxSize)throw new Error("Tried to write to index ".concat(e,", but array is not resizeable and size is: ").concat(this.maxSize));var r=this.tensors[e]||{};if(n.dtype!==this.dtype)throw new Error("TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(e,",\n          because the value dtype is ").concat(n.dtype,", but TensorArray dtype is ").concat(this.dtype,"."));if(0!==this.size()||null!=this.elementShape&&0!==this.elementShape.length||(this.elementShape=n.shape),yi(this.elementShape,n.shape,"TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(e,".")),r.read)throw new Error("TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(e,", because it has already been read."));if(r.written)throw new Error("TensorArray ".concat(this.name,": Could not write to TensorArray index ").concat(e,", because it has already been written."));r.tensor=n,t.keep(n),r.written=!0,this.tensors[e]=r},e.prototype.writeMany=function(e,t){var n=this;if(e.length!==t.length)throw new Error("TensorArray ".concat(this.name,": could not write multiple tensors,")+"because the index size: ".concat(e.length," is not the same as tensors size: ").concat(t.length,"."));e.forEach((function(e,r){return n.write(e,t[r])}))},e.prototype.gather=function(e,n){if(n&&n!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but gather requested dtype ").concat(n));if(e)e=e.slice(0,this.size());else{e=[];for(var r=0;r<this.size();r++)e.push(r)}if(0===e.length)return t.tensor([],[0].concat(this.elementShape));var a=this.readMany(e);return yi(this.elementShape,a[0].shape,"TensorArray shape mismatch: "),t.stack(a,0)},e.prototype.concat=function(e){if(e&&e!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but concat requested dtype ").concat(e));if(0===this.size())return t.tensor([],[0].concat(this.elementShape));for(var n=[],r=0;r<this.size();r++)n.push(r);var a=this.readMany(n);return yi(this.elementShape,a[0].shape,"TensorArray shape mismatch: tensor array shape (".concat(this.elementShape,") vs first tensor shape (").concat(a[0].shape,")")),t.concat(a,0)},e.prototype.scatter=function(e,n){if(n.dtype!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but tensor has dtype ").concat(n.dtype));if(e.length!==n.shape[0])throw new Error("Expected len(indices) == tensor.shape[0], but saw: ".concat(e.length," vs. ").concat(n.shape[0]));var r=Math.max.apply(Math,d([],l(e),!1));if(!this.dynamicSize&&r>=this.maxSize)throw new Error("Max index must be < array size (".concat(r,"  vs. ").concat(this.maxSize,")"));this.writeMany(e,t.unstack(n,0))},e.prototype.split=function(e,n){var r=this;if(n.dtype!==this.dtype)throw new Error("TensorArray dtype is ".concat(this.dtype," but tensor has dtype ").concat(n.dtype));var a=0,o=e.map((function(e){return a+=e}));if(a!==n.shape[0])throw new Error("Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ".concat(a,", and tensor's shape is: ").concat(n.shape));if(!this.dynamicSize&&e.length!==this.maxSize)throw new Error("TensorArray's size is not equal to the size of lengths (".concat(this.maxSize," vs. ").concat(e.length,"), ")+"and the TensorArray is not marked as dynamically resizeable");var s=0===a?0:n.size/a,i=[];t.tidy((function(){n=t.reshape(n,[1,a,s]);for(var u=0;u<e.length;++u){var p=[0,0===u?0:o[u-1],0],c=[1,e[u],s];i[u]=t.reshape(t.slice(n,p,c),r.elementShape)}return i}));for(var u=[],p=0;p<e.length;p++)u[p]=p;this.writeMany(u,i)},e}(),Ni=function(){function e(e,n,r,a){void 0===a&&(a=-1),this.tensors=e,this.elementShape=n,this.elementDtype=r,null!=e&&e.forEach((function(e){if(r!==e.dtype)throw new Error("Invalid data types; op elements ".concat(r,", but list elements ").concat(e.dtype));yi(n,e.shape,"TensorList shape mismatch: "),t.keep(e)})),this.idTensor=t.scalar(0),this.maxNumElements=a,t.keep(this.idTensor)}return Object.defineProperty(e.prototype,"id",{get:function(){return this.idTensor.id},enumerable:!1,configurable:!0}),e.prototype.copy=function(){return new e(d([],l(this.tensors),!1),this.elementShape,this.elementDtype)},e.prototype.clearAndClose=function(e){this.tensors.forEach((function(t){null!=e&&e.has(t.id)||t.dispose()})),this.tensors.length=0,this.idTensor.dispose()},e.prototype.size=function(){return this.tensors.length},e.prototype.stack=function(e,n,r){var a=this;if(void 0===r&&(r=-1),n!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n,", but list elements ").concat(this.elementDtype));if(-1!==r&&this.tensors.length!==r)throw new Error("Operation expected a list with ".concat(r," elements but got a list with ").concat(this.tensors.length," elements."));yi(e,this.elementShape,"TensorList shape mismatch: ");var o=vi(this.elementShape,this.tensors,e);return t.tidy((function(){var e=a.tensors.map((function(e){return t.reshape(e,o)}));return t.stack(e,0)}))},e.prototype.popBack=function(e,n){if(n!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n,", but list elements ").concat(this.elementDtype));if(0===this.size())throw new Error("Trying to pop from an empty list.");var r=vi(this.elementShape,this.tensors,e),a=this.tensors.pop();return a.kept=!1,yi(a.shape,e,"TensorList shape mismatch: "),t.reshape(a,r)},e.prototype.pushBack=function(e){if(e.dtype!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(e.dtype,", but list elements ").concat(this.elementDtype));if(yi(e.shape,this.elementShape,"TensorList shape mismatch: "),this.maxNumElements===this.size())throw new Error("Trying to push element into a full list.");t.keep(e),this.tensors.push(e)},e.prototype.resize=function(t){if(t<0)throw new Error("TensorListResize expects size to be non-negative. Got: ".concat(t));if(-1!==this.maxNumElements&&t>this.maxNumElements)throw new Error("TensorListResize input size ".concat(t," is greater maxNumElement ").concat(this.maxNumElements,"."));var n=new e([],this.elementShape,this.elementDtype,this.maxNumElements);n.tensors.length=t;for(var r=0;r<Math.min(this.tensors.length,t);++r)n.tensors[r]=this.tensors[r];return n},e.prototype.getItem=function(e,n,r){if(r!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(r,", but list elements ").concat(this.elementDtype));if(e<0||e>this.tensors.length)throw new Error("Trying to access element ".concat(e," in a list with ").concat(this.tensors.length," elements."));if(null==this.tensors[e])throw new Error("element at index ".concat(e," is null."));yi(this.tensors[e].shape,n,"TensorList shape mismatch: ");var a=vi(this.elementShape,this.tensors,n);return t.reshape(this.tensors[e],a)},e.prototype.setItem=function(e,n){if(n.dtype!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n.dtype,", but list elements ").concat(this.elementDtype));if(e<0||-1!==this.maxNumElements&&e>=this.maxNumElements)throw new Error("Trying to set element ".concat(e," in a list with max ").concat(this.maxNumElements," elements."));yi(this.elementShape,n.shape,"TensorList shape mismatch: "),t.keep(n),null!=this.tensors[e]&&(this.tensors[e].kept=!1),this.tensors[e]=n},e.prototype.gather=function(e,n,r){var a=this;if(n!==this.elementDtype)throw new Error("Invalid data types; op elements ".concat(n,", but list elements ").concat(this.elementDtype));yi(this.elementShape,r,"TensorList shape mismatch: "),e=e.slice(0,this.size());var o=vi(this.elementShape,this.tensors,r);return 0===e.length?t.tensor([],[0].concat(o)):t.tidy((function(){var n=e.map((function(e){return t.reshape(a.tensors[e],o)}));return t.stack(n,0)}))},e.prototype.concat=function(e,n){var r=this;if(e&&e!==this.elementDtype)throw new Error("TensorList dtype is ".concat(this.elementDtype," but concat requested dtype ").concat(e));yi(this.elementShape,n,"TensorList shape mismatch: ");var a=vi(this.elementShape,this.tensors,n);return 0===this.size()?t.tensor([],[0].concat(a)):t.tidy((function(){var e=r.tensors.map((function(e){return t.reshape(e,a)}));return t.concat(e,0)}))},e}();var wi=function(e,n,r){return u(void 0,void 0,void 0,(function(){var a,o,s,i,u,c,h,f,g,v,b,x,w,k,T,_,S,E,I,O,D,A,M,C,F,R,z,V,L,P,B,K,j,q,U,W,H,G,Z,Q,Y,X,J,$,ee,te,ne,re,ae,oe,se,ie,ue,pe,ce,le,de;return p(this,(function(he){switch(he.label){case 0:switch(e.op){case"If":case"StatelessIf":return[3,1];case"While":case"StatelessWhile":return[3,3];case"LoopCond":return[3,9];case"Switch":return[3,10];case"Merge":return[3,12];case"Enter":return[3,13];case"Exit":return[3,14];case"NextIteration":return[3,15];case"TensorArrayV3":return[3,16];case"TensorArrayWriteV3":return[3,17];case"TensorArrayReadV3":return[3,18];case"TensorArrayGatherV3":return[3,19];case"TensorArrayScatterV3":return[3,20];case"TensorArrayConcatV3":return[3,21];case"TensorArraySplitV3":return[3,22];case"TensorArraySizeV3":return[3,23];case"TensorArrayCloseV3":return[3,24];case"TensorListSetItem":return[3,25];case"TensorListGetItem":return[3,26];case"TensorListScatterV2":case"TensorListScatter":return[3,27];case"TensorListReserve":case"EmptyTensorList":return[3,28];case"TensorListGather":return[3,29];case"TensorListStack":return[3,30];case"TensorListFromTensor":return[3,31];case"TensorListConcat":case"TensorListConcatV2":return[3,32];case"TensorListPushBack":return[3,33];case"TensorListPopBack":return[3,34];case"TensorListSplit":return[3,35];case"TensorListLength":return[3,36];case"TensorListResize":return[3,37]}return[3,38];case 1:return a=m("thenBranch",e,n,r),o=m("elseBranch",e,n,r),s=m("cond",e,n,r),c=m("args",e,n,r),[4,s.data()];case 2:return(g=he.sent())[0]?[2,r.functionMap[a].executeFunctionAsync(c,r.tensorArrayMap,r.tensorListMap)]:[2,r.functionMap[o].executeFunctionAsync(c,r.tensorArrayMap,r.tensorListMap)];case 3:return i=m("body",e,n,r),u=m("cond",e,n,r),c=m("args",e,n,r),[4,r.functionMap[u].executeFunctionAsync(c,r.tensorArrayMap,r.tensorListMap)];case 4:return h=he.sent(),f=c.map((function(e){return e.id})),[4,h[0].data()];case 5:g=he.sent(),h.forEach((function(e){e.kept||-1!==f.indexOf(e.id)||e.dispose()})),v=c,b=function(){var e,t,n;return p(this,(function(a){switch(a.label){case 0:return e=v,[4,r.functionMap[i].executeFunctionAsync(v,r.tensorArrayMap,r.tensorListMap)];case 1:return v=a.sent(),t=v.map((function(e){return e.id})),e.forEach((function(e){e.kept||-1!==f.indexOf(e.id)||-1!==t.indexOf(e.id)||e.dispose()})),[4,r.functionMap[u].executeFunctionAsync(v,r.tensorArrayMap,r.tensorListMap)];case 2:return[4,(n=a.sent())[0].data()];case 3:return g=a.sent(),n.forEach((function(e){e.kept||-1!==f.indexOf(e.id)||-1!==t.indexOf(e.id)||e.dispose()})),[2]}}))},he.label=6;case 6:return g[0]?[5,b()]:[3,8];case 7:return he.sent(),[3,6];case 8:return[2,v];case 9:return[2,[N(x=m("pred",e,n,r))]];case 10:return x=m("pred",e,n,r),(T=m("data",e,n,r)).kept||(T=N(T)),[4,x.data()];case 11:return[2,he.sent()[0]?[void 0,T]:[T,void 0]];case 12:return w=e.inputNames.find((function(e){return void 0!==y(e,n,r)})),w?[2,[N(T=y(w,n,r))]]:[2,void 0];case 13:return k=m("frameName",e,n,r),T=m("tensor",e,n,r),r.enterFrame(k),[2,[N(T)]];case 14:return T=m("tensor",e,n,r),r.exitFrame(),[2,[N(T)]];case 15:return T=m("tensor",e,n,r),r.nextIteration(),[2,[N(T)]];case 16:return ce=m("size",e,n,r),_=m("dtype",e,n,r),se=m("elementShape",e,n,r),S=m("dynamicSize",e,n,r),E=m("clearAfterRead",e,n,r),I=m("identicalElementShapes",e,n,r),O=m("name",e,n,r),D=new xi(O,_,ce,se,I,S,E),r.addTensorArray(D),[2,[D.idTensor,t.scalar(1)]];case 17:return A=m("tensorArrayId",e,n,r),U=m("index",e,n,r),re=m("tensor",e,n,r),(M=r.getTensorArray(A.id)).write(U,re),[2,[M.idTensor]];case 18:return C=m("tensorArrayId",e,n,r),W=m("index",e,n,r),[2,[r.getTensorArray(C.id).read(W)]];case 19:return Y=m("tensorArrayId",e,n,r),X=m("indices",e,n,r),F=m("dtype",e,n,r),[2,[r.getTensorArray(Y.id).gather(X,F)]];case 20:return R=m("tensorArrayId",e,n,r),H=m("indices",e,n,r),G=m("tensor",e,n,r),(z=r.getTensorArray(R.id)).scatter(H,G),[2,[z.idTensor]];case 21:return te=m("tensorArrayId",e,n,r),V=r.getTensorArray(te.id),ne=m("dtype",e,n,r),[2,[V.concat(ne)]];case 22:return L=m("tensorArrayId",e,n,r),oe=m("tensor",e,n,r),ie=m("lengths",e,n,r),(P=r.getTensorArray(L.id)).split(ie,oe),[2,[P.idTensor]];case 23:return B=m("tensorArrayId",e,n,r),K=r.getTensorArray(B.id),[2,[t.scalar(K.size(),"int32")]];case 24:return j=m("tensorArrayId",e,n,r),(q=r.getTensorArray(j.id)).clearAndClose(),[2,[q.idTensor]];case 25:return pe=m("tensorListId",e,n,r),U=m("index",e,n,r),re=m("tensor",e,n,r),(ue=r.getTensorList(pe.id)).setItem(U,re),[2,[ue.idTensor]];case 26:return pe=m("tensorListId",e,n,r),W=m("index",e,n,r),se=m("elementShape",e,n,r),ae=m("elementDType",e,n,r),[2,[(ue=r.getTensorList(pe.id)).getItem(W,se,ae)]];case 27:return H=m("indices",e,n,r),G=m("tensor",e,n,r),se=m("elementShape",e,n,r),J=m("numElements",e,n,r),ue=function(e,n,r,a){if(n.length!==e.shape[0])throw new Error("Expected len(indices) == tensor.shape[0], but saw: ".concat(n.length," vs. ").concat(e.shape[0]));var o=Math.max.apply(Math,d([],l(n),!1));if(null!=a&&-1!==a&&o>=a)throw new Error("Max index must be < array size (".concat(o,"  vs. ").concat(a,")"));var s=new Ni([],r,e.dtype,a),i=t.unstack(e,0);return n.forEach((function(e,t){s.setItem(e,i[t])})),s}(G,H,se,J),r.addTensorList(ue),[2,[ue.idTensor]];case 28:return se=m("elementShape",e,n,r),ee=m("elementDType",e,n,r),Z=void 0,Z="TensorListReserve"===e.op?"numElements":"maxNumElements",J=m(Z,e,n,r),Q="TensorListReserve"===e.op?-1:J,ue=function(e,t,n,r){return new Ni([],e,t,r)}(se,ee,0,Q),r.addTensorList(ue),[2,[ue.idTensor]];case 29:return Y=m("tensorListId",e,n,r),X=m("indices",e,n,r),se=m("elementShape",e,n,r),ee=m("elementDType",e,n,r),[2,[(ue=r.getTensorList(Y.id)).gather(X,ee,se)]];case 30:return pe=m("tensorListId",e,n,r),se=m("elementShape",e,n,r),ee=m("elementDType",e,n,r),J=m("numElements",e,n,r),[2,[(ue=r.getTensorList(pe.id)).stack(se,ee,J)]];case 31:return $=m("tensor",e,n,r),se=m("elementShape",e,n,r),ee=m("elementDType",e,n,r),ue=function(e,n,r){var a=e.dtype;if(e.shape.length<1)throw new Error("Tensor must be at least a vector, but saw shape: ".concat(e.shape));if(e.dtype!==r)throw new Error("Invalid data types; op elements ".concat(e.dtype,", but list elements ").concat(r));yi(e.shape.slice(1),n,"TensorList shape mismatch: ");var o=t.unstack(e);return new Ni(o,n,a)}($,se,ee),r.addTensorList(ue),[2,[ue.idTensor]];case 32:return te=m("tensorListId",e,n,r),ue=r.getTensorList(te.id),ne=m("dtype",e,n,r),se=m("elementShape",e,n,r),[2,[ue.concat(ne,se)]];case 33:return pe=m("tensorListId",e,n,r),re=m("tensor",e,n,r),(ue=r.getTensorList(pe.id)).pushBack(re),[2,[ue.idTensor]];case 34:return pe=m("tensorListId",e,n,r),se=m("elementShape",e,n,r),ae=m("elementDType",e,n,r),[2,[(ue=r.getTensorList(pe.id)).popBack(se,ae)]];case 35:return oe=m("tensor",e,n,r),se=m("elementShape",e,n,r),ie=m("lengths",e,n,r),ue=function(e,n,r){var a=0,o=n.map((function(e){return a+=e}));if(a!==e.shape[0])throw new Error("Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        ".concat(a,", and tensor's shape is: ").concat(e.shape));for(var s=bi(e.shape.slice(1),r),i=0===a?0:e.size/a,u=t.tidy((function(){var r=[];e=t.reshape(e,[1,a,i]);for(var u=0;u<n.length;++u){var p=[0,0===u?0:o[u-1],0],c=[1,n[u],i];r[u]=t.reshape(t.slice(e,p,c),s)}return e.dispose(),r})),p=new Ni([],r,e.dtype,n.length),c=0;c<u.length;c++)p.setItem(c,u[c]);return p}(oe,ie,se),r.addTensorList(ue),[2,[ue.idTensor]];case 36:return pe=m("tensorListId",e,n,r),ue=r.getTensorList(pe.id),[2,[t.scalar(ue.size(),"int32")]];case 37:return pe=m("tensorListId",e,n,r),ce=m("size",e,n,r),le=r.getTensorList(pe.id),de=le.resize(ce),r.addTensorList(de),[2,[de.idTensor]];case 38:throw TypeError("Node type ".concat(e.op," is not implemented"))}}))}))};function ki(e,t,n){var r=l(m("fusedOps",e,t,n),2),a=r[0],o=r[1],s="biasadd"===a,i=!s,u="prelu"===o,p="fusedbatchnorm"===a,c=m("numArgs",e,t,n);if(s){if(u&&2!==c)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!u&&s&&1!==c)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd must have one extra argument: bias.")}if(p)throw new Error("FusedConv2d and DepthwiseConv2d with FusedBatchNorm is not supported");var d=m("strides",e,t,n),h=x(e,t,n),f=m("dataFormat",e,t,n).toUpperCase(),y=m("dilations",e,t,n),g=l(m("args",e,t,n),2),v=g[0],b=g[1];return i&&(b=v,v=void 0),{stride:d,pad:h,dataFormat:f,dilations:y,biasArg:v,preluArg:b,activationFunc:o,leakyreluAlpha:m("leakyreluAlpha",e,t,n)}}function Ti(e,t,n){return{boxes:m("boxes",e,t,n),scores:m("scores",e,t,n),maxOutputSize:m("maxOutputSize",e,t,n),iouThreshold:m("iouThreshold",e,t,n),scoreThreshold:m("scoreThreshold",e,t,n),softNmsSigma:m("softNmsSigma",e,t,n)}}var _i=function(){function e(e,n){this.keyDType=e,this.valueDType=n,this.handle=t.scalar(0),this.tensorMap=new Map,t.keep(this.handle)}return Object.defineProperty(e.prototype,"id",{get:function(){return this.handle.id},enumerable:!1,configurable:!0}),e.prototype.clearAndClose=function(){this.tensorMap.forEach((function(e){return e.dispose()})),this.tensorMap.clear(),this.handle.dispose()},e.prototype.size=function(){return this.tensorMap.size},e.prototype.tensorSize=function(){return Fr(this.size(),"int32")},e.prototype.import=function(e,n){return u(this,void 0,void 0,(function(){var r,a=this;return p(this,(function(o){switch(o.label){case 0:return this.checkKeyAndValueTensor(e,n),[4,e.data()];case 1:return r=o.sent(),this.tensorMap.forEach((function(e){return e.dispose()})),this.tensorMap.clear(),[2,t.tidy((function(){var e=t.unstack(n),o=r.length,s=e.length;t.util.assert(o===s,(function(){return"The number of elements doesn't match, keys has "+"".concat(o," elements, the values has ").concat(s," ")+"elements."}));for(var i=0;i<o;i++){var u=r[i],p=e[i];t.keep(p),a.tensorMap.set(u,p)}return a.handle}))]}}))}))},e.prototype.find=function(e,n){return u(this,void 0,void 0,(function(){var r,a=this;return p(this,(function(o){switch(o.label){case 0:return this.checkKeyAndValueTensor(e,n),[4,e.data()];case 1:return r=o.sent(),[2,t.tidy((function(){for(var e=[],o=0;o<r.length;o++){var s=r[o],i=a.findWithDefault(s,n);e.push(i)}return t.stack(e)}))]}}))}))},e.prototype.findWithDefault=function(e,t){var n=this.tensorMap.get(e);return null!=n?n:t},e.prototype.checkKeyAndValueTensor=function(e,t){if(e.dtype!==this.keyDType)throw new Error("Expect key dtype ".concat(this.keyDType,", but got ")+"".concat(e.dtype));if(t.dtype!==this.valueDType)throw new Error("Expect value dtype ".concat(this.valueDType,", but got ")+"".concat(t.dtype))},e}();function Si(e,n,r,o,s){void 0===s&&(s=a.tidy);var i=function(e,n,r){switch(e.category){case"arithmetic":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"BiasAdd":case"AddV2":case"Add":return[r.add(m("a",e,t,n),m("b",e,t,n))];case"AddN":return[r.addN(m("tensors",e,t,n))];case"FloorMod":case"Mod":return[r.mod(m("a",e,t,n),m("b",e,t,n))];case"Mul":return[r.mul(m("a",e,t,n),m("b",e,t,n))];case"RealDiv":case"Div":return[r.div(m("a",e,t,n),m("b",e,t,n))];case"DivNoNan":return[r.divNoNan(m("a",e,t,n),m("b",e,t,n))];case"FloorDiv":return[r.floorDiv(m("a",e,t,n),m("b",e,t,n))];case"Sub":return[r.sub(m("a",e,t,n),m("b",e,t,n))];case"Minimum":return[r.minimum(m("a",e,t,n),m("b",e,t,n))];case"Maximum":return[r.maximum(m("a",e,t,n),m("b",e,t,n))];case"Pow":return[r.pow(m("a",e,t,n),m("b",e,t,n))];case"SquaredDifference":return[r.squaredDifference(m("a",e,t,n),m("b",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"basic_math":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Abs":case"ComplexAbs":return[r.abs(m("x",e,t,n))];case"Acos":return[r.acos(m("x",e,t,n))];case"Acosh":return[r.acosh(m("x",e,t,n))];case"Asin":return[r.asin(m("x",e,t,n))];case"Asinh":return[r.asinh(m("x",e,t,n))];case"Atan":return[r.atan(m("x",e,t,n))];case"Atan2":return[r.atan2(m("x",e,t,n),m("y",e,t,n))];case"Atanh":return[r.atanh(m("x",e,t,n))];case"Ceil":return[r.ceil(m("x",e,t,n))];case"Complex":return[r.complex(m("real",e,t,n),m("imag",e,t,n))];case"Cos":return[r.cos(m("x",e,t,n))];case"Cosh":return[r.cosh(m("x",e,t,n))];case"Elu":return[r.elu(m("x",e,t,n))];case"Erf":return[r.erf(m("x",e,t,n))];case"Exp":return[r.exp(m("x",e,t,n))];case"Expm1":return[r.expm1(m("x",e,t,n))];case"Floor":return[r.floor(m("x",e,t,n))];case"Log":return[r.log(m("x",e,t,n))];case"Log1p":return[r.log1p(m("x",e,t,n))];case"Imag":return[r.imag(m("x",e,t,n))];case"Neg":return[r.neg(m("x",e,t,n))];case"Reciprocal":return[r.reciprocal(m("x",e,t,n))];case"Real":return[r.real(m("x",e,t,n))];case"Relu":return[r.relu(m("x",e,t,n))];case"Round":return[r.round(m("x",e,t,n))];case"Selu":return[r.selu(m("x",e,t,n))];case"Sigmoid":return[r.sigmoid(m("x",e,t,n))];case"Sin":return[r.sin(m("x",e,t,n))];case"Sign":return[r.sign(m("x",e,t,n))];case"Sinh":return[r.sinh(m("x",e,t,n))];case"Softplus":return[r.softplus(m("x",e,t,n))];case"Sqrt":return[r.sqrt(m("x",e,t,n))];case"Square":return[r.square(m("x",e,t,n))];case"Tanh":return[r.tanh(m("x",e,t,n))];case"Tan":return[r.tan(m("x",e,t,n))];case"ClipByValue":return[r.clipByValue(m("x",e,t,n),m("clipValueMin",e,t,n),m("clipValueMax",e,t,n))];case"Relu6":return[r.relu6(m("x",e,t,n))];case"Rsqrt":return[r.rsqrt(y(e.inputNames[0],t,n))];case"Prod":return[r.prod(m("x",e,t,n),m("axes",e,t,n))];case"LeakyRelu":return[r.leakyRelu(m("x",e,t,n),m("alpha",e,t,n))];case"Prelu":return[r.prelu(m("x",e,t,n),m("alpha",e,t,n))];case"IsNan":return[r.isNaN(y(e.inputNames[0],t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"control":return wi(e,n,r);case"convolution":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Conv1D":var a=m("stride",e,t,n),o=m("pad",e,t,n),s=m("dataFormat",e,t,n).toUpperCase(),i=m("dilation",e,t,n);return[r.conv1d(m("x",e,t,n),m("filter",e,t,n),a,o,s,i)];case"Conv2D":a=m("strides",e,t,n),o=x(e,t,n),s=m("dataFormat",e,t,n).toUpperCase();var u=m("dilations",e,t,n);return[r.conv2d(m("x",e,t,n),m("filter",e,t,n),[a[1],a[2]],o,s,[u[1],u[2]])];case"_FusedConv2D":var p=ki(e,t,n),c=(a=p.stride,o=p.pad,s=p.dataFormat,u=p.dilations,p.biasArg),l=p.preluArg,d=p.activationFunc,h=p.leakyreluAlpha;return[r.fused.conv2d({x:m("x",e,t,n),filter:m("filter",e,t,n),strides:[a[1],a[2]],pad:o,dataFormat:s,dilations:[u[1],u[2]],bias:c,activation:d,preluActivationWeights:l,leakyreluAlpha:h})];case"FusedDepthwiseConv2dNative":var f=ki(e,t,n);return a=f.stride,o=f.pad,s=f.dataFormat,u=f.dilations,c=f.biasArg,l=f.preluArg,d=f.activationFunc,h=f.leakyreluAlpha,[r.fused.depthwiseConv2d({x:m("x",e,t,n),filter:m("filter",e,t,n),strides:[a[1],a[2]],pad:o,dataFormat:s,dilations:[u[1],u[2]],bias:c,activation:d,preluActivationWeights:l,leakyreluAlpha:h})];case"Conv2DBackpropInput":case"Conv2dTranspose":var y=m("outputShape",e,t,n);return a=m("strides",e,t,n),o=x(e,t,n),[r.conv2dTranspose(m("x",e,t,n),m("filter",e,t,n),y,[a[1],a[2]],o)];case"DepthwiseConv2dNative":case"DepthwiseConv2d":return a=m("strides",e,t,n),o=x(e,t,n),u=m("dilations",e,t,n),s=m("dataFormat",e,t,n).toUpperCase(),[r.depthwiseConv2d(m("input",e,t,n),m("filter",e,t,n),[a[1],a[2]],o,s,[u[1],u[2]])];case"Conv3D":return a=m("strides",e,t,n),o=m("pad",e,t,n),s=m("dataFormat",e,t,n).toUpperCase(),u=m("dilations",e,t,n),[r.conv3d(m("x",e,t,n),m("filter",e,t,n),[a[1],a[2],a[3]],o,s,[u[1],u[2],u[3]])];case"AvgPool":a=m("strides",e,t,n),o=m("pad",e,t,n);var g=m("kernelSize",e,t,n);return[r.avgPool(m("x",e,t,n),[g[1],g[2]],[a[1],a[2]],o)];case"MaxPool":return a=m("strides",e,t,n),o=m("pad",e,t,n),g=m("kernelSize",e,t,n),[r.maxPool(m("x",e,t,n),[g[1],g[2]],[a[1],a[2]],o)];case"MaxPoolWithArgmax":a=m("strides",e,t,n),o=m("pad",e,t,n),g=m("kernelSize",e,t,n);var v=m("includeBatchInIndex",e,t,n),b=r.maxPoolWithArgmax(m("x",e,t,n),[g[1],g[2]],[a[1],a[2]],o,v);return[b.result,b.indexes];case"AvgPool3D":return a=m("strides",e,t,n),o=m("pad",e,t,n),g=m("kernelSize",e,t,n),[r.avgPool3d(m("x",e,t,n),[g[1],g[2],g[3]],[a[1],a[2],a[3]],o)];case"MaxPool3D":return a=m("strides",e,t,n),o=m("pad",e,t,n),g=m("kernelSize",e,t,n),[r.maxPool3d(m("x",e,t,n),[g[1],g[2],g[3]],[a[1],a[2],a[3]],o)];case"Dilation2D":var N=m("strides",e,t,n),w=(o=m("pad",e,t,n),u=m("dilations",e,t,n),N[1]),k=N[2],T=u[1],_=u[2];return[r.dilation2d(m("x",e,t,n),m("filter",e,t,n),[w,k],o,[T,_],"NHWC")];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"creation":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Fill":var a=m("shape",e,t,n),o=m("dtype",e,t,n),s=m("value",e,t,n);return[r.fill(a,s,o)];case"LinSpace":var i=m("start",e,t,n),u=m("stop",e,t,n),p=m("num",e,t,n);return[r.linspace(i,u,p)];case"Multinomial":var c=m("logits",e,t,n),l=m("numSamples",e,t,n),d=m("seed",e,t,n);return[r.multinomial(c,l,d)];case"OneHot":var h=m("indices",e,t,n),f=m("depth",e,t,n),y=m("onValue",e,t,n),g=m("offValue",e,t,n);return o=m("dtype",e,t,n),[r.oneHot(h,f,y,g,o)];case"Ones":return[r.ones(m("shape",e,t,n),m("dtype",e,t,n))];case"OnesLike":return[r.onesLike(m("x",e,t,n))];case"RandomStandardNormal":return[r.randomStandardNormal(m("shape",e,t,n),m("dtype",e,t,n),m("seed",e,t,n))];case"RandomUniform":return[r.randomUniform(m("shape",e,t,n),m("minval",e,t,n),m("maxval",e,t,n),m("dtype",e,t,n))];case"Range":i=m("start",e,t,n),u=m("stop",e,t,n);var v=m("step",e,t,n);return[r.range(i,u,v,m("dtype",e,t,n))];case"TruncatedNormal":a=m("shape",e,t,n);var b=m("mean",e,t,n),x=m("stdDev",e,t,n);return d=m("seed",e,t,n),[r.truncatedNormal(a,b,x,m("dtype",e,t,n),d)];case"Zeros":return[r.zeros(m("shape",e,t,n),m("dtype",e,t,n))];case"ZerosLike":return[r.zerosLike(m("x",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"dynamic":return function(e,t,n,r,a){return void 0===a&&(a=mi),u(void 0,void 0,void 0,(function(){var r,o,s,i,u,c,l,d,h,f,y,g;return p(this,(function(p){switch(p.label){case 0:switch(e.op){case"NonMaxSuppressionV5":return[3,1];case"NonMaxSuppressionV4":return[3,3];case"NonMaxSuppressionV3":case"NonMaxSuppressionV2":return[3,5];case"Where":return[3,7];case"ListDiff":return[3,9]}return[3,10];case 1:return r=Ti(e,t,n),c=r.boxes,l=r.scores,d=r.maxOutputSize,h=r.iouThreshold,f=r.scoreThreshold,o=r.softNmsSigma,[4,a.image.nonMaxSuppressionWithScoreAsync(c,l,d,h,f,o)];case 2:return[2,[(g=p.sent()).selectedIndices,g.selectedScores]];case 3:return s=Ti(e,t,n),c=s.boxes,l=s.scores,d=s.maxOutputSize,h=s.iouThreshold,f=s.scoreThreshold,i=m("padToMaxOutputSize",e,t,n),[4,a.image.nonMaxSuppressionPaddedAsync(c,l,d,h,f,i)];case 4:return[2,[(g=p.sent()).selectedIndices,g.validOutputs]];case 5:return u=Ti(e,t,n),c=u.boxes,l=u.scores,d=u.maxOutputSize,h=u.iouThreshold,f=u.scoreThreshold,[4,a.image.nonMaxSuppressionAsync(c,l,d,h,f)];case 6:return[2,[p.sent()]];case 7:return y=a.cast(m("condition",e,t,n),"bool"),[4,a.whereAsync(y)];case 8:return g=[p.sent()],y.dispose(),[2,g];case 9:return[2,a.setdiff1dAsync(m("x",e,t,n),m("y",e,t,n))];case 10:throw TypeError("Node type ".concat(e.op," is not implemented"))}}))}))}(e,n,r);case"evaluation":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"LowerBound":var a=m("sortedSequence",e,t,n),o=m("values",e,t,n);return[r.lowerBound(a,o)];case"TopKV2":var s=m("x",e,t,n),i=m("k",e,t,n),u=m("sorted",e,t,n);return[(p=r.topk(s,i,u)).values,p.indices];case"UpperBound":return a=m("sortedSequence",e,t,n),o=m("values",e,t,n),[r.upperBound(a,o)];case"Unique":return s=m("x",e,t,n),[(p=r.unique(s)).values,p.indices];case"UniqueV2":s=m("x",e,t,n);var p,c=m("axis",e,t,n);return[(p=r.unique(s,c)).values,p.indices];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"image":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"ResizeBilinear":var a=m("images",e,t,n),o=m("size",e,t,n),s=m("alignCorners",e,t,n),i=m("halfPixelCenters",e,t,n);return[r.image.resizeBilinear(a,[o[0],o[1]],s,i)];case"ResizeNearestNeighbor":return a=m("images",e,t,n),o=m("size",e,t,n),s=m("alignCorners",e,t,n),i=m("halfPixelCenters",e,t,n),[r.image.resizeNearestNeighbor(a,[o[0],o[1]],s,i)];case"CropAndResize":var u=m("image",e,t,n),p=m("boxes",e,t,n),c=m("boxInd",e,t,n),l=m("cropSize",e,t,n),d=m("method",e,t,n),h=m("extrapolationValue",e,t,n);return[r.image.cropAndResize(u,p,c,l,d,h)];case"ImageProjectiveTransformV3":a=m("images",e,t,n);var f=m("transforms",e,t,n),y=m("outputShape",e,t,n),g=m("fillValue",e,t,n),v=m("interpolation",e,t,n),b=m("fillMode",e,t,n);return[r.image.transform(a,f,v.toLowerCase(),b.toLowerCase(),g,y)];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"graph":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Const":return t[e.name];case"PlaceholderWithDefault":var a=m("default",e,t,n);return[y(e.name,t,n)||a];case"Placeholder":return[y(e.name,t,n)];case"Identity":case"StopGradient":case"FakeQuantWithMinMaxVars":case"Snapshot":return[N(m("x",e,t,n))];case"IdentityN":return m("x",e,t,n).map((function(e){return N(e)}));case"Shape":return[r.tensor1d(m("x",e,t,n).shape,"int32")];case"ShapeN":return m("x",e,t,n).map((function(e){return r.tensor1d(e.shape)}));case"Size":return[r.scalar(m("x",e,t,n).size,"int32")];case"Rank":return[r.scalar(m("x",e,t,n).rank,"int32")];case"NoOp":return[r.scalar(1)];case"Print":var o=m("x",e,t,n),s=m("data",e,t,n),i=m("message",e,t,n),u=m("summarize",e,t,n);console.warn("The graph has a tf.print() operation,usually used for debugging, which slows down performance."),console.log(i);for(var p=0;p<s.length;p++)console.log(Array.prototype.slice.call(s[p].dataSync()).slice(0,u));return[o];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"logical":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Equal":return[r.equal(m("a",e,t,n),m("b",e,t,n))];case"NotEqual":return[r.notEqual(m("a",e,t,n),m("b",e,t,n))];case"Greater":return[r.greater(m("a",e,t,n),m("b",e,t,n))];case"GreaterEqual":return[r.greaterEqual(m("a",e,t,n),m("b",e,t,n))];case"Less":return[r.less(m("a",e,t,n),m("b",e,t,n))];case"LessEqual":return[r.lessEqual(m("a",e,t,n),m("b",e,t,n))];case"LogicalAnd":return[r.logicalAnd(m("a",e,t,n),m("b",e,t,n))];case"LogicalNot":return[r.logicalNot(m("a",e,t,n))];case"LogicalOr":return[r.logicalOr(m("a",e,t,n),m("b",e,t,n))];case"Select":case"SelectV2":return[r.where(m("condition",e,t,n),m("a",e,t,n),m("b",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"matrices":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"BatchMatMul":case"BatchMatMulV2":case"MatMul":return[r.matMul(m("a",e,t,n),m("b",e,t,n),m("transposeA",e,t,n),m("transposeB",e,t,n))];case"Einsum":return[r.einsum.apply(r,d([m("equation",e,t,n)],l(m("tensors",e,t,n)),!1))];case"Transpose":return[r.transpose(m("x",e,t,n),m("perm",e,t,n))];case"_FusedMatMul":var a=l(m("fusedOps",e,t,n),2),o=a[0],s=a[1],i="biasadd"===o,u="prelu"===s,p=m("numArgs",e,t,n),c=m("leakyreluAlpha",e,t,n);if(i){if(u&&2!==p)throw new Error("Fused MatMul with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!u&&1!==p)throw new Error("Fused MatMul with BiasAdd must have one extra argument: bias.")}var h=l(m("args",e,t,n),2),f=h[0],y=h[1];return[r.fused.matMul({a:m("a",e,t,n),b:m("b",e,t,n),transposeA:m("transposeA",e,t,n),transposeB:m("transposeB",e,t,n),bias:f,activation:s,preluActivationWeights:y,leakyreluAlpha:c})];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"normalization":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"EuclideanNorm":return[r.euclideanNorm(m("x",e,t,n),m("axis",e,t,n),m("keepDims",e,t,n))];case"FusedBatchNorm":case"FusedBatchNormV2":case"FusedBatchNormV3":return[r.batchNorm(m("x",e,t,n),m("mean",e,t,n),m("variance",e,t,n),m("offset",e,t,n),m("scale",e,t,n),m("epsilon",e,t,n))];case"LRN":return[r.localResponseNormalization(m("x",e,t,n),m("radius",e,t,n),m("bias",e,t,n),m("alpha",e,t,n),m("beta",e,t,n))];case"Softmax":return[r.softmax(m("x",e,t,n))];case"LogSoftmax":return[r.logSoftmax(m("x",e,t,n))];case"SparseToDense":return[r.sparseToDense(m("sparseIndices",e,t,n),m("outputShape",e,t,n),m("sparseValues",e,t,n),m("defaultValue",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"ragged":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"RaggedGather":var a=r.raggedGather(m("paramsNestedSplits",e,t,n),m("paramsDenseValues",e,t,n),m("indices",e,t,n),m("outputRaggedRank",e,t,n)),o=a.outputNestedSplits,s=a.outputDenseValues;return o.concat(s);case"RaggedRange":var i=r.raggedRange(m("starts",e,t,n),m("limits",e,t,n),m("splits",e,t,n));return[i.rtNestedSplits,i.rtDenseValues];case"RaggedTensorToTensor":return[r.raggedTensorToTensor(m("shape",e,t,n),m("values",e,t,n),m("defaultValue",e,t,n),m("rowPartitionTensors",e,t,n),m("rowPartitionTypes",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"reduction":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Max":var a=m("axis",e,t,n),o=m("keepDims",e,t,n);return[r.max(m("x",e,t,n),a,o)];case"Mean":return a=m("axis",e,t,n),o=m("keepDims",e,t,n),[r.mean(m("x",e,t,n),a,o)];case"Min":return a=m("axis",e,t,n),o=m("keepDims",e,t,n),[r.min(m("x",e,t,n),a,o)];case"Sum":return a=m("axis",e,t,n),o=m("keepDims",e,t,n),[r.sum(m("x",e,t,n),a,o)];case"All":return a=m("axis",e,t,n),o=m("keepDims",e,t,n),[r.all(m("x",e,t,n),a,o)];case"Any":return a=m("axis",e,t,n),o=m("keepDims",e,t,n),[r.any(m("x",e,t,n),a,o)];case"ArgMax":return a=m("axis",e,t,n),[r.argMax(m("x",e,t,n),a)];case"ArgMin":return a=m("axis",e,t,n),[r.argMin(m("x",e,t,n),a)];case"Prod":return a=m("axis",e,t,n),o=m("keepDims",e,t,n),[r.prod(m("x",e,t,n),a,o)];case"Cumprod":a=m("axis",e,t,n);var s=m("exclusive",e,t,n),i=m("reverse",e,t,n);return[r.cumprod(m("x",e,t,n),a,s,i)];case"Cumsum":return a=m("axis",e,t,n),s=m("exclusive",e,t,n),i=m("reverse",e,t,n),[r.cumsum(m("x",e,t,n),a,s,i)];case"Bincount":var u=m("x",e,t,n),p=m("weights",e,t,n),c=m("size",e,t,n);return[r.bincount(u,p,c)];case"DenseBincount":var l=m("x",e,t,n),d=m("weights",e,t,n),h=m("size",e,t,n),f=m("binaryOutput",e,t,n);return[r.denseBincount(l,d,h,f)];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"slice_join":return s((function(){return function(e,n,r,a){switch(void 0===a&&(a=mi),e.op){case"ConcatV2":case"Concat":var o=m("n",e,n,r),s=m("axis",e,n,r),i=m("tensors",e,n,r);return i=i.slice(0,o),[a.concat(i,s)];case"Gather":var u=m("x",e,n,r),p=m("indices",e,n,r);return[a.gather(u,a.cast(p,"int32"),0)];case"GatherV2":s=m("axis",e,n,r);var c=m("batchDims",e,n,r);return u=m("x",e,n,r),p=m("indices",e,n,r),[a.gather(u,a.cast(p,"int32"),s,c)];case"Reverse":for(var l=m("dims",e,n,r),d=(s=[],0);d<l.length;d++)l[d]&&s.push(d);return u=m("x",e,n,r),[a.reverse(u,s)];case"ReverseV2":return s=m("axis",e,n,r),u=m("x",e,n,r),[a.reverse(u,s)];case"Slice":var h=m("begin",e,n,r),f=m("size",e,n,r);return[a.slice(m("x",e,n,r),h,f)];case"StridedSlice":h=m("begin",e,n,r);var y=m("end",e,n,r),g=m("strides",e,n,r),v=m("beginMask",e,n,r),b=m("endMask",e,n,r),x=m("ellipsisMask",e,n,r),N=m("newAxisMask",e,n,r),w=m("shrinkAxisMask",e,n,r),k=m("x",e,n,r);return[a.stridedSlice(k,h,y,g,v,b,x,N,w)];case"Pack":return t.tidy((function(){var o=m("axis",e,n,r),s=m("tensors",e,n,r),i=s[0].shape,u=a.squeeze(s[0]).shape,p=s.map((function(e){var n=t.util.arraysEqual(e.shape,i);if(!n&&!t.util.arraysEqual(a.squeeze(e).shape,u))throw new Error("the input tensors shape does not match");return n?e:a.reshape(e,i)}));return[a.stack(p,o)]}));case"Unpack":return s=m("axis",e,n,r),k=m("tensor",e,n,r),a.unstack(k,s);case"Tile":var T=m("reps",e,n,r);return[a.tile(m("x",e,n,r),T)];case"Split":case"SplitV":s=m("axis",e,n,r);var _=m("numOrSizeSplits",e,n,r);return k=m("x",e,n,r),a.split(k,_,s);case"ScatterNd":p=m("indices",e,n,r);var S=m("values",e,n,r),E=m("shape",e,n,r);return[a.scatterND(p,S,E)];case"GatherNd":var I=m("x",e,n,r);return p=m("indices",e,n,r),[a.gatherND(I,p)];case"SparseToDense":p=m("sparseIndices",e,n,r),E=m("outputShape",e,n,r);var O=m("sparseValues",e,n,r),D=m("defaultValue",e,n,r);return[a.sparseToDense(p,O,E,O.dtype===D.dtype?D:a.cast(D,O.dtype))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"sparse":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"SparseFillEmptyRows":var a=r.sparse.sparseFillEmptyRows(m("indices",e,t,n),m("values",e,t,n),m("denseShape",e,t,n),m("defaultValue",e,t,n));return[a.outputIndices,a.outputValues,a.emptyRowIndicator,a.reverseIndexMap];case"SparseReshape":var o=r.sparse.sparseReshape(m("inputIndices",e,t,n),m("inputShape",e,t,n),m("newShape",e,t,n));return[o.outputIndices,o.outputShape];case"SparseSegmentMean":return[r.sparse.sparseSegmentMean(m("data",e,t,n),m("indices",e,t,n),m("segmentIds",e,t,n))];case"SparseSegmentSum":return[r.sparse.sparseSegmentSum(m("data",e,t,n),m("indices",e,t,n),m("segmentIds",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"spectral":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"FFT":return[r.fft(m("x",e,t,n))];case"IFFT":return[r.ifft(m("x",e,t,n))];case"RFFT":return[r.rfft(m("x",e,t,n))];case"IRFFT":return[r.irfft(m("x",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"string":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"StringNGrams":var a=r.string.stringNGrams(m("data",e,t,n),m("dataSplits",e,t,n),m("separator",e,t,n),m("nGramWidths",e,t,n),m("leftPad",e,t,n),m("rightPad",e,t,n),m("padWidth",e,t,n),m("preserveShortSequences",e,t,n));return[a.nGrams,a.nGramsSplits];case"StringSplit":var o=r.string.stringSplit(m("input",e,t,n),m("delimiter",e,t,n),m("skipEmpty",e,t,n));return[o.indices,o.values,o.shape];case"StringToHashBucketFast":return[r.string.stringToHashBucketFast(m("input",e,t,n),m("numBuckets",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"transformation":return s((function(){return function(e,t,n,r){switch(void 0===r&&(r=mi),e.op){case"Cast":return[r.cast(m("x",e,t,n),m("dtype",e,t,n))];case"ExpandDims":var a=m("axis",e,t,n);return[r.expandDims(m("x",e,t,n),a)];case"Squeeze":return a=m("axis",e,t,n),[r.squeeze(m("x",e,t,n),a)];case"Reshape":return[r.reshape(m("x",e,t,n),m("shape",e,t,n))];case"MirrorPad":return[r.mirrorPad(m("x",e,t,n),m("padding",e,t,n),m("mode",e,t,n))];case"PadV2":case"Pad":return[r.pad(m("x",e,t,n),m("padding",e,t,n),m("constantValue",e,t,n))];case"SpaceToBatchND":var o=m("blockShape",e,t,n),s=m("paddings",e,t,n);return[r.spaceToBatchND(m("x",e,t,n),o,s)];case"BatchToSpaceND":o=m("blockShape",e,t,n);var i=m("crops",e,t,n);return[r.batchToSpaceND(m("x",e,t,n),o,i)];case"DepthToSpace":var u=m("blockSize",e,t,n),p=m("dataFormat",e,t,n).toUpperCase();return[r.depthToSpace(m("x",e,t,n),u,p)];case"BroadcastTo":return[r.broadcastTo(m("x",e,t,n),m("shape",e,t,n))];case"BroadcastArgs":return[r.broadcastArgs(m("s0",e,t,n),m("s1",e,t,n))];default:throw TypeError("Node type ".concat(e.op," is not implemented"))}}(e,n,r)}));case"hash_table":return function(e,t,n,r){return u(void 0,void 0,void 0,(function(){var a,o,s,i,u,c,l,d;return p(this,(function(p){switch(p.label){case 0:switch(e.op){case"HashTable":case"HashTableV2":return[3,1];case"InitializeTable":case"InitializeTableV2":case"LookupTableImport":case"LookupTableImportV2":return[3,2];case"LookupTableFind":case"LookupTableFindV2":return[3,4];case"LookupTableSize":case"LookupTableSizeV2":return[3,6]}return[3,7];case 1:return null!=(a=r.getHashTableHandleByName(e.name))?[2,[a]]:(o=m("keyDType",e,t,n),s=m("valueDType",e,t,n),d=new _i(o,s),r.addHashTable(e.name,d),[2,[d.handle]]);case 2:return l=m("tableHandle",e,t,n,r),u=m("keys",e,t,n),i=m("values",e,t,n),[4,(d=r.getHashTableById(l.id)).import(u,i)];case 3:case 5:return[2,[p.sent()]];case 4:return l=m("tableHandle",e,t,n,r),u=m("keys",e,t,n),c=m("defaultValue",e,t,n),[4,(d=r.getHashTableById(l.id)).find(u,c)];case 6:return l=m("tableHandle",e,t,n,r),[2,[(d=r.getHashTableById(l.id)).tensorSize()]];case 7:throw TypeError("Node type ".concat(e.op," is not implemented"))}}))}))}(e,n,r,o);case"custom":var a=f(e.op);if(a&&a.customExecutor)return a.customExecutor(new ne(e,n,r));throw TypeError("Custom op ".concat(e.op," is not registered."));default:throw TypeError("Unknown op '".concat(e.op,"'. File an issue at ")+"https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()")}}(e,n,r);return a.util.isPromise(i)?i.then((function(e){return[].concat(e)})):[].concat(i)}var Ei=function(){function e(e,t,n,r){void 0===e&&(e={}),void 0===t&&(t={}),void 0===n&&(n={}),void 0===r&&(r={}),this.weightMap=e,this.tensorArrayMap=t,this.tensorListMap=n,this.functionMap=r,this.rootContext={id:0,frameName:"",iterationId:0},this.contexts=[this.rootContext],this.lastId=0,this.generateCurrentContextIds()}return e.prototype.newFrame=function(e,t){return{id:e,frameName:t,iterationId:0}},Object.defineProperty(e.prototype,"currentContext",{get:function(){return this.contexts},set:function(e){this.contexts!==e&&(this.contexts=e,this.generateCurrentContextIds())},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"currentContextId",{get:function(){return this._currentContextIds[0]},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"currentContextIds",{get:function(){return this._currentContextIds},enumerable:!1,configurable:!0}),e.prototype.generateCurrentContextIds=function(){for(var e=[],t=0;t<this.contexts.length-1;t++){var n=this.contexts.slice(0,this.contexts.length-t);e.push(this.contextIdforContexts(n))}e.push(""),this._currentContextIds=e},e.prototype.contextIdforContexts=function(e){return e?e.map((function(e){return 0===e.id&&0===e.iterationId?"":"".concat(e.frameName,"-").concat(e.iterationId)})).join("/"):""},e.prototype.enterFrame=function(e){this.contexts&&(this.lastId++,this.contexts=this.contexts.slice(),this.contexts.push(this.newFrame(this.lastId,e)),this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)))},e.prototype.exitFrame=function(){if(!(this.contexts&&this.contexts.length>1))throw new Error("Cannot exit frame, the context is empty");this.contexts=this.contexts.slice(),this.contexts.splice(-1),this.currentContextIds.shift()},e.prototype.nextIteration=function(){if(!(this.contexts&&this.contexts.length>0))throw new Error("Cannot increase frame iteration, the context is empty");this.contexts=this.contexts.slice(),this.lastId++;var e=Object.assign({},this.contexts[this.contexts.length-1]);e.iterationId+=1,e.id=this.lastId,this.contexts.splice(-1,1,e),this._currentContextIds.splice(0,1,this.contextIdforContexts(this.contexts))},e.prototype.getWeight=function(e){return this.weightMap[e]},e.prototype.addTensorArray=function(e){this.tensorArrayMap[e.id]=e},e.prototype.getTensorArray=function(e){return this.tensorArrayMap[e]},e.prototype.addTensorList=function(e){this.tensorListMap[e.id]=e},e.prototype.getTensorList=function(e){return this.tensorListMap[e]},e.prototype.dispose=function(e){for(var t in this.tensorArrayMap)this.tensorArrayMap[t].clearAndClose(e);for(var t in this.tensorListMap)this.tensorListMap[t].clearAndClose(e)},e}();function Ii(e,t,n,r){var a=new Set,o=[],s=null,i=null,u=new Set,p=Object.keys(e).map((function(e){return b(e)[0]})),c=[];null!=r&&(c=r.map((function(e){return b(e.name)[0]})));for(var h=d([],l(t),!1);h.length>0;){var f=h.pop();(Mi(f)||Ci(f)||Fi(f))&&null==s&&(i=(s=f).children.map((function(e){return e.name})).filter((function(e){return a.has(e)}))),a.add(f.name),null==n[f.name]&&(-1===p.indexOf(f.name)&&-1===c.indexOf(f.name)&&(0!==f.inputs.length?f.inputs.forEach((function(e){u.has(e.name)||(u.add(e.name),h.push(e))})):o.push(f.name)))}return{inputs:e,outputs:t,usedNodes:a,missingInputs:o,dynamicNode:s,syncInputs:i}}var Oi=["Switch","Merge","Enter","Exit","NextIteration","StatelessIf","StatelessWhile","if","While"],Di=["NonMaxSuppressionV2","NonMaxSuppressionV3","NonMaxSuppressionV5","Where"],Ai=["HashTable","HashTableV2","LookupTableImport","LookupTableImportV2","LookupTableFind","LookupTableFindV2","LookupTableSize","LookupTableSizeV2"];function Mi(e){return Oi.indexOf(e.op)>=0}function Ci(e){return Di.indexOf(e.op)>=0}function Fi(e){return Ai.indexOf(e.op)>=0}var Ri=function(){function e(t,n){var r=this;this.graph=t,this.parent=n,this.compiledMap=new Map,this._weightMap={},this.SEPERATOR=",",this._functions={},this._functionExecutorMap={},this.keepIntermediateTensors=!1,this._outputs=t.outputs,this._inputs=t.inputs,this._initNodes=t.initNodes,this._signature=t.signature,this._functions=t.functions,null!=t.functions&&Object.keys(t.functions).forEach((function(n){r._functionExecutorMap[n]=new e(t.functions[n],r)}))}return Object.defineProperty(e.prototype,"weightIds",{get:function(){return this.parent?this.parent.weightIds:this._weightIds},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"functionExecutorMap",{get:function(){return this.parent?this.parent.functionExecutorMap:this._functionExecutorMap},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"weightMap",{get:function(){return this.parent?this.parent.weightMap:this._weightMap},set:function(e){var t=Object.keys(e).map((function(t){return e[t].map((function(e){return e.id}))}));this._weightIds=[].concat.apply([],d([],l(t),!1)),this._weightMap=e},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"resourceManager",{set:function(e){this._resourceManager=e},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"inputs",{get:function(){return this._inputs.map((function(e){return{name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0}}))},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"outputs",{get:function(){return this._outputs.map((function(e){return{name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0}}))},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"inputNodes",{get:function(){return this._inputs.map((function(e){return e.signatureKey||e.name}))},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"outputNodes",{get:function(){return this._outputs.map((function(e){var t=e.signatureKey||e.name;return e.defaultOutput?"".concat(t,":").concat(e.defaultOutput):t}))},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"functions",{get:function(){var e=this;return Object.keys(this._functions).reduce((function(t,n){return t[n]=e._functions[n].signature,t}),{})},enumerable:!1,configurable:!0}),e.prototype.getCompilationKey=function(e,t){var n=e.map((function(e){return e.name})).sort(),r=t.map((function(e){return e.name})).sort();return n.join(this.SEPERATOR)+"--"+r.join(this.SEPERATOR)},e.prototype.compile=function(e,t){var n=Ii(e,t,this.weightMap,this._initNodes),r=n.missingInputs,a=n.dynamicNode,o=n.syncInputs;if(null!=a)throw new Error("This execution contains the node '".concat(a.name,"', which has ")+"the dynamic op '".concat(a.op,"'. Please use ")+"model.executeAsync() instead. Alternatively, to avoid the "+"dynamic ops, specify the inputs [".concat(o,"]"));if(r.length>0){var s=t.map((function(e){return e.name})),i=Object.keys(e);throw new Error("Cannot compute the outputs [".concat(s,"] from the provided inputs ")+"[".concat(i,"]. Missing the following inputs: [").concat(r,"]"))}return function(e,t,n){var r=n.usedNodes,a=n.inputs,o=[],s=Object.keys(a).map((function(e){return b(e)[0]})).map((function(t){return e.nodes[t]})),i=e.initNodes;s.forEach((function(e){r.has(e.name)&&o.push(e)})),e.weights.forEach((function(e){r.has(e.name)&&o.push(e)})),null!=i&&i.forEach((function(e){r.has(e.name)&&o.push(e)}));for(var u=new Set,p=[];o.length>0;){var c=o.pop();u.add(c.name),t[c.name]||p.push(c),c.children.forEach((function(e){!u.has(e.name)&&r.has(e.name)&&e.inputs.every((function(e){return u.has(e.name)}))&&o.push(e)}))}return p}(this.graph,this.weightMap,n)},e.prototype.cloneAndKeepTensor=function(e){if(null==e)return null;var n=e.clone();return t.keep(n),n},e.prototype.cloneTensorList=function(e){var t=this;if(!e)return null;var n=e.map((function(e){return t.cloneAndKeepTensor(e)}));return n},e.prototype.cloneTensorMap=function(e){var t=this;return Object.fromEntries(Object.entries(e).map((function(e){var n=l(e,2),r=n[0],a=n[1];return[r,t.cloneTensorList(a)]})))},e.prototype.execute=function(e,n){var r=this;this.disposeIntermediateTensors(),e=this.mapInputs(e);var a=Object.keys(e).sort();this.checkInputs(e),this.checkInputShapeAndType(e),n=this.mapOutputs(n),this.checkOutputs(n);var o=a.map((function(e){return r.graph.nodes[b(e)[0]]})),s=n.map((function(e){return b(e)[0]})),i=s.map((function(e){return r.graph.nodes[e]}));0===i.length&&(i=this._outputs);var u=this.getCompilationKey(o,i),p=this.compiledMap.get(u);null==p&&(p=this.compile(e,i),this.compiledMap.set(u,p));try{this.keepIntermediateTensors=t.env().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(e){this.keepIntermediateTensors=!1,console.warn(e.message)}var c={},d={};return t.tidy((function(){var a=new Ei(r.weightMap,c,d,r.functionExecutorMap),o=Object.assign({},r.weightMap);r.keepIntermediateTensors&&(r.clonedTensorsMap=r.cloneTensorMap(r.weightMap)),Object.keys(e).forEach((function(t){var n=l(b(t),2),a=n[0],s=[];s[n[1]]=e[t],o[a]=s,r.keepIntermediateTensors&&(r.clonedTensorsMap[a]=r.cloneTensorList(s))}));for(var i=r.getFrozenTensorIds(o),u={},h=0;h<p.length;h++){var f=p[h];if(!o[f.name]){var m=Si(f,o,a,r._resourceManager);if(t.util.isPromise(m))throw new Error("The execution of the op '".concat(f.op,"' returned a promise. ")+"Please use model.executeAsync() instead.");o[f.name]=m,r.keepIntermediateTensors&&(r.clonedTensorsMap[f.name]=r.cloneTensorList(m)),r.checkTensorForDisposal(f.name,f,o,a,i,s,u)}}return null==r.parent&&a.dispose(i),n.map((function(e){return y(e,o,a)}))}))},e.prototype.getFrozenTensorIds=function(e){var t=[].concat.apply([],Object.keys(e).map((function(t){return e[t]})).map((function(e){return e.map((function(e){return e.id}))})));return new Set(t)},e.prototype.checkTensorForDisposal=function(e,t,n,r,a,o,s){"control"!==t.category&&-1===o.indexOf(e)&&(n[e].forEach((function(e){null!=e&&(s[e.id]=(s[e.id]||0)+t.children.length)})),t.inputs.forEach((function(e){if("control"!==e.category){var t=function(e,t,n){return t[v(e,n.currentContextId)]}(e.name,n,r);null!=t&&t.forEach((function(e){if(e&&!e.kept&&!a.has(e.id)){var t=s[e.id];1===t?(e.dispose(),delete s[e.id]):null!=t&&s[e.id]--}}))}})))},e.prototype.executeAsync=function(e,t){return u(this,void 0,void 0,(function(){return p(this,(function(n){return[2,this._executeAsync(e,t)]}))}))},e.prototype.disposeIntermediateTensors=function(){this.clonedTensorsMap&&(Object.values(this.clonedTensorsMap).forEach((function(e){var t,n;try{for(var r=c(e),a=r.next();!a.done;a=r.next()){var o=a.value;o&&!o.isDisposed&&o.dispose()}}catch(e){t={error:e}}finally{try{a&&!a.done&&(n=r.return)&&n.call(r)}finally{if(t)throw t.error}}})),this.clonedTensorsMap=null)},e.prototype.getIntermediateTensors=function(){return this.clonedTensorsMap},e.prototype._executeAsync=function(e,n,r,a,o){return void 0===r&&(r=!1),void 0===a&&(a={}),void 0===o&&(o={}),u(this,void 0,void 0,(function(){var s,i,u,c,h,f;return p(this,(function(p){switch(p.label){case 0:this.disposeIntermediateTensors(),r||(e=this.mapInputs(e),this.checkInputs(e),this.checkInputShapeAndType(e),n=this.mapOutputs(n),this.checkOutputs(n));try{this.keepIntermediateTensors=t.env().getBool("KEEP_INTERMEDIATE_TENSORS")}catch(e){this.keepIntermediateTensors=!1,console.warn(e.message)}return s=new Ei(this.weightMap,a,o,this.functionExecutorMap),this.keepIntermediateTensors&&(this.clonedTensorsMap=this.cloneTensorMap(this.weightMap)),[4,this.executeWithControlFlow(e,s,n,r)];case 1:return i=p.sent(),u=n.map((function(e){return y(e,i,s)})),c=u.map((function(e){return e.id})),h=Object.keys(e).map((function(t){return e[t].id})),f=new Set(d(d(d([],l(c),!1),l(h),!1),l(this.weightIds),!1)),Object.values(i).forEach((function(e){e.forEach((function(e){!e||e.isDisposed||f.has(e.id)||e.dispose()}))})),null==this.parent&&s.dispose(f),[2,u]}}))}))},e.prototype.executeFunctionAsync=function(e,t,n){return u(this,void 0,void 0,(function(){var r,a=this;return p(this,(function(o){return r=e.reduce((function(e,t,n){return e[a.inputs[n].name]=t,e}),{}),[2,this._executeAsync(r,this.outputNodes,!0,t,n)]}))}))},e.prototype.executeWithControlFlow=function(e,t,n,r){return u(this,void 0,void 0,(function(){var a,o,s,i,u,c,h,f,m,g,v,x,N,w,k,T,_,S=this;return p(this,(function(p){switch(p.label){case 0:a=Object.keys(e),o=a.map((function(e){return S.graph.nodes[b(e)[0]]})),s=n.map((function(e){return b(e)[0]})),0===(i=s.map((function(e){return S.graph.nodes[e]}))).length&&(i=this._outputs),u=Ii(e,i,this.weightMap,this._initNodes),c=u.usedNodes,h=u.missingInputs,f=u.dynamicNode,m=u.syncInputs,g=d(d(d([],l(o),!1),l(this.graph.weights),!1),l(this._initNodes||[]),!1).map((function(e){return{node:e,contexts:t.currentContext}})),v=Object.assign({},this.weightMap),Object.keys(e).forEach((function(t){var n=l(b(t),2),r=n[0],a=[];a[n[1]]=e[t],v[r]=a})),x={},N=this.getFrozenTensorIds(v),w={},p.label=1;case 1:return g.length>0?(k=this.processStack(o,g,t,v,w,N,s,x,c),[4,Promise.all(k)]):[3,3];case 2:return p.sent(),[3,1];case 3:if(null!=f||r||console.warn("This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead."),(T=i.filter((function(e){return!Mi(e)&&!y(e.name,v,t)})).map((function(e){return e.name}))).length>0)throw _="",null!=f&&(_="Alternatively, to avoid the dynamic ops, use model.execute() "+"and specify the inputs [".concat(m,"]")),new Error("Cannot compute the outputs [".concat(T,"] from the provided ")+"inputs [".concat(a,"]. Consider providing the following inputs: ")+"[".concat(h,"]. ").concat(_));return[2,v]}}))}))},e.prototype.processStack=function(e,n,r,a,o,s,i,u,p){for(var c=this,d=[],h=function(){var e,h,y=n.pop();r.currentContext=y.contexts;var v="";if("Enter"===y.node.op&&m("isConstant",y.node,a,r)&&(e=l(g(y.node.name,r),1),v=e[0]),null==a[y.node.name]){var b=Si(y.node,a,r,f._resourceManager);v||(h=l(g(y.node.name,r),1),v=h[0]);var x=r.currentContext;t.util.isPromise(b)?d.push(b.then((function(e){return a[v]=e,c.keepIntermediateTensors&&(c.clonedTensorsMap[v]=c.cloneTensorList(e)),r.currentContext=x,c.checkTensorForDisposal(v,y.node,a,r,s,i,u),c.processChildNodes(y.node,n,r,a,o,p),e}))):(a[v]=b,f.keepIntermediateTensors&&(f.clonedTensorsMap[v]=f.cloneTensorList(b)),f.checkTensorForDisposal(v,y.node,a,r,s,i,u),f.processChildNodes(y.node,n,r,a,o,p))}else f.processChildNodes(y.node,n,r,a,o,p)},f=this;n.length>0;)h();return d},e.prototype.processChildNodes=function(e,t,n,r,a,o){e.children.forEach((function(e){var s=l(g(e.name,n),1)[0];!a[s]&&o.has(e.name)&&("Merge"===e.op?e.inputNames.some((function(e){return!!y(e,r,n)}))&&(a[s]=!0,t.push({contexts:n.currentContext,node:e})):e.inputNames.every((function(e){return!!y(e,r,n)}))&&(a[s]=!0,t.push({contexts:n.currentContext,node:e})))}))},e.prototype.dispose=function(){var e=this;Object.keys(this.weightMap).forEach((function(t){return e.weightMap[t].forEach((function(e){return e.dispose()}))}))},e.prototype.checkInputShapeAndType=function(e){var n=this;Object.keys(e).forEach((function(r){var a=e[r],o=l(b(r),1)[0],s=n.graph.nodes[o];if(s.attrParams.shape&&s.attrParams.shape.value){var i=s.attrParams.shape.value,u=i.length===a.shape.length&&a.shape.every((function(e,t){return-1===i[t]||i[t]===e}));t.util.assert(u,(function(){return"The shape of dict['".concat(s.name,"'] provided in ")+"model.execute(dict) must be [".concat(i,"], but was ")+"[".concat(a.shape,"]")}))}s.attrParams.dtype&&s.attrParams.dtype.value&&t.util.assert(a.dtype===s.attrParams.dtype.value,(function(){return"The dtype of dict['".concat(s.name,"'] provided in ")+"model.execute(dict) must be "+"".concat(s.attrParams.dtype.value,", but was ").concat(a.dtype)}))}))},e.prototype.mapInputs=function(e){var t,n,r={};for(var a in e){var o=null===(n=null===(t=this._signature)||void 0===t?void 0:t.inputs)||void 0===n?void 0:n[a];null!=o?r[o.name]=e[a]:r[a]=e[a]}return r},e.prototype.checkInputs=function(e){var t=this,n=Object.keys(e).filter((function(e){var n=l(b(e),1)[0];return null==t.graph.nodes[n]}));if(n.length>0)throw new Error("The dict provided in model.execute(dict) has "+"keys: [".concat(n,"] that are not part of graph"))},e.prototype.mapOutputs=function(e){var t=this;return e.map((function(e){var n,r,a=null===(r=null===(n=t._signature)||void 0===n?void 0:n.outputs)||void 0===r?void 0:r[e];return null!=a?a.name:e}),{})},e.prototype.checkOutputs=function(e){var t=this;e.forEach((function(e){var n=l(b(e),1)[0];if(!t.graph.nodes[n])throw new Error("The output '".concat(e,"' is not found in the graph"))}))},e}(),zi=function(){function e(e,t){void 0===e&&(e={}),void 0===t&&(t={}),this.hashTableNameToHandle=e,this.hashTableMap=t}return e.prototype.addHashTable=function(e,t){this.hashTableNameToHandle[e]=t.handle,this.hashTableMap[t.id]=t},e.prototype.getHashTableHandleByName=function(e){return this.hashTableNameToHandle[e]},e.prototype.getHashTableById=function(e){return this.hashTableMap[e]},e.prototype.dispose=function(){for(var e in this.hashTableMap)this.hashTableMap[e].clearAndClose(),delete this.hashTableMap[e];for(var t in this.hashTableNameToHandle)this.hashTableNameToHandle[t].dispose(),delete this.hashTableNameToHandle[t]},e}(),Vi="?tfjs-format=file",Li="model.json",Pi=function(){function e(e,n,r){void 0===n&&(n={}),void 0===r&&(r=t.io),this.modelUrl=e,this.loadOptions=n,this.version="n/a",this.io=r,null==n&&(this.loadOptions={}),this.resourceManager=new zi}return Object.defineProperty(e.prototype,"modelVersion",{get:function(){return this.version},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"inputNodes",{get:function(){return this.executor.inputNodes},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"outputNodes",{get:function(){return this.executor.outputNodes},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"inputs",{get:function(){return this.executor.inputs},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"outputs",{get:function(){return this.executor.outputs},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"weights",{get:function(){return this.executor.weightMap},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"metadata",{get:function(){return this.artifacts.userDefinedMetadata},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"modelSignature",{get:function(){return this.signature},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"modelStructuredOutputKeys",{get:function(){return this.structuredOutputKeys},enumerable:!1,configurable:!0}),e.prototype.findIOHandler=function(){var e=this.modelUrl;if(null!=e.load)this.handler=e;else if(null!=this.loadOptions.requestInit)this.handler=this.io.browserHTTPRequest(e,this.loadOptions);else{var t=this.io.getLoadHandlers(e,this.loadOptions);if(0===t.length)t.push(this.io.browserHTTPRequest(e,this.loadOptions));else if(t.length>1)throw new Error("Found more than one (".concat(t.length,") load handlers for ")+"URL '".concat([e],"'"));this.handler=t[0]}},e.prototype.load=function(){var e=this;if(this.findIOHandler(),null==this.handler.load)throw new Error("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");var n=this.handler.load();return t.util.isPromise(n)?n.then((function(t){return e.loadSync(t)})):this.loadSync(n)},e.prototype.loadSync=function(e){this.artifacts=e;var t=this.artifacts.modelTopology,n=this.artifacts.signature;if(null!=this.artifacts.userDefinedMetadata){var r=this.artifacts.userDefinedMetadata;null!=r.signature&&(n=r.signature),null!=r.structuredOutputKeys&&(this.structuredOutputKeys=r.structuredOutputKeys)}this.signature=n,this.version="".concat(t.versions.producer,".").concat(t.versions.minConsumer);var a=this.io.decodeWeights(this.artifacts.weightData,this.artifacts.weightSpecs);if(this.executor=new Ri(K.Instance.transformGraph(t,this.signature)),this.executor.weightMap=this.convertTensorMapToTensorsMap(a),this.executor.resourceManager=this.resourceManager,null!=e.modelInitializer&&null!=e.modelInitializer.node){var o=K.Instance.transformGraph(e.modelInitializer);this.initializer=new Ri(o),this.initializer.weightMap=this.executor.weightMap,this.initializer.resourceManager=this.resourceManager,this.initializerSignature=e.initializerSignature}return!0},e.prototype.save=function(e,t){return u(this,void 0,void 0,(function(){var t;return p(this,(function(n){if("string"==typeof e){if(0===(t=this.io.getSaveHandlers(e)).length)throw new Error("Cannot find any save handlers for URL '".concat(e,"'"));if(t.length>1)throw new Error("Found more than one (".concat(t.length,") save handlers for ")+"URL '".concat(e,"'"));e=t[0]}if(null==e.save)throw new Error("GraphModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");return[2,e.save(this.artifacts)]}))}))},e.prototype.addStructuredOutputNames=function(e){var n=this;if(this.structuredOutputKeys){var r=e instanceof t.Tensor?[e]:e,a={};return r.forEach((function(e,t){return a[n.structuredOutputKeys[t]]=e})),a}return e},e.prototype.predict=function(e,t){var n=this.execute(e,this.outputNodes);return this.addStructuredOutputNames(n)},e.prototype.predictAsync=function(e,t){return u(this,void 0,void 0,(function(){var t;return p(this,(function(n){switch(n.label){case 0:return[4,this.executeAsync(e,this.outputNodes)];case 1:return t=n.sent(),[2,this.addStructuredOutputNames(t)]}}))}))},e.prototype.normalizeInputs=function(e){var n,r=this;if(!(e instanceof t.Tensor||Array.isArray(e))){var a=null===(n=this.signature)||void 0===n?void 0:n.inputs;if(null!=a)for(var o in a){var s=a[o];null!=s.resourceId&&(e[o]=this.resourceIdToCapturedInput[s.resourceId])}return e}e=Array.isArray(e)?e:[e];var i=Object.keys(this.resourceIdToCapturedInput).length;if(e.length+i!==this.inputNodes.length)throw new Error("Input tensor count mismatch, the graph model has ".concat(this.inputNodes.length-i," non-resource placeholders, while there are ").concat(e.length," input tensors provided."));var u=0;return this.inputNodes.reduce((function(t,n){var a,o,s,i=null===(s=null===(o=null===(a=r.signature)||void 0===a?void 0:a.inputs)||void 0===o?void 0:o[n])||void 0===s?void 0:s.resourceId;return t[n]=null!=i?r.resourceIdToCapturedInput[i]:e[u++],t}),{})},e.prototype.normalizeOutputs=function(e){return e=e||this.outputNodes,Array.isArray(e)?e:[e]},e.prototype.executeInitializerGraph=function(){return null==this.initializer?[]:null==this.initializerSignature?this.initializer.execute({},[]):this.initializer.execute({},Object.keys(this.initializerSignature.outputs))},e.prototype.executeInitializerGraphAsync=function(){return u(this,void 0,void 0,(function(){return p(this,(function(e){return null==this.initializer?[2,[]]:null==this.initializerSignature?[2,this.initializer.executeAsync({},[])]:[2,this.initializer.executeAsync({},Object.keys(this.initializerSignature.outputs))]}))}))},e.prototype.setResourceIdToCapturedInput=function(e){if(this.resourceIdToCapturedInput={},this.initializerSignature)for(var t=this.initializerSignature.outputs,n=Object.keys(t),r=0;r<n.length;r++){var a=t[n[r]];this.resourceIdToCapturedInput[a.resourceId]=e[r]}},e.prototype.execute=function(e,t){null==this.resourceIdToCapturedInput&&this.setResourceIdToCapturedInput(this.executeInitializerGraph()),e=this.normalizeInputs(e),t=this.normalizeOutputs(t);var n=this.executor.execute(e,t);return n.length>1?n:n[0]},e.prototype.executeAsync=function(e,t){return u(this,void 0,void 0,(function(){var n,r;return p(this,(function(a){switch(a.label){case 0:return null!=this.resourceIdToCapturedInput?[3,2]:(n=this.setResourceIdToCapturedInput,[4,this.executeInitializerGraphAsync()]);case 1:n.apply(this,[a.sent()]),a.label=2;case 2:return e=this.normalizeInputs(e),t=this.normalizeOutputs(t),[4,this.executor.executeAsync(e,t)];case 3:return[2,(r=a.sent()).length>1?r:r[0]]}}))}))},e.prototype.getIntermediateTensors=function(){return this.executor.getIntermediateTensors()},e.prototype.disposeIntermediateTensors=function(){this.executor.disposeIntermediateTensors()},e.prototype.convertTensorMapToTensorsMap=function(e){return Object.keys(e).reduce((function(t,n){return t[n]=[e[n]],t}),{})},e.prototype.dispose=function(){this.executor.dispose(),this.initializer&&(this.initializer.dispose(),this.resourceIdToCapturedInput&&t.dispose(this.resourceIdToCapturedInput)),this.resourceManager.dispose()},e}();e.GraphModel=Pi,e.deregisterOp=function(e){delete h[e]},e.loadGraphModel=function(e,n,r){return void 0===n&&(n={}),void 0===r&&(r=t.io),u(this,void 0,void 0,(function(){var t;return p(this,(function(a){switch(a.label){case 0:if(null==e)throw new Error("modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model");return null==n&&(n={}),n.fromTFHub&&"string"==typeof e&&(e=function(e){e.endsWith("/")||(e+="/");return"".concat(e).concat(Li).concat(Vi)}(e)),[4,(t=new Pi(e,n,r)).load()];case 1:return a.sent(),[2,t]}}))}))},e.loadGraphModelSync=function(e){if(null==e)throw new Error("modelUrl in loadGraphModelSync() cannot be null. Please provide model artifacts or an IOHandler that loads the model");var n;if(e instanceof Array){var r=l(e,2),a=r[0],o=r[1];if(!a)throw new Error("modelJSON must be the first element of the array");if(!(o&&o instanceof ArrayBuffer))throw new Error("An ArrayBuffer of weights must be the second element of the array");if(!("modelTopology"in a))throw new Error("Model JSON is missing 'modelTopology'");if(!("weightsManifest"in a))throw new Error("Model JSON is missing 'weightsManifest'");var s=t.io.getWeightSpecs(a.weightsManifest),i=t.io.getModelArtifactsForJSONSync(a,s,o);n=t.io.fromMemorySync(i)}else if("load"in e)n=e;else{if(!("modelTopology"in e&&"weightSpecs"in e&&"weightData"in e))throw new Error("Unknown model format");n=t.io.fromMemorySync(e)}var u=new Pi(n);return u.load(),u},e.registerOp=function(e,t){var n={tfOpName:e,category:"custom",inputs:[],attrs:[],customExecutor:t};h[e]=n},e.version_converter="4.2.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-converter.min.js.map
